#!/bin/sh

# IBM Confidential
# OCO Source Materials
# 5724-I66
# (C) Copyright IBM Corporation 2006, 2008
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#
#####################################################
#                                                   #
# WSADIE Workspace Migration Tool                   #
#                                                   #
#                                                   #  
#####################################################

TARGET=[existing_name]
DEBUG=false

# Set the classpath for the tool.
while [ $# != 0 ]
do
    case "$1" in
        -WSADIEworkspace)
                WSADIEWORKSPACE=$2
                shift 2
                ;;
        -WIDworkspace)
                WORKSPACE=$2
                shift 2
                ;;
        -WIDstartup)
                ECLIPSE_ROOT=$2
                shift 2
                ;;
    esac
done

if [ "$ECLIPSE_ROOT" = "" ]
then
    echo You must provide the WID startup folder, target WID workspace directory name, and source WSADIE workspace directory name.

    echo =================================================================================
    echo
    echo Usage:      WSADIEWorkspaceMigration.sh
    echo             -WIDstartup eclipse-folder -WIDworkspace workspace -WSADIEworkspace WSADIE_workspace
    echo
    echo eclipse-folder: The location of your eclipse folder -- usually it's the 'eclipse'
    echo                 found under your product installation folder.
    echo
    echo workspace:  The target WID workspace
    echo
    echo WSADIE_workspace:    The name of the directory containing the WSADIE workspace to migrate.
    echo
    echo =================================================================================
    echo
    echo Example:
    echo
    echo
    echo WSADIEWorkspaceMigration.sh -WIDstartup "IBM/WID/eclipse" -WIDworkspace "WID Workspaces/myWIDWorkspace" -WSADIEworkspace "wsadie workspaces/myWSADIEWorkspace"
else

	$ECLIPSE_ROOT/jdk/jre/bin/java -Xj9  -cp $ECLIPSE_ROOT/plugins/org.eclipse.equinox.launcher_1.0.100.v20080509-1800.jar org.eclipse.core.launcher.Main  -clean -data $WORKSPACE -application com.ibm.wbit.migration.wsadie.WSADIEWorkspaceMigration $WSADIEWORKSPACE $WORKSPACE true false

fi

