<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:scdl="http://www.ibm.com/xmlns/prod/websphere/scdl/6.0.0" xmlns:wsdls="http://schemas.xmlsoap.org/wsdl/" xmlns:fdl="http://www.ibm.com/workflow/2003" xmlns:bpws="http://schemas.xmlsoap.org/ws/2004/03/business-process/" xmlns:bpc="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/" xmlns:redirect="http://xml.apache.org/xalan/redirect" xmlns:xalan="http://xml.apache.org/xalan" xmlns:java="http://xml.apache.org/xalan/java" extension-element-prefixes="redirect xalan java" exclude-result-prefixes="fdl wsdls bpws bpc" version="1.0">
  <!--
    *************************************************************************

      Workfile: BPCSRVR/ws/code/workflow.fdl2bpel/src/com/ibm/bpe/fdl2bpel/converter/v62/xfdl2bpel_scdl.xsl, BPC.workflow, WBI70.BPCSRVR, of0950.12
      Last update: 09/01/14 03:58:21
      SCCS path, id: /family/botp/vc/13/4/8/5/s.59 1.12

    *************************************************************************
    BEGIN COPYRIGHT
    *************************************************************************

      IBM Confidential
      OCO Source Materials
      5655-FLW (C) Copyright IBM Corporation 2003, 2008.
      The source code for this program is not published or otherwise
      divested of its trade secrets, irrespective of what has been
      deposited with the U.S. Copyright Office.

    *************************************************************************
    END COPYRIGHT
  -->
  <!--
    *****************************************************************************************************************************
          Task:      Create SCDL files that belong to an SCA module
    *****************************************************************************************************************************
          Author: Jens Grotrian (jgr@de.ibm.com)
    *****************************************************************************************************************************
   -->
  <xsl:strip-space elements="*"/>
  <xsl:output method="xml" indent="yes" xalan:indent-amount="5"/>
  <!--************************************ -->
  <!--*        Configurable parameters   * -->
  <!--************************************ -->
  <!-- "fdlFileName": FDL file name -->
  <xsl:param name="fdlFileName" select="'unknown FDL file name'"/>
  <!-- "wsdlfile": path of target directory -->
  <xsl:param name="wsdlfile" select="''"/>
  <!-- "outputdir": path of target directory -->
  <xsl:param name="outputdir" select="''"/>
  <!-- "createUPESInvocations" (cp. LI754: Do not prepare process for reuse of UPES ) -->
  <xsl:param name="createUPESInvocations" select="'TRUE'"/>
  <!-- "create_SCA_UPES_IMPORTS_only" (cp. LI1195: Invocation of existing user-defined pgm execution servers in new BPEL processes) -->
  <xsl:param name="create_SCA_UPES_IMPORTS_only" select="'FALSE'"/>
  <!-- "LI1274_Support_inheritance_from_network_settings" -->
  <xsl:param name="LI1274_Support_inheritance_from_network_settings" select="'FALSE'"/>
  <!--************************** -->
  <!--*        Parameters         * -->
  <!--************************** -->
  <!-- "data-binding-suffix": Suffix appended to data binding names -->
  <xsl:param name="data-binding-suffix" select="'_DataBindingImpl'"/>
  <!-- "data-binding-package-name": package name of a data binding Java class -->
  <xsl:param name="data-binding-package-name" select="'com.ibm.workflow.sca.jms.data'"/>
  <!-- "reply-queue-suffix":  Suffix belonging to a JNDI JMS reply queue name -->
  <xsl:param name="reply-queue-suffix" select="'_REPLY'"/>
  <!-- "callback-queue-suffix":  Suffix belonging to a JNDI JMS callback queue name -->
  <xsl:param name="callback-queue-suffix" select="'_CALLBACK'"/>
  <!-- "native_XML_queue_name_prefix":  Prefix added to generated XML message target name if the message format is native XML -->
  <xsl:param name="native_XML_queue_name_prefix" select="''"/>
  <!-- "JMS_compliant_XML_queue_name_prefix":  Prefix added to generated XML message target name if the message format is JMS-compliant XML -->
  <xsl:param name="JMS_compliant_XML_queue_name_prefix" select="'JMS_'"/>
  <!-- "listener-port-name-suffix": Suffix appended to "listener port" names  -->
  <xsl:param name="listener-port-name-suffix" select="'_LP'"/>
  <!-- "destination-name-default":  default name of a messaging destination (queue) -->
  <xsl:param name="destination-name-default" select="'unknown-destination'"/>
  <!-- "connectionFactoryNameDefault":  -->
  <xsl:param name="connectionFactoryNameDefault" select="'FMCQM'"/>
  <!-- "maxBaseQueueNameLength" -->
  <xsl:param name="maxBaseQueueNameLength" select="48"/>
  <!-- "AsyncUpesClassName" contains the class name of the generic databinding for asynchronous UPES -->
  <xsl:param name="AsyncUpesClassName" select="'AsyncUPES'"/>
  <!--
    *** Parameters also used in stylesheet "xfdl2bpel_wsdl.xsl" ***
  -->
  <!-- "end of line" character string -->
  <xsl:param name="eol" select="java:java.lang.System.getProperty('line.separator')"/>
  <!-- "lower-case-characters": "aäbcdefghijklmnoöpqrstuüvwxyz" -->
  <xsl:param name="lower-case-characters" select="'aäbcdefghijklmnoöpqrstuüvwxyz'"/>
  <!-- "upper-case-characters": "AÄBCDEFGHIJKLMNOÖPQRSTUÜVWXYZ" -->
  <xsl:param name="upper-case-characters" select="'AÄBCDEFGHIJKLMNOÖPQRSTUÜVWXYZ'"/>
  <!-- "port-type-suffix": Suffix appended to "port type" names -->
  <xsl:param name="port-type-suffix" select="'_PT'"/>
  <!-- "UPES-output-message-suffix": Suffix appended to "UPES" output message names -->
  <xsl:param name="UPES-output-message-suffix" select="'_UPES_OUT_MSG'"/>
  <!--
    *** Parameters also used in stylesheet "xfdl2bpel_bpel.xsl" ***
  -->
  <!-- "partner-link-suffix": Suffix appended to "partner link" names -->
  <xsl:param name="partner-link-suffix" select="'_PL'"/>
  <!-- "Error" Message severity 1 -->
  <xsl:param name="Error" select="1"/>
  <!-- "Warning" Message severity 2 -->
  <xsl:param name="Warning" select="2"/>
  <!-- "Information" Message severity 3 -->
  <xsl:param name="Information" select="3"/>
  <!--************************** -->
  <!--*        Keys                   * -->
  <!--************************** -->
  <!--
    Key "program-activity-implemented-by-programExecutionUnit" represents a "mapping" between
    programExecutionUnit (UPES) (as "key objects") and program activities (as "value objects")
  -->
  <xsl:key name="program-activity-implemented-by-programExecutionUnit" match="fdl:programActivity" use="fdl:program/@programExecutionUnit"/>
  <!--
    Key "server-by-server-and-system-name" represents a "mapping" between  the concatenated names of server and related system (as "key objects") and server definitions (as "value objects")
  -->
  <xsl:key name="server-by-server-and-system-name" match="fdl:definitions/fdl:server
                                                                    | fdl:definitions/fdl:create/fdl:server
                                                                    | fdl:definitions/fdl:update/fdl:server
                                                                    | fdl:definitions/fdl:replace/fdl:server" use="concat(@name, fdl:relatedSystem/@name)"/>
  <!--
    *****************************************************************************************************************************
    Initial template
    *****************************************************************************************************************************
  -->
  <xsl:template match="/">
    <!-- Create component file for each FDL processes provided that user option "-u" (reuse UPES only) was not selected (cp. LI 1195: Invocation of existing user-defined pgm execution servers in new BPEL processes) -->
    <xsl:if test="not('TRUE' = translate($create_SCA_UPES_IMPORTS_only, $lower-case-characters, $upper-case-characters))">
      <xsl:apply-templates select="fdl:definitions/fdl:process |
                           fdl:definitions/fdl:create/fdl:process |
                           fdl:definitions/fdl:update/fdl:process |
                           fdl:definitions/fdl:replace/fdl:process" mode="component"/>
    </xsl:if>
    <!-- Create import file for each FDL UPES server if user option "-un" (no UPES migration) is not selected (cp. LI754 (Do not prepare process for reuse of UPES) -->
    <xsl:if test="'TRUE' = translate($createUPESInvocations, $lower-case-characters, $upper-case-characters)">
      <xsl:apply-templates select="fdl:definitions/fdl:server |
                           fdl:definitions/fdl:create/fdl:server |
                           fdl:definitions/fdl:update/fdl:server |
                           fdl:definitions/fdl:replace/fdl:server" mode="import"/>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "component" template:

    Translates "fdl:process" into scdl files with extension "component"
    Create iSCA "import" elements for a each descendant "fdl:programActivity" that invokes a UPES
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:process" mode="component">
    <xsl:variable name="scdlfile-local-name" select="concat(@name, '.component')"/>
    <xsl:variable name="scdlfile-path-name" select="concat($outputdir, $scdlfile-local-name)"/>
    <xsl:variable name="message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $scdlfile-local-name)"/>
    <xsl:variable name="addScdl" select="java:com.ibm.bpe.fdl2bpel.converter.ScdlList.add($scdlfile-path-name)"/>
    <redirect:write select="concat($outputdir, $scdlfile-local-name)">
      <scdl:component xmlns:wsdl="http://www.ibm.com/xmlns/prod/websphere/scdl/wsdl/6.0.0" xmlns:process="http://www.ibm.com/xmlns/prod/websphere/scdl/business-process/6.0.0" xmlns:ns1="http://www.ibm.com/xmlns/prod/websphere/mqwf/wsdl/" displayName="{@displayName}" name="{@name}">
        <xsl:variable name="process-local-name" select="concat(@name, '.bpel')"/>
        <xsl:variable name="process-path-name" select="concat($outputdir, $process-local-name)"/>
        <xsl:variable name="process-description" select="document($process-path-name)/bpws:process/bpc:description"/>
        <xsl:if test="$process-description">
          <description>
            <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
            <xsl:value-of select="$process-description" disable-output-escaping="yes"/>
            <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
          </description>
        </xsl:if>
        <interfaces>
          <interface portType="ns1:{@name}{$port-type-suffix}" preferredInteractionStyle="async" xsi:type="wsdl:WSDLPortType">
            <scdl:interfaceQualifier value="false" xsi:type="scdl:JoinTransaction"/>
            <method name="{@name}"/>
          </interface>
        </interfaces>
        <references>
          <!-- Create references for FDL process activities calling a subprocess -->
          <xsl:apply-templates select="descendant::fdl:processActivity[ fdl:process ]" mode="reference">
            <xsl:with-param name="process" select="current()"/>
          </xsl:apply-templates>
          <!-- User option "-un" (no UPES migration) is not selected (cp. LI754 (Do not prepare process for reuse of UPES) -->
          <xsl:if test="'TRUE' = translate($createUPESInvocations, $lower-case-characters, $upper-case-characters)">
            <!-- Create references for FDL server  -->
            <xsl:apply-templates select="//fdl:server
                        | //fdl:create/fdl:server
                        | //fdl:update/fdl:server
                        | //fdl:replace/fdl:server" mode="reference">
              <xsl:with-param name="process" select="current()"/>
            </xsl:apply-templates>
          </xsl:if>
        </references>
        <implementation xsi:type="process:ProcessImplementation">
          <scdl:implementationQualifier value="global" xsi:type="scdl:Transaction"/>
          <process bpel="/{@name}.bpel"/>
        </implementation>
      </scdl:component>
    </redirect:write>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "reference" template:
    Creates a "reference" element for each "fdl:processActivity" calling another process.
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:processActivity" mode="reference">
    <xsl:param name="process"/>
    <xsl:choose>
      <!-- CASE: late-bound process invocation (process name taken from container) -->
      <xsl:when test="fdl:process/fdl:dataStructureMemberName">
        <reference name="{@name}{$partner-link-suffix}">
          <interface portType="ns1:{@name}{$port-type-suffix}" xsi:type="wsdl:WSDLPortType">
            <method name="{@name}"/>
          </interface>
          <scdl:referenceQualifier value="commit" xsi:type="scdl:DeliverAsyncAt"/>
        </reference>
      </xsl:when>
      <xsl:otherwise>
        <xsl:if test="not( preceding::fdl:processActivity[ ancestor::fdl:process/@name =$process/@name and fdl:process/@name = current()/fdl:process/@name ] )">
          <reference name="{fdl:process/@name}{$partner-link-suffix}">
            <interface portType="ns1:{fdl:process/@name}{$port-type-suffix}" xsi:type="wsdl:WSDLPortType">
              <method name="{fdl:process/@name}"/>
            </interface>
            <scdl:referenceQualifier value="commit" xsi:type="scdl:DeliverAsyncAt"/>
          </reference>
        </xsl:if>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "reference" template:
    Creates a "reference" element for each "fdl:server" that is referred to by some program activity.
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:server" mode="reference">
    <xsl:param name="process"/>
    <xsl:variable name="related-system-name" select="fdl:relatedSystem/@name"/>
    <xsl:variable name="related-group-name" select="fdl:relatedGroup/@name"/>
    <!-- Create reference only if the server is referred to by some program activity contained in the process (if it is of type 'service invocation activity' -->
    <xsl:variable name="server-is-used-by-a-service-invocation-activity">
      <xsl:for-each select="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))[ @name = $process//fdl:programActivity/@name ]">
        <xsl:variable name="program-activity-type">
          <xsl:call-template name="program-activity-type">
            <xsl:with-param name="activity" select="current()"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:if test="$program-activity-type = 'service invocation activity'">
          <xsl:value-of select="'TRUE'"/>
        </xsl:if>
      </xsl:for-each>
    </xsl:variable>
    <xsl:if test="contains($server-is-used-by-a-service-invocation-activity, 'TRUE')">
      <xsl:variable name="partner-link-name" select="concat($related-system-name, '_', @name, $partner-link-suffix)"/>
      <xsl:variable name="port-type-name" select="concat($related-system-name, '_', @name, $port-type-suffix)"/>
      <xsl:variable name="port-type" select="document($wsdlfile)/wsdls:definitions/wsdls:portType[ @name =$port-type-name ]"/>
      <!-- Create the "reference" -->
      <reference name="{$partner-link-name}">
        <interface portType="ns1:{$port-type-name}" xsi:type="wsdl:WSDLPortType">
          <xsl:for-each select="$port-type/wsdls:operation">
            <method name="{@name}"/>
          </xsl:for-each>
        </interface>
        <scdl:referenceQualifier value="commit" xsi:type="scdl:DeliverAsyncAt"/>
        <wire target="{$related-system-name}_{@name}"/>
      </reference>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "import" template:
    Create SCDL IMPORT for a each "fdl:server" that represents an UPES
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:server" mode="import">
    <xsl:variable name="related-system-name" select="fdl:relatedSystem/@name"/>
    <xsl:variable name="related-group-name" select="fdl:relatedGroup/@name"/>
    <!-- Create SCDL IMPORT only if the server is referred to by some program activity of type 'service invocation activity' (UPES) -->
    <xsl:variable name="server-is-used-by-a-service-invocation-activity">
      <xsl:for-each select="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))">
        <xsl:variable name="program-activity-type">
          <xsl:call-template name="program-activity-type">
            <xsl:with-param name="activity" select="current()"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:if test="$program-activity-type = 'service invocation activity'">
          <xsl:value-of select="'TRUE'"/>
        </xsl:if>
      </xsl:for-each>
    </xsl:variable>
    <xsl:if test="contains($server-is-used-by-a-service-invocation-activity, 'TRUE')">
      <xsl:variable name="port-type-name" select="concat($related-system-name, '_', @name, $port-type-suffix)"/>
      <xsl:variable name="port-type" select="document($wsdlfile)/wsdls:definitions/wsdls:portType[ @name =$port-type-name ]"/>
      <xsl:variable name="connectionFactoryName">
        <xsl:choose>
          <xsl:when test="fdl:userDefinedProgramExecutionServer/@queueManagerName">
            <xsl:value-of select="fdl:userDefinedProgramExecutionServer/@queueManagerName"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$connectionFactoryNameDefault"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:variable name="send-queue-name">
        <xsl:choose>
          <xsl:when test="fdl:userDefinedProgramExecutionServer/@physicalQueueName">
            <xsl:choose>
              <xsl:when test="fdl:userDefinedProgramExecutionServer/@messageFormat='JMS_XML'">
                <xsl:value-of select="concat($JMS_compliant_XML_queue_name_prefix, fdl:userDefinedProgramExecutionServer/@physicalQueueName)"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="concat($native_XML_queue_name_prefix, fdl:userDefinedProgramExecutionServer/@physicalQueueName)"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$destination-name-default"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <!-- FG: added variable that hold the target-client type depending on the messageFormat
                   JMS_...  ==> target-client-type = JMS   otherwise   = MQ
      -->
      <xsl:variable name="target-client-type">
        <xsl:choose>
          <xsl:when test="'TRUE'=starts-with($send-queue-name,$JMS_compliant_XML_queue_name_prefix)">
            <xsl:value-of select="'JMS'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'MQ'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:variable name="reply-queue-name" select="concat($send-queue-name, $reply-queue-suffix)"/>
      <xsl:variable name="scdlfile-local-name" select="concat($related-system-name, '_', @name, '.import')"/>
      <xsl:variable name="scdlfile-path-name" select="concat($outputdir, $scdlfile-local-name)"/>
      <xsl:variable name="message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $scdlfile-local-name)"/>
      <xsl:variable name="addScdl" select="java:com.ibm.bpe.fdl2bpel.converter.ScdlList.add($scdlfile-path-name)"/>
      <redirect:write select="concat($outputdir, $scdlfile-local-name)">
        <scdl:import xmlns:wsdl="http://www.ibm.com/xmlns/prod/websphere/scdl/wsdl/6.0.0" xmlns:ns1="http://www.ibm.com/xmlns/prod/websphere/mqwf/wsdl/" xmlns:mqjms="http://www.ibm.com/xmlns/prod/websphere/scdl/mqjms/6.0.0" displayName="{$related-system-name}_{@name}" name="{$related-system-name}_{@name}">
          <!-- Create the "interfaces" element -->
          <interfaces>
            <interface preferredInteractionStyle="async" portType="ns1:{$port-type/@name}" xsi:type="wsdl:WSDLPortType">
              <xsl:for-each select="$port-type/wsdls:operation">
                <method name="{@name}"/>
              </xsl:for-each>
            </interface>
          </interfaces>
          <esbBinding responseCorrelationScheme="RequestMsgIDToCorrelID" xsi:type="mqjms:MQJMSImportBinding">
            <outboundConnection>
              <mqConfiguration>
                <queueManager>
                  <xsl:value-of select="$connectionFactoryName"/>
                </queueManager>
              </mqConfiguration>
            </outboundConnection>
            <responseListener/>
            <send targetClient="{$target-client-type}" type="javax.jms.Queue">
              <xsl:if test="string-length($send-queue-name) &gt; $maxBaseQueueNameLength">
                <!--COMMENT: *** CWWBMnnnnE: The base queue name "nn" exceeds the maximum length of <number> characters".   *** -->
                <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'BaseQueueNameTooLong', $send-queue-name, $maxBaseQueueNameLength), ' *** --&gt;', $eol)"/>
              </xsl:if>
              <baseName>
                <xsl:value-of select="$send-queue-name"/>
              </baseName>
            </send>
            <receive targetClient="{$target-client-type}" type="javax.jms.Queue">
              <xsl:if test="string-length($reply-queue-name) &gt; $maxBaseQueueNameLength">
                <!--COMMENT: *** CWWBMnnnnE: The base queue name "nn" exceeds the maximum length of <number> characters".   *** -->
                <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'BaseQueueNameTooLong', $reply-queue-name, $maxBaseQueueNameLength), ' *** --&gt;', $eol)"/>
              </xsl:if>
              <baseName>
                <xsl:value-of select="$reply-queue-name"/>
              </baseName>
            </receive>
            <xsl:for-each select="$port-type/wsdls:operation">
              <xsl:variable name="message-name" select="substring-after(current()/wsdls:output/@message, ':')"/>
              <!--
                  FG: In case of an asynchronous port-type definition there is no wsdls:output element available.
                                    So a generic DatabindingImpl class is used for asynchronous UPES invocation.
              -->
              <xsl:variable name="class-name">
                <xsl:choose>
                  <xsl:when test="current()/wsdls:output/@message">
                    <xsl:value-of select="concat(translate(substring($message-name, 1, 1), $lower-case-characters, $upper-case-characters), substring($message-name, 2))"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="$AsyncUpesClassName"/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:variable>
              <xsl:variable name="data-binding-type" select="concat($data-binding-package-name, '.', $class-name, $data-binding-suffix)"/>
              <methodBinding outDataBindingType="{$data-binding-type}" inDataBindingType="{$data-binding-type}" method="{@name}"/>
            </xsl:for-each>
          </esbBinding>
        </scdl:import>
      </redirect:write>
    </xsl:if>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "program-activity-type":

    Determines the type of an FDL program activity.
    Selects from types "empty activity", "service invocation activity" (UPES activity),  "staff activity",
    "assumed staff activity"
    NOTE THAT THIS TEMPLATE IS SHARED IN:
      "XFDLBPEL_ANALYZE.XSL", "XFDLBPEL_XSD.XSL", "XFDLBPEL_WSDL.XSL", "XFDLBPEL_BPEL.XSL"
    ****************************************************************************************************************
   -->
  <xsl:template name="program-activity-type">
    <xsl:param name="activity"/>
    <xsl:param name="server-may-be-missing" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;program-activity-type&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="domain" select="//fdl:domain[1]"/>
    <xsl:variable name="system-group" select="//fdl:group[1]"/>
    <xsl:variable name="primary-system" select="//fdl:system[ @primarySystem ='yes' ][1]"/>
    <!-- Note that the following variables will contain appropriate values for "service invocation activities" (UPES) only -->
    <xsl:variable name="program-execution-unit" select="$activity/fdl:program/@programExecutionUnit"/>
    <xsl:variable name="server-name" select="substring-before($program-execution-unit, '.')"/>
    <xsl:variable name="related-system-name" select="substring-before(substring-after($program-execution-unit, concat($server-name, '.')), '.')"/>
    <xsl:variable name="server-and-system-name" select="concat($server-name, $related-system-name)"/>
    <xsl:choose>
      <!--
        CASE: "empty activity"
          A program activity is an "empty activity" if
          1) if the activity implementation is a program with the name FMCINTERNALNOOP
          2) the execution mode is chained
          3) the input and output data structures are the same
      -->
      <xsl:when test="$activity/fdl:program/@name='FMCINTERNALNOOP'
                and $activity/fdl:program/@synchronization='chained'
                and $activity/fdl:input/@type = $activity/fdl:output/@type">
        <xsl:value-of select="'empty activity'"/>
      </xsl:when>
      <!--
        CASE: "service invocation activity"
          A program activity is an "service invocation activity" if a user-defined program execution server
          (UPES) is specified (attribute "fdl:program/@programExecutionUnit").
      -->
      <xsl:when test="$activity/fdl:program/@programExecutionUnit
                  and (key('server-by-server-and-system-name', $server-and-system-name)[1]/fdl:userDefinedProgramExecutionServer or $server-may-be-missing = 'true')">
        <xsl:choose>
          <!-- CASE: User option "-un" (no UPES migration) is selected (cp. LI754 (Do not prepare process for reuse of UPES) -->
          <xsl:when test="'TRUE' = translate($createUPESInvocations, $lower-case-characters, $upper-case-characters)">
            <xsl:value-of select="'service invocation activity'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'empty activity'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!--
        CASE: "staff activity"
          A program activity is a "staff activity" if the following conditions apply:
          1. Start type is "manual"
          2. Attribute "checkoutPossible" indicates that it can be checked out from the runtime database.
      -->
      <xsl:when test="$activity/fdl:join/@startType='manual'
                  and ( $activity/fdl:defaultSetting/@checkoutPossible='yes'
                       or (  not($activity/fdl:defaultSetting/@checkoutPossible='no')
                          and (   $activity/ancestor::fdl:process/fdl:activityDefaultSetting/@checkoutPossible='yes'
                              or (   'TRUE' = translate($LI1274_Support_inheritance_from_network_settings, $lower-case-characters, $upper-case-characters)
                                  and not($activity/ancestor::fdl:process/fdl:activityDefaultSetting/@checkoutPossible='no')
                                  and (  $primary-system/fdl:activityDefaultSetting/@checkoutPossible='yes'
                                      or (  not($primary-system/fdl:activityDefaultSetting/@checkoutPossible='no')
                                          and (   $system-group/fdl:activityDefaultSetting/@checkoutPossible='yes'
                                              or (  not($system-group/fdl:activityDefaultSetting/@checkoutPossible='no')
                                                  and $domain/fdl:activityDefaultSetting/@checkoutPossible='yes' ) ) ) ) ) ) ) )">
        <xsl:value-of select="'staff activity'"/>
      </xsl:when>
      <!--
        OTHERWISE: "unclassified activity"
          A program activity is an "unclassified activity" if none of the above rules apply.
          In this case assume a "staff activity".
      -->
      <xsl:otherwise>
        <xsl:value-of select="'assumed staff activity'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:transform>
