<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform xmlns="http://schemas.xmlsoap.org/wsdl/" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:process="http://schemas.xml.org/wsdl/process/" xmlns:plnk="http://schemas.xmlsoap.org/ws/2004/03/partner-link/" xmlns:jms="http://schemas.xmlsoap.org/wsdl/jms/" xmlns:format="http://schemas.xmlsoap.org/wsdl/formatbinding/" xmlns:fdl="http://www.ibm.com/workflow/2003" xmlns:xalan="http://xml.apache.org/xalan" xmlns:java="http://xml.apache.org/xalan/java" extension-element-prefixes="xalan java" exclude-result-prefixes="fdl" version="1.0">
  <!--
    *************************************************************************

      Workfile: BPCSRVR/ws/code/workflow.fdl2bpel/src/com/ibm/bpe/fdl2bpel/converter/v62/xfdl2bpel_wsdl.xsl, BPC.workflow, WBI70.BPCSRVR, of0950.12
      Last update: 09/01/14 03:58:57
      SCCS path, id: /family/botp/vc/13/4/8/5/s.60 1.14

    *************************************************************************
    BEGIN COPYRIGHT
    *************************************************************************

      IBM Confidential
      OCO Source Materials
      5655-FLW (C) Copyright IBM Corporation 2003, 2008.
      The source code for this program is not published or otherwise
      divested of its trade secrets, irrespective of what has been
      deposited with the U.S. Copyright Office.

    *************************************************************************
    END COPYRIGHT
  -->
  <!--
    *****************************************************************************************************************************
          Task:      Create a WSDL file that containes the required service informations for a business process
    *****************************************************************************************************************************
          Author: Jens Grotrian (jgr@de.ibm.com)
    *****************************************************************************************************************************
   -->
  <xsl:strip-space elements="*"/>
  <xsl:output method="xml" indent="yes" xalan:indent-amount="5"/>
  <!--************************************ -->
  <!--*        Configurable parameters   * -->
  <!--************************************ -->
  <!-- "fdlFileName": FDL file name -->
  <xsl:param name="fdlFileName" select="'unknown FDL file name'"/>
  <!-- "xsdfile": XMLSchema definition file for FDL data types -->
  <xsl:param name="xsdfile"/>
  <!-- "outputdir": path of target directory -->
  <xsl:param name="outputdir" select="''"/>
  <!-- "createPredefinedDataMembers": Create the predefined MQWF data structure members -->
  <xsl:param name="createPredefinedDataMembers" select="'TRUE'"/>
  <!-- "targetPackageXMLSchema": used for the creation of format type maps -->
  <xsl:param name="targetPackageXMLSchema" select="'com.ibm.www.workflow.schema'"/>
  <!-- "createUPESInvocations" (cp. LI754: Do not prepare process for reuse of UPES ) -->
  <xsl:param name="createUPESInvocations" select="'TRUE'"/>
  <!-- "create_SCA_UPES_IMPORTS_only" (cp. LI1195: Invocation of existing user-defined pgm execution servers in new BPEL processes) -->
  <xsl:param name="create_SCA_UPES_IMPORTS_only" select="'FALSE'"/>
  <!-- "LI1274_Support_inheritance_from_network_settings" -->
  <xsl:param name="LI1274_Support_inheritance_from_network_settings" select="'FALSE'"/>
  <!--************************************ -->
  <!--*        Global parameters             * -->
  <!--************************************ -->
  <!-- "end of line" character string -->
  <xsl:param name="eol" select="java:java.lang.System.getProperty('line.separator')"/>
  <!-- element-input-name -->
  <xsl:param name="element-input-name" select="'input1'"/>
  <!-- element-output-name -->
  <xsl:param name="element-output-name" select="'output1'"/>
  <!-- activity-status-message-name   -->
  <xsl:param name="activity-status-message-name" select="'ActivityStatus'"/>
  <!--"activity-status-part-name": Part name used in status "variables" -->
  <xsl:param name="activity-status-part-name" select="'ActivityStatus'"/>
  <!-- message-part-name -->
  <xsl:param name="message-part-name" select="'Part1'"/>
  <!-- operation-fault-name -->
  <xsl:param name="operation-fault-name" select="'fault1'"/>
  <!-- UPES-message-part-name -->
  <xsl:param name="UPES-message-part-name" select="'Container'"/>
  <!-- "message-suffix": Suffix appended to "standard" message names  -->
  <xsl:param name="message-suffix" select="'_MSG'"/>
  <!-- "port-type-suffix": Suffix appended to "port type" names -->
  <xsl:param name="port-type-suffix" select="'_PT'"/>
  <!-- "operation-input-name-suffix": Suffix appended to "operation" input names  -->
  <xsl:param name="operation-input-name-suffix" select="'_Request'"/>
  <!-- "operation-output-name-suffix": Suffix appended to "operation" output names -->
  <xsl:param name="operation-output-name-suffix" select="'_Response'"/>
  <!-- "request-suffix": Suffix appended to request messages  -->
  <xsl:param name="request-suffix" select="'_Request'"/>
  <!-- "response-suffix": Suffix appended to response messages  -->
  <xsl:param name="response-suffix" select="'_Response'"/>
  <!-- "UPES-suffix": Suffix appended to UPES operations and UPES related XMLSchema elements -->
  <xsl:param name="UPES-suffix" select="'_UPES'"/>
  <!-- "UPES-request-suffix": Suffix appended to UPES request messages  -->
  <xsl:param name="UPES-request-suffix" select="'_Request_UPES'"/>
  <!-- "UPES-response-suffix": Suffix appended to UPES response messages  -->
  <xsl:param name="UPES-response-suffix" select="'_Response_UPES'"/>
  <!-- "UPES-fault-suffix": Suffix appended to UPES fault messages  -->
  <xsl:param name="UPES-fault-suffix" select="'_Fault_UPES'"/>
  <!-- "global-container-suffix": Suffix appended to global container messages and element definitions-->
  <xsl:param name="global-container-suffix" select="'_GC'"/>
  <!-- "partner-link-type-suffix": Suffix appended to "partner link type" names -->
  <xsl:param name="partner-link-type-suffix" select="'_PLT'"/>
  <!-- "role-suffix": Suffix appended to role names   -->
  <xsl:param name="role-suffix" select="'_Role'"/>
  <!-- "Error" Message severity 1 -->
  <xsl:param name="Error" select="1"/>
  <!-- "Warning" Message severity 2 -->
  <xsl:param name="Warning" select="2"/>
  <!-- "Information" Message severity 3 -->
  <xsl:param name="Information" select="3"/>
  <!--
    *** Parameters also used in stylesheet "xfdl2bpel_xsdl.xsl" ***
  -->
  <!-- "lower-case-characters": "aäbcdefghijklmnoöpqrstuüvwxyz" -->
  <xsl:param name="lower-case-characters" select="'aäbcdefghijklmnoöpqrstuüvwxyz'"/>
  <!-- "Upper-case-characters": "AÄBCDEFGHIJKLMNOÖPQRSTUÜVWXYZ" -->
  <xsl:param name="upper-case-characters" select="'AÄBCDEFGHIJKLMNOÖPQRSTUÜVWXYZ'"/>
  <!-- "message-type-suffix": Suffix appended to message type names  -->
  <xsl:param name="message-type-suffix" select="'_MT'"/>
  <!-- "UPES-input-message-type-suffix": Suffix appended to UPES input message type names -->
  <xsl:param name="UPES-input-message-type-suffix" select="'_UPES_IN_MT'"/>
  <!-- "UPES-output-message-type-suffix": Suffix appended to UPES output message type names -->
  <xsl:param name="UPES-output-message-type-suffix" select="'_UPES_OUT_MT'"/>
  <!-- "global-container-message-type-suffix": Suffix appended to message type names that specify a "global container" -->
  <xsl:param name="global-container-message-type-suffix" select="'_GC_MT'"/>
  <!--************************** -->
  <!--*        Keys                   * -->
  <!--************************** -->
  <!--
    Key "program-activity-implemented-by-program" represents a "mapping" between
    program names (as "key objects") and program activities (as "value objects")
  -->
  <xsl:key name="program-activity-implemented-by-program" match="fdl:programActivity" use="fdl:program/@name"/>
  <!--
    Key "program-activity-implemented-by-programExecutionUnit" represents a "mapping" between
    programExecutionUnit (UPES) (as "key objects") and program activities (as "value objects")
  -->
  <xsl:key name="program-activity-implemented-by-programExecutionUnit" match="fdl:programActivity" use="fdl:program/@programExecutionUnit"/>
  <!--
    Key "server-by-server-and-system-name" represents a "mapping" between  the concatenated names of server and related system (as "key objects") and server definitions (as "value objects")
  -->
  <xsl:key name="server-by-server-and-system-name" match="fdl:definitions/fdl:server
                                                                    | fdl:definitions/fdl:create/fdl:server
                                                                    | fdl:definitions/fdl:update/fdl:server
                                                                    | fdl:definitions/fdl:replace/fdl:server" use="concat(@name, fdl:relatedSystem/@name)"/>
  <!--************************** -->
  <!--*        Templates           *-->
  <!--************************** -->
  <!--
    *****************************************************************************************************************************
    Initial template
    *****************************************************************************************************************************
  -->
  <xsl:template match="/">
    <!-- Create WSDL definitions  -->
    <xsl:apply-templates select="fdl:definitions" mode="wsdl-definitions"/>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "wsdl-definitions" template:

    Translates "fdl:definitions" into "wsdl:definitions".
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:definitions" mode="wsdl-definitions">
    <definitions xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:mqwf="http://www.ibm.com/xmlns/prod/websphere/mqwf/schema/" xmlns:wsdl1="http://www.ibm.com/xmlns/prod/websphere/mqwf/wsdl/" targetNamespace="http://www.ibm.com/xmlns/prod/websphere/mqwf/wsdl/">
      <!--
        Import shared data type definitions (derived from FDL data structures)
      -->
      <!-- Create comment: *** Import message type definitions *** -->
      <xsl:value-of select="concat($eol, '&lt;!-- *** Import message type definitions *** --&gt;', $eol)" disable-output-escaping="yes"/>
      <xsl:variable name="xsdfile-local-name" select="substring-after($xsdfile, $outputdir)"/>
      <types>
        <xsd:schema targetNamespace="http://www.ibm.com/xmlns/prod/websphere/mqwf/wsdl/">
          <xsd:import namespace="http://www.ibm.com/xmlns/prod/websphere/mqwf/schema/" schemaLocation="{$xsdfile-local-name}"/>
          <!--
              Create XMLSchema elements
          -->
          <!-- Create comment: *** XMLSchema elements *** -->
          <xsl:value-of select="concat($eol, '&lt;!-- *** XMLSchema elements *** --&gt;', $eol)" disable-output-escaping="yes"/>
          <!--
            Create WSDL definitions for processes and activitiies provided that user option "-u" (reuse UPES only) was not selected
            (cp. LI 1195: Invocation of existing user-defined pgm execution servers in new BPEL processes)
          -->
          <xsl:if test="not('TRUE' = translate($create_SCA_UPES_IMPORTS_only, $lower-case-characters, $upper-case-characters))">
            <!-- Create XMLSchema elements for FDL processes -->
            <xsl:apply-templates select="fdl:process | fdl:create/fdl:process | fdl:update/fdl:process | fdl:replace/fdl:process" mode="elements"/>
            <!-- Create XMLSchema elements for FDL process activities -->
            <xsl:apply-templates select="//fdl:processActivity" mode="elements"/>
            <!-- Create XMLSchema elements for FDL block activities -->
            <xsl:apply-templates select="//fdl:block" mode="elements"/>
            <!-- Create XMLSchema elements for FDL program activities -->
            <xsl:apply-templates select="//fdl:programActivity" mode="elements"/>
          </xsl:if>
          <!-- Create XMLSchema elements for FDL servers if user option "-un" (no UPES migration) is not selected (cp. LI754 (Do not prepare process for reuse of UPES) -->
          <xsl:if test="'TRUE' = translate($createUPESInvocations, $lower-case-characters, $upper-case-characters)">
            <xsl:apply-templates select="fdl:server
                        | fdl:create/fdl:server
                        | fdl:update/fdl:server
                        | fdl:replace/fdl:server" mode="elements"/>
          </xsl:if>
        </xsd:schema>
      </types>
      <!--
        Create Messages
      -->
      <!-- Create comment: *** Messages *** -->
      <xsl:value-of select="concat($eol, '&lt;!-- *** Messages *** --&gt;', $eol)" disable-output-escaping="yes"/>
      <xsl:if test="not('TRUE' = translate($create_SCA_UPES_IMPORTS_only, $lower-case-characters, $upper-case-characters))">
        <!-- Create WSDL messages for FDL processes -->
        <xsl:apply-templates select="fdl:process | fdl:create/fdl:process | fdl:update/fdl:process | fdl:replace/fdl:process" mode="messages"/>
        <!-- Create WSDL messages for FDL process activities -->
        <xsl:apply-templates select="//fdl:processActivity" mode="messages"/>
        <!-- Create WSDL messages for FDL block activities -->
        <xsl:apply-templates select="//fdl:block" mode="messages"/>
        <!-- Create WSDL messages for FDL program activities -->
        <xsl:apply-templates select="//fdl:programActivity" mode="messages"/>
      </xsl:if>
      <!-- Create WSDL messages for FDL servers if user option "-un" (no UPES migration) is not selected (cp. LI754 (Do not prepare process for reuse of UPES) -->
      <xsl:if test="'TRUE' = translate($createUPESInvocations, $lower-case-characters, $upper-case-characters)">
        <xsl:apply-templates select="fdl:server
                        | fdl:create/fdl:server
                        | fdl:update/fdl:server
                        | fdl:replace/fdl:server" mode="messages"/>
      </xsl:if>
      <xsl:if test="not('TRUE' = translate($create_SCA_UPES_IMPORTS_only, $lower-case-characters, $upper-case-characters))">
        <!-- Create another auxiliary message used for loop control -->
        <message name="{$activity-status-message-name}{$message-suffix}">
          <part type="xsd:string" name="{$message-part-name}"/>
        </message>
      </xsl:if>
      <!--
        Create port types
      -->
      <!-- Create comment: *** Port types *** -->
      <xsl:value-of select="concat($eol, '&lt;!-- *** Port types *** --&gt;', $eol)" disable-output-escaping="yes"/>
      <xsl:if test="not('TRUE' = translate($create_SCA_UPES_IMPORTS_only, $lower-case-characters, $upper-case-characters))">
        <!-- Create port types for FDL processes -->
        <xsl:apply-templates select="fdl:process | fdl:create/fdl:process | fdl:update/fdl:process | fdl:replace/fdl:process" mode="port-types"/>
        <!-- Create port types for FDL process activities calling a late-bound subprocess -->
        <xsl:apply-templates select="//fdl:processActivity[ fdl:process/fdl:dataStructureMemberName/fdl:nameComponent ]" mode="port-types"/>
        <!-- Create port types for applications (fdl:program) called by FDL program activities -->
        <xsl:apply-templates select="fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]
                        | fdl:create/fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]
                        | fdl:update/fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]
                        | fdl:replace/fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]" mode="port-types"/>
      </xsl:if>
      <!--
        Create port types for UPES server definition (fdl:server) that is referenced by FDL program activities provided that
        user option "-un" (no UPES migration) is not selected (cp. LI754 (Do not prepare process for reuse of UPES)
      -->
      <xsl:if test="'TRUE' = translate($createUPESInvocations, $lower-case-characters, $upper-case-characters)">
        <xsl:apply-templates select="fdl:server
                        | fdl:create/fdl:server
                        | fdl:update/fdl:server
                        | fdl:replace/fdl:server" mode="port-types"/>
      </xsl:if>
      <!--
          Create partner link types
      -->
      <!-- Create comment: *** Partner link types *** -->
      <xsl:value-of select="concat($eol, '&lt;!-- *** Partner link types *** --&gt;', $eol)" disable-output-escaping="yes"/>
      <xsl:if test="not('TRUE' = translate($create_SCA_UPES_IMPORTS_only, $lower-case-characters, $upper-case-characters))">
        <!-- Create partner link types for FDL processes -->
        <xsl:apply-templates select="fdl:process | fdl:create/fdl:process | fdl:update/fdl:process | fdl:replace/fdl:process" mode="partner-link-types"/>
        <!-- Create partner link types for FDL process activities calling a late-bound subprocess -->
        <xsl:apply-templates select="//fdl:processActivity[ fdl:process/fdl:dataStructureMemberName/fdl:nameComponent ]" mode="partner-link-types"/>
        <!-- Create partner link types for applications called by FDL program activities -->
        <xsl:apply-templates select="fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]
                        | fdl:create/fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]
                        | fdl:update/fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]
                        | fdl:replace/fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]" mode="partner-link-types"/>
      </xsl:if>
      <!--
        Create partner link types for UPES servers called by FDL program activities provided that user option "-un"
        (no UPES migration) is not selected (cp. LI754 (Do not prepare process for reuse of UPES)
      -->
      <xsl:if test="'TRUE' = translate($createUPESInvocations, $lower-case-characters, $upper-case-characters)">
        <xsl:apply-templates select="fdl:server | fdl:create/fdl:server | fdl:update/fdl:server | fdl:replace/fdl:server" mode="partner-link-types"/>
      </xsl:if>
    </definitions>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "messages" template:

    Translates the input/output of an FDL process into "wsdl:element" definitions
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:process" mode="elements">
    <!-- Create comment: XMLSchema element belonging to request message of process "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- XMLSchema element belonging to request message of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsd:element name="{@name}">
      <xsd:complexType>
        <xsd:sequence>
          <xsl:choose>
            <xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
              <xsd:element type="mqwf:{fdl:input/@type}{$message-type-suffix}" nillable="true" name="{$element-input-name}"/>
            </xsl:when>
            <xsl:otherwise>
              <xsd:element type="mqwf:{fdl:input/@type}" nillable="true" name="{$element-input-name}"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsd:sequence>
      </xsd:complexType>
    </xsd:element>
    <!-- Create comment: XMLSchema element belonging to response message of process "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- XMLSchema element belonging to response message of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsd:element name="{@name}{$response-suffix}">
      <xsd:complexType>
        <xsd:sequence>
          <xsl:choose>
            <xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
              <xsd:element type="mqwf:{fdl:output/@type}{$message-type-suffix}" nillable="true" name="{$element-output-name}"/>
            </xsl:when>
            <xsl:otherwise>
              <xsd:element type="mqwf:{fdl:output/@type}" nillable="true" name="{$element-output-name}"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsd:sequence>
      </xsd:complexType>
    </xsd:element>
    <xsl:if test="fdl:globalContainer/@type">
      <!-- Create comment: XMLSchema element belonging to "Global Container" message of process "nnn" -->
      <xsl:value-of select="concat($eol, '&lt;!-- XMLSchema element belonging to &quot;Global Container&quot; message of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
      <xsd:element name="{@name}{$global-container-suffix}">
        <xsd:complexType>
          <xsd:sequence>
            <xsl:choose>
              <xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
                <xsd:element type="mqwf:{fdl:globalContainer/@type}{$global-container-message-type-suffix}" nillable="true" name="{$element-input-name}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsd:element type="mqwf:{fdl:globalContainer/@type}" nillable="true" name="{$element-input-name}"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsd:sequence>
        </xsd:complexType>
      </xsd:element>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "messages" template:

    Translates the input/output of an FDL process activity into "wsdl:element" definitions
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:processActivity" mode="elements">
    <!-- Create comment: XMLSchema element belonging to request message of process activity"nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- XMLSchema element belonging to request message of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsd:element name="{@name}">
      <xsd:complexType>
        <xsd:sequence>
          <xsl:choose>
            <xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
              <xsd:element type="mqwf:{fdl:input/@type}{$message-type-suffix}" nillable="true" name="{$element-input-name}"/>
            </xsl:when>
            <xsl:otherwise>
              <xsd:element type="mqwf:{fdl:input/@type}" nillable="true" name="{$element-input-name}"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsd:sequence>
      </xsd:complexType>
    </xsd:element>
    <!-- Create comment: XMLSchema element belonging to response message of process activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- XMLSchema element belonging to response message of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsd:element name="{@name}{$response-suffix}">
      <xsd:complexType>
        <xsd:sequence>
          <xsl:choose>
            <xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
              <xsd:element type="mqwf:{fdl:output/@type}{$message-type-suffix}" nillable="true" name="{$element-output-name}"/>
            </xsl:when>
            <xsl:otherwise>
              <xsd:element type="mqwf:{fdl:output/@type}" nillable="true" name="{$element-output-name}"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsd:sequence>
      </xsd:complexType>
    </xsd:element>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "messages" template:

    Translates the input/output of an FDL block activity into "wsdl:element" definitions
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:block" mode="elements">
    <!-- Create comment: XMLSchema element belonging to request message of block activity"nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- XMLSchema element belonging to request message of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsd:element name="{@name}">
      <xsd:complexType>
        <xsd:sequence>
          <xsl:choose>
            <xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
              <xsd:element type="mqwf:{fdl:input/@type}{$message-type-suffix}" nillable="true" name="{$element-input-name}"/>
            </xsl:when>
            <xsl:otherwise>
              <xsd:element type="mqwf:{fdl:input/@type}" nillable="true" name="{$element-input-name}"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsd:sequence>
      </xsd:complexType>
    </xsd:element>
    <!-- Create comment: XMLSchema element belonging to response message of block activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- XMLSchema element belonging to response message of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsd:element name="{@name}{$response-suffix}">
      <xsd:complexType>
        <xsd:sequence>
          <xsl:choose>
            <xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
              <xsd:element type="mqwf:{fdl:output/@type}{$message-type-suffix}" nillable="true" name="{$element-output-name}"/>
            </xsl:when>
            <xsl:otherwise>
              <xsd:element type="mqwf:{fdl:output/@type}" nillable="true" name="{$element-output-name}"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsd:sequence>
      </xsd:complexType>
    </xsd:element>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "messages" template:

    Translates the input/output of an FDL program activity into "wsdl:element" definitions
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:programActivity" mode="elements">
    <!-- Create comment: XMLSchema element belonging to request message of program activity"nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- XMLSchema element belonging to request message of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsd:element name="{@name}">
      <xsd:complexType>
        <xsd:sequence>
          <xsl:choose>
            <xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
              <xsd:element type="mqwf:{fdl:input/@type}{$message-type-suffix}" nillable="true" name="{$element-input-name}"/>
            </xsl:when>
            <xsl:otherwise>
              <xsd:element type="mqwf:{fdl:input/@type}" nillable="true" name="{$element-input-name}"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsd:sequence>
      </xsd:complexType>
    </xsd:element>
    <!-- Create comment: XMLSchema element belonging to response message of program activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- XMLSchema element belonging to response message of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsd:element name="{@name}{$response-suffix}">
      <xsd:complexType>
        <xsd:sequence>
          <xsl:choose>
            <xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
              <xsd:element type="mqwf:{fdl:output/@type}{$message-type-suffix}" nillable="true" name="{$element-output-name}"/>
            </xsl:when>
            <xsl:otherwise>
              <xsd:element type="mqwf:{fdl:output/@type}" nillable="true" name="{$element-output-name}"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsd:sequence>
      </xsd:complexType>
    </xsd:element>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "messages" template:

    Translates the input/output/fault of an FDL "UPES" into "wsdl:element" definitions
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:server" mode="elements">
    <xsl:variable name="related-system-name" select="fdl:relatedSystem/@name"/>
    <xsl:variable name="related-group-name" select="fdl:relatedGroup/@name"/>
    <xsl:variable name="server-name" select="@name"/>
    <!-- Create elements only if the server is referred to by some program activity of type 'service invocation activity' -->
    <xsl:if test="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))">
      <!--
          Create WSDL messages for each "fdl:programActivity" that is implemented by "fdl:server".
      -->
      <xsl:for-each select="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))">
        <xsl:variable name="program-activity-type">
          <xsl:call-template name="program-activity-type">
            <xsl:with-param name="activity" select="current()"/>
          </xsl:call-template>
        </xsl:variable>
        <!-- Create WSDL elements only if the program activity is of type "service invocation activity" -->
        <xsl:if test="$program-activity-type = 'service invocation activity'">
          <xsl:variable name="UPES-execution-mode">
            <xsl:call-template name="UPES-execution-mode">
              <xsl:with-param name="activity" select="current()"/>
            </xsl:call-template>
          </xsl:variable>
          <!-- Create comment: XMLSchema element belonging to UPES request message of program activity"nnn" invoking server "nnn" of system "nnn" -->
          <xsl:value-of select="concat($eol, '&lt;!-- XMLSchema element belonging to UPES request message of program activity &quot;', current()/@name, '&quot; invoking server &quot;', $server-name, '&quot; of system &quot;', $related-system-name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
          <xsd:element name="{current()/@name}{$UPES-suffix}">
            <xsd:complexType>
              <xsd:sequence>
                <xsl:choose>
                  <!-- CASE: data structures of input and output are the same (we can use a simple type name) -->
                  <xsl:when test="current()/fdl:input/@type = current()/fdl:output/@type">
                    <xsd:element type="mqwf:{current()/fdl:input/@type}{$UPES-input-message-type-suffix}" nillable="true" name="{$element-input-name}"/>
                  </xsl:when>
                  <!--
                      OTHERWISE: different data structures of input and output (we need the names of input
                                 and output data structures in order to prevent type name clashes)
                  -->
                  <xsl:otherwise>
                    <xsd:element type="mqwf:{current()/fdl:input/@type}_{current()/fdl:output/@type}{$UPES-input-message-type-suffix}" nillable="true" name="{$element-input-name}"/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsd:sequence>
            </xsd:complexType>
          </xsd:element>
          <xsl:if test="$UPES-execution-mode = 'synchronous'">
            <!-- Create comment: XMLSchema element belonging to UPES response message of program activity"nnn" invoking server "nnn" of system "nnn" -->
            <xsl:value-of select="concat($eol, '&lt;!-- XMLSchema element belonging to UPES response message of program activity &quot;', current()/@name, '&quot; invoking server &quot;', $server-name, '&quot; of system &quot;', $related-system-name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
            <xsd:element name="{current()/@name}{$UPES-response-suffix}">
              <xsd:complexType>
                <xsd:sequence>
                  <xsd:element type="mqwf:{current()/fdl:output/@type}{$UPES-output-message-type-suffix}" nillable="true" name="{$element-output-name}"/>
                </xsd:sequence>
              </xsd:complexType>
            </xsd:element>
            <!-- Create comment: XMLSchema element belonging to UPES fault message of program activity"nnn" invoking server "nnn" of system "nnn" -->
            <xsl:value-of select="concat($eol, '&lt;!-- XMLSchema element belonging to UPES fault message of program activity &quot;', current()/@name, '&quot; invoking server &quot;', $server-name, '&quot; of system &quot;', $related-system-name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
            <xsd:element type="mqwf:{current()/fdl:output/@type}{$UPES-output-message-type-suffix}" name="{current()/@name}{$UPES-fault-suffix}"/>
          </xsl:if>
        </xsl:if>
      </xsl:for-each>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "messages" template:

    Translates the input/output of an FDL process into "wsdl:message" definitions
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:process" mode="messages">
    <!-- Create comment: Request message of process "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Request message of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <message name="{@name}{$request-suffix}{$message-suffix}">
      <part element="wsdl1:{@name}" name="{$message-part-name}"/>
    </message>
    <!-- Create comment: Response message of process "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Response message of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <message name="{@name}{$response-suffix}{$message-suffix}">
      <part element="wsdl1:{@name}{$response-suffix}" name="{$message-part-name}"/>
    </message>
    <xsl:if test="fdl:globalContainer/@type">
      <!-- Create comment: "Global Container" message of process "nnn" -->
      <xsl:value-of select="concat($eol, '&lt;!-- &quot;Global Container&quot; message of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
      <message name="{@name}{$global-container-suffix}{$message-suffix}">
        <part element="wsdl1:{@name}{$global-container-suffix}" name="{$message-part-name}"/>
      </message>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "messages" template:

    Translates the input/output of an FDL process activity into "wsdl:message" definitions
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:processActivity" mode="messages">
    <!-- Create comment: Request message of process activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Request message of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <message name="{@name}{$request-suffix}{$message-suffix}">
      <part element="wsdl1:{@name}" name="{$message-part-name}"/>
    </message>
    <!-- Create comment: Response message of process activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Response message of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <message name="{@name}{$response-suffix}{$message-suffix}">
      <part element="wsdl1:{@name}{$response-suffix}" name="{$message-part-name}"/>
    </message>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "messages" template:

    Translates the input/output of an FDL block activity into "wsdl:message" definitions
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:block" mode="messages">
    <!-- Create comment: Request message of block activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Request message of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <message name="{@name}{$request-suffix}{$message-suffix}">
      <part element="wsdl1:{@name}" name="{$message-part-name}"/>
    </message>
    <!-- Create comment: Response message of block activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Response message of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <message name="{@name}{$response-suffix}{$message-suffix}">
      <part element="wsdl1:{@name}{$response-suffix}" name="{$message-part-name}"/>
    </message>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "messages" template:

    Translates the input/output of an FDL program activity into "wsdl:message" definitions
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:programActivity" mode="messages">
    <!-- Create comment: Request message of program activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Request message of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <message name="{@name}{$request-suffix}{$message-suffix}">
      <part element="wsdl1:{@name}" name="{$message-part-name}"/>
    </message>
    <!-- Create comment: Response message of program activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Response message of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <message name="{@name}{$response-suffix}{$message-suffix}">
      <part element="wsdl1:{@name}{$response-suffix}" name="{$message-part-name}"/>
    </message>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "messages" template:

    Creates "wsdl:message" definitions representing the input/output/fault of a respective wsdl:portType" definition
        for each "fdl:server" that is referenced by some "fdl:programActivity" of type 'service invocation activity' (UPES).
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:server" mode="messages">
    <xsl:variable name="related-system-name" select="fdl:relatedSystem/@name"/>
    <xsl:variable name="related-group-name" select="fdl:relatedGroup/@name"/>
    <!--
        Create WSDL messages for each "fdl:programActivity" that is implemented by "fdl:server".
    -->
    <xsl:for-each select="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))">
      <xsl:variable name="program-activity-type">
        <xsl:call-template name="program-activity-type">
          <xsl:with-param name="activity" select="current()"/>
        </xsl:call-template>
      </xsl:variable>
      <!-- Create WSDL messages only if the program activity is of type "service invocation activity" -->
      <xsl:if test="$program-activity-type = 'service invocation activity'">
        <xsl:variable name="UPES-execution-mode">
          <xsl:call-template name="UPES-execution-mode">
            <xsl:with-param name="activity" select="current()"/>
          </xsl:call-template>
        </xsl:variable>
        <!-- Create comment: UPES request message of activity "nnn" invoking server "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- UPES request message of activity &quot;', current()/@name, '&quot; invoking server &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <message name="{current()/@name}{$UPES-request-suffix}{$message-suffix}">
          <part element="wsdl1:{current()/@name}{$UPES-suffix}" name="{$message-part-name}"/>
        </message>
        <xsl:if test="$UPES-execution-mode = 'synchronous'">
          <!-- Create comment: UPES response message of activity "nnn" invoking server "nnn" -->
          <xsl:value-of select="concat($eol, '&lt;!-- UPES response message of activity &quot;', current()/@name, '&quot; invoking server &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
          <message name="{current()/@name}{$UPES-response-suffix}{$message-suffix}">
            <part element="wsdl1:{current()/@name}{$UPES-response-suffix}" name="{$message-part-name}"/>
          </message>
          <!-- Create comment: UPES fault message of activity "nnn" invoking server "nnn" -->
          <xsl:value-of select="concat($eol, '&lt;!-- UPES fault message of activity &quot;', current()/@name, '&quot; invoking server &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
          <message name="{current()/@name}{$UPES-fault-suffix}{$message-suffix}">
            <part element="wsdl1:{current()/@name}{$UPES-fault-suffix}" name="{$message-part-name}"/>
          </message>
        </xsl:if>
      </xsl:if>
    </xsl:for-each>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "port-types" template:

    Creates a "wsdl:portType" for each "fdl:process".
    (representing the process interface)
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:process" mode="port-types">
    <!-- Create comment: Port type for process "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Port type for process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <portType name="{@name}{$port-type-suffix}">
      <operation name="{@name}">
        <input message="wsdl1:{@name}{$request-suffix}{$message-suffix}" name="{@name}{$request-suffix}"/>
        <output message="wsdl1:{@name}{$response-suffix}{$message-suffix}" name="{@name}{$response-suffix}"/>
      </operation>
    </portType>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "port-types" template:

    Creates a "wsdl:portType" for each "fdl:processActivity"
    that references a late-bound subprocess
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:processActivity" mode="port-types">
    <!-- Create comment: Port type for processActivity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Port type for late-bound subprocess invoked by process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <portType name="{@name}{$port-type-suffix}">
      <operation name="{@name}">
        <input message="wsdl1:{@name}{$request-suffix}{$message-suffix}" name="{@name}{$request-suffix}"/>
        <output message="wsdl1:{@name}{$response-suffix}{$message-suffix}" name="{@name}{$response-suffix}"/>
      </operation>
    </portType>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "port-types" template:

    Creates a "wsdl:portType" for each "fdl:program".
    (if it is referenced by some "fdl:programActivity")
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:program" mode="port-types">
    <!-- Create comment: Port type for program "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Port type for program &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <portType name="{@name}{$port-type-suffix}">
      <xsl:for-each select="key('program-activity-implemented-by-program', @name)">
        <!-- Create comment: Operation used in activity "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Operation used in activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <operation name="{current()/@name}">
          <input message="wsdl1:{current()/@name}{$request-suffix}{$message-suffix}" name="{current()/@name}{$request-suffix}"/>
          <output message="wsdl1:{current()/@name}{$response-suffix}{$message-suffix}" name="{current()/@name}{$response-suffix}"/>
        </operation>
      </xsl:for-each>
    </portType>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "port-types" template:

    Creates a "wsdl:portType" for each "fdl:server" that
    is referenced by some "fdl:programActivity" of type 'service invocation activity' (UPES).
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:server" mode="port-types">
    <xsl:variable name="related-system-name" select="fdl:relatedSystem/@name"/>
    <xsl:variable name="related-group-name" select="fdl:relatedGroup/@name"/>
    <!-- Create port type only if the server is referred to by some program activity of type 'service invocation activity' (UPES) -->
    <xsl:variable name="server-is-used-by-a-service-invocation-activity">
      <xsl:for-each select="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))">
        <xsl:variable name="program-activity-type">
          <xsl:call-template name="program-activity-type">
            <xsl:with-param name="activity" select="current()"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:if test="$program-activity-type = 'service invocation activity'">
          <xsl:value-of select="'TRUE'"/>
        </xsl:if>
      </xsl:for-each>
    </xsl:variable>
    <xsl:if test="contains($server-is-used-by-a-service-invocation-activity, 'TRUE')">
      <!-- Create comment: Port type for server "nnn" of system "nnn" -->
      <xsl:value-of select="concat($eol, '&lt;!-- Port type for server &quot;', @name, '&quot; of system &quot;', $related-system-name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
      <portType name="{$related-system-name}_{@name}{$port-type-suffix}">
        <!--
          Assign a "wsdl:operation" for each "fdl:programActivity" that is implemented by "fdl:server".
        -->
        <xsl:for-each select="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))">
          <xsl:variable name="program-activity-type">
            <xsl:call-template name="program-activity-type">
              <xsl:with-param name="activity" select="current()"/>
            </xsl:call-template>
          </xsl:variable>
          <!-- Create "wsdl:operation" only if the program activity is of type "service invocation activity" -->
          <xsl:if test="$program-activity-type = 'service invocation activity'">
            <!-- Create comment: Operation used in activity "nnn" -->
            <xsl:value-of select="concat($eol, '&lt;!-- Operation used in activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
            <xsl:variable name="UPES-execution-mode">
              <xsl:call-template name="UPES-execution-mode">
                <xsl:with-param name="activity" select="current()"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <!-- CASE: asynchronous execution mode -->
              <xsl:when test="$UPES-execution-mode = 'asynchronous'">
                <operation name="{current()/@name}{$UPES-suffix}">
                  <input message="wsdl1:{current()/@name}{$UPES-request-suffix}{$message-suffix}" name="{current()/@name}{$request-suffix}"/>
                </operation>
              </xsl:when>
              <!-- OTHERWISE: synchronous execution mode assumed -->
              <xsl:otherwise>
                <operation name="{current()/@name}{$UPES-suffix}">
                  <input message="wsdl1:{current()/@name}{$UPES-request-suffix}{$message-suffix}" name="{current()/@name}{$UPES-request-suffix}"/>
                  <output message="wsdl1:{current()/@name}{$UPES-response-suffix}{$message-suffix}" name="{current()/@name}{$UPES-response-suffix}"/>
                  <fault message="wsdl1:{current()/@name}{$UPES-fault-suffix}{$message-suffix}" name="{$operation-fault-name}"/>
                </operation>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:if>
        </xsl:for-each>
      </portType>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "partner-link-types" template:

    Creates a "plnk:partnerLinkType" for each "fdl:process".
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:process" mode="partner-link-types">
    <!-- Create comment: Partner link type for process "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Partner link type for process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <plnk:partnerLinkType name="{@name}{$partner-link-type-suffix}">
      <plnk:role name="{@name}{$role-suffix}">
        <plnk:portType name="wsdl1:{@name}{$port-type-suffix}"/>
      </plnk:role>
    </plnk:partnerLinkType>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "partner-link-types" template:

    Creates a "plnk:partnerLinkType" for each "fdl:processActivity"
    that references a late-bound subprocess.
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:processActivity" mode="partner-link-types">
    <!-- Create comment: Partner link type for late-bound subprocess invoked by process activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Partner link type for late-bound subprocess invoked by process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <plnk:partnerLinkType name="{@name}{$partner-link-type-suffix}">
      <plnk:role name="{@name}{$role-suffix}">
        <plnk:portType name="wsdl1:{@name}{$port-type-suffix}"/>
      </plnk:role>
    </plnk:partnerLinkType>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "partner-link-types" template:

    Creates a "plnk:partnerLinkType" for each "fdl:program".
    that is referenced by some "fdl:programActivity".
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:program" mode="partner-link-types">
    <!-- Create comment: Partner link type for program "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Partner link type for program &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <plnk:partnerLinkType name="{@name}{$partner-link-type-suffix}">
      <plnk:role name="{@name}{$role-suffix}">
        <plnk:portType name="wsdl1:{@name}{$port-type-suffix}"/>
      </plnk:role>
    </plnk:partnerLinkType>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "partner-link-types" template:

    Creates a "plnk:partnerLinkType" for each "fdl:server".
    that is referenced by some "fdl:programActivity" of type 'service invocation activity' (UPES).
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:server" mode="partner-link-types">
    <xsl:variable name="related-system-name" select="fdl:relatedSystem/@name"/>
    <xsl:variable name="related-group-name" select="fdl:relatedGroup/@name"/>
    <xsl:variable name="server-name" select="@name"/>
    <!-- Create partner link type only if the server is referred to by some program activity of type 'service invocation activity' (UPES) -->
    <xsl:variable name="server-is-used-by-a-service-invocation-activity">
      <xsl:for-each select="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))">
        <xsl:variable name="program-activity-type">
          <xsl:call-template name="program-activity-type">
            <xsl:with-param name="activity" select="current()"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:if test="$program-activity-type = 'service invocation activity'">
          <xsl:value-of select="'TRUE'"/>
        </xsl:if>
      </xsl:for-each>
    </xsl:variable>
    <xsl:if test="contains($server-is-used-by-a-service-invocation-activity, 'TRUE')">
      <!-- Create comment: Partner link type for server "nnn" of system "nnn" -->
      <xsl:value-of select="concat($eol, '&lt;!-- Partner link type for server &quot;', @name, '&quot; of system &quot;', $related-system-name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
      <plnk:partnerLinkType name="{$related-system-name}_{@name}{$partner-link-type-suffix}">
        <plnk:role name="{$related-system-name}_{@name}{$role-suffix}">
          <plnk:portType name="wsdl1:{$related-system-name}_{@name}{$port-type-suffix}"/>
        </plnk:role>
      </plnk:partnerLinkType>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    Template "UPES-execution-mode":

    Determines the execution mode of an "UPES" program activity.
    Selects from types "synchronous", "asynchronous"
    (NOTE THAT THIS TEMPLATE IS SHARED IN "XFDLBPEL_BPEL.XSL"!)
    *****************************************************************************************************************************
   -->
  <xsl:template name="UPES-execution-mode">
    <xsl:param name="activity"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;UPES-execution-mode&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:choose>
      <!-- CASE: "synchronous invocation"   -->
      <xsl:when test="$activity/fdl:program/@synchronization = 'nested'">
        <xsl:value-of select="'synchronous'"/>
      </xsl:when>
      <!-- CASE: "asynchronous invocation" -->
      <xsl:when test="$activity/fdl:program/@synchronization = 'chained'">
        <xsl:value-of select="'asynchronous'"/>
      </xsl:when>
      <!-- OTHERWISE: "*** not defined ***" -->
      <xsl:otherwise>
        <xsl:value-of select="'*** not defined ***'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "program-activity-type":

    Determines the type of an FDL program activity.
    Selects from types "empty activity", "service invocation activity" (UPES activity),  "staff activity",
    "assumed staff activity"
    NOTE THAT THIS TEMPLATE IS SHARED IN:
      "XFDLBPEL_ANALYZE.XSL", "XFDLBPEL_XSD.XSL", "XFDLBPEL_BPEL.XSL", "XFDLBPEL_SCDL.XSL"
    ****************************************************************************************************************
   -->
  <xsl:template name="program-activity-type">
    <xsl:param name="activity"/>
    <xsl:param name="server-may-be-missing" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;program-activity-type&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="domain" select="//fdl:domain[1]"/>
    <xsl:variable name="system-group" select="//fdl:group[1]"/>
    <xsl:variable name="primary-system" select="//fdl:system[ @primarySystem ='yes' ][1]"/>
    <!-- Note that the following variables will contain appropriate values for "service invocation activities" (UPES) only -->
    <xsl:variable name="program-execution-unit" select="$activity/fdl:program/@programExecutionUnit"/>
    <xsl:variable name="server-name" select="substring-before($program-execution-unit, '.')"/>
    <xsl:variable name="related-system-name" select="substring-before(substring-after($program-execution-unit, concat($server-name, '.')), '.')"/>
    <xsl:variable name="server-and-system-name" select="concat($server-name, $related-system-name)"/>
    <xsl:choose>
      <!--
        CASE: "empty activity"
          A program activity is an "empty activity" if
          1) if the activity implementation is a program with the name FMCINTERNALNOOP
          2) the execution mode is chained
          3) the input and output data structures are the same
      -->
      <xsl:when test="$activity/fdl:program/@name='FMCINTERNALNOOP'
                and $activity/fdl:program/@synchronization='chained'
                and $activity/fdl:input/@type = $activity/fdl:output/@type">
        <xsl:value-of select="'empty activity'"/>
      </xsl:when>
      <!--
        CASE: "service invocation activity"
          A program activity is an "service invocation activity" if a user-defined program execution server
          (UPES) is specified (attribute "fdl:program/@programExecutionUnit").
      -->
      <xsl:when test="$activity/fdl:program/@programExecutionUnit
                  and (key('server-by-server-and-system-name', $server-and-system-name)[1]/fdl:userDefinedProgramExecutionServer or $server-may-be-missing = 'true')">
        <xsl:choose>
          <!-- CASE: User option "-un" (no UPES migration) is selected (cp. LI754 (Do not prepare process for reuse of UPES) -->
          <xsl:when test="'TRUE' = translate($createUPESInvocations, $lower-case-characters, $upper-case-characters)">
            <xsl:value-of select="'service invocation activity'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'empty activity'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!--
        CASE: "staff activity"
          A program activity is a "staff activity" if the following conditions apply:
          1. Start type is "manual"
          2. Attribute "checkoutPossible" indicates that it can be checked out from the runtime database.
      -->
      <xsl:when test="$activity/fdl:join/@startType='manual'
                  and ( $activity/fdl:defaultSetting/@checkoutPossible='yes'
                       or (  not($activity/fdl:defaultSetting/@checkoutPossible='no')
                          and (   $activity/ancestor::fdl:process/fdl:activityDefaultSetting/@checkoutPossible='yes'
                              or (   'TRUE' = translate($LI1274_Support_inheritance_from_network_settings, $lower-case-characters, $upper-case-characters)
                                  and not($activity/ancestor::fdl:process/fdl:activityDefaultSetting/@checkoutPossible='no')
                                  and (  $primary-system/fdl:activityDefaultSetting/@checkoutPossible='yes'
                                      or (  not($primary-system/fdl:activityDefaultSetting/@checkoutPossible='no')
                                          and (   $system-group/fdl:activityDefaultSetting/@checkoutPossible='yes'
                                              or (  not($system-group/fdl:activityDefaultSetting/@checkoutPossible='no')
                                                  and $domain/fdl:activityDefaultSetting/@checkoutPossible='yes' ) ) ) ) ) ) ) )">
        <xsl:value-of select="'staff activity'"/>
      </xsl:when>
      <!--
        OTHERWISE: "unclassified activity"
          A program activity is an "unclassified activity" if none of the above rules apply.
          In this case assume a "staff activity".
      -->
      <xsl:otherwise>
        <xsl:value-of select="'assumed staff activity'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:transform>
