import java.util.HashMap;
import java.util.List;

import com.ibm.j2ca.base.internal.WPSServiceHelper;
import com.ibm.websphere.sca.Service;
import com.ibm.websphere.sca.ServiceBusinessException;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.websphere.sca.scdl.InterfaceType;
import com.ibm.websphere.sca.scdl.OperationType;
import commonj.sdo.DataObject;
import commonj.sdo.Property;


public class Input_Async_Processing {
	/**
	 * Default constructor.
	 */
	public Input_Async_Processing() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * This method is used to locate the service for the reference
	 * named "Async_PortTypePartner".  This will return an instance of 
	 * {@link com.ibm.websphere.sca.Service}.  This is the dynamic
	 * interface which is used to invoke operations on the reference service
	 * either synchronously or asynchronously.  You will need to pass the operation
	 * name in order to invoke an operation on the service.
	 *
	 * @generated (com.ibm.wbit.java)
	 *
	 * @return Service
	 */
	public Service locateService_Async_PortTypePartner() {
		return (Service) ServiceManager.INSTANCE
				.locateService("Async_PortTypePartner");
	}

	/**
	 * Method generated to support implemention of all the methods above 
	 * named "Async_PortType".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that its a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	private void invokeService(DataObject dataObj){
		try{
			List interfaceTypeList = locateService_Async_PortTypePartner().getReference().getInterfaceTypes();
			InterfaceType interfaceType = (InterfaceType)interfaceTypeList.get(0);
			OperationType operationType = ((OperationType)interfaceType.getOperationTypes().get(0));
			String method = operationType.getName();
			locateService_Async_PortTypePartner().invokeAsync(method, dataObj);	
		}catch(Exception e){
			throw new ServiceBusinessException(e.getMessage());
		}		
	}
	
	
	private DataObject getInputType(DataObject mailBO) throws Exception {
		HashMap<String,String> attributeMap = new HashMap<String,String>(); 
		// WBI Property -> JCA Property
		attributeMap.put("FromAddress", "From");
		attributeMap.put("ToAddress", "To");
		attributeMap.put("CC", "CC");
		attributeMap.put("BCC", "BCC");
		attributeMap.put("Subject", "Subject");
		attributeMap.put("ReplyTo", "Reply-To");
		attributeMap.put("SendDate", "Date");
		
		String bgName = this.getTargetBOType();
		String boName = bgName.replace("BG", "");
		String baseNameSpace = "http://www.ibm.com/websphere/crossworlds/2002/BOSchema";
		String bgNameSpace = baseNameSpace+"/"+boName+"/"+bgName;
		
		DataObject wrapperBG = WPSServiceHelper.createDataObject(bgNameSpace, bgName);
		DataObject wrapperBO = wrapperBG.createDataObject(boName);
		wrapperBG.setString("verb", "Create");
		
		//Copy the simple data type
		for(Object wbiProp : wrapperBO.getType().getProperties()) {
			String wbiPropName = ((Property) wbiProp).getName();
			if ( attributeMap.containsKey(wbiPropName) && !((Property)wbiProp).isContainment()) {
				String jcaPropName = attributeMap.get(wbiPropName);
				String jcaPropValue = mailBO.getString(jcaPropName);
				if (jcaPropValue != null) {
					wrapperBO.setString(wbiPropName, jcaPropValue);
				}
			}
		}
		
		//Copy the mail attachments
		List mailAttachs = mailBO.getList("mailAttachments");
		for(Object mailAttach : mailAttachs){
			String attachName = ((DataObject)mailAttach).getString("attachmentName");
			DataObject attachBO = ((DataObject)mailAttach).getDataObject("appBOData");
			wrapperBO.setDataObject(attachName, attachBO);
		}
		
		//Copy the mail Content
		DataObject mailContent = mailBO.getDataObject("mailContent");
		if(mailContent != null){
			if(mailContent.getType().getName().equalsIgnoreCase("UnstructuredContent")){// Pass-through scenario
				//mailContent.getString("AsText");
				
			}else{// DTF scenario
				wrapperBO.setDataObject(mailContent.getType().getName(), mailContent);
			}
		}
		
		return wrapperBG;
	}

}