import com.ibm.j2ca.base.exceptions.InvalidObjectDefinitionException;
import com.ibm.j2ca.base.internal.WPSServiceHelper;
import com.ibm.wbiserverspi.mediation.MediateException;
import com.ibm.websphere.sca.Service;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.websphere.sca.Ticket;
import commonj.sdo.DataObject;


public class Output_Processing {
	/**
	 * Default constructor.
	 */
	public Output_Processing() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * This method is used to locate the service for the reference
	 * named "Output".  This will return an instance of
	 * {@link com.ibm.websphere.sca.Service}.  This is the dynamic
	 * interface which is used to invoke operations on the reference service
	 * either synchronously or asynchronously.  You will need to pass the operation
	 * name in order to invoke an operation on the service.
	 *
	 * @generated (com.ibm.wbit.java)
	 *
	 * @return Service
	 */
	public Service locateService_Output() {
		return (Service) ServiceManager.INSTANCE.locateService("Output");
	}

	private String getVerb(DataObject dataObject) {
		String verb = null;
		try {
			verb = WPSServiceHelper.getTopLevelVerb(dataObject);
		} catch (InvalidObjectDefinitionException e) {
			// TODO Auto-generated catch block
			verb = null;
		}
		return verb;
	}

	private String getOperation(String verb, DataObject dataObject)
	throws Exception {

		String operation = null;

		String outRootTypeName = null;

		outRootTypeName = WPSServiceHelper.getRootBusinessObjectInstance(dataObject).getType().getName();
		
		if(outRootTypeName.endsWith("Wrapper")){
			outRootTypeName = outRootTypeName.replace("Wrapper", "");
		
		}
		if (verb == null) {
			throw new MediateException(
			"The operation to invoke on the target interface could not be determined because the verb defined for the input Business Graph is null.");
		}
		if (outRootTypeName == null) {
			throw new MediateException(
			"The operation to invoke on the target interface could not be determined because the ouput Business Object type is null.");
		}

		verb = verb.toLowerCase();

		//TODO: JText adapter only supports "create" verb, we need to check the FileWriteMode attribute value, 
		//"a" represents for "append" operation; "o" represents for "overwrite" operation.
		if (verb.equalsIgnoreCase("create")||verb.equalsIgnoreCase("append")||verb.equalsIgnoreCase("overwrite")) {
			operation = verb + outRootTypeName;
		}

		return operation;

	}
	
	private DataObject getInputType(String verb, DataObject boBG) throws Exception {
		DataObject inputType=null;
		if(verb.equalsIgnoreCase("create")||verb.equalsIgnoreCase("append")||verb.equalsIgnoreCase("overwrite")){
		//InputType is WrapperBG
			DataObject bo = WPSServiceHelper.getRootBusinessObjectInstance(boBG);
			String wrapperBGName = bo.getType().getName()+"WrapperBG";
			DataObject wrapperBG = WPSServiceHelper.createDataObject("http://www.ibm.com/xmlns/prod/websphere/j2ca/ftp/"+wrapperBGName.toLowerCase(), wrapperBGName);
			DataObject wrapper = wrapperBG.createDataObject(bo.getType().getName()+"Wrapper");
			wrapper.setDataObject("Content", bo);
			inputType = wrapperBG;
		}else if(verb.equalsIgnoreCase("delete")||verb.equalsIgnoreCase("exists")||verb.equalsIgnoreCase("retrieve")||verb.equalsIgnoreCase("list")){
		//InputType is FTPBG
			DataObject ftpBG = WPSServiceHelper.createDataObject("http://www.ibm.com/xmlns/prod/websphere/j2ca/ftp/ftpbg","FTPBG");
			ftpBG.createDataObject("FTP");
			inputType = ftpBG;
		}
		return inputType;
	}
	
}