/*
 *
 * Sample program for use with the Product
 * Licensed Materials  - Property of IBM
 * 5724-I66
 * (c) Copyright IBM Corp.  2008
 *   
 */

package com.ibm.wbit.tel.client.form;

import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;

/**
 * This class provides some general utilities, usefully in the context of Lotus
 * Forms integration.
 * 
 */
public class FormUtils {

	/**
	 * The width of the object (used to embed a XFDL file in a web page) in
	 * pixels
	 */
	public static final String OBJECT_WIDTH = "90%";

	/**
	 * The height of the object (used to embed a XFDL file in a web page) in
	 * pixels
	 */
	public static final String OBJECT_HEIGHT = "600";

	/**
	 * Get the complete servlet URL.
	 */
	public static String createFacesServletURL() {
		HttpServletRequest request = (HttpServletRequest) FacesContext.getCurrentInstance().getExternalContext().getRequest();
		String servletPath = request.getRequestURI();
		String urlStringPrefix;
		int offSet;

		if ((offSet = servletPath.lastIndexOf("/")) == -1) {
			servletPath = "/";
		} else {
			servletPath = servletPath.substring(0, offSet + 1);
		}

		urlStringPrefix = request.getScheme() + "://" + request.getServerName() + ":" + String.valueOf(request.getServerPort()) + servletPath + "faces/";
		return urlStringPrefix;
	}
	
}
