/*
 *
 * Sample program for use with the Product
 * Licensed Materials  - Property of IBM
 * 5724-I66
 * (c) Copyright IBM Corp.  2008
 *   
 */

package com.ibm.wbit.tel.client.form.command;

import java.util.ArrayList;
import java.util.List;

import com.PureEdge.error.UWIException;
import com.ibm.wbit.tel.client.jsf.bean.ToDoInstance;
import com.ibm.wbit.tel.client.jsf.command.ToDoRelease;
import com.ibm.wbit.tel.client.jsf.handler.ToDoMessageHandler;
import com.ibm.wbit.tel.client.jsf.infrastructure.FacesUtils;

/**
 * Releases a task.
 */
class ReleaseCommand extends CommandAdapter {

	private ToDoMessageHandler toDoMessageHandler;

	ReleaseCommand() {
		super(new ToDoRelease());
		this.toDoMessageHandler = (ToDoMessageHandler) FacesUtils.getManagedBeanInstance("toDoMessageHandler", ToDoMessageHandler.class);
	}

	/* (non-Javadoc)
	 * @see com.ibm.wbit.tel.client.form.command.CommandAdapter#getInstances()
	 */
	List getInstances() throws UWIException {
		List<ToDoInstance> instances = new ArrayList<ToDoInstance>();
		ToDoInstance todo = toDoMessageHandler.getToDoInstance();
		instances.add(todo);
		return instances;
	}

	/* (non-Javadoc)
	 * @see com.ibm.wbit.tel.client.form.command.CommandAdapter#getContext()
	 */
	Object getContext() {
		return this.toDoMessageHandler;
	}
}
