/*
 *
 * Sample program for use with the Product
 * Licensed Materials  - Property of IBM
 * 5724-I66
 * (c) Copyright IBM Corp.  2008
 *   
 */

package com.ibm.wbit.tel.client.form.decorator;

import com.PureEdge.error.UWIException;
import com.PureEdge.xfdl.FormNodeP;

/**
 * To make a form read-only, this decorator sets
 * <code>ufv_settings[modifiable]</code> to <code>off</code>.
 */
class ReadOnlyDecorator extends FormDecorator {

	ReadOnlyDecorator(FormNodeP form) {
		super(form);
	}

	void add() throws UWIException {
		FormNodeP global = this.form.getChildren().getChildren();
		global.setLiteralByRefEx(null, "ufv_settings[modifiable]", 0, null, null, "off");
	}

	void remove() throws UWIException {
		FormNodeP global = this.form.getChildren().getChildren();
		global.setLiteralByRefEx(null, "ufv_settings[modifiable]", 0, null, null, "on");
	}
}
