<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:mqwf="http://www.ibm.com/xmlns/prod/websphere/mqwf/schema/" xmlns:wsdl1="http://www.ibm.com/xmlns/prod/websphere/mqwf/wsdl/" xmlns:staff="http://www.ibm.com/xmlns/prod/websphere/mqwf/tel/" xmlns:tel="http://www.ibm.com/xmlns/prod/websphere/human-task/6.0.0/" xmlns:tel1="http://www.ibm.com/xmlns/prod/websphere/mqwf/bpel//_OTASK_PROC" xmlns:wpc="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/" xmlns:bpws="http://schemas.xmlsoap.org/ws/2004/03/business-process/" xmlns:fdl="http://www.ibm.com/workflow/2003" xmlns:redirect="http://xml.apache.org/xalan/redirect" xmlns:xalan="http://xml.apache.org/xalan" xmlns:java="http://xml.apache.org/xalan/java" extension-element-prefixes="redirect xalan java" exclude-result-prefixes="fdl wsdl bpws wpc tel" version="1.0">
  <!--
    *************************************************************************

      Workfile: BPCSRVR/ws/code/workflow.fdl2bpel/src/com/ibm/bpe/fdl2bpel/converter/v62/xfdl2bpel_bpel.xsl, BPC.workflow, WBI70.BPCSRVR, of0950.12
      Last update: 09/10/27 11:19:33
      SCCS path, id: /family/botp/vc/13/4/8/5/s.56 1.63

    *************************************************************************
    BEGIN COPYRIGHT
    *************************************************************************

      IBM Confidential
      OCO Source Materials
      5655-FLW (C) Copyright IBM Corporation 2003, 2009.
      The source code for this program is not published or otherwise
      divested of its trade secrets, irrespective of what has been
      deposited with the U.S. Copyright Office.

    *************************************************************************
    END COPYRIGHT
  -->
  <!--
    *****************************************************************************************************************************
          Task:      Create a BPEL file that represents a business process
    *****************************************************************************************************************************
   -->
  <xsl:output method="xml" indent="yes" xalan:indent-amount="5"/>
  <!--************************************ -->
  <!--*        Configurable parameters   * -->
  <!--************************************ -->
  <!-- "fdlFileName": FDL file name -->
  <xsl:param name="fdlFileName" select="'unknown FDL file name'"/>
  <!-- "xsdfile": XMLSchema definition file for FDL data types -->
  <xsl:param name="xsdfile"/>
  <!-- "wsdlfile": path of target directory -->
  <xsl:param name="wsdlfile" select="''"/>
  <!-- "outputdir": path of target directory -->
  <xsl:param name="outputdir" select="''"/>
  <!-- "wsdlNamespace": WSDL namespace -->
  <xsl:param name="wsdlNamespace" select="'http://schemas.xmlsoap.org/wsdl/'"/>
  <!-- "telNamespace": TEL namespace -->
  <xsl:param name="telNamespace" select="'http://www.ibm.com/xmlns/prod/websphere/human-task/6.0.0/'"/>
  <!-- "wsdlTargetNamespace": target namespace of imported WSDL file -->
  <xsl:param name="wsdlTargetNamespace" select="'http://www.ibm.com/xmlns/prod/websphere/mqwf/wsdl/'"/>
  <!-- "bpelTargetNamespace": target namespace of BPEL file -->
  <xsl:param name="bpelTargetNamespace" select="'http://www.ibm.com/xmlns/prod/websphere/mqwf/bpel/'"/>
  <!-- "telTargetNamespace": target namespace of imported TEL files -->
  <xsl:param name="telTargetNamespace" select="'http://www.ibm.com/xmlns/prod/websphere/mqwf/tel/'"/>
  <!-- "process-name": the name of the FDL process to be converted -->
  <xsl:param name="process-name"/>
  <!-- "java": URI for Java expression language-->
  <xsl:param name="JAVA" select="'http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/'"/>
  <!-- "java": URI for XPath expression language-->
  <xsl:param name="XPATH" select="'http://www.w3.org/TR/1999/REC-xpath-19991116'"/>
  <!-- "java": URI for builtin expression language-->
  <xsl:param name="BUILTIN" select="'http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/built-in/6.0.0/'"/>
  <!-- "queryLanguage": BPEL attribute "queryLanguage" -->
  <xsl:param name="queryLanguage" select="'http://www.w3.org/TR/1999/REC-xpath-19991116'"/>
  <!-- "expiration-expression-language" ( legal values are "XPATH" or "JAVA" (default) -->
  <xsl:param name="expiration-expression-language" select="'JAVA'"/>
  <!-- "locale": language locale -->
  <xsl:param name="locale" select="'en-US'"/>
  <!-- "initializePredefinedDataMembers": Initialize the predefined data members _ACTIVITY,  _PROCESS_MODEL -->
  <xsl:param name="initializePredefinedDataMembers" select="'false'"/>
  <!-- "createPredefinedDataMembers": Create the predefined MQWF data structure members -->
  <xsl:param name="createPredefinedDataMembers" select="'true'"/>
  <!-- "create_Java_Snippets" -->
  <xsl:param name="create_Java_Snippets" select="'true'"/>
  <!-- "create_Java_conditions" -->
  <xsl:param name="create_Java_conditions" select="'false'"/>
  <!-- "merge_the_output_of_a_staff_activity" -->
  <xsl:param name="merge_the_output_of_a_staff_activity" select="'false'"/>
  <!-- "merge_the_output_of_a_staff_activity" -->
  <xsl:param name="merge_the_output_of_a_process_activity" select="'false'"/>
  <!-- "variable-type-mode": Allowed values are "DATA" (default) or "INTERFACE" -->
  <xsl:param name="variable-type-mode" select="'DATA'"/>
  <xsl:param name="option_ev" select="'false'"/>
  <xsl:param name="option_mj" select="'false'"/>
  <xsl:param name="option_id" select="'false'"/>
  <xsl:param name="option_ip" select="'false'"/>

  <!-- New after v6.2 -->
  <xsl:param name="option_eb" select="'false'"/>
  <xsl:param name="option_ib" select="'false'"/>
  <xsl:param name="option_is" select="'false'"/>
  <xsl:param name="option_ij" select="'false'"/>
  <!-- "createUPESInvocations" (cp. LI754: Do not prepare process for reuse of UPES ) -->
  <xsl:param name="createUPESInvocations" select="'true'"/>
  <!-- "create_SCA_UPES_IMPORTS_only" (cp. LI1195: Invocation of existing user-defined pgm execution servers in new BPEL processes) -->
  <xsl:param name="create_SCA_UPES_IMPORTS_only" select="'false'"/>
  <!-- "LI490_Support_repeatUntil" -->
  <xsl:param name="LI490_Support_repeatUntil" select="'false'"/>
  <!-- "LI1109_Generate_O_Task_for_the_process" -->
  <xsl:param name="LI1109_Generate_O_Task_for_the_process" select="'false'"/>
  <!-- "LI1143_Support_for_the_link_name_option_in_ControlFlow_and_DataFlow" -->
  <xsl:param name="LI1143_Support_for_the_link_name_option_in_ControlFlow_and_DataFlow" select="'true'"/>
  <!-- "LI1274_Support_inheritance_from_network_settings" -->
  <xsl:param name="LI1274_Support_inheritance_from_network_settings" select="'false'"/>
  <!--************************************ -->
  <!--*        Global parameters             * -->
  <!--************************************ -->
  <!-- "end of line" character string -->
  <xsl:param name="eol" select="java:java.lang.System.getProperty('line.separator')"/>
  <!-- "partner-link-suffix": Suffix appended to "partner link" names -->
  <xsl:param name="partner-link-suffix" select="'_PL'"/>
  <!-- "input-variable-suffix": Suffix appended to names of data input "variables" -->
  <xsl:param name="input-variable-suffix" select="'_IN'"/>
  <!-- "default-input-variable-suffix": Suffix appended to names of default input "variables" -->
  <xsl:param name="default-input-variable-suffix" select="'_DEFAULT_IN'"/>
  <!-- "UPES-input-variable-suffix": Suffix appended to names of UPES data input "variables" -->
  <xsl:param name="UPES-input-variable-suffix" select="'_UPES_IN'"/>
  <!-- "output-variable-suffix": Suffix appended to names of data output "variables" -->
  <xsl:param name="output-variable-suffix" select="'_OUT'"/>
  <!-- "UPES-output-variable-suffix": Suffix appended to names of UPES data output "variables" -->
  <xsl:param name="UPES-output-variable-suffix" select="'_UPES_OUT'"/>
  <!-- "human-task-output-variable-suffix": Suffix appended to names of human task data output "variables" -->
  <xsl:param name="human-task-output-variable-suffix" select="'_HT_OUT'"/>
  <!-- "subprocess-output-variable-suffix": Suffix appended to names of subprocess data output "variables" -->
  <xsl:param name="subprocess-output-variable-suffix" select="'_SP_OUT'"/>
  <!-- "status-variable-suffix": Suffix appended to names of activity status "variables" -->
  <xsl:param name="status-variable-suffix" select="'_ST'"/>
  <!-- "activity-started-indicator": Indicator used as value of status "variables" -->
  <xsl:param name="activity-started-indicator" select="'started'"/>
  <!-- "activity-status-reset-indicator": Indicator used as value of status "variables" -->
  <xsl:param name="activity-status-reset-indicator" select="''"/>
  <!-- "maxDisplayNameLength": maximum number of characters in a display name -->
  <xsl:param name="maxDisplayNameLength" select="64"/>
  <!-- "maxDescriptionFieldLength": maximum number of characters in a description field -->
  <xsl:param name="maxDescriptionFieldLength" select="254"/>
  <!-- "maxDocumentationFieldLength": maximum number of characters in a description field -->
  <xsl:param name="maxDocumentationFieldLength" select="4096"/>
  <!-- "ActivityImplInvoke": XML message type for UPES invocation -->
  <xsl:param name="ActivityImplInvoke" select="'ActivityImplInvoke'"/>
  <!-- "ptask-name-suffix": Suffix appended to task name -->
  <xsl:param name="ptask-name-suffix" select="'_PTASK'"/>
  <!-- "process-admin-task-suffix": Suffix appended to a process administration task name -->
  <xsl:param name="process-admin-task-suffix" select="'_ATASK_PROC'"/>
  <!-- "process-originating-task-suffix": Suffix appended to a process originating task name -->
  <xsl:param name="process-originating-task-suffix" select="'_OTASK_PROC'"/>
  <!-- "activity-admin-task-suffix": Suffix appended to an activity administration task name -->
  <xsl:param name="activity-admin-task-suffix" select="'_ATASK_ACT'"/>
  <!--
    *** Parameters also used in stylesheet "xfdl2bpel_wsdl.xsl" ***
  -->
  <!-- "lower-case-characters": "aäbcdefghijklmnoöpqrstuüvwxyz" -->
  <xsl:param name="lower-case-characters" select="'aäbcdefghijklmnoöpqrstuüvwxyz'"/>
  <!-- "upper-case-characters": "AÄBCDEFGHIJKLMNOÖPQRSTUÜVWXYZ" -->
  <xsl:param name="upper-case-characters" select="'AÄBCDEFGHIJKLMNOÖPQRSTUÜVWXYZ'"/>
  <!-- element-input-name -->
  <xsl:param name="element-input-name" select="'input1'"/>
  <!-- element-output-name -->
  <xsl:param name="element-output-name" select="'output1'"/>
  <!-- activity-status-message-name -->
  <xsl:param name="activity-status-message-name" select="'ActivityStatus'"/>
  <!-- message-part-name -->
  <xsl:param name="message-part-name" select="'Part1'"/>
  <!-- "message-suffix": Suffix appended to "message" names -->
  <xsl:param name="message-suffix" select="'_MSG'"/>
  <!-- "port-type-suffix": Suffix appended to "port type" names  -->
  <xsl:param name="port-type-suffix" select="'_PT'"/>
  <!-- "request-suffix": Suffix appended to request messages  -->
  <xsl:param name="request-suffix" select="'_Request'"/>
  <!-- "response-suffix": Suffix appended to response messages  -->
  <xsl:param name="response-suffix" select="'_Response'"/>
  <!-- "UPES-suffix": Suffix appended to UPES operations and UPES related XMLSchema elements -->
  <xsl:param name="UPES-suffix" select="'_UPES'"/>
  <!-- "UPES-request-suffix": Suffix appended to UPES request messages  -->
  <xsl:param name="UPES-request-suffix" select="'_Request_UPES'"/>
  <!-- "UPES-response-suffix": Suffix appended to UPES response messages  -->
  <xsl:param name="UPES-response-suffix" select="'_Response_UPES'"/>
  <!-- "UPES-fault-suffix": Suffix appended to UPES fault messages  -->
  <xsl:param name="UPES-fault-suffix" select="'_Fault_UPES'"/>
  <!-- "partner-link-type-suffix": Suffix appended to "partner link type" names -->
  <xsl:param name="partner-link-type-suffix" select="'_PLT'"/>
  <!-- "role-suffix": Suffix appended to role names   -->
  <xsl:param name="role-suffix" select="'_Role'"/>
  <!-- "Error" Message severity 1 -->
  <xsl:param name="Error" select="1"/>
  <!-- "Warning" Message severity 2 -->
  <xsl:param name="Warning" select="2"/>
  <!-- "Information" Message severity 3 -->
  <xsl:param name="Information" select="3"/>
  <!--
    *** Parameters also used in stylesheet "xfdl2bpel_xsd.xsl" ***
  -->
  <!-- "message-type-suffix": Suffix appended to message type names -->
  <xsl:param name="message-type-suffix" select="'_MT'"/>
  <!-- "UPES-input-message-type-suffix": Suffix appended to UPES input message type names -->
  <xsl:param name="UPES-input-message-type-suffix" select="'_UPES_IN_MT'"/>
  <!-- "UPES-output-message-type-suffix": Suffix appended to UPES output message type names -->
  <xsl:param name="UPES-output-message-type-suffix" select="'_UPES_OUT_MT'"/>
  <!-- "global-container-message-type-suffix": Suffix appended to "global container" message type names -->
  <xsl:param name="global-container-message-type-suffix" select="'_GC_MT'"/>
  <!--
    *** Parameters also used in stylesheet "xfdl2bpel_bpelex.xsl" ***
  -->
  <!-- "Execute-activities-contained-in-process": Display name used for a flow activity that contains the activities of a process -->
  <xsl:param name="Execute-activities-contained-in-process" select="'Execute activities contained in process'"/>
  <!-- "Execute-activities-contained-in-block": Display name used for a flow activity that contains the activities of a block -->
  <xsl:param name="Execute-activities-contained-in-block" select="'Execute activities contained in block'"/>
  <!--************************** -->
  <!--*        Keys                   * -->
  <!--************************** -->
  <!--
    Key "program-activity-implemented-by-programExecutionUnit" represents a "mapping" between
    programExecutionUnit (UPES) (as "key objects") and program activities (as "value objects")
  -->
  <xsl:key name="program-activity-implemented-by-programExecutionUnit" match="fdl:programActivity" use="fdl:program/@programExecutionUnit"/>
  <!--
    Key "server-by-server-and-system-name" represents a "mapping" between the concatenated names
        of server and related system (as "key objects") and server definitions (as "value objects")
  -->
  <xsl:key name="server-by-server-and-system-name" match="fdl:definitions/fdl:server
                                                                    | fdl:definitions/fdl:create/fdl:server
                                                                    | fdl:definitions/fdl:update/fdl:server
                                                                    | fdl:definitions/fdl:replace/fdl:server" use="concat(@name, fdl:relatedSystem/@name)"/>
  <!--
    Key "activity-by-name" represents a "mapping" between
    activity names (as "key") and respective activities (as "value objects").
  -->
  <xsl:key name="activity-by-name" match="fdl:programActivity | fdl:processActivity | fdl:block" use="@name"/>
  <!--
    Key "inDataConnByName" represents a "mapping" between
    activity names (as "key") and data connectors (as "value objects").
  -->
  <xsl:key name="inDataConnByName" match="fdl:data" use="@to"/>
  <!--
    Key "outDataConnByName" represents a "mapping" between
    activity names (as "key") and data connectors (as "value objects").
  -->
  <xsl:key name="outDataConnByName" match="fdl:data" use="@from"/>
  <!--
    Key "data-connector-with-STRUCT-TO-STRUCT-mapping" represents a "mapping" between
    data connector identifiers (as "key") and respective data connectors (as "value objects") with
    the following rules:
    1) There is a (single) mapping FROM '_STRUCT' TO '_STRUCT'
    2) There are no other mappings
  -->
  <xsl:key name="data-connector-with-STRUCT-TO-STRUCT-mapping-by-id" match="fdl:data
                 [ count(fdl:map) = 1
                   and count(fdl:map[1]/fdl:sourceMember/fdl:dataStructureMemberName/fdl:nameComponent) = 1
                   and fdl:map[1]/fdl:sourceMember/fdl:dataStructureMemberName/fdl:nameComponent[1]/@name = '_STRUCT'
                   and count(fdl:map/fdl:targetMember/fdl:dataStructureMemberName/fdl:nameComponent) = 1
                   and fdl:map[1]/fdl:targetMember/fdl:dataStructureMemberName/fdl:nameComponent[1]/@name = '_STRUCT'
                ]" use="generate-id()"/>
  <!--
    Key "data-connector-with-CONTAINER-TO-CONTAINER-mapping" represents a "mapping" between
    data connector identifiers (as "key") and respective data connectors (as "value objects") with
    the following rules:
    1) The first mapping is FROM '_PROCESS_INFO' TO '_PROCESS_INFO'
    2) The second mapping is FROM '_ACTIVITY_INFO' TO '_ACTIVITY_INFO'
    3) The third mapping is FROM '_STRUCT' TO '_STRUCT'
    4) There are no other mappings
  -->
  <xsl:key name="data-connector-with-CONTAINER-TO-CONTAINER-mapping-by-id" match="fdl:data
                 [ count(fdl:map) = 3
                   and count(fdl:map[1]/fdl:sourceMember/fdl:dataStructureMemberName/fdl:nameComponent) = 1
                   and fdl:map[1]/fdl:sourceMember/fdl:dataStructureMemberName/fdl:nameComponent[1]/@name = '_PROCESS_INFO'
                   and count(fdl:map[1]/fdl:targetMember/fdl:dataStructureMemberName/fdl:nameComponent) = 1
                   and fdl:map[1]/fdl:targetMember/fdl:dataStructureMemberName/fdl:nameComponent[1]/@name = '_PROCESS_INFO'
                   and count(fdl:map[2]/fdl:sourceMember/fdl:dataStructureMemberName/fdl:nameComponent) = 1
                   and fdl:map[2]/fdl:sourceMember/fdl:dataStructureMemberName/fdl:nameComponent[1]/@name = '_ACTIVITY_INFO'
                   and count(fdl:map[2]/fdl:targetMember/fdl:dataStructureMemberName/fdl:nameComponent) = 1
                   and fdl:map[2]/fdl:targetMember/fdl:dataStructureMemberName/fdl:nameComponent[1]/@name = '_ACTIVITY_INFO'
                   and count(fdl:map[3]/fdl:sourceMember/fdl:dataStructureMemberName/fdl:nameComponent) = 1
                   and fdl:map[3]/fdl:sourceMember/fdl:dataStructureMemberName/fdl:nameComponent[1]/@name = '_STRUCT'
                   and count(fdl:map[3]/fdl:targetMember/fdl:dataStructureMemberName/fdl:nameComponent) = 1
                   and fdl:map[3]/fdl:targetMember/fdl:dataStructureMemberName/fdl:nameComponent[1]/@name = '_STRUCT'
                ]" use="generate-id()"/>
  <!--
    Key "loop-data-connectors" represents a "mapping" between activity names (as "key") and data connectors (as "value objects").
  -->
  <xsl:key name="loop-data-connectors-by-activity-name" match="fdl:data" use="@loop"/>
  <!--
    Key "default-data-connectors-by-activity-name" represents a "mapping" between
    activity names (as "key") and data connectors (as "value objects").
  -->
  <xsl:key name="default-data-connectors-by-activity-name" match="fdl:data" use="@default"/>
  <!--
    Key "outbound-control-connectors-by-activity-name" represents a "mapping" between
    activity names (as "key") and control connectors (as "value objects").
  -->
  <xsl:key name="outbound-control-connectors-by-activity-name" match="fdl:control" use="@from"/>
  <!--
    *****************************************************************************************************************************
    Initial template
    *****************************************************************************************************************************
  -->
  <xsl:template match="/">
    <xsl:if test="not( 'true' = $create_SCA_UPES_IMPORTS_only )">
      <!-- Run the FDL2BPEL conversion -->
      <xsl:apply-templates select="fdl:definitions/fdl:process[ @name = $process-name ]
                          | fdl:definitions/fdl:create/fdl:process[ @name = $process-name ]
                          | fdl:definitions/fdl:update/fdl:process[ @name = $process-name ]
                          | fdl:definitions/fdl:replace/fdl:process[ @name = $process-name ]" mode="business-process"/>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
     "business-process" template:

    Creates a "process" for each "fdl:process".
    (writes the result in a separate file with extension ".bpel")
    *****************************************************************************************************************************
  -->
  <xsl:template match="fdl:process" mode="business-process">
    <xsl:variable name="domain" select="//fdl:domain[1]"/>
    <xsl:variable name="system-group" select="//fdl:group[1]"/>
    <xsl:variable name="primary-system" select="//fdl:system[ @primarySystem ='yes' ][1]"/>
    <xsl:variable name="process-admin-task-name" select="concat(@name, $process-admin-task-suffix)"/>
    <xsl:variable name="process-atask-telfile-local-name" select="concat($process-admin-task-name, '.itel')"/>
    <xsl:variable name="activity-admin-task-name" select="concat(@name, $activity-admin-task-suffix)"/>
    <xsl:variable name="activity-atask-telfile-local-name" select="concat($activity-admin-task-name, '.itel')"/>
    <xsl:variable name="process-originating-task-name" select="concat(@name, $process-originating-task-suffix)"/>
    <xsl:variable name="process-otask-telfile-local-name" select="concat($process-originating-task-name, '.itel')"/>
    <xsl:if test="'true' = $option_ev and 'DATA' = $variable-type-mode">
      <!-- Register alias names for shared BPEL variables -->
      <xsl:apply-templates select="current()" mode="register-alias-names-for-SOURCE-variable"/>
      <xsl:apply-templates select="current()" mode="register-alias-names-for-SINK-variable"/>
      <xsl:apply-templates select="current()" mode="register-alias-names-for-GLOBAL_CONTAINER-variable"/>
      <xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="register-alias-names-for-activity-input-variable"/>
      <xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="register-alias-names-for-activity-output-variable"/>
      <!-- Register alias names for shared BPEL variables inside of fdl:block -->
      <xsl:apply-templates select="fdl:block" mode="register-alias-names-for-variables"/>
    </xsl:if>
    <xsl:variable name="input-variable-name" select="concat(@name, $input-variable-suffix)"/>
    <xsl:variable name="default-input-variable-name" select="concat(@name, $default-input-variable-suffix)"/>
    <xsl:variable name="output-variable-name" select="concat(@name, $output-variable-suffix)"/>
    <xsl:variable name="primary-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($input-variable-name)"/>
    <xsl:variable name="primary-output-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($output-variable-name)"/>
    <xsl:variable name="variables">
      <!-- Create comment: *** Variables *** -->
      <xsl:value-of select="concat($eol, '&lt;!-- *** Variables *** --&gt;', $eol)" disable-output-escaping="yes"/>
      <bpws:variables>
        <xsl:choose>
          <!-- CASE: interface-typed BPEL variables -->
          <xsl:when test="'INTERFACE' = $variable-type-mode">
            <!-- Create comment: Default input variable of process "nnn" -->
            <xsl:value-of select="concat($eol, '&lt;!-- Default input variable of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
            <!-- Create BPEL variable for the default input of the process -->
            <bpws:variable messageType="wsdl1:{@name}{$request-suffix}{$message-suffix}" name="{$default-input-variable-name}"/>
            <!-- Create comment: Data input variable of process "nnn" -->
            <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
            <!-- Create BPEL variable for the data input of the process -->
            <bpws:variable messageType="wsdl1:{@name}{$request-suffix}{$message-suffix}" name="{$input-variable-name}"/>
            <!-- Create comment: Data output variable of process "nnn" -->
            <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
            <!-- Create BPEL variable for the data output of the process -->
            <bpws:variable messageType="wsdl1:{@name}{$response-suffix}{$message-suffix}" name="{$output-variable-name}"/>
          </xsl:when>
          <!-- OTHERWISE: data-typed BPEL variables assumed -->
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="'true' = $createPredefinedDataMembers">
                <!-- Create comment: Default input variable of process "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Default input variable of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the default input of the process -->
                <bpws:variable type="mqwf:{fdl:input/@type}{$message-type-suffix}" name="{$default-input-variable-name}"/>
              </xsl:when>
              <xsl:otherwise>
                <!-- Create comment: Default input variable of process "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Default input variable of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the default input of the process -->
                <bpws:variable type="mqwf:{fdl:input/@type}" name="{$default-input-variable-name}"/>
              </xsl:otherwise>
            </xsl:choose>
            <xsl:choose>
              <xsl:when test="'true' = $option_ev">
                <xsl:choose>
                  <xsl:when test="'true' = $createPredefinedDataMembers">
                    <xsl:if test="$input-variable-name = $primary-input-variable-name">
                      <!-- Create comment: Data input variable of process "nnn" -->
                      <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                      <!-- Create BPEL variable for the data input of the process -->
                      <bpws:variable type="mqwf:{fdl:input/@type}{$message-type-suffix}" name="{$input-variable-name}"/>
                    </xsl:if>
                    <xsl:if test="$output-variable-name = $primary-output-variable-name">
                      <!-- Create comment: Data output variable of process "nnn" -->
                      <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                      <!-- Create BPEL variable for the data output of the process -->
                      <bpws:variable type="mqwf:{fdl:output/@type}{$message-type-suffix}" name="{$output-variable-name}"/>
                    </xsl:if>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:if test="$input-variable-name = $primary-input-variable-name">
                      <!-- Create comment: Data input variable of process "nnn" -->
                      <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                      <!-- Create BPEL variable for the data input of the process -->
                      <bpws:variable type="mqwf:{fdl:input/@type}" name="{$input-variable-name}"/>
                    </xsl:if>
                    <xsl:if test="$output-variable-name = $primary-output-variable-name">
                      <!-- Create comment: Data output variable of process "nnn" -->
                      <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                      <!-- Create BPEL variable for the data output of the process -->
                      <bpws:variable type="mqwf:{fdl:output/@type}" name="{$output-variable-name}"/>
                    </xsl:if>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:otherwise>
                <xsl:choose>
                  <xsl:when test="'true' = $createPredefinedDataMembers">
                    <!-- Create comment: Data input variable of process "nnn" -->
                    <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                    <!-- Create BPEL variable for the data input of the process -->
                    <bpws:variable type="mqwf:{fdl:input/@type}{$message-type-suffix}" name="{$input-variable-name}"/>
                    <!-- Create comment: Data output variable of process "nnn" -->
                    <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                    <!-- Create BPEL variable for the data output of the process -->
                    <bpws:variable type="mqwf:{fdl:output/@type}{$message-type-suffix}" name="{$output-variable-name}"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <!-- Create comment: Data input variable of process "nnn" -->
                    <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                    <!-- Create BPEL variable for the data input of the process -->
                    <bpws:variable type="mqwf:{fdl:input/@type}" name="{$input-variable-name}"/>
                    <!-- Create comment: Data output variable of process "nnn" -->
                    <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                    <!-- Create BPEL variable for the data output of the process -->
                    <bpws:variable type="mqwf:{fdl:output/@type}" name="{$output-variable-name}"/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
        <!-- Create an element-valued BPEL "variable" for each FDL "Global Container" -->
        <xsl:apply-templates select="fdl:globalContainer" mode="variables">
          <xsl:with-param name="process-name" select="@name"/>
        </xsl:apply-templates>
        <!-- Create "variables" for data input, data output, and optionally an auxiliary "status variable" for each activity contained in the process -->
        <xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="variables"/>
      </bpws:variables>
    </xsl:variable>
    <xsl:variable name="display-name">
      <xsl:choose>
        <xsl:when test="@displayName">
          <xsl:call-template name="tailor-display-name">
            <xsl:with-param name="untailored-display-name" select="@displayName"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="tailor-display-name">
            <xsl:with-param name="untailored-display-name" select="@name"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- Determine value of "validFrom" attribute -->
    <xsl:variable name="time-stamp">
      <xsl:choose>
        <xsl:when test="@validFrom">
          <!-- Format time stamp (replace blank between date and time by letter 'T') -->
          <xsl:value-of select="concat(substring-before(@validFrom, ' '), 'T', substring-after(@validFrom, ' '))"/>
        </xsl:when>
        <xsl:otherwise>
          <!-- Create current time stamp (otherwise the generated BPEL file cannot be viewed with the WebSphere Studio BPEL editor) -->
          <xsl:value-of select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.getCurrentDateAndTime()"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <bpws:process wpc:continueOnError="no" wpc:ignoreMissingData="yes" expressionLanguage="{$XPATH}" name="{@name}" suppressJoinFailure="yes" targetNamespace="{$bpelTargetNamespace}" wpc:displayName="{$display-name}" wpc:executionMode="longRunning" wpc:validFrom="{$time-stamp}">
      <xsl:variable name="keep-processes-maximum-duration">
        <xsl:choose>
          <xsl:when test="fdl:keepProcesses/@maximumDuration">
            <xsl:value-of select="fdl:keepProcesses/@maximumDuration"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$primary-system/fdl:processDefaultSetting/fdl:keepProcesses/@maximumDuration
                          and 'true' = $LI1274_Support_inheritance_from_network_settings">
                <xsl:value-of select="$primary-system/fdl:processDefaultSetting/fdl:keepProcesses/@maximumDuration"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:choose>
                  <xsl:when test="$system-group/fdl:processDefaultSetting/fdl:keepProcesses/@maximumDuration
                              and 'true' = $LI1274_Support_inheritance_from_network_settings">
                    <xsl:value-of select="$system-group/fdl:processDefaultSetting/fdl:keepProcesses/@maximumDuration"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:choose>
                      <xsl:when test="$domain/fdl:processDefaultSetting/fdl:keepProcesses/@maximumDuration
                                  and 'true' = $LI1274_Support_inheritance_from_network_settings">
                        <xsl:value-of select="$domain/fdl:processDefaultSetting/fdl:keepProcesses/@maximumDuration"/>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:value-of select="'not set'"/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <!-- Add "autoDelete" attribute -->
      <xsl:if test="$keep-processes-maximum-duration">
        <xsl:choose>
          <!-- CASE: never -->
          <xsl:when test="$keep-processes-maximum-duration = 'never'">
            <xsl:attribute name="wpc:autoDelete"><xsl:value-of select="'yes'"/></xsl:attribute>
          </xsl:when>
          <!-- CASE: forever -->
          <xsl:when test="$keep-processes-maximum-duration = 'forever'">
            <xsl:attribute name="wpc:autoDelete"><xsl:value-of select="'no'"/></xsl:attribute>
          </xsl:when>
          <!-- OTHERWISE: maximum duration as time period -->
          <xsl:otherwise>
            <!-- See creation of a warning below -->
          </xsl:otherwise>
        </xsl:choose>
      </xsl:if>
      <!-- Check whether the process is a "peer" or "child" process -->
      <xsl:choose>
        <!-- CASE: "peer" process -->
        <xsl:when test="@controlAutonomy='yes'
                or (   'true' = $LI1274_Support_inheritance_from_network_settings
                    and  not(@controlAutonomy='no')
                    and (  $primary-system/fdl:processDefaultSetting/@controlAutonomy='yes'
                        or (  not($primary-system/fdl:processDefaultSetting/@controlAutonomy='no')
                            and (   $system-group/fdl:processDefaultSetting/@controlAutonomy='yes'
                                or (  not($system-group/fdl:processDefaultSetting/@controlAutonomy='no')
                                    and $domain/fdl:processDefaultSetting/@controlAutonomy='yes' ) ) ) ) )">
          <!-- Add "autonomy" attribute with value "peer" -->
          <xsl:attribute name="wpc:autonomy"><xsl:value-of select="'peer'"/></xsl:attribute>
        </xsl:when>
        <!-- CASE: "child" process -->
        <xsl:when test="@controlAutonomy='no'
                or (   'true' = $LI1274_Support_inheritance_from_network_settings
                    and  not(@controlAutonomy='yes')
                    and (  $primary-system/fdl:processDefaultSetting/@controlAutonomy='no'
                        or (  not($primary-system/fdl:processDefaultSetting/@controlAutonomy='yes')
                            and (   $system-group/fdl:processDefaultSetting/@controlAutonomy='no'
                                or (  not($system-group/fdl:processDefaultSetting/@controlAutonomy='yes')
                                    and $domain/fdl:processDefaultSetting/@controlAutonomy='no' ) ) ) ) )">
          <!-- Add "autonomy" attribute with value "child" -->
          <xsl:attribute name="wpc:autonomy"><xsl:value-of select="'child'"/></xsl:attribute>
        </xsl:when>
        <!-- OTHERWISE: "child" process -->
        <xsl:otherwise>
          <!-- Add "autonomy" attribute with value "child" (the default) -->
          <xsl:attribute name="wpc:autonomy"><xsl:value-of select="'child'"/></xsl:attribute>
        </xsl:otherwise>
      </xsl:choose>
      <!-- Add optional business relevance indicator -->
      <xsl:choose>
        <!-- CASE: Filter option set in the FDL file -->
        <xsl:when test="string-length(fdl:activityDefaultSetting/@auditFilterDB) &gt; 0 or string-length(fdl:activityDefaultSetting/@auditFilterMQ) &gt; 0">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: Option "Audit trail" specified on page "Control" of the process settings -->
        <xsl:when test="@auditToDB = 'full' or @auditToDB = 'condensed' or @auditToMQ = 'full' or @auditToMQ = 'condensed'">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to DB" settings inherited from the primary system -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not(@auditToDB = 'no')
                    and ( $primary-system/fdl:processDefaultSetting/@auditToDB = 'full' or $primary-system/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to MQ" settings inherited from the primary system -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not(@auditToMQ = 'no')
                    and ( $primary-system/fdl:processDefaultSetting/@auditToMQ = 'full' or $primary-system/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to DB" settings inherited from the system group -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($primary-system/fdl:processDefaultSetting/@auditToDB = 'no')
                    and ( $system-group/fdl:processDefaultSetting/@auditToDB = 'full' or $system-group/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to MQ" settings inherited from the system group -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($primary-system/fdl:processDefaultSetting/@auditToMQ = 'no')
                    and ( $system-group/fdl:processDefaultSetting/@auditToMQ = 'full' or $system-group/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to DB" settings inherited from the domain -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($system-group/fdl:processDefaultSetting/@auditToDB = 'no')
                    and ( $domain/fdl:processDefaultSetting/@auditToDB = 'full' or $domain/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to MQ" settings inherited from the domain -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($system-group/fdl:processDefaultSetting/@auditToMQ = 'no')
                    and ( $domain/fdl:processDefaultSetting/@auditToMQ = 'full' or $domain/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
          <xsl:attribute name="wpc:businessRelevant">no</xsl:attribute>
        </xsl:otherwise>
      </xsl:choose>
      <!--
          Issue attribute warnings
      -->
      <xsl:if test="not(@validFrom)">
        <!-- "validFrom" is mandatory for BPEL -->
        <!--COMMENT: *** CWWBMnnnnW: Missing FDL attribute "validFrom" in process "nn" (dummy value created) *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MissingAttribute_ValidFrom', $fdlFileName, fdl:fdlLoc/@line, @displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
      </xsl:if>
      <xsl:if test="$keep-processes-maximum-duration">
        <xsl:choose>
          <!-- CASE: never -->
          <xsl:when test="$keep-processes-maximum-duration = 'never'">
            <!-- Is ok: no warning -->
          </xsl:when>
          <!-- CASE: forever -->
          <xsl:when test="$keep-processes-maximum-duration = 'forever'">
            <!-- Is ok: no warning -->
          </xsl:when>
          <xsl:when test="$keep-processes-maximum-duration = 'not set'">
            <!-- Is ok: no warning -->
          </xsl:when>
          <!-- OTHERWISE: maximum duration as time period -->
          <xsl:otherwise>
            <!--COMMENT: *** CWWBMnnnnW: No BPEL mapping available for FDL option "Keep finished processes for <duration>" in process "nn" *** -->
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_KeepFinishedProcessesFor', $fdlFileName, fdl:fdlLoc/@line, @displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:if>
      <!-- Process description and documentation -->
      <xsl:call-template name="translate-description-and-documentation-fields">
        <xsl:with-param name="node" select="current()"/>
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
        <xsl:with-param name="primary-input-variable-name" select="$primary-input-variable-name"/>
      </xsl:call-template>
      <!-- Process category -->
      <xsl:if test="@category">
        <wpc:customProperty name="Category">
          <wpc:value>
            <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
            <xsl:value-of select="@category"/>
            <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
          </wpc:value>
        </wpc:customProperty>
      </xsl:if>
      <!-- Process administrator -->
      <xsl:variable name="process-administrator">
        <xsl:choose>
          <xsl:when test="fdl:staff/fdl:processAdministrator">
            <xsl:copy-of select="fdl:staff"/>
          </xsl:when>
          <xsl:otherwise>
            <fdl:staff>
              <fdl:processStarter/>
            </fdl:staff>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <!--
        Create process administration task (generate A-task TEL file)
      -->
      <!-- Create comment: Reference to process administration task definition -->
      <xsl:value-of select="concat($eol, '&lt;!-- *** Reference to process administration task definition *** --&gt;', $eol)" disable-output-escaping="yes"/>
      <wpc:adminTask name="staff:{$process-admin-task-name}"/>
      <!-- Generate process A-task TEL file -->
      <xsl:variable name="process-atask-telfile-path-name" select="concat($outputdir, $process-atask-telfile-local-name)"/>
      <xsl:variable name="message1" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $process-atask-telfile-local-name)"/>
      <xsl:variable name="addITel1" select="java:com.ibm.bpe.fdl2bpel.converter.ITelList.add($process-atask-telfile-path-name)"/>
      <redirect:write select="concat($outputdir, $process-atask-telfile-local-name)">
        <tel:task defaultLocale="{$locale}" supportsFollowOnTask="no" supportsSubTask="no" kind="aTask" jndiNameStaffPluginProvider="bpe/staff/samplevmmconfiguration" targetNamespace="{$telTargetNamespace}" name="{$process-admin-task-name}" xmlns_wsdl1="{$wsdlTargetNamespace}">
          <tel:staffSettings>
            <tel:administrator>
              <tel:verb>
                <xsl:apply-templates select="xalan:nodeset($process-administrator)/fdl:staff" mode="create-staff-query-verb">
                  <xsl:with-param name="node" select="current()"/>
                  <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
                  <xsl:with-param name="local-variable-name" select="$primary-input-variable-name"/>
                </xsl:apply-templates>
              </tel:verb>
            </tel:administrator>
          </tel:staffSettings>
          <tel:uiSettings/>
          <tel:escalationSettings/>
        </tel:task>
      </redirect:write>
      <!--
        Create activity administration task (generate A-task TEL file)
      -->
      <!-- Create comment: Reference to process administration task definition -->
      <xsl:value-of select="concat($eol, '&lt;!-- *** Reference to process administration task definition *** --&gt;', $eol)" disable-output-escaping="yes"/>
      <wpc:activityAdminTask name="staff:{$activity-admin-task-name}"/>
      <!-- Generate activity A-task TEL file -->
      <xsl:variable name="activity-atask-telfile-path-name" select="concat($outputdir, $activity-atask-telfile-local-name)"/>
      <xsl:variable name="message2" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $activity-atask-telfile-local-name)"/>
      <xsl:variable name="addITel2" select="java:com.ibm.bpe.fdl2bpel.converter.ITelList.add($activity-atask-telfile-path-name)"/>
      <redirect:write select="concat($outputdir, $activity-atask-telfile-local-name)">
        <tel:task defaultLocale="{$locale}" supportsFollowOnTask="no" supportsSubTask="no" kind="aTask" jndiNameStaffPluginProvider="bpe/staff/samplevmmconfiguration" targetNamespace="{$telTargetNamespace}" name="{$activity-admin-task-name}" xmlns_wsdl1="{$wsdlTargetNamespace}">
          <tel:staffSettings>
            <tel:administrator>
              <tel:verb>
                <xsl:apply-templates select="xalan:nodeset($process-administrator)/fdl:staff" mode="create-staff-query-verb">
                  <xsl:with-param name="node" select="current()"/>
                  <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
                  <xsl:with-param name="local-variable-name" select="$primary-input-variable-name"/>
                </xsl:apply-templates>
              </tel:verb>
            </tel:administrator>
          </tel:staffSettings>
          <tel:uiSettings/>
          <tel:escalationSettings/>
        </tel:task>
      </redirect:write>
      <!--
        Create process originating task (generate O-task TEL file)
      -->
      <xsl:if test="@category and 'true' = $LI1109_Generate_O_Task_for_the_process">
        <xsl:variable name="process-otask-telfile-path-name" select="concat($outputdir, $process-otask-telfile-local-name)"/>
        <xsl:variable name="message3" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $process-otask-telfile-local-name)"/>
        <xsl:variable name="addITel3" select="java:com.ibm.bpe.fdl2bpel.converter.ITelList.add($process-otask-telfile-path-name)"/>
        <xsl:variable name="tel-target-namespace" select="concat($bpelTargetNamespace, '/', $process-originating-task-suffix)"/>
        <redirect:write select="concat($outputdir, $process-otask-telfile-local-name)">
          <tel:task targetNamespace="{$tel-target-namespace}" supportsSubTask="no" supportsFollowOnTask="no" supportsDelegation="no" name="{$process-originating-task-name}" kind="oTask" jndiNameStaffPluginProvider="bpe/staff/samplevmmconfiguration" durationUntilDeleted="DURATION_INFINITE" defaultLocale="{$locale}" calendarName="Simple" businessRelevance="no">
            <xsl:variable name="wsdlfile-local-name" select="substring-after($wsdlfile, $outputdir)"/>
            <tel:import namespace="{$wsdlTargetNamespace}" location="{$wsdlfile-local-name}" importType="{$wsdlNamespace}"/>
            <tel:interface portType="wsdl1:{@name}{$port-type-suffix}" operation="{@name}" kind="outbound"/>
            <!-- Process starter (used to assign a staff verb to the process O-task) -->
            <xsl:variable name="process-starter">
              <fdl:staff>
                <fdl:role name="{@category}"/>
              </fdl:staff>
            </xsl:variable>
            <tel:staffSettings>
              <tel:potentialInstanceCreator>
                <tel:verb>
                  <xsl:apply-templates select="xalan:nodeset($process-starter)/fdl:staff" mode="create-staff-query-verb">
                    <xsl:with-param name="node" select="current()"/>
                    <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
                    <xsl:with-param name="local-variable-name" select="$primary-input-variable-name"/>
                  </xsl:apply-templates>
                </tel:verb>
              </tel:potentialInstanceCreator>
              <tel:potentialStarter>
                <tel:verb>
                  <xsl:apply-templates select="xalan:nodeset($process-starter)/fdl:staff" mode="create-staff-query-verb">
                    <xsl:with-param name="node" select="current()"/>
                    <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
                    <xsl:with-param name="local-variable-name" select="$primary-input-variable-name"/>
                  </xsl:apply-templates>
                </tel:verb>
              </tel:potentialStarter>
            </tel:staffSettings>
            <tel:uiSettings/>
            <tel:escalationSettings/>
          </tel:task>
        </redirect:write>
      </xsl:if>
      <xsl:if test="fdl:staff/@autonomy='yes'
              or (   'true' = $LI1274_Support_inheritance_from_network_settings
                  and not(fdl:staff/@autonomy='no')
                  and (  $primary-system/fdl:processDefaultSetting/fdl:staff/@autonomy='yes'
                      or (  not($primary-system/fdl:processDefaultSetting/fdl:staff/@autonomy='no')
                          and (   $system-group/fdl:processDefaultSetting/fdl:staff/@autonomy='yes'
                              or (  not($system-group/fdl:processDefaultSetting/fdl:staff/@autonomy='no')
                                  and $domain/fdl:processDefaultSetting/fdl:staff/@autonomy='yes' ) ) ) ) )">
        <!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff autonomy flag in process "nnn" *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_StaffAutonomy', $fdlFileName, fdl:fdlLoc/@line, @displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
      </xsl:if>
      <xsl:if test="fdl:notification/@autonomy='yes'
              or (   'true' = $LI1274_Support_inheritance_from_network_settings
                  and not(fdl:notification/@autonomy='no')
                  and (  $primary-system/fdl:processDefaultSetting/fdl:notification/@autonomy='yes'
                      or (  not($primary-system/fdl:processDefaultSetting/fdl:notification/@autonomy='no')
                          and (   $system-group/fdl:processDefaultSetting/fdl:notification/@autonomy='yes'
                              or (  not($system-group/fdl:processDefaultSetting/fdl:notification/@autonomy='no')
                                  and $domain/fdl:processDefaultSetting/fdl:notification/@autonomy='yes' ) ) ) ) )">
        <!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL notification autonomy flag in process "nnn" *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_NotificationAutonomy', $fdlFileName, fdl:fdlLoc/@line, @displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
      </xsl:if>
      <xsl:if test="fdl:activityDefaultSetting/@includeProcessAssignment='yes'
              or (   'true' = $LI1274_Support_inheritance_from_network_settings
                  and not(fdl:activityDefaultSetting/@includeProcessAssignment='no')
                  and (  $primary-system/fdl:activityDefaultSetting/@includeProcessAssignment='yes'
                      or (  not($primary-system/fdl:activityDefaultSetting/@includeProcessAssignment='no')
                          and (   $system-group/fdl:activityDefaultSetting/@includeProcessAssignment='yes'
                              or (  not($system-group/fdl:activityDefaultSetting/@includeProcessAssignment='no')
                                  and $domain/fdl:activityDefaultSetting/@includeProcessAssignment='yes' ) ) ) ) )">
        <!-- Create comment: ***CWWBMnnnnW: Option "Include process assignment" cannot be mapped to BPEL. *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_IncludeProcessAssignment', $fdlFileName, fdl:fdlLoc/@line), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
      </xsl:if>
      <xsl:if test="fdl:activityDefaultSetting/@preferLocalUsers='yes'
              or (   'true' = $LI1274_Support_inheritance_from_network_settings
                  and not(fdl:activityDefaultSetting/@preferLocalUsers='no')
                  and (  $primary-system/fdl:activityDefaultSetting/@preferLocalUsers='yes'
                      or (  not($primary-system/fdl:activityDefaultSetting/@preferLocalUsers='no')
                          and (   $system-group/fdl:activityDefaultSetting/@preferLocalUsers='yes'
                              or (  not($system-group/fdl:activityDefaultSetting/@preferLocalUsers='no')
                                  and $domain/fdl:activityDefaultSetting/@preferLocalUsers='yes' ) ) ) ) )">
        <!-- Create comment: ***CWWBMnnnnW: Option "Prefer local users" cannot be mapped to BPEL. *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_PreferLocalUsers', $fdlFileName, fdl:fdlLoc/@line), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
      </xsl:if>
      <xsl:if test="fdl:activityDefaultSetting/@duplicateNotification='yes'
              or (   'true' = $LI1274_Support_inheritance_from_network_settings
                  and not(fdl:activityDefaultSetting/@duplicateNotification='no')
                  and (  $primary-system/fdl:activityDefaultSetting/@duplicateNotification='yes'
                      or (  not($primary-system/fdl:activityDefaultSetting/@duplicateNotification='no')
                          and (   $system-group/fdl:activityDefaultSetting/@duplicateNotification='yes'
                              or (  not($system-group/fdl:activityDefaultSetting/@duplicateNotification='no')
                                  and $domain/fdl:activityDefaultSetting/@duplicateNotification='yes' ) ) ) ) )">
        <!-- Create comment: ***CWWBMnnnnW: Option "Duplicate Notification" cannot be mapped to BPEL. *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_DuplicateNotification', $fdlFileName, fdl:fdlLoc/@line), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
      </xsl:if>
      <xsl:if test="@administrationAutonomy='yes'
              or (   'true' = $LI1274_Support_inheritance_from_network_settings
                  and not(@administrationAutonomy='no')
                  and (  $primary-system/fdl:processDefaultSetting/@administrationAutonomy='yes'
                      or (  not($primary-system/fdl:processDefaultSetting/@administrationAutonomy='no')
                          and (   $system-group/fdl:processDefaultSetting/@administrationAutonomy='yes'
                              or (  not($system-group/fdl:processDefaultSetting/@administrationAutonomy='no')
                                  and $domain/fdl:processDefaultSetting/@administrationAutonomy='yes' ) ) ) ) )">
        <!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL administration autonomy flag in process "nnn" *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_AdministrationAutonomy', $fdlFileName, fdl:fdlLoc/@line, @displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
      </xsl:if>
      <!-- WSDL import -->
      <xsl:variable name="wsdlfile-local-name" select="substring-after($wsdlfile, $outputdir)"/>
      <bpws:import namespace="{$wsdlTargetNamespace}" location="{$wsdlfile-local-name}" importType="{$wsdlNamespace}"/>
      <!-- TEL import for process administration aTask -->
      <bpws:import namespace="{$telTargetNamespace}" location="{$process-atask-telfile-local-name}" importType="{$telNamespace}"/>
      <!-- TEL import for activity administration aTask -->
      <bpws:import namespace="{$telTargetNamespace}" location="{$activity-atask-telfile-local-name}" importType="{$telNamespace}"/>
      <!-- TEL import for process administration oTask -->
      <xsl:if test="@category and 'true' = $LI1109_Generate_O_Task_for_the_process">
        <bpws:import namespace="{$telTargetNamespace}" location="{$process-otask-telfile-local-name}" importType="{$telNamespace}"/>
      </xsl:if>
      <!-- TEL imports for "staff activity" pTask -->
      <xsl:apply-templates select="current()//fdl:programActivity" mode="TEL-file">
        <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
        <xsl:with-param name="process-name" select="@name"/>
      </xsl:apply-templates>
      <!-- Create comment: *** Partner links *** -->
      <xsl:value-of select="concat($eol, '&lt;!-- *** Partner links *** --&gt;', $eol)" disable-output-escaping="yes"/>
      <bpws:partnerLinks>
        <!-- Create comment: Partner link used to invoke process "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Partner link used to invoke process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <xsl:choose>
          <!-- CASE: There is at least one process activity that invokes process "nnn" recursively -->
          <xsl:when test="descendant::fdl:processActivity/fdl:process/@name = @name">
            <!-- Create a "partnerLink" element for the service represented by the process -->
            <bpws:partnerLink partnerRole="{@name}{$role-suffix}" myRole="{@name}{$role-suffix}" partnerLinkType="wsdl1:{@name}{$partner-link-type-suffix}" name="{@name}{$partner-link-suffix}">
              <wpc:processResolver processTemplateName="{@name}"/>
            </bpws:partnerLink>
          </xsl:when>
          <!-- OTHERWISE: No recursive invocation of this process found -->
          <xsl:otherwise>
            <!-- Create a "partnerLink" element for the service represented by the process -->
            <bpws:partnerLink myRole="{@name}{$role-suffix}" partnerLinkType="wsdl1:{@name}{$partner-link-type-suffix}" name="{@name}{$partner-link-suffix}"/>
          </xsl:otherwise>
        </xsl:choose>
        <!-- Create "partnerLink" elements for the process activities contained in the process -->
        <xsl:apply-templates select="descendant::fdl:processActivity[ not( fdl:process/@name = current()/@name ) ]" mode="partner-links">
          <xsl:with-param name="process" select="current()"/>
        </xsl:apply-templates>
        <!--
          Create "partnerLink" elements for the server definitions (UPES) referred to in the process
          user option "-un" (no UPES migration) is selected (cp. LI754 (Do not prepare process for reuse of UPES)
        -->
        <xsl:if test="'true' = $createUPESInvocations">
          <xsl:apply-templates select="//fdl:definitions/fdl:server
                              | //fdl:definitions/fdl:create/fdl:server
                              | //fdl:definitions/fdl:update/fdl:server
                              | //fdl:definitions/fdl:replace/fdl:server" mode="partner-links">
            <xsl:with-param name="process" select="current()"/>
          </xsl:apply-templates>
        </xsl:if>
      </bpws:partnerLinks>
      <xsl:copy-of select="$variables"/>
      <!-- Determine the activities that are contained in the process -->
      <xsl:variable name="activities-contained-in-process" select="fdl:programActivity | fdl:processActivity | fdl:block"/>
      <!-- Create a sequence: "receive" - "flow" - "reply" -->
      <bpws:sequence wpc:displayName="sequence" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
        <!--
          Translate the SOURCE of the process to a "receive" activity
        -->
        <!-- Create comment: Receive the input data of process "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Receive the input data of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create "receive" activity -->
        <xsl:choose>
          <!-- CASE: interface-typed BPEL variables -->
          <xsl:when test="'INTERFACE' = $variable-type-mode">
            <bpws:receive partnerLink="{@name}{$partner-link-suffix}" portType="wsdl1:{@name}{$port-type-suffix}" operation="{@name}" variable="{$input-variable-name}" createInstance="yes" wpc:displayName="Receive the process input" name="Receive_the_process_input"/>
          </xsl:when>
          <!-- OTHERWISE: data-typed BPEL variables assumed -->
          <xsl:otherwise>
            <bpws:receive partnerLink="{@name}{$partner-link-suffix}" portType="wsdl1:{@name}{$port-type-suffix}" operation="{@name}" createInstance="yes" wpc:displayName="Receive the process input" name="Receive_the_process_input">
              <xsl:if test="@category and 'true' = $LI1109_Generate_O_Task_for_the_process">
                <!-- Create comment: Reference to process originating task definition -->
                <xsl:value-of select="concat($eol, '&lt;!-- *** Reference to process originating task definition *** --&gt;', $eol)" disable-output-escaping="yes"/>
                <wpc:task name="tel1:{$process-originating-task-name}"/>
              </xsl:if>
              <wpc:output>
                <wpc:parameter name="{$element-input-name}" variable="{$primary-input-variable-name}"/>
              </wpc:output>
            </bpws:receive>
          </xsl:otherwise>
        </xsl:choose>
        <!--
          Translate the setting of data defaults to an "assign" activity or "Java snippet".
        -->
        <xsl:if test="('true' = $createPredefinedDataMembers
                          and 'true' = $initializePredefinedDataMembers )
                          or (   fdl:input/fdl:dataDefaults/fdl:field
                            or fdl:output/fdl:dataDefaults/fdl:field
                            or fdl:globalContainer/fdl:dataDefaults/fdl:field
                            or descendant::fdl:programActivity/fdl:input/fdl:dataDefaults/fdl:field
                            or descendant::fdl:programActivity/fdl:output/fdl:dataDefaults/fdl:field
                            or descendant::fdl:processActivity/fdl:input/fdl:dataDefaults/fdl:field
                            or descendant::fdl:processActivity/fdl:output/fdl:dataDefaults/fdl:field
                            or descendant::fdl:block/fdl:input/fdl:dataDefaults/fdl:field
                            or descendant::fdl:block/fdl:output/fdl:dataDefaults/fdl:field )">
          <xsl:variable name="data-connector-between-process-input-and-default-input">
            <fdl:data>
              <fdl:map>
                <fdl:sourceMember>
                  <fdl:dataStructureMemberName>
                    <fdl:nameComponent name="_STRUCT"/>
                  </fdl:dataStructureMemberName>
                </fdl:sourceMember>
                <fdl:targetMember>
                  <fdl:dataStructureMemberName>
                    <fdl:nameComponent name="_STRUCT"/>
                  </fdl:dataStructureMemberName>
                </fdl:targetMember>
              </fdl:map>
            </fdl:data>
          </xsl:variable>
          <!-- Create comment: *** Set the data default values *** -->
          <xsl:value-of select="concat($eol, '&lt;!-- Set the data default values --&gt;', $eol)" disable-output-escaping="yes"/>
          <bpws:assign wpc:displayName="Set the data default values" name="Set_the_data_default_values">
            <!--
              Assign default values of process input to auxiliary variable
            -->
            <xsl:call-template name="set-data-fields">
              <xsl:with-param name="create-activity" select="false()"/>
              <xsl:with-param name="data-fields" select="fdl:input/fdl:dataDefaults"/>
              <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
              <xsl:with-param name="variable-name" select="$default-input-variable-name"/>
              <xsl:with-param name="node" select="current()"/>
              <xsl:with-param name="container-type" select="'input'"/>
            </xsl:call-template>
            <!--
              Translate the setting of process output data defaults.
            -->
            <xsl:call-template name="set-data-fields">
              <xsl:with-param name="create-activity" select="false()"/>
              <xsl:with-param name="data-fields" select="fdl:output/fdl:dataDefaults"/>
              <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
              <xsl:with-param name="variable-name" select="$primary-output-variable-name"/>
              <xsl:with-param name="node" select="current()"/>
              <xsl:with-param name="container-type" select="'output'"/>
            </xsl:call-template>
            <xsl:if test="fdl:globalContainer/fdl:dataDefaults">
              <!--
                Translate the setting of global container data defaults.
              -->
              <xsl:call-template name="set-data-fields">
                <xsl:with-param name="create-activity" select="false()"/>
                <xsl:with-param name="data-fields" select="fdl:globalContainer/fdl:dataDefaults"/>
                <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
                <xsl:with-param name="variable-name" select="'GLOBAL_CONTAINER'"/>
                <xsl:with-param name="node" select="current()"/>
                <xsl:with-param name="container-type" select="'global container'"/>
              </xsl:call-template>
            </xsl:if>
            <xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="data-defaults">
              <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
              <xsl:with-param name="create-activity" select="false()"/>
            </xsl:apply-templates>
          </bpws:assign>
          <!-- Create comment: *** Add default values to the process input *** -->
          <xsl:value-of select="concat($eol, '&lt;!-- Add default values to the process input --&gt;', $eol)" disable-output-escaping="yes"/>
          <bpws:invoke wpc:continueOnError="no" portType="wpc:null" partnerLink="null" operation="null" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Add default values to the process input">
            <wpc:script>
              <wpc:javaCode>
                <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
                <!--
                  Complement missing process input data with default values
                -->
                <!-- Create comment: Complement missing process input data with default values -->
                <xsl:value-of select="concat($eol, '// Complement missing process input data with default values', $eol)" disable-output-escaping="yes"/>
                <xsl:call-template name="create-data-mapping-activity">
                  <xsl:with-param name="data" select="xalan:nodeset($data-connector-between-process-input-and-default-input)/fdl:data"/>
                  <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
                  <xsl:with-param name="from-variable-name" select="$primary-input-variable-name"/>
                  <xsl:with-param name="to-variable-name" select="$default-input-variable-name"/>
                  <xsl:with-param name="node" select="current()"/>
                  <xsl:with-param name="merged_data_distribution" select="true()"/>
                  <xsl:with-param name="set_process_input_default_values" select="true()"/>
                </xsl:call-template>
                <xsl:if test="'true' = $createPredefinedDataMembers">
                  <!-- Set process instance name -->
                  <xsl:value-of select="concat(  $eol,
                                          $primary-input-variable-name,
                                          '.set(&quot;_PROCESS&quot;, processInstance().getName());'
                                          )" disable-output-escaping="yes"/>
                </xsl:if>
                <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
              </wpc:javaCode>
            </wpc:script>
          </bpws:invoke>
        </xsl:if>
        <!--
          Translate data connectors from the process data input container ("SOURCE") to "assign" activities or "Java snippets" .
        -->
        <xsl:variable name="SOURCE-data-connectors" select="fdl:data[
                @from = current()/fdl:input/@name
                and not( java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName(concat(current()/@name, $input-variable-suffix)) = java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName(concat(@to, $input-variable-suffix)) ) ]"/>
        <xsl:choose>
          <xsl:when test="$SOURCE-data-connectors">
            <!-- Create comment: Distribute the input data of process "nnn" to the start activities of its implementation -->
            <xsl:value-of select="concat($eol, '&lt;!-- Distribute the input data of process &quot;', @name, '&quot; to the start activities of its implementation --&gt;', $eol)" disable-output-escaping="yes"/>
            <xsl:choose>
              <!-- CASE: Option "merged data distribution" is enabled and there is more than one inbound data connector -->
              <xsl:when test="'true' = $option_mj and count($SOURCE-data-connectors) &gt; 1">
                <xsl:choose>
                  <!-- CASE: create "Java snippet" -->
                  <xsl:when test="'true' = $create_Java_Snippets">
                    <bpws:invoke wpc:continueOnError="no" portType="wpc:null" partnerLink="null" operation="null" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Distribute the process input data to the start activities">
                      <wpc:script>
                        <wpc:javaCode>
                          <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
                          <!-- Create comment: Distribute the process input data to the start activities -->
                          <xsl:value-of select="concat($eol, '// Distribute the process input data to the start activities', $eol)" disable-output-escaping="yes"/>
                          <!-- Translate data connectors with their respective data mappings -->
                          <xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
                            <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
                            <xsl:with-param name="node" select="current()"/>
                            <xsl:with-param name="merged_data_distribution" select="true()"/>
                          </xsl:apply-templates>
                          <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
                        </wpc:javaCode>
                      </wpc:script>
                    </bpws:invoke>
                  </xsl:when>
                  <!-- OTHERWISE: create "assign" activity -->
                  <xsl:otherwise>
                    <bpws:assign wpc:displayName="Distribute the process input data to the start activities" name="Distribute_the_process_input_data_to_the_start_activities">
                      <!-- Translate data connectors with their respective data mappings -->
                      <xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
                        <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
                        <xsl:with-param name="node" select="current()"/>
                        <xsl:with-param name="merged_data_distribution" select="true()"/>
                      </xsl:apply-templates>
                    </bpws:assign>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <!-- OTHERWISE: Option "merged data distribution" is disabled -->
              <xsl:otherwise>
                <!-- If more than one data connector goes out from SOURCE, enclose the data flows ("data mapping" activities) with a "flow" activity -->
                <xsl:choose>
                  <!-- CASE: more than one connector -->
                  <xsl:when test="count($SOURCE-data-connectors) &gt; 1">
                    <bpws:flow wpc:displayName="Distribute the process input data to the start activities" name="Distribute_the_process_input_data_to_the_start_activities">
                      <!-- Translate data connectors with their respective data mappings "data mapping" ("assign" or "Java snippet") activities -->
                      <xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
                        <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
                        <xsl:with-param name="node" select="current()"/>
                      </xsl:apply-templates>
                    </bpws:flow>
                  </xsl:when>
                  <!-- OTHERWISE: (exactly one connector) -->
                  <xsl:otherwise>
                    <!-- Translate data connectors with their respective data mappings by "data mapping" ("assign" or "Java snippet") activities -->
                    <xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
                      <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
                      <xsl:with-param name="node" select="current()"/>
                    </xsl:apply-templates>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <!-- OTHERWISE: no connector -->
          <xsl:otherwise>
            <!--COMMENT: *** CWWBMnnnnW: There is no data connector in process "nnn" that distributes the process input data. *** -->
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MissingInputDataConnector', $fdlFileName, fdl:fdlLoc/@line, @displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
          </xsl:otherwise>
        </xsl:choose>
        <!--
          Translate the activities and their respective control and data connectors contained in the process.
          Enclose the translation into a "flow" activity, if there are at least two activities.
        -->
        <xsl:if test="count($activities-contained-in-process) &gt; 0">
          <!-- Create comment: *** Implementation of process "nnn" *** -->
          <xsl:value-of select="concat($eol, '&lt;!-- Implementation of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
        <xsl:choose>
          <!-- CASE: more than one activity contained in the process -->
          <xsl:when test="count($activities-contained-in-process) &gt; 1">
            <!-- Create a "flow" element -->
            <bpws:flow wpc:displayName="{$Execute-activities-contained-in-process}" name="Execute_activities_contained_in_process">
              <!-- Translate the control connectors -->
              <xsl:if test="fdl:control">
                <!-- Create comment: Links that implement the internal control flow of process "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Links that implement the internal control flow of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <bpws:links>
                  <xsl:apply-templates select="fdl:control" mode="links">
                    <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
                    <xsl:with-param name="node" select="current()"/>
                  </xsl:apply-templates>
                </bpws:links>
              </xsl:if>
              <!-- Translate the activities and their related data connectors -->
              <xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="activities">
                <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
                <xsl:with-param name="activity-contained-in-flow" select="true()"/>
              </xsl:apply-templates>
            </bpws:flow>
          </xsl:when>
          <!-- OTHERWISE: one or no activity contained in the process -->
          <xsl:otherwise>
            <!--  No "flow" element necessary. Translate one activity, if there is one. -->
            <xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="activities">
              <xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
            </xsl:apply-templates>
          </xsl:otherwise>
        </xsl:choose>
        <!-- Check whether the process has any outbound data connector in the FDL -->
        <xsl:variable name="TARGET-data-connectors" select="fdl:data[ @to = current()/fdl:output/@name ]"/>
        <xsl:if test="not($TARGET-data-connectors)">
          <!--COMMENT: *** CWWBMnnnnW: There is no data connector in process "nnn" that collects the process output data. *** -->
          <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MissingOutputDataConnector', $fdlFileName, fdl:fdlLoc/@line, @displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
        <!--
            Translate the SINK of the process to a "reply" activity
        -->
        <!-- Create comment: Send the output data of process "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Send the output data of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create "repy" activity -->
        <xsl:choose>
          <!-- CASE: interface-typed BPEL variables -->
          <xsl:when test="'INTERFACE' = $variable-type-mode">
            <bpws:reply partnerLink="{@name}{$partner-link-suffix}" portType="wsdl1:{@name}{$port-type-suffix}" operation="{@name}" variable="{$output-variable-name}" wpc:displayName="Return the process output" name="Return_the_process_output"/>
          </xsl:when>
          <!-- OTHERWISE: data-typed BPEL variables assumed -->
          <xsl:otherwise>
            <bpws:reply partnerLink="{@name}{$partner-link-suffix}" portType="wsdl1:{@name}{$port-type-suffix}" operation="{@name}" wpc:displayName="Return the process output" name="Return_the_process_output">
              <wpc:input>
                <wpc:parameter name="{$element-output-name}" variable="{$primary-output-variable-name}"/>
              </wpc:input>
            </bpws:reply>
          </xsl:otherwise>
        </xsl:choose>
      </bpws:sequence>
    </bpws:process>
    <!-- Generate MON file -->
    <xsl:variable name="mon-local-name" select="concat(@name, '_bpel.mon')"/>
    <xsl:variable name="mon-path-name" select="concat($outputdir, $mon-local-name)"/>
    <xsl:variable name="message4" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $mon-local-name)"/>
    <xsl:variable name="addMon" select="java:com.ibm.bpe.fdl2bpel.converter.MonList.add($mon-path-name)"/>
    <redirect:write select="concat($outputdir, $mon-local-name)">
      <Monitor xmlns="http://www.ibm.com/xmlns/prod/websphere/monitoring/6.0.0/mon" xmlns:bpel="http://www.ibm.com/xmlns/prod/websphere/scdl/business-process" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.ibm.com/xmlns/prod/websphere/monitoring/6.0.0/mon monitor.xsd" kind="http://www.ibm.com/xmlns/prod/websphere/scdl/business-process/6.0.0" name="{@name}" targetName="{@name}" targetNamespace="{$bpelTargetNamespace}:{@name}">
        <EnableDefaultEvents>false</EnableDefaultEvents>
        <Configuration>
          <Entry key="FULL_MODE" value="FIELDS"/>
        </Configuration>
        <Attributes>
          <Entry key="IdentifyingAttribute" value="wpc:id"/>
        </Attributes>
      </Monitor>
    </redirect:write>
  </xsl:template>
  <!--
    ****************************************************************
    "TEL-file" template:

    Creates and imports TEL file referenced  by a "staff activity"
    ****************************************************************
   -->
  <xsl:template match="fdl:programActivity" mode="TEL-file">
    <xsl:param name="variables"/>
    <xsl:param name="process-name"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;TEL-file&quot; match=&quot;fdl:programActivity&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($process-name) or $process-name=''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;TEL-file&quot; match=&quot;fdl:programActivity&quot;', $eol, 'Parameter &quot;process-name&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="local-variable-name" select="concat(@name, $input-variable-suffix)"/>
    <xsl:variable name="primary-local-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($local-variable-name)"/>
    <xsl:variable name="parent-process" select="current()/ancestor::fdl:process"/>
    <xsl:variable name="process-input-variable-name" select="concat($parent-process/@name, $input-variable-suffix)"/>
    <xsl:variable name="primary-process-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($process-input-variable-name)"/>
    <xsl:variable name="domain" select="//fdl:domain[1]"/>
    <xsl:variable name="system-group" select="//fdl:group[1]"/>
    <xsl:variable name="primary-system" select="//fdl:system[ @primarySystem ='yes' ][1]"/>
    <!-- Check whether the program is a "staff activity" -->
    <xsl:variable name="program-activity-type">
      <xsl:call-template name="program-activity-type">
        <xsl:with-param name="activity" select="current()"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:if test="$program-activity-type = 'staff activity' or $program-activity-type = 'assumed staff activity'">
      <xsl:variable name="port-type">
        <xsl:choose>
          <xsl:when test="fdl:program/@name">
            <xsl:value-of select="concat('wsdl1:', fdl:program/@name, $port-type-suffix)"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'null'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:variable name="operation" select="@name"/>
      <xsl:variable name="telfile-local-name" select="concat($process-name, '_', @name, '.itel')"/>
      <xsl:variable name="telfile-path-name" select="concat($outputdir, $telfile-local-name)"/>
      <xsl:variable name="task-name" select="concat(@name, $ptask-name-suffix)"/>
      <xsl:variable name="wsdlfile-local-name" select="substring-after($wsdlfile, $outputdir)"/>
      <xsl:variable name="substitution-policy">
        <xsl:choose>
          <xsl:when test="fdl:defaultSetting/@substitution='yes'
                       or (  not(fdl:defaultSetting/@substitution='no')
                          and (   $parent-process/fdl:activityDefaultSetting/@substitution='yes'
                              or (   'true' = $LI1274_Support_inheritance_from_network_settings
                                  and not($parent-process/fdl:activityDefaultSetting/@substitution='no')
                                  and (  $primary-system/fdl:activityDefaultSetting/@substitution='yes'
                                      or (  not($primary-system/fdl:activityDefaultSetting/@substitution='no')
                                          and (   $system-group/fdl:activityDefaultSetting/@substitution='yes'
                                              or (  not($system-group/fdl:activityDefaultSetting/@substitution='no')
                                                  and $domain/fdl:activityDefaultSetting/@substitution='yes' ) ) ) ) ) ) )">
            <xsl:value-of select="'SubstituteUserIfAbsent'"/>
          </xsl:when>
          <xsl:when test="fdl:defaultSetting/@preferNonAbsentUsers='yes'
                       or (  not(fdl:defaultSetting/@preferNonAbsentUsers='no')
                          and (   $parent-process/fdl:activityDefaultSetting/@preferNonAbsentUsers='yes'
                              or (   'true' = $LI1274_Support_inheritance_from_network_settings
                                  and not($parent-process/fdl:activityDefaultSetting/@preferNonAbsentUsers='no')
                                  and (  $primary-system/fdl:activityDefaultSetting/@preferNonAbsentUsers='yes'
                                      or (  not($primary-system/fdl:activityDefaultSetting/@preferNonAbsentUsers='no')
                                          and (   $system-group/fdl:activityDefaultSetting/@preferNonAbsentUsers='yes'
                                              or (  not($system-group/fdl:activityDefaultSetting/@preferNonAbsentUsers='no')
                                                  and $domain/fdl:activityDefaultSetting/@preferNonAbsentUsers='yes' ) ) ) ) ) ) )">
            <xsl:value-of select="'SelectUserIfPresent'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'NoSubstitution'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <!-- Create TEL-file import -->
      <bpws:import namespace="{$telTargetNamespace}" location="{$telfile-local-name}" importType="{$telNamespace}"/>
      <xsl:variable name="staff-verb">
        <xsl:choose>
          <xsl:when test="fdl:staff">
            <tel:verb>
              <xsl:apply-templates select="fdl:staff" mode="create-staff-query-verb">
                <xsl:with-param name="node" select="current()"/>
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="local-variable-name" select="$primary-local-variable-name"/>
              </xsl:apply-templates>
            </tel:verb>
          </xsl:when>
          <xsl:when test="$parent-process/fdl:staff">
            <xsl:variable name="parent-local-variable-name" select="concat($parent-process/@name, $input-variable-suffix)"/>
            <xsl:variable name="primary-parent-local-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($parent-local-variable-name)"/>
            <tel:verb>
              <xsl:apply-templates select="$parent-process/fdl:staff" mode="create-staff-query-verb">
                <xsl:with-param name="node" select="$parent-process"/>
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="local-variable-name" select="$primary-parent-local-variable-name"/>
              </xsl:apply-templates>
            </tel:verb>
          </xsl:when>
          <xsl:otherwise>
            <tel:verb>
              <!-- Create comment: FDL staff query "All people" -->
              <xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;All people&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
              <tel:name>Everybody</tel:name>
            </tel:verb>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:variable name="message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $telfile-local-name)"/>
      <xsl:variable name="addITel" select="java:com.ibm.bpe.fdl2bpel.converter.ITelList.add($telfile-path-name)"/>
      <redirect:write select="concat($outputdir, $telfile-local-name)">
        <tel:task defaultLocale="{$locale}" kind="pTask" jndiNameStaffPluginProvider="bpe/staff/samplevmmconfiguration" targetNamespace="{$telTargetNamespace}" substitutionPolicy="{$substitution-policy}" name="{$task-name}" xmlns_wsdl1="{$wsdlTargetNamespace}">
          <xsl:choose>
            <!-- CASE: fixed priority value (Note that priority 0 is equivalent to "not set") -->
            <xsl:when test="@priority &gt; 0">
              <!-- Add "priority" attribute -->
              <xsl:attribute name="priority"><xsl:value-of select="@priority"/></xsl:attribute>
            </xsl:when>
            <!-- CASE: priority value from container member -->
            <xsl:when test="fdl:priority/fdl:dataStructureMemberName">
              <!-- Add "priorityDefinition" attribute -->
              <xsl:variable name="priority-expression">
                <xsl:apply-templates select="fdl:priority/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
                  <xsl:with-param name="display-name" select="@displayName"/>
                  <xsl:with-param name="node" select="current()"/>
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="local-variable-name" select="$primary-local-variable-name"/>
                  <xsl:with-param name="FDL-location" select="fdl:fdlLoc"/>
                </xsl:apply-templates>
              </xsl:variable>
              <xsl:attribute name="priorityDefinition"><xsl:value-of select="concat('%wf:', substring-after($priority-expression, '%'))"/></xsl:attribute>
            </xsl:when>
            <!-- CASE: priority value from predefined container member -->
            <xsl:when test="@priorityDefinedInInputContainer='yes'">
              <xsl:choose>
                <xsl:when test="'true' = $createPredefinedDataMembers">
                  <!-- Add "priorityDefinition" attribute -->
                  <xsl:variable name="priority-expression">
                    <xsl:choose>
                      <!-- CASE: interface-typed BPEL variables -->
                      <xsl:when test="'INTERFACE' = $variable-type-mode">
                        <xsl:value-of select="concat('%wf:', $local-variable-name, '\', $message-part-name, '\_ACTIVITY_INFO/Priority%')"/>
                      </xsl:when>
                      <!-- OTHERWISE: data-typed BPEL variables assumed -->
                      <xsl:otherwise>
                        <xsl:value-of select="concat('%wf:', $primary-local-variable-name, '\\_ACTIVITY_INFO/Priority%')"/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:variable>
                  <xsl:attribute name="priorityDefinition"><xsl:value-of select="$priority-expression"/></xsl:attribute>
                </xsl:when>
                <xsl:otherwise>
                  <!-- Create comment: *** CWWBMnnnnW: Option "Priority from predefined member" of program activity nnn cannot be mapped to BPEL, because you deselected the generation of predefined data members. *** -->
                  <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_PriorityFromPredefinedMember', $fdlFileName, fdl:fdlLoc/@line, @displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:when>
          </xsl:choose>
          <tel:import location="{$wsdlfile-local-name}" importType="{$wsdlNamespace}" namespace="{$wsdlTargetNamespace}"/>
          <tel:interface portType="{$port-type}" operation="{$operation}" kind="inbound"/>
          <tel:staffSettings>
            <tel:administrator>
              <tel:verb>
                <xsl:choose>
                  <xsl:when test="fdl:staff/fdl:processAdministrator">
                    <xsl:apply-templates select="fdl:staff" mode="create-staff-query-verb">
                      <xsl:with-param name="node" select="current()"/>
                      <xsl:with-param name="variables" select="$variables"/>
                      <xsl:with-param name="local-variable-name" select="$primary-local-variable-name"/>
                    </xsl:apply-templates>
                  </xsl:when>
                  <xsl:when test="$parent-process/fdl:staff/fdl:processAdministrator">
                    <xsl:apply-templates select="$parent-process/fdl:staff" mode="create-staff-query-verb">
                      <xsl:with-param name="node" select="$parent-process"/>
                      <xsl:with-param name="variables" select="$variables"/>
                      <xsl:with-param name="local-variable-name" select="$primary-process-input-variable-name"/>
                    </xsl:apply-templates>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:variable name="process-starter">
                      <fdl:staff>
                        <fdl:processStarter/>
                      </fdl:staff>
                    </xsl:variable>
                    <xsl:apply-templates select="xalan:nodeset($process-starter)/fdl:staff" mode="create-staff-query-verb">
                      <xsl:with-param name="node" select="$parent-process"/>
                      <xsl:with-param name="variables" select="$variables"/>
                      <xsl:with-param name="local-variable-name" select="$primary-process-input-variable-name"/>
                    </xsl:apply-templates>
                  </xsl:otherwise>
                </xsl:choose>
              </tel:verb>
            </tel:administrator>
            <tel:potentialOwner>
              <xsl:if test="fdl:defaultSetting/@includeProcessAssignment='yes'
                     or (  not(fdl:defaultSetting/@includeProcessAssignment='no')
                        and (   $parent-process/fdl:activityDefaultSetting/@includeProcessAssignment='yes'
                            or (   'true' = $LI1274_Support_inheritance_from_network_settings
                                and not($parent-process/fdl:activityDefaultSetting/@includeProcessAssignment='no')
                                and (  $primary-system/fdl:activityDefaultSetting/@includeProcessAssignment='yes'
                                    or (  not($primary-system/fdl:activityDefaultSetting/@includeProcessAssignment='no')
                                        and (   $system-group/fdl:activityDefaultSetting/@includeProcessAssignment='yes'
                                            or (  not($system-group/fdl:activityDefaultSetting/@includeProcessAssignment='no')
                                                and $domain/fdl:activityDefaultSetting/@includeProcessAssignment='yes' ) ) ) ) ) ) )">
                <!-- Create comment: ***CWWBMnnnnW: Option "Include process assignment" cannot be mapped to BPEL. *** -->
                <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_IncludeProcessAssignment', $fdlFileName, fdl:fdlLoc/@line), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
              </xsl:if>
              <xsl:copy-of select="$staff-verb"/>
            </tel:potentialOwner>
          </tel:staffSettings>
          <tel:uiSettings/>
          <tel:escalationSettings>
            <xsl:if test="fdl:defaultSetting/@notificationSubstitution='yes'
                   or (  not(fdl:defaultSetting/@notificationSubstitution='no')
                      and (   $parent-process/fdl:activityDefaultSetting/@notificationSubstitution='yes'
                          or (   'true' = $LI1274_Support_inheritance_from_network_settings
                              and not($parent-process/fdl:activityDefaultSetting/@notificationSubstitution='no')
                              and (  $primary-system/fdl:activityDefaultSetting/@notificationSubstitution='yes'
                                  or (  not($primary-system/fdl:activityDefaultSetting/@notificationSubstitution='no')
                                      and (   $system-group/fdl:activityDefaultSetting/@notificationSubstitution='yes'
                                          or (  not($system-group/fdl:activityDefaultSetting/@notificationSubstitution='no')
                                              and $domain/fdl:activityDefaultSetting/@notificationSubstitution='yes' ) ) ) ) ) ) )">
              <!-- Create comment: ***CWWBMnnnnW: Option "Assign substitute for notification if user is absent" cannot be mapped to BPEL. *** -->
              <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_NotificationSubstitution', $fdlFileName, fdl:fdlLoc/@line), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
            </xsl:if>
            <xsl:if test="fdl:defaultSetting/@duplicateNotification='yes'
                   or (  not(fdl:defaultSetting/@duplicateNotification='no')
                      and (   $parent-process/fdl:activityDefaultSetting/@duplicateNotification='yes'
                          or (   'true' = $LI1274_Support_inheritance_from_network_settings
                              and not($parent-process/fdl:activityDefaultSetting/@duplicateNotification='no')
                              and (  $primary-system/fdl:activityDefaultSetting/@duplicateNotification='yes'
                                  or (  not($primary-system/fdl:activityDefaultSetting/@duplicateNotification='no')
                                      and (   $system-group/fdl:activityDefaultSetting/@duplicateNotification='yes'
                                          or (  not($system-group/fdl:activityDefaultSetting/@duplicateNotification='no')
                                              and $domain/fdl:activityDefaultSetting/@duplicateNotification='yes' ) ) ) ) ) ) )">
              <!-- Create comment: ***CWWBMnnnnW: Option "Duplicate Notification" cannot be mapped to BPEL. *** -->
              <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_DuplicateNotification', $fdlFileName, fdl:fdlLoc/@line), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
            </xsl:if>
            <xsl:if test="fdl:defaultSetting/@preferLocalUsers='yes'
                   or (  not(fdl:defaultSetting/@preferLocalUsers='no')
                      and (   $parent-process/fdl:activityDefaultSetting/@preferLocalUsers='yes'
                          or (   'true' = $LI1274_Support_inheritance_from_network_settings
                              and not($parent-process/fdl:activityDefaultSetting/@preferLocalUsers='no')
                              and (  $primary-system/fdl:activityDefaultSetting/@preferLocalUsers='yes'
                                  or (  not($primary-system/fdl:activityDefaultSetting/@preferLocalUsers='no')
                                      and (   $system-group/fdl:activityDefaultSetting/@preferLocalUsers='yes'
                                          or (  not($system-group/fdl:activityDefaultSetting/@preferLocalUsers='no')
                                              and $domain/fdl:activityDefaultSetting/@preferLocalUsers='yes' ) ) ) ) ) ) )">
              <!-- Create comment: ***CWWBMnnnnW: Option "Assign substitute for notification if user is absent" cannot be mapped to BPEL. *** -->
              <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_PreferLocalUsers', $fdlFileName, fdl:fdlLoc/@line), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
            </xsl:if>
            <xsl:call-template name="create-escalation-chain">
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="activity" select="current()"/>
            </xsl:call-template>
          </tel:escalationSettings>
        </tel:task>
      </redirect:write>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "partner-links" template:

    Creates a (unique) "partnerLink" for each "fdl:process that is referenced by "fdl:processActivity"
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:processActivity" mode="partner-links">
    <!--
      Create a "partnerLink" element only, if the current "processActivity" element does not point to an identical "process" element
      as a preceding "processActivity" within the same "process" (because then the "partnerLink" element is already created in a
      previous call of this template).
    -->
    <xsl:choose>
      <!-- CASE: subprocess name is specified at build time -->
      <xsl:when test="fdl:process/@name">
        <xsl:if test="fdl:process/@name and not( fdl:process/@name = preceding::fdl:processActivity[ ancestor::fdl:process/@name = current()/ancestor::fdl:process/@name ]/fdl:process/@name )">
          <!-- Create comment: Partner link used to invoke process "nnn" -->
          <xsl:value-of select="concat($eol, '&lt;!-- Partner link used to invoke process &quot;', fdl:process/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
          <bpws:partnerLink partnerRole="{fdl:process/@name}{$role-suffix}" partnerLinkType="wsdl1:{fdl:process/@name}{$partner-link-type-suffix}" name="{fdl:process/@name}{$partner-link-suffix}">
            <wpc:processResolver processTemplateName="{fdl:process/@name}"/>
          </bpws:partnerLink>
        </xsl:if>
      </xsl:when>
      <!-- CASE: subprocess name is specified at run time (taken from data container) -->
      <xsl:when test="fdl:process/fdl:dataStructureMemberName/fdl:nameComponent">
        <!-- Create comment: Partner link used to invoke late-bound subprocess invoke by process activity "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Partner link used to invoke late-bound subprocess invoke by process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <bpws:partnerLink partnerRole="{@name}{$role-suffix}" partnerLinkType="wsdl1:{@name}{$partner-link-type-suffix}" name="{@name}{$partner-link-suffix}"/>
      </xsl:when>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "partner-links" template:

    Creates a "partnerLink" for each"fdl:server" that is referred to in the process
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:server" mode="partner-links">
    <xsl:param name="process"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($process)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;partner-links&quot; match=&quot;fdl:server&quot;', $eol, 'Parameter &quot;process&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="related-system-name" select="fdl:relatedSystem/@name"/>
    <xsl:variable name="related-group-name" select="fdl:relatedGroup/@name"/>
    <!-- Create partner link only if the server is referred to by some program activity of type 'service invocation activity' -->
    <xsl:variable name="server-is-used-by-a-service-invocation-activity">
      <xsl:for-each select="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))[ @name = $process//fdl:programActivity/@name ]">
        <xsl:variable name="program-activity-type">
          <xsl:call-template name="program-activity-type">
            <xsl:with-param name="activity" select="current()"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:if test="$program-activity-type = 'service invocation activity'">
          <xsl:value-of select="'true'"/>
        </xsl:if>
      </xsl:for-each>
    </xsl:variable>
    <xsl:if test="contains($server-is-used-by-a-service-invocation-activity, 'true')">
      <!-- Create comment: partner link used to invoke server "nnn" -->
      <xsl:value-of select="concat($eol, '&lt;!-- Partner link used to invoke server &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
      <bpws:partnerLink partnerRole="{$related-system-name}_{@name}{$role-suffix}" partnerLinkType="wsdl1:{$related-system-name}_{@name}{$partner-link-type-suffix}" name="{$related-system-name}_{@name}{$partner-link-suffix}"/>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "variables" template:

    Creates a data input and a data output "variable" for each FDL program activity.
    Creates an additional pair of UPES input/output variables for a "service invocation activity".
    Assigns qualified names to the variables using a prefix that indicates the position of the related
    activity in the process hierarchy.
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:programActivity" mode="variables">
    <xsl:variable name="program-activity-type">
      <xsl:call-template name="program-activity-type">
        <xsl:with-param name="activity" select="current()"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="input-variable-name" select="concat(@name, $input-variable-suffix)"/>
    <xsl:variable name="output-variable-name" select="concat(@name, $output-variable-suffix)"/>
    <xsl:variable name="primary-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($input-variable-name)"/>
    <xsl:variable name="primary-output-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($output-variable-name)"/>
    <xsl:choose>
      <!-- CASE: interface-typed BPEL variables -->
      <xsl:when test="'INTERFACE' = $variable-type-mode">
        <!-- Create comment: Data input variable of program activity "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create BPEL variable for the data input of the program activity -->
        <bpws:variable messageType="wsdl1:{@name}{$request-suffix}{$message-suffix}" name="{$input-variable-name}"/>
        <!-- Create comment: Data output variable of program activity "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create BPEL variable for the data output of the program activity -->
        <bpws:variable messageType="wsdl1:{@name}{$response-suffix}{$message-suffix}" name="{$output-variable-name}"/>
      </xsl:when>
      <!-- OTHERWISE: data-typed BPEL variables assumed -->
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="'true' = $option_ev">
            <xsl:choose>
              <xsl:when test="'true' = $createPredefinedDataMembers">
                <xsl:if test="$input-variable-name = $primary-input-variable-name">
                  <!-- Create comment: Data input variable of program activity "nnn" -->
                  <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                  <!-- Create BPEL variable for the data input of the program activity -->
                  <bpws:variable type="mqwf:{fdl:input/@type}{$message-type-suffix}" name="{$input-variable-name}"/>
                </xsl:if>
                <xsl:if test="$output-variable-name = $primary-output-variable-name">
                  <!-- Create comment: Data output variable of program activity "nnn" -->
                  <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                  <!-- Create BPEL variable for the data output of the program activity -->
                  <bpws:variable type="mqwf:{fdl:output/@type}{$message-type-suffix}" name="{$output-variable-name}"/>
                </xsl:if>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="$input-variable-name = $primary-input-variable-name">
                  <!-- Create comment: Data input variable of program activity "nnn" -->
                  <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                  <!-- Create BPEL variable for the data input of the program activity -->
                  <bpws:variable type="mqwf:{fdl:input/@type}" name="{$input-variable-name}"/>
                </xsl:if>
                <xsl:if test="$output-variable-name = $primary-output-variable-name">
                  <!-- Create comment: Data output variable of program activity "nnn" -->
                  <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                  <!-- Create BPEL variable for the data output of the program activity -->
                  <bpws:variable type="mqwf:{fdl:output/@type}" name="{$output-variable-name}"/>
                </xsl:if>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="'true' = $createPredefinedDataMembers">
                <!-- Create comment: Data input variable of program activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data input of the program activity -->
                <bpws:variable type="mqwf:{fdl:input/@type}{$message-type-suffix}" name="{$input-variable-name}"/>
                <!-- Create comment: Data output variable of program activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data output of the program activity -->
                <bpws:variable type="mqwf:{fdl:output/@type}{$message-type-suffix}" name="{$output-variable-name}"/>
              </xsl:when>
              <xsl:otherwise>
                <!-- Create comment: Data input variable of program activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data input of the program activity -->
                <bpws:variable type="mqwf:{fdl:input/@type}" name="{$input-variable-name}"/>
                <!-- Create comment: Data output variable of program activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of program activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data output of the program activity -->
                <bpws:variable type="mqwf:{fdl:output/@type}" name="{$output-variable-name}"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <!-- Create auxiliary "status variable" that is either used for loop control, if the attribute "exitCondition" is defined, or used to capture the "_Expired" state -->
    <xsl:if test="(fdl:exitCondition and not('true' = $LI490_Support_repeatUntil))
                           or ( fdl:expiration and not( $program-activity-type = 'empty activity' ) )
                           or following-sibling::fdl:control[ @from = current()/@name ]//fdl:operator[ fdl:state/@name = '_Expired' and fdl:function/@type = '_State' and not( fdl:function/fdl:literal ) ]
                           or following-sibling::fdl:control//fdl:operator[ fdl:state/@name = '_Expired' and fdl:function/@type = '_State' and fdl:function/fdl:literal/@value = current()/@name ]">
      <!-- Create comment: Auxiliary status variable of activity "nnn" -->
      <xsl:value-of select="concat($eol, '&lt;!-- Auxiliary status variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
      <!-- Create auxiliary BPEL variable for activity status -->
      <xsl:choose>
        <!-- CASE: interface-typed BPEL variables -->
        <xsl:when test="'INTERFACE' = $variable-type-mode">
          <bpws:variable messageType="wsdl1:{$activity-status-message-name}{$message-suffix}" name="{@name}{$status-variable-suffix}"/>
        </xsl:when>
        <!-- OTHERWISE: data-typed BPEL variables assumed -->
        <xsl:otherwise>
          <bpws:variable type="xsd:string" name="{@name}{$status-variable-suffix}"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
    <xsl:choose>
      <!-- CASE: staff activity -->
      <xsl:when test="($program-activity-type='staff activity' or $program-activity-type='assumed staff activity')
                        and 'true' = $merge_the_output_of_a_staff_activity">
        <!-- Create comment: human task data output variable of activity "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- human task data output variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create BPEL variable for human task data output -->
        <xsl:choose>
          <!-- CASE: interface-typed BPEL variables -->
          <xsl:when test="'INTERFACE' = $variable-type-mode">
            <bpws:variable messageType="wsdl1:{@name}{$response-suffix}{$message-suffix}" name="{@name}{$human-task-output-variable-suffix}"/>
          </xsl:when>
          <!-- OTHERWISE: data-typed BPEL variables assumed -->
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="'true' = $createPredefinedDataMembers">
                <bpws:variable type="mqwf:{fdl:output/@type}{$message-type-suffix}" name="{@name}{$human-task-output-variable-suffix}"/>
              </xsl:when>
              <xsl:otherwise>
                <bpws:variable type="mqwf:{fdl:output/@type}" name="{@name}{$human-task-output-variable-suffix}"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- CASE: service invocation activity (UPES activity) -->
      <xsl:when test="$program-activity-type = 'service invocation activity'">
        <!-- Create comment: UPES data input variable of activity "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- UPES data input variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create BPEL variable for activity UPES data input -->
        <xsl:choose>
          <!-- CASE: interface-typed BPEL variables -->
          <xsl:when test="'INTERFACE' = $variable-type-mode">
            <bpws:variable messageType="wsdl1:{@name}{$UPES-request-suffix}{$message-suffix}" name="{@name}{$UPES-input-variable-suffix}"/>
          </xsl:when>
          <!-- OTHERWISE: data-typed BPEL variables assumed -->
          <xsl:otherwise>
            <xsl:choose>
              <!-- CASE: data structures of input and output are the same (we can use a simple type name) -->
              <xsl:when test="fdl:input/@type = fdl:output/@type">
                <bpws:variable type="mqwf:{fdl:input/@type}{$UPES-input-message-type-suffix}" name="{@name}{$UPES-input-variable-suffix}"/>
              </xsl:when>
              <!--
                  OTHERWISE: different data structures of input and output (we need the names of input
                             and output data structures in order to prevent type name clashes)
              -->
              <xsl:otherwise>
                <bpws:variable type="mqwf:{fdl:input/@type}_{fdl:output/@type}{$UPES-input-message-type-suffix}" name="{@name}{$UPES-input-variable-suffix}"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
        <!-- Determine the UPES execution mode (synchronous or asynchronous) -->
        <xsl:variable name="UPES-execution-mode">
          <xsl:call-template name="UPES-execution-mode">
            <xsl:with-param name="activity" select="current()"/>
          </xsl:call-template>
        </xsl:variable>
        <!-- Add UPES data output variable for synchronous execution mode -->
        <xsl:if test="$UPES-execution-mode = 'synchronous'">
          <!-- Create comment: UPES data output variable of activity "nnn" -->
          <xsl:value-of select="concat($eol, '&lt;!-- UPES data output variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
          <!-- Create BPEL variable for activity UPES data output -->
          <xsl:choose>
            <!-- CASE: interface-typed BPEL variables -->
            <xsl:when test="'INTERFACE' = $variable-type-mode">
              <bpws:variable messageType="wsdl1:{@name}{$UPES-response-suffix}{$message-suffix}" name="{@name}{$UPES-output-variable-suffix}"/>
            </xsl:when>
            <!-- OTHERWISE: data-typed BPEL variables assumed -->
            <xsl:otherwise>
              <bpws:variable type="mqwf:{fdl:output/@type}{$UPES-output-message-type-suffix}" name="{@name}{$UPES-output-variable-suffix}"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:if>
      </xsl:when>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "variables" template:

    Creates a data input and a data output "variable" for each FDL process activity.
    Creates an additional output variable that receives the subprocess output data (which will be "merged" with any
        default data in a subsequent "Java snippet").
    Assigns qualified names to the variables using a prefix that indicates the position of the related
    activity in the process hierarchy.
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:processActivity" mode="variables">
    <xsl:variable name="input-variable-name" select="concat(@name, $input-variable-suffix)"/>
    <xsl:variable name="output-variable-name" select="concat(@name, $output-variable-suffix)"/>
    <xsl:variable name="primary-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($input-variable-name)"/>
    <xsl:variable name="primary-output-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($output-variable-name)"/>
    <xsl:choose>
      <!-- CASE: interface-typed BPEL variables -->
      <xsl:when test="'INTERFACE' = $variable-type-mode">
        <!-- Create comment: Data input variable of process activity "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create BPEL variable for the data input of the process activity -->
        <bpws:variable messageType="wsdl1:{@name}{$request-suffix}{$message-suffix}" name="{$input-variable-name}"/>
        <!-- Create comment: Data output variable of process activity "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create BPEL variable for the data output of the process activity -->
        <bpws:variable messageType="wsdl1:{@name}{$response-suffix}{$message-suffix}" name="{$output-variable-name}"/>
      </xsl:when>
      <!-- OTHERWISE: data-typed BPEL variables assumed -->
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="'true' = $option_ev">
            <xsl:choose>
              <xsl:when test="'true' = $createPredefinedDataMembers">
                <xsl:if test="$input-variable-name = $primary-input-variable-name">
                  <!-- Create comment: Data input variable of process activity "nnn" -->
                  <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                  <!-- Create BPEL variable for the data input of the process activity -->
                  <bpws:variable type="mqwf:{fdl:input/@type}{$message-type-suffix}" name="{$input-variable-name}"/>
                </xsl:if>
                <xsl:if test="$output-variable-name = $primary-output-variable-name">
                  <!-- Create comment: Data output variable of process activity "nnn" -->
                  <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                  <!-- Create BPEL variable for the data output of the process activity -->
                  <bpws:variable type="mqwf:{fdl:output/@type}{$message-type-suffix}" name="{$output-variable-name}"/>
                </xsl:if>
              </xsl:when>
              <xsl:otherwise>
                <!-- Create comment: Data input variable of process activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data input of the process activity -->
                <bpws:variable type="mqwf:{fdl:input/@type}" name="{$input-variable-name}"/>
                <!-- Create comment: Data output variable of process activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data output of the process activity -->
                <bpws:variable type="mqwf:{fdl:output/@type}" name="{$output-variable-name}"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="'true' = $createPredefinedDataMembers">
                <!-- Create comment: Data input variable of process activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data input of the process activity -->
                <bpws:variable type="mqwf:{fdl:input/@type}{$message-type-suffix}" name="{$input-variable-name}"/>
                <!-- Create comment: Data output variable of process activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data output of the process activity -->
                <bpws:variable type="mqwf:{fdl:output/@type}{$message-type-suffix}" name="{$output-variable-name}"/>
              </xsl:when>
              <xsl:otherwise>
                <!-- Create comment: Data input variable of process activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data input of the process activity -->
                <bpws:variable type="mqwf:{fdl:input/@type}" name="{$input-variable-name}"/>
                <!-- Create comment: Data output variable of process activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of process activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data output of the process activity -->
                <bpws:variable type="mqwf:{fdl:output/@type}" name="{$output-variable-name}"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="'true' = $merge_the_output_of_a_process_activity">
      <!-- Create comment: subprocess data output variable of activity "nnn" -->
      <xsl:value-of select="concat($eol, '&lt;!-- subprocess data output variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
      <!-- Create BPEL variable for subprocess data output -->
      <xsl:choose>
        <!-- CASE: interface-typed BPEL variables -->
        <xsl:when test="'INTERFACE' = $variable-type-mode">
          <bpws:variable messageType="wsdl1:{@name}{$response-suffix}{$message-suffix}" name="{@name}{$subprocess-output-variable-suffix}"/>
        </xsl:when>
        <!-- OTHERWISE: data-typed BPEL variables assumed -->
        <xsl:otherwise>
          <xsl:choose>
            <xsl:when test="'true' = $createPredefinedDataMembers">
              <bpws:variable type="mqwf:{fdl:output/@type}{$message-type-suffix}" name="{@name}{$subprocess-output-variable-suffix}"/>
            </xsl:when>
            <xsl:otherwise>
              <bpws:variable type="mqwf:{fdl:output/@type}" name="{@name}{$subprocess-output-variable-suffix}"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
    <!-- Create auxiliary "status variable" that is either used for loop control, if the attribute "exitCondition" is defined, or used to capture the "_Expired" state -->
    <xsl:if test="(fdl:exitCondition and not('true' = $LI490_Support_repeatUntil))
              or fdl:expiration
                  or following-sibling::fdl:control[ @from = current()/@name ]//fdl:operator[ fdl:state/@name = '_Expired' and fdl:function/@type = '_State' and not( fdl:function/fdl:literal ) ]
              or following-sibling::fdl:control//fdl:operator[ fdl:state/@name = '_Expired' and fdl:function/@type = '_State' and fdl:function/fdl:literal/@value = current()/@name ]">
      <!-- Create comment: Auxiliary status variable of activity "nnn" -->
      <xsl:value-of select="concat($eol, '&lt;!-- Auxiliary status variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
      <!-- Create auxiliary BPEL variable for activity status -->
      <xsl:choose>
        <!-- CASE: interface-typed BPEL variables -->
        <xsl:when test="'INTERFACE' = $variable-type-mode">
          <bpws:variable messageType="wsdl1:{$activity-status-message-name}{$message-suffix}" name="{@name}{$status-variable-suffix}"/>
        </xsl:when>
        <!-- OTHERWISE: data-typed BPEL variables assumed -->
        <xsl:otherwise>
          <bpws:variable type="xsd:string" name="{@name}{$status-variable-suffix}"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "variables" template:

    Creates a data input and a data output "variable" for each FDL block activity.
    Creates variables contained in the block.
    Assigns qualified names to the variables using a prefix that indicates the position of the related
    activity in the process hierarchy.
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:block" mode="variables">
    <xsl:variable name="input-variable-name" select="concat(@name, $input-variable-suffix)"/>
    <xsl:variable name="output-variable-name" select="concat(@name, $output-variable-suffix)"/>
    <xsl:variable name="primary-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($input-variable-name)"/>
    <xsl:variable name="primary-output-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($output-variable-name)"/>
    <xsl:choose>
      <!-- CASE: interface-typed BPEL variables -->
      <xsl:when test="'INTERFACE' = $variable-type-mode">
        <!-- Create comment: Data input variable of block activity "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create BPEL variable for the data input of the block activity -->
        <bpws:variable messageType="wsdl1:{@name}{$request-suffix}{$message-suffix}" name="{$input-variable-name}"/>
        <!-- Create comment: Data output variable of block activity "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create BPEL variable for the data output of the block activity -->
        <bpws:variable messageType="wsdl1:{@name}{$response-suffix}{$message-suffix}" name="{$output-variable-name}"/>
      </xsl:when>
      <!-- OTHERWISE: data-typed BPEL variables assumed -->
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="'true' = $option_ev">
            <xsl:choose>
              <xsl:when test="'true' = $createPredefinedDataMembers">
                <xsl:if test="$input-variable-name = $primary-input-variable-name">
                  <!-- Create comment: Data input variable of block activity "nnn" -->
                  <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                  <!-- Create BPEL variable for the data input of the block activity -->
                  <bpws:variable type="mqwf:{fdl:input/@type}{$message-type-suffix}" name="{$input-variable-name}"/>
                </xsl:if>
                <xsl:if test="$output-variable-name = $primary-output-variable-name">
                  <!-- Create comment: Data output variable of block activity "nnn" -->
                  <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                  <!-- Create BPEL variable for the data output of the block activity -->
                  <bpws:variable type="mqwf:{fdl:output/@type}{$message-type-suffix}" name="{$output-variable-name}"/>
                </xsl:if>
              </xsl:when>
              <xsl:otherwise>
                <!-- Create comment: Data input variable of block activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data input of the block activity -->
                <bpws:variable type="mqwf:{fdl:input/@type}" name="{$input-variable-name}"/>
                <!-- Create comment: Data output variable of block activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data output of the block activity -->
                <bpws:variable type="mqwf:{fdl:output/@type}" name="{$output-variable-name}"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="'true' = $createPredefinedDataMembers">
                <!-- Create comment: Data input variable of block activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data input of the block activity -->
                <bpws:variable type="mqwf:{fdl:input/@type}{$message-type-suffix}" name="{$input-variable-name}"/>
                <!-- Create comment: Data output variable of block activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data output of the block activity -->
                <bpws:variable type="mqwf:{fdl:output/@type}{$message-type-suffix}" name="{$output-variable-name}"/>
              </xsl:when>
              <xsl:otherwise>
                <!-- Create comment: Data input variable of block activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data input variable of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data input of the block activity -->
                <bpws:variable type="mqwf:{fdl:input/@type}" name="{$input-variable-name}"/>
                <!-- Create comment: Data output variable of block activity "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Data output variable of block activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create BPEL variable for the data output of the block activity -->
                <bpws:variable type="mqwf:{fdl:output/@type}" name="{$output-variable-name}"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <!-- Create auxiliary "status variable" that is either used for loop control, if the attribute "exitCondition" is defined, or used to capture the "_Expired" state -->
    <xsl:if test="(fdl:exitCondition and not('true' = $LI490_Support_repeatUntil))
              or fdl:expiration
                  or following-sibling::fdl:control[ @from = current()/@name ]//fdl:operator[ fdl:state/@name = '_Expired' and fdl:function/@type = '_State' and not( fdl:function/fdl:literal ) ]
              or following-sibling::fdl:control//fdl:operator[ fdl:state/@name = '_Expired' and fdl:function/@type = '_State' and fdl:function/fdl:literal/@value = current()/@name ]">
      <!-- Create comment: Auxiliary status variable of activity "nnn" -->
      <xsl:value-of select="concat($eol, '&lt;!-- Auxiliary status variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
      <!-- Create auxiliary BPEL variable for activity status -->
      <xsl:choose>
        <!-- CASE: interface-typed BPEL variables -->
        <xsl:when test="'INTERFACE' = $variable-type-mode">
          <bpws:variable messageType="wsdl1:{$activity-status-message-name}{$message-suffix}" name="{@name}{$status-variable-suffix}"/>
        </xsl:when>
        <!-- OTHERWISE: data-typed BPEL variables assumed -->
        <xsl:otherwise>
          <bpws:variable type="xsd:string" name="{@name}{$status-variable-suffix}"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
    <!-- Create "variables" for data input, data output, and optionally an auxiliary "status variable" for each activity contained in the block -->
    <xsl:apply-templates select="fdl:blockImplementation/fdl:programActivity | fdl:blockImplementation/fdl:processActivity | fdl:blockImplementation/fdl:block" mode="variables"/>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "variables" template:

    Creates an element-valued BPEL "variable" that represents a "Global Container" (if present in the FDL file)
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:globalContainer" mode="variables">
    <xsl:param name="process-name"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($process-name) or $process-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;variables&quot; match=&quot;fdl:globalContainer&quot;', $eol, 'Parameter &quot;process-name&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="primary-global-container-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName('GLOBAL_CONTAINER')"/>
    <xsl:if test="not('true' = $option_ev)
            or $primary-global-container-name = 'GLOBAL_CONTAINER'">
      <xsl:variable name="message-type">
        <xsl:choose>
          <xsl:when test="'true' = $createPredefinedDataMembers">
            <xsl:value-of select="concat('mqwf:', @type, $global-container-message-type-suffix)"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="concat('mqwf:', @type)"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <!-- Create comment: "Global Container" variable -->
      <xsl:value-of select="concat($eol, '&lt;!-- &quot;Global Container&quot; variable --&gt;', $eol)" disable-output-escaping="yes"/>
      <!-- Create BPEL variable for "Global Container" -->
      <bpws:variable type="{$message-type}" name="GLOBAL_CONTAINER">
        <!-- Verify that the referenced FDL data structure is missing or not empty -->
        <xsl:choose>
          <!-- CASE: missing data structure definition -->
          <xsl:when test="not(//fdl:structure[ @name = current()/@type ])">
            <xsl:variable name="missing-object" select="concat('data structure &quot;', current()/@type, '&quot;')"/>
            <xsl:variable name="location" select="local-name(current())"/>
            <!--COMMENT: *** CWWBMnnnnW: The data structure "nnn" is used at "nnn" of process "nnn", but is not defined in the FDL. *** -->
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'IncorrectFDL_MissingObject', $missing-object, $location, $process-name), ' *** --&gt;', $eol)" disable-output-escaping="no"/>
          </xsl:when>
          <!-- CASE: empty data structure definition -->
          <xsl:when test="//fdl:structure[ @name = current()/@type and not( fdl:member ) ]">
            <xsl:variable name="empty-data-structure" select="current()/@type"/>
            <!--COMMENT: *** CWWBMnnnnW: The global container of process "nnn" is specified with an empty data structure ("nnn"). *** -->
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'IncorrectFDL_EmptyDataStructureInGlobalContainer', $process-name, $empty-data-structure), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
          </xsl:when>
          <!-- OTHERWISE: create key data properties -->
          <xsl:otherwise>
            <xsl:if test="not(@noQueries='yes')">
              <xsl:call-template name="createKeyDataProperties">
                <xsl:with-param name="globalContainer" select="current()"/>
              </xsl:call-template>
            </xsl:if>
          </xsl:otherwise>
        </xsl:choose>
      </bpws:variable>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "variables" template "createKeyDataProperties"

    Creates the key data properties of BPEL variable "GLOBAL_CONTAINER"
    *****************************************************************************************************************************
   -->
  <xsl:template name="createKeyDataProperties">
    <xsl:param name="globalContainer"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($globalContainer)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;createKeyDataProperties&quot;', $eol, 'Parameter &quot;globalContainer&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <wpc:queryProperties>
      <xsl:for-each select="//fdl:structure[ @name = $globalContainer/@type ]/fdl:member">
        <xsl:variable name="type">
          <xsl:choose>
            <xsl:when test="'STRING' = translate(@type, $lower-case-characters, $upper-case-characters)">
              <xsl:text>xsd:string</xsl:text>
            </xsl:when>
            <xsl:when test="'LONG' = translate(@type, $lower-case-characters, $upper-case-characters)">
              <xsl:text>xsd:long</xsl:text>
            </xsl:when>
            <xsl:when test="'FLOAT' = translate(@type, $lower-case-characters, $upper-case-characters)">
              <xsl:text>xsd:float</xsl:text>
            </xsl:when>
            <xsl:when test="'BINARY' = translate(@type, $lower-case-characters, $upper-case-characters)">
              <xsl:text>xsd:hexBinary</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:text>mqwf:</xsl:text>
              <xsl:value-of select="@type"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <wpc:queryProperty type="{$type}" name="{@name}">
          <wpc:query>
            <xsl:choose>
              <xsl:when test="'true' = $createPredefinedDataMembers">
                <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
                <xsl:value-of select="concat('_STRUCT/', @name)" disable-output-escaping="yes"/>
                <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
                <xsl:value-of select="@name" disable-output-escaping="yes"/>
                <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
              </xsl:otherwise>
            </xsl:choose>
          </wpc:query>
        </wpc:queryProperty>
      </xsl:for-each>
    </wpc:queryProperties>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "links" template:

    Creates a "link" for each "fdl:control"
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:control" mode="links">
    <xsl:param name="variables"/>
    <xsl:param name="node"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;links&quot; match=&quot;fdl:control&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($node)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;links&quot; match=&quot;fdl:control&quot;', $eol, 'Parameter &quot;node&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- The control connector "from" variable should be the output variable of a local activity -->
    <xsl:variable name="from-variable-name" select="concat(@from, $output-variable-suffix)"/>
    <xsl:variable name="primary-from-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($from-variable-name)"/>
    <xsl:variable name="link-name">
      <xsl:choose>
        <xsl:when test="'true' = $LI1143_Support_for_the_link_name_option_in_ControlFlow_and_DataFlow and string-length(@name) &gt; 0">
          <xsl:value-of select="@name"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="concat(@from, '-to-', @to)"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <bpws:link name="{$link-name}">
      <!-- Control connector description -->
      <xsl:call-template name="translate-description-and-documentation-fields">
        <xsl:with-param name="node" select="current()"/>
        <xsl:with-param name="display-name" select="$link-name"/>
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="primary-input-variable-name" select="$primary-from-variable-name"/>
      </xsl:call-template>
    </bpws:link>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "activities" template:

    Translates "fdl:programActivity" and "fdl:processActivity" to "invoke" activities.
    Translates "fdl:block" to a "flow" activity that is enclosed in a "sequence" element.
    Encloses the respective "invoke" or "flow" activities in a "while" activity, if  attribute "exitCondition" is defined.
    Adds "data mapping" activities ("assign" or "Java snippet") that map the output data to the following activities.
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:programActivity | fdl:processActivity | fdl:block" mode="activities">
    <xsl:param name="variables"/>
    <xsl:param name="activity-contained-in-flow" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;links&quot; match=&quot;fdl:control&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="activity-type">
      <xsl:choose>
        <xsl:when test="local-name() = 'programActivity'">
          <xsl:call-template name="program-activity-type">
            <xsl:with-param name="activity" select="current()"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="local-name()"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- Check whether the migrated activity needs "auxiliary" nodes -->
    <xsl:variable name="activity-needs-auxiliary-nodes">
      <xsl:choose>
        <!-- CASE: Activity has an exit condition and is translated using BPEL "while" -->
        <xsl:when test="fdl:exitCondition and not('true' = $LI490_Support_repeatUntil)">
          <xsl:value-of select="true()"/>
        </xsl:when>
        <!-- CASE: Activity is not of type 'empty activity' -->
        <xsl:when test="not($activity-type = 'empty activity')">
          <xsl:value-of select="true()"/>
        </xsl:when>
        <!-- CASE: Activity has a default data connector -->
        <xsl:when test="current()/../fdl:data[ @default = current()/@name ]">
          <xsl:value-of select="true()"/>
        </xsl:when>
        <!-- CASE: Activity has a loop data connector -->
        <xsl:when test="current()/../fdl:data[ @loop = current()/@name ]">
          <xsl:value-of select="true()"/>
        </xsl:when>
        <!-- CASE: Activity has an exit condition -->
        <xsl:when test="current()/fdl:expiration">
          <xsl:value-of select="true()"/>
        </xsl:when>
        <!-- OTHERWISE: Activity needs auxiliary nodes -->
        <xsl:otherwise>
          <xsl:value-of select="false()"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="outbound-data-connectors" select="current()/../fdl:data[ @from = current()/@name ]"/>
    <xsl:variable name="display-name">
      <xsl:choose>
        <xsl:when test="@displayName">
          <xsl:call-template name="tailor-display-name">
            <xsl:with-param name="untailored-display-name" select="@displayName"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="tailor-display-name">
            <xsl:with-param name="untailored-display-name" select="@name"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- Create comment: Activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsl:choose>
      <!-- CASE: outbound data connectors found -->
      <xsl:when test="$outbound-data-connectors">
        <!--
          If the activity is contained in a "flow" element, then enforce the correct order of
           activity invocation and data flow with a "sequence" element
         -->
        <xsl:variable name="trace" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.traceXsl(concat('Activity ', @name, ' has outbound data connectors, 1.' ))"/>
        <xsl:choose>
          <xsl:when test="$activity-contained-in-flow = 'true'">
            <bpws:sequence wpc:displayName="{$display-name}" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
              <xsl:call-template name="create-standard-elements">
                <xsl:with-param name="activity" select="current()"/>
                <xsl:with-param name="display-name" select="$display-name"/>
                <xsl:with-param name="variables" select="$variables"/>
              </xsl:call-template>
              <xsl:call-template name="translate-activity-with-outbound-data-connectors">
                <xsl:with-param name="activity" select="current()"/>
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="outbound-data-connectors" select="$outbound-data-connectors"/>
                <xsl:with-param name="activity-type" select="$activity-type"/>
                <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
              </xsl:call-template>
            </bpws:sequence>
          </xsl:when>
          <xsl:otherwise>
            <xsl:call-template name="translate-activity-with-outbound-data-connectors">
              <xsl:with-param name="activity" select="current()"/>
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="outbound-data-connectors" select="$outbound-data-connectors"/>
              <xsl:with-param name="activity-type" select="$activity-type"/>
              <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
            </xsl:call-template>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- OTHERWISE: no outbound data connectors found -->
      <xsl:otherwise>
        <!--
          If the activity is contained in a "flow" element and needs "auxiliary" nodes,
           then enforce the correct order of activity invocation and data flow with a "sequence" element
         -->
        <xsl:choose>
          <xsl:when test="$activity-contained-in-flow = 'true'">
            <xsl:choose>
              <!-- CASE: Activity needs auxiliary nodes (create the "sequence" activity) -->
              <xsl:when test="$activity-needs-auxiliary-nodes = 'true'">
                <bpws:sequence wpc:displayName="{$display-name}" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
                  <xsl:call-template name="create-standard-elements">
                    <xsl:with-param name="activity" select="current()"/>
                    <xsl:with-param name="display-name" select="$display-name"/>
                    <xsl:with-param name="variables" select="$variables"/>
                  </xsl:call-template>
                  <xsl:call-template name="translate-activity-without-outbound-data-connectors">
                    <xsl:with-param name="activity" select="current()"/>
                    <xsl:with-param name="variables" select="$variables"/>
                    <xsl:with-param name="activity-type" select="$activity-type"/>
                    <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
                  </xsl:call-template>
                </bpws:sequence>
              </xsl:when>
              <!-- OTHERWISE: Activity does not need auxiliary nodes (omit the "sequence" activity -->
              <xsl:otherwise>
                <xsl:call-template name="translate-activity-without-outbound-data-connectors">
                  <xsl:with-param name="activity" select="current()"/>
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="create-link-source-and-target-elements" select="true()"/>
                  <xsl:with-param name="activity-type" select="$activity-type"/>
                  <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <xsl:call-template name="translate-activity-without-outbound-data-connectors">
              <xsl:with-param name="activity" select="current()"/>
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="activity-type" select="$activity-type"/>
              <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
            </xsl:call-template>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "translate-activity-with-outbound-data-connectors":

    Called by an "activities" template.
    ****************************************************************************************************************
   -->
  <xsl:template name="translate-activity-with-outbound-data-connectors">
    <xsl:param name="activity"/>
    <xsl:param name="variables"/>
    <xsl:param name="outbound-data-connectors"/>
    <xsl:param name="activity-type"/>
    <xsl:param name="activity-needs-auxiliary-nodes"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-with-outbound-data-connectors&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-with-outbound-data-connectors&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($outbound-data-connectors)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-with-outbound-data-connectors&quot;', $eol, 'Parameter &quot;outbound-data-connectors&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity-type) or $activity-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-with-outbound-data-connectors&quot;', $eol, 'Parameter &quot;activity-type&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity-needs-auxiliary-nodes) or $activity-needs-auxiliary-nodes = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-with-outbound-data-connectors&quot;', $eol, 'Parameter &quot;activity-needs-auxiliary-nodes&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="output-variable-name" select="concat($activity/@name, $output-variable-suffix)"/>
    <xsl:variable name="primary-output-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($output-variable-name)"/>
    <xsl:variable name="activity-calls-UPES-asynchronously">
      <xsl:choose>
        <xsl:when test="$activity-type = 'service invocation activity'">
          <xsl:variable name="UPES-execution-mode">
            <xsl:call-template name="UPES-execution-mode">
              <xsl:with-param name="activity" select="$activity"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$UPES-execution-mode = 'asynchronous'">
              <xsl:value-of select="'true'"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="'false'"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'false'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <!-- CASE: Do not generate exit condition in case of asynchronous UPES invocation -->
      <xsl:when test="$activity-calls-UPES-asynchronously = 'true'">
        <xsl:choose>
          <xsl:when test="$activity/fdl:expiration and not($activity-type = 'empty activity')">
            <xsl:call-template name="translate-activity">
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="activity" select="$activity"/>
              <xsl:with-param name="activity-has-expiration" select="true()"/>
              <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
            </xsl:call-template>
          </xsl:when>
          <xsl:otherwise>
            <xsl:call-template name="translate-activity">
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="activity" select="$activity"/>
              <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
            </xsl:call-template>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- OTHERWISE: Normal check for an exit condition -->
      <xsl:otherwise>
        <xsl:choose>
          <!--  Enclose activity with a "while" or "repeatUntil" activity, if the attribute "exitCondition" is defined. -->
          <xsl:when test="$activity/fdl:exitCondition">
            <xsl:choose>
              <xsl:when test="$activity/fdl:expiration and not($activity-type = 'empty activity')">
                <xsl:call-template name="translate-activity">
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="activity" select="$activity"/>
                  <xsl:with-param name="activity-has-exitCondition" select="true()"/>
                  <xsl:with-param name="activity-has-expiration" select="true()"/>
                  <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
                </xsl:call-template>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="translate-activity">
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="activity" select="$activity"/>
                  <xsl:with-param name="activity-has-exitCondition" select="true()"/>
                  <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$activity/fdl:expiration and not($activity-type = 'empty activity')">
                <xsl:call-template name="translate-activity">
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="activity" select="$activity"/>
                  <xsl:with-param name="activity-has-expiration" select="true()"/>
                  <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
                </xsl:call-template>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="translate-activity">
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="activity" select="$activity"/>
                  <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <!-- Translate outbound data connectors with their respective data mappings by "data mapping" ("assign" or "Java snippet") activities -->
    <!-- If there is more than one outbound data connector, enclose the data flows ("data mapping" activities) with a "flow" activity -->
    <!--
      *******************************************************************************************************************************
      CAUTION: BUG OF THE XALAN TRANSLATOR WHILE RECURSIVE TEMPLATE INVOCATION !!!
      *******************************************************************************************************************************
      The value of variable $outbound-data-connectors is lost here, when a block (or block in a block) is processed.
      That is why another variable $outbound-data-connectors1 is used to redetermine the outbound data connectors.
      *******************************************************************************************************************************
     -->
    <xsl:variable name="outbound-data-connectors1" select="$activity/../fdl:data[
                @from = $activity/@name
                and fdl:map
                     and not( java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName(concat($activity/@name, $output-variable-suffix)) = java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName(concat(@to, $input-variable-suffix)) ) ]"/>
    <xsl:if test="$outbound-data-connectors1">
    <xsl:variable name="trace" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.traceXsl(concat('Activity ', $activity/@name, ' has outbound data connectors, 2.' ))"/>
      <xsl:choose>
        <!-- CASE: Option "merged data distribution" is enabled and there is more than one outbound data connector -->
        <xsl:when test="'true' = $option_mj and count($outbound-data-connectors1) &gt; 1">
          <xsl:choose>
            <!-- CASE: create "Java snippet" -->
            <xsl:when test="'true' = $create_Java_Snippets">
              <bpws:invoke wpc:continueOnError="no" portType="wpc:null" partnerLink="null" operation="null" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Distribute the activity output data">
                <wpc:script>
                  <wpc:javaCode>
                    <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
                    <!-- Create comment: Distribute the activity output data -->
                    <xsl:value-of select="concat($eol, '// Distribute the activity output data', $eol)" disable-output-escaping="yes"/>
                    <!-- Translate data connectors with their respective data mappings -->
                    <!-- <xsl:apply-templates select="$outbound-data-connectors" mode="data"> -->
                    <xsl:apply-templates select="$outbound-data-connectors1" mode="data">
                      <xsl:with-param name="variables" select="$variables"/>
                      <xsl:with-param name="node" select="$activity"/>
                      <xsl:with-param name="merged_data_distribution" select="true()"/>
                    </xsl:apply-templates>
                    <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
                  </wpc:javaCode>
                </wpc:script>
              </bpws:invoke>
            </xsl:when>
            <!-- OTHERWISE: create "assign" activity -->
            <xsl:otherwise>
              <bpws:assign wpc:displayName="Distribute the activity output data" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
                <!-- Translate data connectors with their respective data mappings -->
                <!--  <xsl:apply-templates select="$outbound-data-connectors" mode="data">  -->
                <xsl:apply-templates select="$outbound-data-connectors1" mode="data">
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="node" select="$activity"/>
                  <xsl:with-param name="merged_data_distribution" select="true()"/>
                </xsl:apply-templates>
              </bpws:assign>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <!-- OTHERWISE: Option "merged data distribution" is disabled -->
        <xsl:otherwise>
          <xsl:choose>
            <!-- CASE: more than one connector -->
            <!-- <xsl:when test="count($outbound-data-connectors) &gt; 1"> -->
            <xsl:when test="count($outbound-data-connectors1) &gt; 1">
              <bpws:flow wpc:displayName="Distribute the activity output data" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
                <!-- Translate outbound data connectors with their respective data mappings by "assign" or "Java snippets" -->
                <!-- <xsl:apply-templates select="$outbound-data-connectors" mode="data"> -->
                <xsl:apply-templates select="$outbound-data-connectors1" mode="data">
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="node" select="$activity"/>
                </xsl:apply-templates>
              </bpws:flow>
            </xsl:when>
            <!-- OTHERWISE: exactly one connector (if this template was correctly invoked) -->
            <xsl:otherwise>
              <!-- Translate outbound data connector with its respective data mappings by an "assign" activity or "Java snippet" -->
              <!--  <xsl:apply-templates select="$outbound-data-connectors" mode="data">  -->
              <xsl:apply-templates select="$outbound-data-connectors1" mode="data">
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="node" select="$activity"/>
              </xsl:apply-templates>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "translate-activity-without-outbound-data-connectors":

    Called by an "activities" template.
    ****************************************************************************************************************
   -->
  <xsl:template name="translate-activity-without-outbound-data-connectors">
    <xsl:param name="activity"/>
    <xsl:param name="variables"/>
    <xsl:param name="create-link-source-and-target-elements" select="false()"/>
    <xsl:param name="activity-type"/>
    <xsl:param name="activity-needs-auxiliary-nodes"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-without-outbound-data-connectors&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-without-outbound-data-connectors&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity-type) or $activity-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-without-outbound-data-connectors&quot;', $eol, 'Parameter &quot;activity-type&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity-needs-auxiliary-nodes) or $activity-needs-auxiliary-nodes = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-without-outbound-data-connectors&quot;', $eol, 'Parameter &quot;activity-needs-auxiliary-nodes&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="activity-calls-UPES-asynchronously">
      <xsl:choose>
        <xsl:when test="$activity-type = 'service invocation activity'">
          <xsl:variable name="UPES-execution-mode">
            <xsl:call-template name="UPES-execution-mode">
              <xsl:with-param name="activity" select="$activity"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
            <xsl:when test="$UPES-execution-mode = 'asynchronous'">
              <xsl:value-of select="'true'"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="'false'"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'false'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <!-- CASE: Do not generate exit condition in case of asynchronous UPES invocation -->
      <xsl:when test="$activity-calls-UPES-asynchronously = 'true'">
        <xsl:choose>
          <xsl:when test="$activity/fdl:expiration and not($activity-type = 'empty activity')">
            <xsl:call-template name="translate-activity">
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="activity" select="$activity"/>
              <xsl:with-param name="activity-has-expiration" select="true()"/>
              <xsl:with-param name="create-link-source-and-target-elements" select="$create-link-source-and-target-elements"/>
              <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
            </xsl:call-template>
          </xsl:when>
          <xsl:otherwise>
            <xsl:call-template name="translate-activity">
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="activity" select="$activity"/>
              <xsl:with-param name="create-link-source-and-target-elements" select="$create-link-source-and-target-elements"/>
              <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
            </xsl:call-template>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- OTHERWISE: Normal check for an exit condition -->
      <xsl:otherwise>
        <xsl:choose>
          <!-- Enclose activity with a "while" or "repeatUntil" activity, if the attribute "exitCondition" is defined. -->
          <xsl:when test="$activity/fdl:exitCondition">
            <xsl:choose>
              <xsl:when test="$activity/fdl:expiration and not($activity-type = 'empty activity')">
                <xsl:call-template name="translate-activity">
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="activity" select="$activity"/>
                  <xsl:with-param name="activity-has-exitCondition" select="true()"/>
                  <xsl:with-param name="activity-has-expiration" select="true()"/>
                  <xsl:with-param name="create-link-source-and-target-elements" select="$create-link-source-and-target-elements"/>
                  <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
                </xsl:call-template>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="translate-activity">
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="activity" select="$activity"/>
                  <xsl:with-param name="activity-has-exitCondition" select="true()"/>
                  <xsl:with-param name="create-link-source-and-target-elements" select="$create-link-source-and-target-elements"/>
                  <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$activity/fdl:expiration and not($activity-type = 'empty activity')">
                <xsl:call-template name="translate-activity">
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="activity" select="$activity"/>
                  <xsl:with-param name="activity-has-expiration" select="true()"/>
                  <xsl:with-param name="create-link-source-and-target-elements" select="$create-link-source-and-target-elements"/>
                  <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
                </xsl:call-template>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="translate-activity">
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="activity" select="$activity"/>
                  <xsl:with-param name="create-link-source-and-target-elements" select="$create-link-source-and-target-elements"/>
                  <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "translate-activity":

    Called by an "activities" template.
    Translates "fdl:programActivity" and "fdl:processActivity" to "invoke" activities.
    Translates "fdl:block" to a "flow" activity that is enclosed in a "sequence" element.
    ****************************************************************************************************************
   -->
  <xsl:template name="translate-activity">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="activity-has-exitCondition" select="false()"/>
    <xsl:param name="activity-has-expiration" select="false()"/>
    <xsl:param name="create-link-source-and-target-elements" select="false()"/>
    <xsl:param name="activity-needs-auxiliary-nodes"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity-needs-auxiliary-nodes) or $activity-needs-auxiliary-nodes = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity&quot;', $eol, 'Parameter &quot;activity-needs-auxiliary-nodes&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- Add "assign" activity or "Java snippet" that maps the input data to the output, if there is a "data default connector" -->
    <xsl:apply-templates select="$activity/../fdl:data[ @default = $activity/@name ]" mode="data">
      <xsl:with-param name="variables" select="$variables"/>
      <xsl:with-param name="node" select="$activity"/>
    </xsl:apply-templates>
    <xsl:choose>
      <!--  Enclose activity with a "while" activity, if the attribute "exitCondition" is defined. -->
      <xsl:when test="$activity-has-exitCondition = 'true'">
        <xsl:choose>
          <xsl:when test="'true' = $LI490_Support_repeatUntil">
            <xsl:call-template name="translate-activity-using-BPEL-repeatUntil">
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="activity" select="$activity"/>
              <xsl:with-param name="activity-has-expiration" select="$activity-has-expiration"/>
              <xsl:with-param name="create-link-source-and-target-elements" select="$create-link-source-and-target-elements"/>
              <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
            </xsl:call-template>
          </xsl:when>
          <xsl:otherwise>
            <xsl:call-template name="translate-activity-using-BPEL-while">
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="activity" select="$activity"/>
              <xsl:with-param name="activity-has-expiration" select="$activity-has-expiration"/>
            </xsl:call-template>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$activity-has-expiration">
            <bpws:scope wpc:displayName="scope" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
              <xsl:if test="$create-link-source-and-target-elements = 'true'">
                <!--
                  Create link source and target elements
                -->
                <xsl:call-template name="create-link-source-and-target-elements">
                  <xsl:with-param name="activity" select="$activity"/>
                  <xsl:with-param name="variables" select="$variables"/>
                </xsl:call-template>
              </xsl:if>
              <bpws:faultHandlers>
                <bpws:catch faultName="wpc:timeout">
                  <xsl:call-template name="create-activity-expiration-fault-handler">
                    <xsl:with-param name="variables" select="$variables"/>
                    <xsl:with-param name="activity" select="$activity"/>
                  </xsl:call-template>
                </bpws:catch>
              </bpws:faultHandlers>
              <bpws:sequence wpc:displayName="sequence" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
                <xsl:call-template name="create-activity">
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="activity" select="$activity"/>
                  <xsl:with-param name="create-link-source-and-target-elements" select="false()"/>
                </xsl:call-template>
              </bpws:sequence>
            </bpws:scope>
          </xsl:when>
          <xsl:otherwise>
            <xsl:call-template name="create-activity">
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="activity" select="$activity"/>
              <xsl:with-param name="create-link-source-and-target-elements" select="$create-link-source-and-target-elements"/>
            </xsl:call-template>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "translate-activity-using-BPEL-while":

    Called by "translate-activity" template.

    Encloses activity with a "while" activity, if the attribute "exitCondition" is defined.
    Note that the "while" condition expression must be set to the negation of the original "exit" condition expression.
    Moreover, extending the "while" condition expression by a check of an "activity-started" indicator ensures that
    the activity will be executed at least once.
    ****************************************************************************************************************
   -->
  <xsl:template name="translate-activity-using-BPEL-while">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="activity-has-expiration" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-using-BPEL-while&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-using-BPEL-while&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="status-variable" select="concat($activity/@name, $status-variable-suffix)"/>
    <xsl:variable name="status-variable-type">
      <xsl:choose>
        <!-- CASE: interface-typed BPEL variables -->
        <xsl:when test="'INTERFACE' = $variable-type-mode">
          <xsl:value-of select="$variables//bpws:variable[@name = $status-variable]/@messageType"/>
        </xsl:when>
        <!-- OTHERWISE: data-typed BPEL variables assumed -->
        <xsl:otherwise>
          <xsl:value-of select="$variables//bpws:variable[@name = $status-variable]/@type"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- Create comment: Reset status variable of activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Reset status variable of activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <!-- Create "assign" activity that resets the "activity-started" indicator -->
    <xsl:call-template name="create-assign-activity-to-set-BPEL-variable">
      <xsl:with-param name="BPEL-variable" select="$status-variable"/>
    </xsl:call-template>
    <xsl:choose>
      <xsl:when test="$activity-has-expiration = 'true'">
        <bpws:scope wpc:displayName="scope" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
          <bpws:faultHandlers>
            <bpws:catch faultName="wpc:timeout">
              <xsl:call-template name="create-activity-expiration-fault-handler">
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="activity" select="$activity"/>
              </xsl:call-template>
            </bpws:catch>
          </bpws:faultHandlers>
          <xsl:call-template name="create-while-activity">
            <xsl:with-param name="variables" select="$variables"/>
            <xsl:with-param name="activity" select="$activity"/>
            <xsl:with-param name="status-variable" select="$status-variable"/>
            <xsl:with-param name="status-variable-type" select="$status-variable-type"/>
          </xsl:call-template>
        </bpws:scope>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="create-while-activity">
          <xsl:with-param name="variables" select="$variables"/>
          <xsl:with-param name="activity" select="$activity"/>
          <xsl:with-param name="status-variable" select="$status-variable"/>
          <xsl:with-param name="status-variable-type" select="$status-variable-type"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "create-while-activity":

    Called by "translate-activity-using-BPEL-while" template.

    Encloses activity with a "while" activity, if the attribute "exitCondition" is defined.
    Note that the "while" condition expression must be set to the negation of the original "exit" condition expression.
    Moreover, extending the "while" condition expression by a check of an "activity-started" indicator ensures that
    the activity will be executed at least once.
    ****************************************************************************************************************
   -->
  <xsl:template name="create-while-activity">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="status-variable"/>
    <xsl:param name="status-variable-type"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-while-activity&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-while-activity&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($status-variable) or $status-variable = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-while-activity&quot;', $eol, 'Parameter &quot;status-variable&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($status-variable-type) or $status-variable-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-while-activity&quot;', $eol, 'Parameter &quot;status-variable-type&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <bpws:while wpc:displayName="while" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
      <bpws:condition expressionLanguage="{$XPATH}">
        <!-- Create XPath expression for activity exit condition -->
        <xsl:variable name="condition-expression">
          <xsl:call-template name="create-condition-xpath-expression">
            <xsl:with-param name="display-name" select="$activity/@displayName"/>
            <xsl:with-param name="variables" select="$variables"/>
            <xsl:with-param name="activity" select="$activity"/>
            <xsl:with-param name="condition" select="$activity/fdl:exitCondition/fdl:condition"/>
            <xsl:with-param name="translate-to-BPEL-while-condition" select="true()"/>
            <xsl:with-param name="FDL-location" select="$activity/fdl:fdlLoc[1]"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="condition-expression-could-not-be-resolved">
          <xsl:choose>
            <xsl:when test="contains($condition-expression, 'UNKNOWN_DATA_STRUCTURE_MEMBER')">
              <xsl:value-of select="'true'"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="'false'"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:if test="'true' = $condition-expression-could-not-be-resolved">
          <xsl:value-of select="concat($eol, '&lt;!-- *** Adjust the following incorrect expression *** ', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
        <xsl:value-of select="$condition-expression"/>
        <xsl:if test="'true' = $condition-expression-could-not-be-resolved">
          <xsl:value-of select="concat($eol, ' --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
      </bpws:condition>
      <bpws:sequence wpc:displayName="sequence" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
        <!-- Create comment: Set status variable of activity "nnn" to "started" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Set status variable of activity &quot;', $activity/@name, '&quot; to &quot;started&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create "assign" activity that sets the "activity-started" indicator -->
        <xsl:call-template name="create-assign-activity-to-set-BPEL-variable">
          <xsl:with-param name="BPEL-variable" select="$status-variable"/>
          <xsl:with-param name="BPEL-variable-value" select="'started'"/>
        </xsl:call-template>
        <xsl:call-template name="create-activity">
          <xsl:with-param name="variables" select="$variables"/>
          <xsl:with-param name="activity" select="$activity"/>
        </xsl:call-template>
      </bpws:sequence>
    </bpws:while>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "translate-activity-using-BPEL-repeatUntil":

    Called by "translate-activity" template.

    Encloses activity with a "repeatUntil" activity, if the attribute "exitCondition" is defined.
    ****************************************************************************************************************
   -->
  <xsl:template name="translate-activity-using-BPEL-repeatUntil">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="activity-has-expiration" select="false()"/>
    <xsl:param name="create-link-source-and-target-elements" select="false()"/>
    <xsl:param name="activity-needs-auxiliary-nodes"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-using-BPEL-repeatUntil&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-using-BPEL-repeatUntil&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity-needs-auxiliary-nodes) or $activity-needs-auxiliary-nodes = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-activity-using-BPEL-repeatUntil&quot;', $eol, 'Parameter &quot;activity-needs-auxiliary-nodes&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="status-variable" select="concat($activity/@name, $status-variable-suffix)"/>
    <xsl:variable name="status-variable-type">
      <xsl:choose>
        <!-- CASE: interface-typed BPEL variables -->
        <xsl:when test="'INTERFACE' = $variable-type-mode">
          <xsl:value-of select="$variables//bpws:variable[@name = $status-variable]/@messageType"/>
        </xsl:when>
        <!-- OTHERWISE: data-typed BPEL variables assumed -->
        <xsl:otherwise>
          <xsl:value-of select="$variables//bpws:variable[@name = $status-variable]/@type"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="$activity-has-expiration = 'true'">
        <bpws:scope wpc:displayName="scope" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
          <xsl:if test="$create-link-source-and-target-elements = 'true'">
            <!--
              Create link source and target elements
            -->
            <xsl:call-template name="create-link-source-and-target-elements">
              <xsl:with-param name="activity" select="$activity"/>
              <xsl:with-param name="variables" select="$variables"/>
            </xsl:call-template>
          </xsl:if>
          <bpws:faultHandlers>
            <bpws:catch faultName="wpc:timeout">
              <xsl:call-template name="create-activity-expiration-fault-handler">
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="activity" select="$activity"/>
              </xsl:call-template>
            </bpws:catch>
          </bpws:faultHandlers>
          <xsl:call-template name="create-repeatUntil-activity">
            <xsl:with-param name="variables" select="$variables"/>
            <xsl:with-param name="activity" select="$activity"/>
            <xsl:with-param name="status-variable" select="$status-variable"/>
            <xsl:with-param name="status-variable-type" select="$status-variable-type"/>
            <xsl:with-param name="create-link-source-and-target-elements" select="false()"/>
            <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
          </xsl:call-template>
        </bpws:scope>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="create-repeatUntil-activity">
          <xsl:with-param name="variables" select="$variables"/>
          <xsl:with-param name="activity" select="$activity"/>
          <xsl:with-param name="status-variable" select="$status-variable"/>
          <xsl:with-param name="status-variable-type" select="$status-variable-type"/>
          <xsl:with-param name="create-link-source-and-target-elements" select="$create-link-source-and-target-elements"/>
          <xsl:with-param name="activity-needs-auxiliary-nodes" select="$activity-needs-auxiliary-nodes"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "create-repeatUntil-activity":

    Called by "translate-activity-using-BPEL-repeatUntil" template.

    Encloses activity with a "repeatUntil" activity, if the attribute "exitCondition" is defined.
    ****************************************************************************************************************
   -->
  <xsl:template name="create-repeatUntil-activity">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="status-variable"/>
    <xsl:param name="status-variable-type"/>
    <xsl:param name="create-link-source-and-target-elements" select="false()"/>
    <xsl:param name="activity-needs-auxiliary-nodes"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-repeatUntil-activity&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-repeatUntil-activity&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($status-variable) or $status-variable = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-repeatUntil-activity&quot;', $eol, 'Parameter &quot;status-variable&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($status-variable-type) or $status-variable-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-repeatUntil-activity&quot;', $eol, 'Parameter &quot;status-variable-type&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity-needs-auxiliary-nodes) or $activity-needs-auxiliary-nodes = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-repeatUntil-activity&quot;', $eol, 'Parameter &quot;activity-needs-auxiliary-nodes&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <bpws:repeatUntil wpc:displayName="repeatUntil" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
      <xsl:if test="$create-link-source-and-target-elements = 'true'">
        <!--
          Create link source and target elements
        -->
        <xsl:call-template name="create-link-source-and-target-elements">
          <xsl:with-param name="activity" select="$activity"/>
          <xsl:with-param name="variables" select="$variables"/>
        </xsl:call-template>
      </xsl:if>
      <xsl:choose>
        <xsl:when test="$activity-needs-auxiliary-nodes = 'true'">
          <bpws:sequence wpc:displayName="sequence" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
            <xsl:call-template name="create-activity">
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="activity" select="$activity"/>
            </xsl:call-template>
          </bpws:sequence>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="create-activity">
            <xsl:with-param name="variables" select="$variables"/>
            <xsl:with-param name="activity" select="$activity"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
      <bpws:condition expressionLanguage="{$XPATH}">
        <!-- Create XPath expression for activity exit condition -->
        <xsl:variable name="condition-expression">
          <xsl:call-template name="create-condition-xpath-expression">
            <xsl:with-param name="display-name" select="$activity/@displayName"/>
            <xsl:with-param name="variables" select="$variables"/>
            <xsl:with-param name="activity" select="$activity"/>
            <xsl:with-param name="condition" select="$activity/fdl:exitCondition/fdl:condition"/>
            <xsl:with-param name="translate-to-BPEL-while-condition" select="false()"/>
            <xsl:with-param name="FDL-location" select="$activity/fdl:fdlLoc[1]"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="condition-expression-could-not-be-resolved">
          <xsl:choose>
            <xsl:when test="contains($condition-expression, 'UNKNOWN_DATA_STRUCTURE_MEMBER')">
              <xsl:value-of select="'true'"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="'false'"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:if test="'true' = $condition-expression-could-not-be-resolved">
          <xsl:value-of select="concat($eol, '&lt;!-- *** Adjust the following incorrect expression *** ', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
        <xsl:value-of select="$condition-expression"/>
        <xsl:if test="'true' = $condition-expression-could-not-be-resolved">
          <xsl:value-of select="concat($eol, ' --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
      </bpws:condition>
    </bpws:repeatUntil>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "create-activity":

    Called by an "activities" template.
    Translates "fdl:programActivity" and "fdl:processActivity" to "invoke" activities.
    Translates "fdl:block" to a "flow" activity that is enclosed in a "sequence" element.
    ****************************************************************************************************************
   -->
  <xsl:template name="create-activity">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="create-link-source-and-target-elements" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-activity&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-activity&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="parent-process" select="$activity/ancestor::fdl:process"/>
    <xsl:variable name="process-input-variable-name" select="concat($parent-process/@name, $input-variable-suffix)"/>
    <xsl:variable name="primary-process-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($process-input-variable-name)"/>
    <xsl:variable name="domain" select="//fdl:domain[1]"/>
    <xsl:variable name="system-group" select="//fdl:group[1]"/>
    <xsl:variable name="primary-system" select="//fdl:system[ @primarySystem ='yes' ][1]"/>
    <xsl:variable name="display-name">
      <xsl:choose>
        <xsl:when test="$activity/@displayName">
          <xsl:call-template name="tailor-display-name">
            <xsl:with-param name="untailored-display-name" select="$activity/@displayName"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="tailor-display-name">
            <xsl:with-param name="untailored-display-name" select="$activity/@name"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <!--
         CASE: "fdl:programActivity"
       -->
      <xsl:when test="local-name($activity) = 'programActivity'">
        <!--
          Check whether the program activity maps to one of the following BPEL activities:
            "service invocation activity"
            "staff activity"
            "empty activity"
          If it cannot be mapped to any of them ("unclassified activity") the returned activity type is
          an "assumed staff activity" and a respective warning will be inserted as a comment.
        -->
        <xsl:variable name="program-activity-type">
          <xsl:call-template name="program-activity-type">
            <xsl:with-param name="activity" select="$activity"/>
          </xsl:call-template>
        </xsl:variable>
        <!--
          Check whether the program definition exists
        -->
        <xsl:variable name="program-name" select="$activity/fdl:program/@name"/>
        <xsl:if test="$program-name and not(//fdl:definitions/fdl:program[ @name = $program-name ]
                          or //fdl:definitions/fdl:create/fdl:program[ @name = $program-name ]
                          or //fdl:definitions/fdl:update/fdl:program[ @name = $program-name ]
                          or //fdl:definitions/fdl:replace/fdl:program[ @name = $program-name ])">
          <!--COMMENT: *** CWWBMnnnnE: The program "{0}" is referred to at activity nnn, but it is not defined in the FDL input file. *** -->
          <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'unknownProgramName', $fdlFileName, $activity/fdl:fdlLoc/@line, $program-name, $activity/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
        <!--
            If the unsupported option "Program execution server from container" is selected issue a warning.
        -->
        <xsl:if test="$activity/fdl:program/fdl:dataStructureMemberName">
          <!--COMMENT: *** CWWBMnnnnW: Option "Program execution server from container" of program activity "nn" cannot be mapped to BPEL. *** -->
          <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_ProgramExecutionServerTakenFrom', $fdlFileName, $activity/fdl:fdlLoc/@line, $activity/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
        <!--
          Create an "UPES activity", if the program activity type equals "service invocation activity".
          Create an "empty activity", if the program activity type equals "empty activity".
          Otherwise, create a "standard" activity.
        -->
        <xsl:choose>
          <!-- CASE: service invocation (UPES) activity -->
          <xsl:when test="$program-activity-type = 'service invocation activity'">
            <xsl:call-template name="create-UPES-activity">
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="activity" select="$activity"/>
              <xsl:with-param name="display-name" select="$display-name"/>
              <xsl:with-param name="create-link-source-and-target-elements" select="$create-link-source-and-target-elements"/>
            </xsl:call-template>
          </xsl:when>
          <!-- CASE: empty activity -->
          <xsl:when test="$program-activity-type = 'empty activity'">
            <xsl:call-template name="create-empty-activity">
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="activity" select="$activity"/>
              <xsl:with-param name="display-name" select="$display-name"/>
              <xsl:with-param name="create-link-source-and-target-elements" select="$create-link-source-and-target-elements"/>
            </xsl:call-template>
          </xsl:when>
          <!-- OTHERWISE: standard activity -->
          <xsl:otherwise>
            <xsl:call-template name="create-standard-activity">
              <xsl:with-param name="variables" select="$variables"/>
              <xsl:with-param name="activity" select="$activity"/>
              <xsl:with-param name="display-name" select="$display-name"/>
              <xsl:with-param name="program-activity-type" select="$program-activity-type"/>
              <xsl:with-param name="create-link-source-and-target-elements" select="$create-link-source-and-target-elements"/>
            </xsl:call-template>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!--
        CASE: "fdl:processActivity"
      -->
      <xsl:when test="local-name($activity) = 'processActivity'">
        <!-- Determine the value of the "portType" attribute -->
        <xsl:variable name="port-type">
          <xsl:choose>
            <xsl:when test="$activity/fdl:process/@name">
              <xsl:value-of select="concat('wsdl1:', $activity/fdl:process/@name, $port-type-suffix)"/>
            </xsl:when>
            <xsl:when test="$activity/fdl:process/fdl:dataStructureMemberName/fdl:nameComponent">
              <xsl:value-of select="concat('wsdl1:', $activity/@name, $port-type-suffix)"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="'null'"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <!-- Determine the value of the "operation" attribute -->
        <xsl:variable name="operation">
          <xsl:choose>
            <xsl:when test="$activity/fdl:process/@name">
              <xsl:value-of select="$activity/fdl:process/@name"/>
            </xsl:when>
            <xsl:when test="$activity/fdl:process/fdl:dataStructureMemberName/fdl:nameComponent">
              <xsl:value-of select="$activity/@name"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="'null'"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <!-- Determine the value of the "partnerLink" attribute -->
        <xsl:variable name="partner-link">
          <xsl:choose>
            <xsl:when test="$activity/fdl:process/@name">
              <xsl:value-of select="concat($activity/fdl:process/@name, $partner-link-suffix)"/>
            </xsl:when>
            <xsl:when test="$activity/fdl:process/fdl:dataStructureMemberName/fdl:nameComponent">
              <xsl:value-of select="concat($activity/@name, $partner-link-suffix)"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="'null'"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="input-variable-name" select="concat($activity/@name, $input-variable-suffix)"/>
        <xsl:variable name="output-variable-name">
          <xsl:choose>
            <!-- CASE: process activity requires additional subprocess output variable -->
            <xsl:when test="'true' = $merge_the_output_of_a_process_activity">
              <xsl:value-of select="concat($activity/@name, $subprocess-output-variable-suffix)"/>
            </xsl:when>
            <!-- OTHERWISE -->
            <xsl:otherwise>
              <xsl:value-of select="concat($activity/@name, $output-variable-suffix)"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="primary-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($input-variable-name)"/>
        <xsl:variable name="primary-output-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($output-variable-name)"/>
        <!-- Check whether option "Process from container" is defined in the FDL -->
        <xsl:if test="$activity/fdl:process/fdl:dataStructureMemberName/fdl:nameComponent">
          <!-- Create comment: Assign late-bound subprocess name for process activity "nnn" -->
          <xsl:value-of select="concat($eol, '&lt;!-- Assign late-bound subprocess name for process activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
          <!-- Create an "assign" activity which copies the "service reference" of the respective subprocess to the corresponding "partner link" -->
          <bpws:assign wpc:displayName="Assign subprocess name" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
            <bpws:copy>
              <bpws:from>
                <bpws:expression expressionLanguage="{$XPATH}">
                  <xsl:variable name="xpath-expression">
                    <xsl:apply-templates select="$activity/fdl:process/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
                      <xsl:with-param name="display-name" select="$display-name"/>
                      <xsl:with-param name="node" select="$activity"/>
                      <xsl:with-param name="variables" select="$variables"/>
                      <xsl:with-param name="local-variable-name" select="$primary-input-variable-name"/>
                      <xsl:with-param name="FDL-location" select="$activity/fdl:fdlLoc"/>
                    </xsl:apply-templates>
                  </xsl:variable>
                  <xsl:value-of select="concat('wpc:getServiceRefForProcessTemplate(&quot;', $xpath-expression, '&quot;, &quot;', $wsdlTargetNamespace, '&quot;, &quot;', $activity/@name, $partner-link-suffix, '&quot;)')"/>
                </bpws:expression>
              </bpws:from>
              <bpws:to partnerLink="{$activity/@name}{$partner-link-suffix}"/>
            </bpws:copy>
          </bpws:assign>
        </xsl:if>
        <!-- Create comment: Invoke process activity "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Invoke process activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create "invoke" activity -->
        <bpws:invoke wpc:continueOnError="no" partnerLink="{$partner-link}" portType="{$port-type}" operation="{$operation}" name="{$activity/@name}">
          <!-- Add optional display name -->
          <xsl:if test="$activity/@displayName">
            <xsl:attribute name="wpc:displayName"><xsl:value-of select="$display-name"/></xsl:attribute>
          </xsl:if>
          <!-- Add optional business relevance indicator -->
          <xsl:choose>
            <!-- CASE: Filter option set in the FDL file -->
            <xsl:when test="string-length($activity/fdl:activityDefaultSetting/@auditFilterDB) &gt; 0 or string-length($activity/fdl:activityDefaultSetting/@auditFilterMQ) &gt; 0">
              <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
            </xsl:when>
            <!-- CASE: Option "Audit trail" specified on page "Control" of the process settings -->
            <xsl:when test="$parent-process/@auditToDB = 'full' or $parent-process/@auditToDB = 'condensed' or $parent-process/@auditToMQ = 'full' or $parent-process/@auditToMQ = 'condensed'">
              <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
            </xsl:when>
            <!-- CASE: "Audit to DB" settings inherited from the primary system -->
            <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                        and not($parent-process/@auditToDB = 'no')
                        and ( $primary-system/fdl:processDefaultSetting/@auditToDB = 'full' or $primary-system/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
              <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
            </xsl:when>
            <!-- CASE: "Audit to MQ" settings inherited from the primary system -->
            <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                        and not($parent-process/@auditToMQ = 'no')
                        and ( $primary-system/fdl:processDefaultSetting/@auditToMQ = 'full' or $primary-system/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
              <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
            </xsl:when>
            <!-- CASE: "Audit to DB" settings inherited from the system group -->
            <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                        and not($primary-system/fdl:processDefaultSetting/@auditToDB = 'no')
                        and ( $system-group/fdl:processDefaultSetting/@auditToDB = 'full' or $system-group/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
              <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
            </xsl:when>
            <!-- CASE: "Audit to MQ" settings inherited from the system group -->
            <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                        and not($primary-system/fdl:processDefaultSetting/@auditToMQ = 'no')
                        and ( $system-group/fdl:processDefaultSetting/@auditToMQ = 'full' or $system-group/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
              <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
            </xsl:when>
            <!-- CASE: "Audit to DB" settings inherited from the domain -->
            <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                        and not($system-group/fdl:processDefaultSetting/@auditToDB = 'no')
                        and ( $domain/fdl:processDefaultSetting/@auditToDB = 'full' or $domain/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
              <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
            </xsl:when>
            <!-- CASE: "Audit to MQ" settings inherited from the domain -->
            <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                        and not($system-group/fdl:processDefaultSetting/@auditToMQ = 'no')
                        and ( $domain/fdl:processDefaultSetting/@auditToMQ = 'full' or $domain/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
              <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
              <xsl:attribute name="wpc:businessRelevant">no</xsl:attribute>
            </xsl:otherwise>
          </xsl:choose>
          <!-- Create input/output variable attributes in case of interface-typed BPEL variables -->
          <xsl:if test="'INTERFACE' = $variable-type-mode">
            <xsl:attribute name="inputVariable"><xsl:value-of select="$input-variable-name"/></xsl:attribute>
            <xsl:attribute name="outputVariable"><xsl:value-of select="$output-variable-name"/></xsl:attribute>
          </xsl:if>
          <!-- Activity description and documentation -->
          <xsl:call-template name="translate-description-and-documentation-fields">
            <xsl:with-param name="node" select="$activity"/>
            <xsl:with-param name="display-name" select="$display-name"/>
            <xsl:with-param name="variables" select="$variables"/>
            <xsl:with-param name="primary-input-variable-name" select="$primary-input-variable-name"/>
          </xsl:call-template>
          <!-- Create reference to administration task  -->
          <xsl:variable name="activity-admin-task-name" select="concat($activity/@name, $activity-admin-task-suffix)"/>
          <!-- Create comment: Reference to activity administration task definition -->
          <xsl:value-of select="concat($eol, '&lt;!-- *** Reference to activity administration task definition *** --&gt;', $eol)" disable-output-escaping="yes"/>
          <wpc:adminTask name="staff:{$activity-admin-task-name}"/>
          <!-- Generate A-task TEL file -->
          <xsl:variable name="activity-atask-telfile-local-name" select="concat($activity-admin-task-name, '.itel')"/>
          <xsl:variable name="activity-atask-telfile-path-name" select="concat($outputdir, $activity-atask-telfile-local-name)"/>
          <xsl:variable name="message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $activity-atask-telfile-local-name)"/>
          <xsl:variable name="addITel" select="java:com.ibm.bpe.fdl2bpel.converter.ITelList.add($activity-atask-telfile-path-name)"/>
          <redirect:write select="concat($outputdir, $activity-atask-telfile-local-name)">
            <tel:task defaultLocale="{$locale}" supportsFollowOnTask="no" supportsSubTask="no" kind="aTask" jndiNameStaffPluginProvider="bpe/staff/samplevmmconfiguration" targetNamespace="{$telTargetNamespace}" name="{$activity-admin-task-name}" xmlns_wsdl1="{$wsdlTargetNamespace}">
              <tel:staffSettings>
                <tel:administrator>
                  <tel:verb>
                    <xsl:choose>
                      <xsl:when test="$activity/fdl:staff/fdl:processAdministrator">
                        <xsl:apply-templates select="$activity/fdl:staff" mode="create-staff-query-verb">
                          <xsl:with-param name="node" select="$activity"/>
                          <xsl:with-param name="variables" select="$variables"/>
                          <xsl:with-param name="local-variable-name" select="$primary-input-variable-name"/>
                        </xsl:apply-templates>
                      </xsl:when>
                      <xsl:when test="$parent-process/fdl:staff/fdl:processAdministrator">
                        <xsl:apply-templates select="$parent-process/fdl:staff" mode="create-staff-query-verb">
                          <xsl:with-param name="node" select="$parent-process"/>
                          <xsl:with-param name="variables" select="$variables"/>
                          <xsl:with-param name="local-variable-name" select="$primary-process-input-variable-name"/>
                        </xsl:apply-templates>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:variable name="process-starter">
                          <fdl:staff>
                            <fdl:processStarter/>
                          </fdl:staff>
                        </xsl:variable>
                        <xsl:apply-templates select="xalan:nodeset($process-starter)/fdl:staff" mode="create-staff-query-verb">
                          <xsl:with-param name="node" select="$parent-process"/>
                          <xsl:with-param name="variables" select="$variables"/>
                          <xsl:with-param name="local-variable-name" select="$primary-process-input-variable-name"/>
                        </xsl:apply-templates>
                      </xsl:otherwise>
                    </xsl:choose>
                  </tel:verb>
                </tel:administrator>
              </tel:staffSettings>
              <tel:uiSettings/>
              <tel:escalationSettings/>
            </tel:task>
          </redirect:write>
          <!-- Create input/output variable attributes in case of interface-typed BPEL variables -->
          <xsl:if test="'DATA' = $variable-type-mode">
            <wpc:input>
              <wpc:parameter name="{$element-input-name}" variable="{$primary-input-variable-name}"/>
            </wpc:input>
            <wpc:output>
              <wpc:parameter name="{$element-output-name}" variable="{$primary-output-variable-name}"/>
            </wpc:output>
          </xsl:if>
        </bpws:invoke>
        <xsl:if test="'true' = $merge_the_output_of_a_process_activity">
          <!--
              Create "assign" activity or "Java snippet" that merges the subprocess data output message with any default values in the "standard" data output.
          -->
          <xsl:call-template name="create-data-mapping-subprocess-to-standard">
            <xsl:with-param name="variables" select="$variables"/>
            <xsl:with-param name="activity" select="$activity"/>
          </xsl:call-template>
        </xsl:if>
      </xsl:when>
      <!--
        CASE: "fdl:block"
      -->
      <xsl:when test="local-name($activity) = 'block'">
        <xsl:variable name="input-variable-name" select="concat($activity/@name, $input-variable-suffix)"/>
        <xsl:variable name="primary-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($input-variable-name)"/>
        <!-- Translate data connectors from the block activity "SOURCE" container to "data mapping" ("assign" or "Java snippet") activities -->
        <xsl:variable name="SOURCE-data-connectors" select="$activity/fdl:blockImplementation/fdl:data[
                @from = $activity/fdl:blockImplementation/fdl:input/@name
                and not( $primary-input-variable-name = java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName(concat(@to, $input-variable-suffix)) ) ]"/>
        <xsl:if test="$SOURCE-data-connectors">
          <!-- Create comment: Distribute the input data of block activity "nnn" to the start activities of its implementation -->
          <xsl:value-of select="concat($eol, '&lt;!-- Distribute the input data of block activity &quot;', $activity/@name, '&quot; to the start activities of its implementation --&gt;', $eol)" disable-output-escaping="yes"/>
          <xsl:choose>
            <!-- CASE: Option "merged data distribution" is enabled and there is more than one outbound data connector -->
            <xsl:when test="'true' = $option_mj and count($SOURCE-data-connectors) &gt; 1">
              <xsl:choose>
                <!-- CASE: create "Java snippet" -->
                <xsl:when test="'true' = $create_Java_Snippets">
                  <bpws:invoke wpc:continueOnError="no" portType="wpc:null" partnerLink="null" operation="null" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Distribute the block input data">
                    <wpc:script>
                      <wpc:javaCode>
                        <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
                        <!-- Create comment: Distribute the block input data -->
                        <xsl:value-of select="concat($eol, '// Distribute the block input data', $eol)" disable-output-escaping="yes"/>
                        <!-- Translate data connectors with their respective data mappings -->
                        <xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
                          <xsl:with-param name="variables" select="$variables"/>
                          <xsl:with-param name="node" select="$activity"/>
                          <xsl:with-param name="merged_data_distribution" select="true()"/>
                        </xsl:apply-templates>
                        <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
                      </wpc:javaCode>
                    </wpc:script>
                  </bpws:invoke>
                </xsl:when>
                <!-- OTHERWISE: create "assign" activity -->
                <xsl:otherwise>
                  <bpws:assign wpc:displayName="Distribute the block input data" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
                    <!-- Translate data connectors with their respective data mappings -->
                    <xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
                      <xsl:with-param name="variables" select="$variables"/>
                      <xsl:with-param name="node" select="$activity"/>
                      <xsl:with-param name="merged_data_distribution" select="true()"/>
                    </xsl:apply-templates>
                  </bpws:assign>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:when>
            <!-- OTHERWISE: Option "merged data distribution" is disabled -->
            <xsl:otherwise>
              <!-- If there is more than one inbound data connector at the block input, enclose the data flows ("data mapping" activities) with a "flow" activity -->
              <xsl:choose>
                <!-- CASE: more than one connector -->
                <xsl:when test="count($SOURCE-data-connectors) &gt; 1">
                  <bpws:flow wpc:displayName="Distribute the block input data" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
                    <!-- Translate data connectors with their respective data mappings to "assign" activities or "Java snippets" -->
                    <xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
                      <xsl:with-param name="variables" select="$variables"/>
                      <xsl:with-param name="node" select="$activity"/>
                    </xsl:apply-templates>
                  </bpws:flow>
                </xsl:when>
                <!-- CASE: exactly one connector -->
                <xsl:otherwise>
                  <!-- Translate data connector with their respective data mappings to "assign" activities or "Java snippets" -->
                  <xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
                    <xsl:with-param name="variables" select="$variables"/>
                    <xsl:with-param name="node" select="$activity"/>
                  </xsl:apply-templates>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:if>
        <!-- Create comment: Implementation of block activity "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Implementation of block activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <!--  Translate the activities and their respective control and data connectors contained in the block implementation. Enclose the translation into a "flow" activity. -->
        <xsl:variable name="activities-contained-in-block" select="$activity/fdl:blockImplementation/fdl:programActivity | $activity/fdl:blockImplementation/fdl:processActivity | $activity/fdl:blockImplementation/fdl:block"/>
        <xsl:choose>
          <!-- CASE: more than one activity contained in the block -->
          <xsl:when test="count($activities-contained-in-block) &gt; 1">
            <!-- Create a "flow" element -->
            <bpws:flow wpc:displayName="{$Execute-activities-contained-in-block}" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
              <!-- Translate the control connectors -->
              <xsl:if test=" $activity/fdl:blockImplementation/fdl:control">
                <!-- Create comment: Links that implement the internal control flow of process "nnn" -->
                <xsl:value-of select="concat($eol, '&lt;!-- Links that implement the internal control flow of block activity &quot;',  $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
                <bpws:links>
                  <xsl:apply-templates select="$activity/fdl:blockImplementation/fdl:control" mode="links">
                    <xsl:with-param name="variables" select="$variables"/>
                    <xsl:with-param name="node" select="$activity"/>
                  </xsl:apply-templates>
                </bpws:links>
              </xsl:if>
              <!-- Translate the activities and their related data connectors -->
              <xsl:apply-templates select="$activity/fdl:blockImplementation/fdl:programActivity | $activity/fdl:blockImplementation/fdl:processActivity | $activity/fdl:blockImplementation/fdl:block" mode="activities">
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="activity-contained-in-flow" select="true()"/>
              </xsl:apply-templates>
            </bpws:flow>
          </xsl:when>
          <!-- OTHERWISE: one or no activity contained in the block -->
          <xsl:otherwise>
            <!--  No "flow" element necessary. Translate one activity, if there is one. -->
            <xsl:apply-templates select="$activity/fdl:blockImplementation/fdl:programActivity | $activity/fdl:blockImplementation/fdl:processActivity | $activity/fdl:blockImplementation/fdl:block" mode="activities">
              <xsl:with-param name="variables" select="$variables"/>
            </xsl:apply-templates>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
    </xsl:choose>
    <!-- Add "assign" activity or "Java snippet" that maps the output data to the input, if there is a "data loop connector" -->
    <xsl:apply-templates select="$activity/../fdl:data[ @loop = $activity/@name and fdl:map ]" mode="data">
      <xsl:with-param name="variables" select="$variables"/>
      <xsl:with-param name="node" select="$activity"/>
    </xsl:apply-templates>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "create-activity-expiration-fault-handler":

    Sets the activity status variable to state "expired"
    ****************************************************************************************************************
   -->
  <xsl:template name="create-activity-expiration-fault-handler">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-activity-expiration-fault-handler&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-activity-expiration-fault-handler&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="status-variable" select="concat($activity/@name, $status-variable-suffix)"/>
    <xsl:variable name="status-variable-type">
      <xsl:choose>
        <!-- CASE: interface-typed BPEL variables -->
        <xsl:when test="'INTERFACE' = $variable-type-mode">
          <xsl:value-of select="$variables//bpws:variable[@name = $status-variable]/@messageType"/>
        </xsl:when>
        <!-- OTHERWISE: data-typed BPEL variables assumed -->
        <xsl:otherwise>
          <xsl:value-of select="$variables//bpws:variable[@name = $status-variable]/@type"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- Create comment: Set status variable of activity "nnn" to "expired" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Set status variable of activity &quot;', $activity/@name, '&quot; to &quot;expired&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <!-- Create "assign" activity that sets the "activity-started" indicator -->
    <xsl:call-template name="create-assign-activity-to-set-BPEL-variable">
      <xsl:with-param name="BPEL-variable" select="$status-variable"/>
      <xsl:with-param name="BPEL-variable-value" select="'expired'"/>
    </xsl:call-template>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "create-empty-activity":

    Called by an "create-activity" template.
    Translates "fdl:programActivity"  to an "empty" activity.
    ****************************************************************************************************************
   -->
  <xsl:template name="create-empty-activity">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="display-name"/>
    <xsl:param name="create-link-source-and-target-elements" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-empty-activity&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-empty-activity&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-empty-activity&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="parent-process" select="$activity/ancestor::fdl:process"/>
    <xsl:variable name="domain" select="//fdl:domain[1]"/>
    <xsl:variable name="system-group" select="//fdl:group[1]"/>
    <xsl:variable name="primary-system" select="//fdl:system[ @primarySystem ='yes' ][1]"/>
    <xsl:variable name="input-variable-name" select="concat($activity/@name, $input-variable-suffix)"/>
    <xsl:variable name="primary-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($input-variable-name)"/>
    <!-- Create comment: Empty activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Empty activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <!-- Create "empty" activity -->
    <bpws:empty name="{$activity/@name}">
      <!-- Add optional display name -->
      <xsl:if test="$activity/@displayName">
        <xsl:attribute name="wpc:displayName"><xsl:value-of select="$display-name"/></xsl:attribute>
      </xsl:if>
      <!-- Add optional business relevance indicator -->
      <xsl:choose>
        <!-- CASE: Filter option set in the FDL file -->
        <xsl:when test="string-length($activity/fdl:activityDefaultSetting/@auditFilterDB) &gt; 0 or string-length($activity/fdl:activityDefaultSetting/@auditFilterMQ) &gt; 0">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: Option "Audit trail" specified on page "Control" of the process settings -->
        <xsl:when test="$parent-process/@auditToDB = 'full' or $parent-process/@auditToDB = 'condensed' or $parent-process/@auditToMQ = 'full' or $parent-process/@auditToMQ = 'condensed'">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to DB" settings inherited from the primary system -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($parent-process/@auditToDB = 'no')
                    and ( $primary-system/fdl:processDefaultSetting/@auditToDB = 'full' or $primary-system/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to MQ" settings inherited from the primary system -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($parent-process/@auditToMQ = 'no')
                    and ( $primary-system/fdl:processDefaultSetting/@auditToMQ = 'full' or $primary-system/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to DB" settings inherited from the system group -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($primary-system/fdl:processDefaultSetting/@auditToDB = 'no')
                    and ( $system-group/fdl:processDefaultSetting/@auditToDB = 'full' or $system-group/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to MQ" settings inherited from the system group -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($primary-system/fdl:processDefaultSetting/@auditToMQ = 'no')
                    and ( $system-group/fdl:processDefaultSetting/@auditToMQ = 'full' or $system-group/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to DB" settings inherited from the domain -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($system-group/fdl:processDefaultSetting/@auditToDB = 'no')
                    and ( $domain/fdl:processDefaultSetting/@auditToDB = 'full' or $domain/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to MQ" settings inherited from the domain -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                        and not($system-group/fdl:processDefaultSetting/@auditToMQ = 'no')
                        and ( $domain/fdl:processDefaultSetting/@auditToMQ = 'full' or $domain/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
          <xsl:attribute name="wpc:businessRelevant">no</xsl:attribute>
        </xsl:otherwise>
      </xsl:choose>
      <!-- Activity description and documentation -->
      <xsl:call-template name="translate-description-and-documentation-fields">
        <xsl:with-param name="node" select="$activity"/>
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="primary-input-variable-name" select="$primary-input-variable-name"/>
      </xsl:call-template>
      <xsl:if test="$create-link-source-and-target-elements = 'true'">
        <!--
          Create link source and target elements
        -->
        <xsl:call-template name="create-link-source-and-target-elements">
          <xsl:with-param name="activity" select="$activity"/>
          <xsl:with-param name="variables" select="$variables"/>
        </xsl:call-template>
      </xsl:if>
    </bpws:empty>
  </xsl:template>
  <!--
    *****************************************************************************************
    Template "create-standard-activity":

    Called by an "create-activity" template.
    Translates "fdl:programActivity"  to an "invoke" activity.
    *****************************************************************************************
   -->
  <xsl:template name="create-standard-activity">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="display-name"/>
    <xsl:param name="program-activity-type"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-standard-activity&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-standard-activity&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-standard-activity&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($program-activity-type) or $program-activity-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-standard-activity&quot;', $eol, 'Parameter &quot;program-activity-type&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="parent-process" select="$activity/ancestor::fdl:process"/>
    <xsl:variable name="domain" select="//fdl:domain[1]"/>
    <xsl:variable name="system-group" select="//fdl:group[1]"/>
    <xsl:variable name="primary-system" select="//fdl:system[ @primarySystem ='yes' ][1]"/>
    <!-- Determine the value of the "portType" attribute -->
    <xsl:variable name="port-type">
      <xsl:choose>
        <xsl:when test="$activity/fdl:program/@name">
          <xsl:value-of select="concat('wsdl1:', $activity/fdl:program/@name, $port-type-suffix)"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'null'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- Determine the value of the "operation" attribute -->
    <xsl:variable name="operation" select="$activity/@name"/>
    <!-- Determine the value of the "partnerLink" attribute for "service invocation" activities, only -->
    <xsl:variable name="partner-link">
      <xsl:choose>
        <!-- CASE: empty activity -->
        <xsl:when test="$program-activity-type='empty activity'">
          <xsl:value-of select="'null'"/>
        </xsl:when>
        <!-- CASE: staff activity -->
        <xsl:when test="$program-activity-type='staff activity' or $program-activity-type='assumed staff activity'">
          <xsl:value-of select="'null'"/>
        </xsl:when>
        <!-- CASE: service invocation activity -->
        <xsl:when test="$program-activity-type='service invocation activity'">
          <xsl:value-of select="concat($activity/@name, $partner-link-suffix)"/>
        </xsl:when>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="input-variable-name" select="concat($activity/@name, $input-variable-suffix)"/>
    <xsl:variable name="output-variable-name">
      <xsl:choose>
        <!-- CASE: staff activity requires additional "human task" output variable -->
        <xsl:when test="($program-activity-type='staff activity' or $program-activity-type='assumed staff activity')
                        and 'true' = $merge_the_output_of_a_staff_activity">
          <xsl:value-of select="concat($activity/@name, $human-task-output-variable-suffix)"/>
        </xsl:when>
        <!-- OTHERWISE -->
        <xsl:otherwise>
          <xsl:value-of select="concat($activity/@name, $output-variable-suffix)"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="primary-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($input-variable-name)"/>
    <xsl:variable name="primary-output-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($output-variable-name)"/>
    <!--
                If the activity type is a human task then create a "Java snippet" that initializes the human task data input message
                (in case that the BPEL variable is empty)
    -->
    <xsl:if test="$program-activity-type='staff activity' or $program-activity-type='assumed staff activity'">
      <xsl:call-template name="initialize-human-task-input">
        <xsl:with-param name="variable-name" select="$primary-input-variable-name"/>
      </xsl:call-template>
    </xsl:if>
    <!-- Create comment: Invoke program activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Invoke program activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsl:if test="$program-activity-type='assumed staff activity'">
      <!-- Create comment: *** CWWBMnnnnW: Cannot decide whether program activity "nnn" should be mapped to a BPEL "empty activity", "staff activity", or "service invocation activity"  ("staff activity" assumed). *** -->
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'AmbiguousMapping_ProgramActivity', $fdlFileName, $activity/fdl:fdlLoc/@line, $activity/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- Create "invoke" activity -->
    <bpws:invoke wpc:continueOnError="no" partnerLink="{$partner-link}" portType="{$port-type}" operation="{$operation}" name="{$activity/@name}">
      <!-- Add optional display name -->
      <xsl:if test="$activity/@displayName">
        <xsl:attribute name="wpc:displayName"><xsl:value-of select="$display-name"/></xsl:attribute>
      </xsl:if>
      <!-- Add optional business relevance indicator -->
      <xsl:choose>
        <!-- CASE: Filter option set in the FDL file -->
        <xsl:when test="string-length($activity/fdl:activityDefaultSetting/@auditFilterDB) &gt; 0 or string-length($activity/fdl:activityDefaultSetting/@auditFilterMQ) &gt; 0">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: Option "Audit trail" specified on page "Control" of the process settings -->
        <xsl:when test="$parent-process/@auditToDB = 'full' or $parent-process/@auditToDB = 'condensed' or $parent-process/@auditToMQ = 'full' or $parent-process/@auditToMQ = 'condensed'">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to DB" settings inherited from the primary system -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($parent-process/@auditToDB = 'no')
                    and ( $primary-system/fdl:processDefaultSetting/@auditToDB = 'full' or $primary-system/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to MQ" settings inherited from the primary system -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($parent-process/@auditToMQ = 'no')
                    and ( $primary-system/fdl:processDefaultSetting/@auditToMQ = 'full' or $primary-system/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to DB" settings inherited from the system group -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($primary-system/fdl:processDefaultSetting/@auditToDB = 'no')
                    and ( $system-group/fdl:processDefaultSetting/@auditToDB = 'full' or $system-group/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to MQ" settings inherited from the system group -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($primary-system/fdl:processDefaultSetting/@auditToMQ = 'no')
                    and ( $system-group/fdl:processDefaultSetting/@auditToMQ = 'full' or $system-group/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to DB" settings inherited from the domain -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($system-group/fdl:processDefaultSetting/@auditToDB = 'no')
                    and ( $domain/fdl:processDefaultSetting/@auditToDB = 'full' or $domain/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to MQ" settings inherited from the domain -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                        and not($system-group/fdl:processDefaultSetting/@auditToMQ = 'no')
                        and ( $domain/fdl:processDefaultSetting/@auditToMQ = 'full' or $domain/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
          <xsl:attribute name="wpc:businessRelevant">no</xsl:attribute>
        </xsl:otherwise>
      </xsl:choose>
      <!-- Create input/output variable attributes in case of interface-typed BPEL variables -->
      <xsl:if test="'INTERFACE' = $variable-type-mode">
        <xsl:attribute name="inputVariable"><xsl:value-of select="$input-variable-name"/></xsl:attribute>
        <xsl:attribute name="outputVariable"><xsl:value-of select="$output-variable-name"/></xsl:attribute>
      </xsl:if>
      <!-- Activity description and documentation -->
      <xsl:call-template name="translate-description-and-documentation-fields">
        <xsl:with-param name="node" select="$activity"/>
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="primary-input-variable-name" select="$primary-input-variable-name"/>
      </xsl:call-template>
      <!--
          If the program activity maps to a BPEL "staff activity" that add a reference to the respective "human task" ("to-do task"),  .
      -->
      <xsl:if test="$program-activity-type='staff activity' or $program-activity-type='assumed staff activity'">
        <xsl:variable name="task-name" select="concat($activity/@name, $ptask-name-suffix)"/>
        <!-- Create comment: staff assignment (to-do task) for activity "nnn" -->
        <xsl:value-of select="concat($eol, '&lt;!-- Staff assignment (to-do task) for activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <wpc:task name="staff:{$task-name}"/>
      </xsl:if>
      <!-- Create input/output variable attributes in case of interface-typed BPEL variables -->
      <xsl:if test="'DATA' = $variable-type-mode">
        <wpc:input>
          <wpc:parameter name="{$element-input-name}" variable="{$primary-input-variable-name}"/>
        </wpc:input>
        <wpc:output>
          <wpc:parameter name="{$element-output-name}" variable="{$primary-output-variable-name}"/>
        </wpc:output>
      </xsl:if>
      <!-- Add "expiration expression" -->
      <xsl:call-template name="add-expiration-expression">
        <xsl:with-param name="activity" select="$activity"/>
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="variables" select="$variables"/>
      </xsl:call-template>
    </bpws:invoke>
    <xsl:if test="($program-activity-type='staff activity' or $program-activity-type='assumed staff activity')
                        and 'true' = $merge_the_output_of_a_staff_activity">
      <!--
          Create "assign" activity or "Java snippet" that merges the human task data output message with any default values in the "standard" data output.
      -->
      <xsl:call-template name="create-data-mapping-human-task-to-standard">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="activity" select="$activity"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************
    Template "create-UPES-activity"

    Called by an "create-activity" template.
    Translates "fdl:programActivity"  to an "invoke" activity
    that refers to an "UPES" port type
    *****************************************************************************************
   -->
  <xsl:template name="create-UPES-activity">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="display-name"/>
    <xsl:param name="create-link-source-and-target-elements" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-UPES-activity&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-UPES-activity&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-UPES-activity&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="parent-process" select="$activity/ancestor::fdl:process"/>
    <xsl:variable name="process-input-variable-name" select="concat($parent-process/@name, $input-variable-suffix)"/>
    <xsl:variable name="primary-process-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($process-input-variable-name)"/>
    <xsl:variable name="domain" select="//fdl:domain[1]"/>
    <xsl:variable name="system-group" select="//fdl:group[1]"/>
    <xsl:variable name="primary-system" select="//fdl:system[ @primarySystem ='yes' ][1]"/>
    <!-- Check whether the server definition exists -->
    <xsl:variable name="program-execution-unit" select="$activity/fdl:program/@programExecutionUnit"/>
    <xsl:variable name="server-name" select="substring-before($program-execution-unit, '.')"/>
    <xsl:variable name="related-system-name" select="substring-before(substring-after($program-execution-unit, concat($server-name, '.')), '.')"/>
    <xsl:if test="not(//fdl:definitions/fdl:server[ @name = $server-name and fdl:relatedSystem/@name = $related-system-name ]
        or //fdl:definitions/fdl:create/fdl:server[ @name = $server-name and fdl:relatedSystem/@name = $related-system-name ]
        or //fdl:definitions/fdl:update/fdl:server[ @name = $server-name and fdl:relatedSystem/@name = $related-system-name ]
        or //fdl:definitions/fdl:replace/fdl:server[ @name = $server-name and fdl:relatedSystem/@name = $related-system-name ])">
      <!--COMMENT: *** CWWBMnnnnE: The required program execution server definition nnn (UPES) was not found at activity nnn. *** -->
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'MissingUPES', $fdlFileName, $activity/fdl:fdlLoc/@line, $program-execution-unit, $activity/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- Determine the value of the "portType" attribute -->
    <xsl:variable name="port-type">
      <xsl:value-of select="concat('wsdl1:', $related-system-name, '_', $server-name, $port-type-suffix)"/>
    </xsl:variable>
    <!-- Determine the UPES execution mode (synchronous or asynchronous) -->
    <xsl:variable name="UPES-execution-mode">
      <xsl:call-template name="UPES-execution-mode">
        <xsl:with-param name="activity" select="$activity"/>
      </xsl:call-template>
    </xsl:variable>
    <!-- Determine the value of the "operation" attribute -->
    <xsl:variable name="operation" select="concat($activity/@name, $UPES-suffix)"/>
    <!-- Determine the value of the "partnerLink" attribute for "service invocation" activities, only -->
    <xsl:variable name="partner-link" select="concat($related-system-name, '_', $server-name, $partner-link-suffix)"/>
    <!-- Create activity that maps the data input message into another one which conforms to the UPES interoperability convention. -->
    <xsl:call-template name="create-data-mapping-standard-to-UPES">
      <xsl:with-param name="variables" select="$variables"/>
      <xsl:with-param name="activity" select="$activity"/>
    </xsl:call-template>
    <!-- Create activity that completes the data format conversion ("standard" to UPES) by mapping the output data defaults to UPES input message -->
    <xsl:if test="$activity/fdl:output/fdl:dataDefaults
            or $activity/../fdl:data[ @default = $activity/@name ]
            or 'true' = $initializePredefinedDataMembers">
      <xsl:call-template name="create-UPES-default-container-mapping">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="activity" select="$activity"/>
      </xsl:call-template>
    </xsl:if>
    <!-- Create the initial context data for UPES using a "Java snippet" -->
    <xsl:call-template name="set-initial-context-data-for-UPES">
      <xsl:with-param name="variable-name" select="concat($activity/@name, $UPES-input-variable-suffix)"/>
      <xsl:with-param name="UPES-execution-mode" select="$UPES-execution-mode"/>
      <xsl:with-param name="program-name" select="$activity/fdl:program/@name"/>
    </xsl:call-template>
    <xsl:variable name="UPES-input-variable-name" select="concat($activity/@name, $UPES-input-variable-suffix)"/>
    <xsl:variable name="UPES-output-variable-name" select="concat($activity/@name, $UPES-output-variable-suffix)"/>
    <xsl:variable name="input-variable-name" select="concat($activity/@name, $input-variable-suffix)"/>
    <xsl:variable name="primary-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($input-variable-name)"/>
    <!-- Create comment: Invoke UPES program activity "nnn" -->
    <xsl:value-of select="concat($eol, '&lt;!-- Invoke UPES program activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <!-- Create "invoke" activity -->
    <bpws:invoke wpc:continueOnError="no" partnerLink="{$partner-link}" portType="{$port-type}" operation="{$operation}" name="{$activity/@name}">
      <!-- Add optional display name -->
      <xsl:if test="$activity/@displayName">
        <xsl:attribute name="wpc:displayName"><xsl:value-of select="$display-name"/></xsl:attribute>
      </xsl:if>
      <!-- Add optional business relevance indicator -->
      <xsl:choose>
        <!-- CASE: Filter option set in the FDL file -->
        <xsl:when test="string-length($activity/fdl:activityDefaultSetting/@auditFilterDB) &gt; 0 or string-length($activity/fdl:activityDefaultSetting/@auditFilterMQ) &gt; 0">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: Option "Audit trail" specified on page "Control" of the process settings -->
        <xsl:when test="$parent-process/@auditToDB = 'full' or $parent-process/@auditToDB = 'condensed' or $parent-process/@auditToMQ = 'full' or $parent-process/@auditToMQ = 'condensed'">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to DB" settings inherited from the primary system -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($parent-process/@auditToDB = 'no')
                    and ( $primary-system/fdl:processDefaultSetting/@auditToDB = 'full' or $primary-system/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to MQ" settings inherited from the primary system -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($parent-process/@auditToMQ = 'no')
                    and ( $primary-system/fdl:processDefaultSetting/@auditToMQ = 'full' or $primary-system/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to DB" settings inherited from the system group -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($primary-system/fdl:processDefaultSetting/@auditToDB = 'no')
                    and ( $system-group/fdl:processDefaultSetting/@auditToDB = 'full' or $system-group/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to MQ" settings inherited from the system group -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($primary-system/fdl:processDefaultSetting/@auditToMQ = 'no')
                    and ( $system-group/fdl:processDefaultSetting/@auditToMQ = 'full' or $system-group/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to DB" settings inherited from the domain -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                    and not($system-group/fdl:processDefaultSetting/@auditToDB = 'no')
                    and ( $domain/fdl:processDefaultSetting/@auditToDB = 'full' or $domain/fdl:processDefaultSetting/@auditToDB = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <!-- CASE: "Audit to MQ" settings inherited from the domain -->
        <xsl:when test="'true' = $LI1274_Support_inheritance_from_network_settings
                        and not($system-group/fdl:processDefaultSetting/@auditToMQ = 'no')
                        and ( $domain/fdl:processDefaultSetting/@auditToMQ = 'full' or $domain/fdl:processDefaultSetting/@auditToMQ = 'condensed' )">
          <xsl:attribute name="wpc:businessRelevant">yes</xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
          <xsl:attribute name="wpc:businessRelevant">no</xsl:attribute>
        </xsl:otherwise>
      </xsl:choose>
      <!-- Create input/output variable attributes in case of interface-typed BPEL variables -->
      <xsl:if test="'INTERFACE' = $variable-type-mode">
        <xsl:attribute name="inputVariable"><xsl:value-of select="$UPES-input-variable-name"/></xsl:attribute>
        <xsl:attribute name="outputVariable"><xsl:value-of select="$UPES-output-variable-name"/></xsl:attribute>
      </xsl:if>
      <!-- Activity description and documentation -->
      <xsl:call-template name="translate-description-and-documentation-fields">
        <xsl:with-param name="node" select="$activity"/>
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="primary-input-variable-name" select="$primary-input-variable-name"/>
      </xsl:call-template>
      <!--
          Create reference to administration task
        -->
      <xsl:variable name="activity-admin-task-name" select="concat($activity/@name, $activity-admin-task-suffix)"/>
      <!-- Create comment: Reference to activity administration task definition -->
      <xsl:value-of select="concat($eol, '&lt;!-- *** Reference to activity administration task definition *** --&gt;', $eol)" disable-output-escaping="yes"/>
      <wpc:adminTask name="staff:{$activity-admin-task-name}"/>
      <!-- Generate A-task TEL file -->
      <xsl:variable name="activity-atask-telfile-local-name" select="concat($activity-admin-task-name, '.itel')"/>
      <xsl:variable name="activity-atask-telfile-path-name" select="concat($outputdir, $activity-atask-telfile-local-name)"/>
      <xsl:variable name="message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $activity-atask-telfile-local-name)"/>
      <xsl:variable name="addITel" select="java:com.ibm.bpe.fdl2bpel.converter.ITelList.add($activity-atask-telfile-path-name)"/>
      <redirect:write select="concat($outputdir, $activity-atask-telfile-local-name)">
        <tel:task defaultLocale="{$locale}" supportsFollowOnTask="no" supportsSubTask="no" kind="aTask" jndiNameStaffPluginProvider="bpe/staff/samplevmmconfiguration" targetNamespace="{$telTargetNamespace}" name="{$activity-admin-task-name}" xmlns_wsdl1="{$wsdlTargetNamespace}">
          <tel:staffSettings>
            <tel:administrator>
              <tel:verb>
                <xsl:choose>
                  <xsl:when test="fdl:staff/fdl:processAdministrator">
                    <xsl:apply-templates select="$activity/fdl:staff" mode="create-staff-query-verb">
                      <xsl:with-param name="node" select="$activity"/>
                      <xsl:with-param name="variables" select="$variables"/>
                      <xsl:with-param name="local-variable-name" select="$primary-input-variable-name"/>
                    </xsl:apply-templates>
                  </xsl:when>
                  <xsl:when test="$parent-process/fdl:staff/fdl:processAdministrator">
                    <xsl:apply-templates select="$parent-process/fdl:staff" mode="create-staff-query-verb">
                      <xsl:with-param name="node" select="$parent-process"/>
                      <xsl:with-param name="variables" select="$variables"/>
                      <xsl:with-param name="local-variable-name" select="$primary-process-input-variable-name"/>
                    </xsl:apply-templates>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:variable name="process-starter">
                      <fdl:staff>
                        <fdl:processStarter/>
                      </fdl:staff>
                    </xsl:variable>
                    <xsl:apply-templates select="xalan:nodeset($process-starter)/fdl:staff" mode="create-staff-query-verb">
                      <xsl:with-param name="node" select="$parent-process"/>
                      <xsl:with-param name="variables" select="$variables"/>
                      <xsl:with-param name="local-variable-name" select="$primary-process-input-variable-name"/>
                    </xsl:apply-templates>
                  </xsl:otherwise>
                </xsl:choose>
              </tel:verb>
            </tel:administrator>
          </tel:staffSettings>
          <tel:uiSettings/>
          <tel:escalationSettings/>
        </tel:task>
      </redirect:write>
      <!-- Create input/output variable attributes in case of interface-typed BPEL variables -->
      <xsl:if test="'DATA' = $variable-type-mode">
        <wpc:input>
          <wpc:parameter name="{$element-input-name}" variable="{$UPES-input-variable-name}"/>
        </wpc:input>
        <xsl:if test="$UPES-execution-mode = 'synchronous'">
          <wpc:output>
            <wpc:parameter name="{$element-output-name}" variable="{$UPES-output-variable-name}"/>
          </wpc:output>
        </xsl:if>
      </xsl:if>
      <!-- Add "expiration expression" -->
      <xsl:call-template name="add-expiration-expression">
        <xsl:with-param name="activity" select="$activity"/>
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="variables" select="$variables"/>
      </xsl:call-template>
    </bpws:invoke>
    <xsl:if test="$UPES-execution-mode = 'synchronous'">
      <!--
          Create "assign" activity or "Java snippet" that maps the UPES data output message back to the "standard" data message format.
      -->
      <xsl:call-template name="create-data-mapping-UPES-to-standard">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="activity" select="$activity"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************
    "set-initial-context-data-for-UPES" template:

    Creates a Java snippet that sets the initial context data
    required for a UPES invocation.
    *****************************************************************************************
   -->
  <xsl:template name="set-initial-context-data-for-UPES">
    <xsl:param name="variable-name"/>
    <xsl:param name="UPES-execution-mode"/>
    <xsl:param name="program-name"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variable-name) or $variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;set-initial-context-data-for-UPES&quot;', $eol, 'Parameter &quot;variable-name&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($UPES-execution-mode) or $UPES-execution-mode = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;set-initial-context-data-for-UPES&quot;', $eol, 'Parameter &quot;UPES-execution-mode&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($program-name) or $program-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;set-initial-context-data-for-UPES&quot;', $eol, 'Parameter &quot;program-name&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="response-required">
      <xsl:choose>
        <!-- CASE: asynchronous execution mode -->
        <xsl:when test="$UPES-execution-mode = 'asynchronous'">
          <xsl:value-of select="'No'"/>
        </xsl:when>
        <!-- OTHERWISE: synchronous execution assumed-->
        <xsl:otherwise>
          <xsl:value-of select="'Yes'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <bpws:invoke wpc:continueOnError="no" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Set UPES context" operation="null" partnerLink="null" portType="wpc:null">
      <wpc:script>
        <wpc:javaCode>
          <xsl:value-of select="concat($eol, '&lt;![CDATA[')" disable-output-escaping="yes"/>
          <!-- Create comment: Set UPES context -->
          <xsl:value-of select="concat($eol, '// Set UPES context', $eol)" disable-output-escaping="yes"/>
          <!-- Initialize business object -->
          <xsl:value-of select="concat($eol,
                                          'if (',
                          $variable-name,
                                          ' == null) {',
                                          $eol,
                                          '    com.ibm.websphere.bo.BOFactory boFactory = (com.ibm.websphere.bo.BOFactory)com.ibm.websphere.sca.ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
                                          $eol,
                                          '    ',
                          $variable-name,
                                          ' = boFactory.createByType(getVariableType(&quot;',
                          $variable-name,
                          '&quot;));',
                                          $eol,
                                          '}')" disable-output-escaping="yes"/>
          <!-- Get UPES message context -->
          <xsl:value-of select="concat($eol,
                                          'commonj.sdo.DataObject messageContext = ',
                          $variable-name,
                          '.getDataObject(&quot;MessageContext&quot;);',
                                          $eol,
                                          'if (messageContext == null) {',
                                          $eol,
                                          '    messageContext = ',
                          $variable-name,
                          '.createDataObject(&quot;MessageContext&quot;);',
                                          $eol,
                                          '}')" disable-output-escaping="yes"/>
          <xsl:value-of select="concat($eol, 'messageContext.set(&quot;_PROCESS&quot;, processInstance().getName());')" disable-output-escaping="yes"/>
          <xsl:value-of select="concat($eol, 'messageContext.set(&quot;ResponseRequired&quot;, &quot;', $response-required, '&quot;);')" disable-output-escaping="yes"/>
          <xsl:value-of select="concat($eol, 'messageContext.set(&quot;ActImplCorrelID&quot;, ', 'com.ibm.bpe.interop.WMQWFHelper.createCorrelationID());')" disable-output-escaping="yes"/>
          <xsl:value-of select="concat($eol, 'messageContext.set(&quot;Starter&quot;, processInstance().getStarter().toString());')" disable-output-escaping="yes"/>
          <xsl:value-of select="concat($eol, 'messageContext.set(&quot;ProcTemplID&quot;, processInstance().getProcessTemplateID().toString());')" disable-output-escaping="yes"/>
          <xsl:value-of select="concat($eol, 'messageContext.set(&quot;ProgramName&quot;, &quot;', $program-name, '&quot;);')" disable-output-escaping="yes"/>
          <xsl:value-of select="concat($eol, ']]&gt;', $eol)" disable-output-escaping="yes"/>
        </wpc:javaCode>
      </wpc:script>
    </bpws:invoke>
  </xsl:template>
  <!--
    *****************************************************************************************
    "create-standard-elements" template:

    Creates the standard activity elements  "wpc:joinCondition" , "source", "target".
        Add "description" and "documentation" elements if required.
    *****************************************************************************************
   -->
  <xsl:template name="create-standard-elements">
    <xsl:param name="activity"/>
    <xsl:param name="display-name"/>
    <xsl:param name="variables"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-standard-elements&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-standard-elements&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-standard-elements&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="input-variable-name" select="concat($activity/@name, $input-variable-suffix)"/>
    <xsl:variable name="primary-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($input-variable-name)"/>
    <!-- Activity description and documentation  -->
    <xsl:call-template name="translate-description-and-documentation-fields">
      <xsl:with-param name="node" select="$activity"/>
      <xsl:with-param name="display-name" select="$display-name"/>
      <xsl:with-param name="variables" select="$variables"/>
      <xsl:with-param name="primary-input-variable-name" select="$primary-input-variable-name"/>
    </xsl:call-template>
    <!-- Link source and target elements -->
    <xsl:call-template name="create-link-source-and-target-elements">
      <xsl:with-param name="activity" select="$activity"/>
      <xsl:with-param name="variables" select="$variables"/>
    </xsl:call-template>
  </xsl:template>
  <!--
    ***************************************************************************************************************************************************
      "create-link-source-and-target-elements" template

      Adds the Link source and target elements
    ***************************************************************************************************************************************************
  -->
  <xsl:template name="create-link-source-and-target-elements">
    <xsl:param name="activity"/>
    <xsl:param name="variables"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-link-source-and-target-elements&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-link-source-and-target-elements&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="link-sources" select="$activity/../fdl:control[ @from = $activity/@name ]"/>
    <xsl:variable name="link-targets" select="$activity/../fdl:control[ @to = $activity/@name ]"/>
    <!-- Add the "target" elements for "links" that end at this activity -->
    <xsl:if test="$link-targets">
      <bpws:targets>
        <!-- Add the "wpc:joinCondition" element" -->
        <xsl:apply-templates select="$activity/fdl:join" mode="join-condition"/>
        <xsl:apply-templates select="$link-targets" mode="link-targets"/>
      </bpws:targets>
    </xsl:if>
    <!-- Add the "source" elements for "links" that start from this activity -->
    <xsl:if test="$link-sources">
      <bpws:sources>
        <xsl:apply-templates select="$link-sources" mode="link-sources">
          <xsl:with-param name="activity" select="$activity"/>
          <xsl:with-param name="variables" select="$variables"/>
        </xsl:apply-templates>
      </bpws:sources>
    </xsl:if>
  </xsl:template>
  <!--
    ***************************************************************************************************************************************************
      "add-expiration-expression" template

      Adds the BPEL translation of an FDL expiration
    ***************************************************************************************************************************************************
  -->
  <xsl:template name="add-expiration-expression">
    <xsl:param name="activity"/>
    <xsl:param name="display-name"/>
    <xsl:param name="variables"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;add-expiration-expression&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;add-expiration-expression&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;add-expiration-expression&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:choose>
      <!-- Expiration defined in FDL -->
      <xsl:when test="$activity/fdl:expiration/@maximumDuration">
        <xsl:call-template name="create-expiration-expression">
          <xsl:with-param name="maximum-duration" select="$activity/fdl:expiration/@maximumDuration"/>
        </xsl:call-template>
      </xsl:when>
      <!-- Dynamic expiration value from container member -->
      <xsl:when test="$activity/fdl:expiration/fdl:dataStructureMemberName">
        <xsl:variable name="local-variable-name" select="concat($activity/@name, $input-variable-suffix)"/>
        <xsl:variable name="primary-local-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($local-variable-name)"/>
        <xsl:variable name="xpath-expression-with-delimiters">
          <xsl:apply-templates select="$activity/fdl:expiration/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
            <xsl:with-param name="display-name" select="$display-name"/>
            <xsl:with-param name="node" select="$activity"/>
            <xsl:with-param name="variables" select="$variables"/>
            <xsl:with-param name="local-variable-name" select="$primary-local-variable-name"/>
            <xsl:with-param name="FDL-location" select="$activity/fdl:fdlLoc"/>
          </xsl:apply-templates>
        </xsl:variable>
        <xsl:variable name="delimiter">
          <xsl:choose>
            <!-- CASE: interface-typed BPEL variables -->
            <xsl:when test="'INTERFACE' = $variable-type-mode">
              <xsl:value-of select="concat('\', $message-part-name, '\')"/>
            </xsl:when>
            <!-- OTHERWISE: data-typed BPEL variables assumed -->
            <xsl:otherwise>
              <xsl:value-of select="'\\'"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="xpath-expression-without-delimiters" select="substring-before(substring-after($xpath-expression-with-delimiters, $delimiter), '%')"/>
        <wpc:expiration>
          <xsl:choose>
            <xsl:when test="'XPATH' = translate($expiration-expression-language, $lower-case-characters, $upper-case-characters)">
              <xsl:variable name="bpel-duration-expression">
                <xsl:choose>
                  <!-- CASE: interface-typed BPEL variables -->
                  <xsl:when test="'INTERFACE' = $variable-type-mode">
                    <xsl:value-of select="concat('$', $local-variable-name, '.', $message-part-name, '/', $xpath-expression-without-delimiters)"/>
                  </xsl:when>
                  <!-- OTHERWISE: data-typed BPEL variables assumed -->
                  <xsl:otherwise>
                    <xsl:value-of select="concat('$', $primary-local-variable-name, '/', $xpath-expression-without-delimiters)"/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:variable>
              <wpc:for expressionLanguage="{$XPATH}">
                <xsl:value-of select="$bpel-duration-expression"/>
              </wpc:for>
            </xsl:when>
            <xsl:otherwise>
              <xsl:variable name="Java-translation-of-XPath-expression">
                <xsl:call-template name="translate-XPath-to-Java-get-int-expression">
                  <xsl:with-param name="current-XPath-expression" select="$xpath-expression-without-delimiters"/>
                  <xsl:with-param name="current-Java-translation" select="$primary-local-variable-name"/>
                </xsl:call-template>
              </xsl:variable>
              <xsl:variable name="Java-expression">
                <xsl:value-of select="concat($eol,
                                      'int duration = 0;',
                                      $eol,
                                      'try {',
                                      $eol,
                                      '    if (',
                                      $primary-local-variable-name,
                                      ' == null) {',
                                      $eol,
                                      '        com.ibm.websphere.bo.BOFactory boFactory = (com.ibm.websphere.bo.BOFactory)com.ibm.websphere.sca.ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
                                      $eol,
                                      '        ',
                                      $primary-local-variable-name,
                                      ' = boFactory.createByType(getVariableType(&quot;',
                                      $primary-local-variable-name,
                                      '&quot;));',
                                      $eol,
                                      '    }')" disable-output-escaping="yes"/>
                <xsl:value-of select="concat($eol,
                                      '    duration = ',
                                      $Java-translation-of-XPath-expression,
                                      ';',
                                      $eol,
                                      '} catch (Exception e) {',
                                      $eol,
                                      '    e.printStackTrace();',
                                      $eol,
                                      '}',
                                      $eol,
                                      'return duration;',
                                      $eol)" disable-output-escaping="yes"/>
              </xsl:variable>
              <wpc:for expressionLanguage="{$JAVA}">
                <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
                <xsl:value-of select="$Java-expression" disable-output-escaping="yes"/>
                <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
              </wpc:for>
            </xsl:otherwise>
          </xsl:choose>
        </wpc:expiration>
      </xsl:when>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************
    Template "create-expiration-expression"

    Called by a "create-standard-activity", "create-empty-activity",
    and "create-UPES-activity" templates.
    Creates expression for "invoke" activity expiration.

    ASSUMPTION: Usage of the "SIMPLE Arithmetic Calendar" of the
    WebSphere Scheduler.
    The interval is calculated using a simple java.util.Calendar based scheme.
    Each term has the form "NNNNNtype", where "NNNN is an integer and "type"
    indicates one of the following values:
      seconds
      minutes
      hours
      days
      months
      years
    *****************************************************************************************
   -->
  <xsl:template name="create-expiration-expression">
    <xsl:param name="maximum-duration"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($maximum-duration) or $maximum-duration = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-expiration-expression&quot;', $eol, 'Parameter &quot;maximum-duration&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <wpc:expiration>
      <wpc:timeout duration="{$maximum-duration}"/>
    </wpc:expiration>
  </xsl:template>
  <!--
    ***************************************************************************************************************************************************
    "translate-XPath-to-Java-get-int-expression" template

    Translates XPath location path to an equivalent Java expression that retrieves an object of type "int" (provided that the FDL type is "LONG").

    Parameter "current-Xpath-expression":  XPath expression recursively updated during each call of the template
                                          (see explanation of example below)
    Parameter "current-Java-translation":      Java translation of the preceding XPath expression recursively updated during each
                                                                    call of the template

    Example:
    Assume the following Xpath:  '/B1/C1[3]/D1'
    Then the generated XPath location path will look like the following: '/A/B[4]/C[1]'
    (Note that an xpath array begins with 1, other than FDL arrays or Java lists!)

    The equivalent Java translation is:
                                          ((Integer) ( (commonj.sdo.DataObject) ACT_IN.getDataObject("A").getList("B").get(3) ).getList("C").get(0)).intValue()
    ***************************************************************************************************************************************************
  -->
  <xsl:template name="translate-XPath-to-Java-get-int-expression">
    <xsl:param name="current-XPath-expression" select="''"/>
    <xsl:param name="current-Java-translation" select="''"/>
    <!-- remove leading slash -->
    <xsl:variable name="current-XPath-expression-without-leading-slash">
      <xsl:choose>
        <xsl:when test="starts-with($current-XPath-expression, '/')">
          <xsl:value-of select="substring-after($current-XPath-expression, '/')"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$current-XPath-expression"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="current-XPath-step-with-optional-index-expression">
      <xsl:choose>
        <!-- CASE: current XPath expression contains more than one step -->
        <xsl:when test="contains($current-XPath-expression-without-leading-slash, '/')">
          <xsl:value-of select="substring-before($current-XPath-expression-without-leading-slash, '/')"/>
        </xsl:when>
        <!-- OTHERWISE: current XPath expression is a simple step -->
        <xsl:otherwise>
          <xsl:value-of select="$current-XPath-expression-without-leading-slash"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- Next XPath expression is equal to the current XPath expression without the leading XPath step -->
    <xsl:variable name="next-XPath-expression">
      <xsl:choose>
        <!-- CASE: current XPath expression contains more than one step -->
        <xsl:when test="contains($current-XPath-expression-without-leading-slash, '/')">
          <xsl:value-of select="substring-after($current-XPath-expression-without-leading-slash, '/')"/>
        </xsl:when>
        <!-- OTHERWISE: current XPath expression is a simple step -->
        <xsl:otherwise>
          <xsl:value-of select="''"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="current-XPath-step-without-optional-index-expression">
      <xsl:choose>
        <!-- CASE: current XPath expression contains index expression -->
        <xsl:when test="contains($current-XPath-step-with-optional-index-expression, '[')">
          <!-- ASSERT CONDITION -->
          <xsl:if test="not(contains($current-XPath-step-with-optional-index-expression, ']'))">
            <xsl:variable name="error-message" select="'ASSERTION FAILED in template &quot;translate-XPath-to-Java-get-int-expression&quot;: XPath with illegal index expression'"/>
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
          </xsl:if>
          <xsl:value-of select="substring-before($current-XPath-step-with-optional-index-expression, '[')"/>
        </xsl:when>
        <!-- OTHERWISE: current XPath expression is a simple step -->
        <xsl:otherwise>
          <xsl:value-of select="$current-XPath-step-with-optional-index-expression"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="current-array-index">
      <xsl:choose>
        <!-- CASE: current XPath expression contains index expression -->
        <xsl:when test="contains($current-XPath-step-with-optional-index-expression, '[')">
          <!-- ASSERT CONDITION -->
          <xsl:if test="not(contains($current-XPath-step-with-optional-index-expression, ']'))">
            <xsl:variable name="error-message" select="'ASSERTION FAILED in template &quot;translate-XPath-to-Java-get-int-expression&quot;: XPath with illegal index expression'"/>
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
          </xsl:if>
          <xsl:value-of select="substring-before(substring-after($current-XPath-step-with-optional-index-expression, '['), ']')"/>
        </xsl:when>
        <!-- OTHERWISE: current XPath expression is a simple step -->
        <xsl:otherwise>
          <xsl:value-of select="''"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="next-Java-translation">
      <xsl:choose>
        <!-- CASE: There are more XPath location steps to translate -->
        <xsl:when test="string-length($next-XPath-expression) &gt; 0">
          <xsl:choose>
            <!-- CASE: Current XPath step has an index expression (array) -->
            <xsl:when test="string-length($current-array-index) &gt; 0">
              <xsl:value-of select="concat('( (commonj.sdo.DataObject) ', $current-Java-translation, '.getList(&quot;', $current-XPath-step-without-optional-index-expression, '&quot;).get(', $current-array-index - 1, ') )')"/>
            </xsl:when>
            <!-- OTHERWISE: Current XPath step has no (or empty) index expression -->
            <xsl:otherwise>
              <xsl:value-of select="concat($current-Java-translation, '.getDataObject(&quot;', $current-XPath-step-without-optional-index-expression, '&quot;)')"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <!-- OTHERWISE: Last location step of XPath found -->
        <xsl:otherwise>
          <xsl:choose>
            <!-- CASE: Current XPath step has an index expression (array) -->
            <xsl:when test="string-length($current-array-index) &gt; 0">
              <xsl:value-of select="concat('( (Integer) ', $current-Java-translation, '.getList(&quot;', $current-XPath-step-without-optional-index-expression, '&quot;).get(', $current-array-index - 1, ') ).intValue()')"/>
            </xsl:when>
            <!-- OTHERWISE: Current XPath step has no (or empty) index expression -->
            <xsl:otherwise>
              <xsl:value-of select="concat($current-Java-translation, '.getInt(&quot;', $current-XPath-step-without-optional-index-expression, '&quot;)')"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <!-- CASE: XPath contains more remaining steps to translate -->
      <xsl:when test="string-length($next-XPath-expression) &gt; 0">
        <xsl:call-template name="translate-XPath-to-Java-get-int-expression">
          <xsl:with-param name="current-XPath-expression" select="$next-XPath-expression"/>
          <xsl:with-param name="current-Java-translation" select="$next-Java-translation"/>
        </xsl:call-template>
      </xsl:when>
      <!-- OTHERWISE: Current XPath step was the last one: return the translated Java expression -->
      <xsl:otherwise>
        <xsl:value-of select="$next-Java-translation"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************
    "create-staff-query-verb" template:

    Creates a staff query verb.
    *****************************************************************************************
   -->
  <xsl:template match="fdl:staff" mode="create-staff-query-verb">
    <xsl:param name="node"/>
    <xsl:param name="variables"/>
    <xsl:param name="local-variable-name"/>
    <xsl:param name="current-named-users-parameter-list"/>
    <xsl:param name="staff-from-predefined-members" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($node)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;create-staff-query-verb&quot; match=&quot;fdl:staff&quot;', $eol, 'Parameter &quot;node&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;create-staff-query-verb&quot; match=&quot;fdl:staff&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($local-variable-name) or $local-variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;create-staff-query-verb&quot; match=&quot;fdl:staff&quot;', $eol, 'Parameter &quot;local-variable-name&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="display-name">
      <xsl:choose>
        <xsl:when test="$node/@displayName">
          <xsl:call-template name="tailor-display-name">
            <xsl:with-param name="untailored-display-name" select="$node/@displayName"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="tailor-display-name">
            <xsl:with-param name="untailored-display-name" select="$node/@name"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="staff-query-type">
      <xsl:choose>
        <xsl:when test="$staff-from-predefined-members = 'true'">
          <xsl:value-of select="'Organization'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:apply-templates select="current()" mode="find-staff-query-type">
            <xsl:with-param name="node" select="$node"/>
          </xsl:apply-templates>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <!--
        Static staff queries
      -->
      <!-- CASE: All people -->
      <xsl:when test="$staff-query-type = 'All people'">
        <!-- Create comment: FDL staff query "All people" -->
        <xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;All people&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <tel:name>Everybody</tel:name>
      </xsl:when>
      <!-- CASE: Staff from predefined members -->
      <xsl:when test="$staff-query-type = 'Staff from predefined members'">
        <xsl:variable name="predefined-container-field-organization">
          <fdl:staff>
            <fdl:organization includeChildOrganizations="yes">
              <fdl:dataStructureMemberName>
                <fdl:nameComponent name="_ACTIVITY_INFO"/>
                <fdl:nameComponent name="Organization"/>
              </fdl:dataStructureMemberName>
            </fdl:organization>
          </fdl:staff>
        </xsl:variable>
        <!-- Create comment: *** CWWBMnnnnW: The BPEL mapping for FDL staff query type "Staff from predefined members" is limited to the _ACTIVITY_INFO field “Organization”*** -->
        <xsl:choose>
          <xsl:when test="local-name($node) = 'process'">
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_StaffFromPredefinedMembers1', $fdlFileName, $node/fdl:fdlLoc/@line, $display-name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_StaffFromPredefinedMembers2', $fdlFileName, $node/fdl:fdlLoc/@line, $display-name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:apply-templates select="xalan:nodeset($predefined-container-field-organization)/fdl:staff" mode="create-staff-query-verb">
          <xsl:with-param name="node" select="$node"/>
          <xsl:with-param name="variables" select="$variables"/>
          <xsl:with-param name="local-variable-name" select="$local-variable-name"/>
          <xsl:with-param name="staff-from-predefined-members" select="true()"/>
        </xsl:apply-templates>
      </xsl:when>
      <!-- CASE: Coordinator of role -->
      <xsl:when test="$staff-query-type = 'Coordinator of role'">
        <!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff query type "Coordinator of role" *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_RoleCoordinator', $fdlFileName, $node/fdl:fdlLoc/@line, $node/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create comment: *** CWWBMnnnnW: Default staff verb "Everybody" used *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'DefaultStaffVerbEverybodyUsed'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
        <tel:name>Everybody</tel:name>
      </xsl:when>
      <!-- CASE: Manager of organization -->
      <xsl:when test="$staff-query-type = 'Manager of organization'">
        <!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff query type "Manager of organization" *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_OrganizationManager', $fdlFileName, $node/fdl:fdlLoc/@line, $node/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
        <!-- Create comment: *** CWWBMnnnnW: Default staff verb "Everybody" used *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'DefaultStaffVerbEverybodyUsed'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
        <tel:name>Everybody</tel:name>
      </xsl:when>
      <!-- CASE: People -->
      <xsl:when test="$staff-query-type = 'People'">
        <!-- Create comment: FDL staff query "People" -->
        <xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;People&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <xsl:choose>
          <xsl:when test="$current-named-users-parameter-list">
            <tel:name>Users by user ID without Named Users</tel:name>
          </xsl:when>
          <xsl:otherwise>
            <tel:name>Users by user ID</tel:name>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="fdl:person[1]">
          <xsl:choose>
            <xsl:when test="fdl:person[1]/@name">
              <tel:parameter id="UserID">
                <xsl:value-of select="fdl:person[1]/@name"/>
              </tel:parameter>
            </xsl:when>
            <xsl:when test="fdl:person[1]/fdl:dataStructureMemberName">
              <tel:parameter id="UserID">
                <xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
                <xsl:apply-templates select="fdl:person[1]/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
                  <xsl:with-param name="display-name" select="$display-name"/>
                  <xsl:with-param name="node" select="$node"/>
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="local-variable-name" select="$local-variable-name"/>
                  <xsl:with-param name="FDL-location" select="$node/fdl:fdlLoc"/>
                </xsl:apply-templates>
                <xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
              </tel:parameter>
            </xsl:when>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="fdl:person[2]">
          <xsl:choose>
            <xsl:when test="fdl:person[2]/@name">
              <tel:parameter id="AlternativeID1">
                <xsl:value-of select="fdl:person[2]/@name"/>
              </tel:parameter>
            </xsl:when>
            <xsl:when test="fdl:person[2]/fdl:dataStructureMemberName">
              <tel:parameter id="AlternativeID1">
                <xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
                <xsl:apply-templates select="fdl:person[2]/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
                  <xsl:with-param name="display-name" select="$display-name"/>
                  <xsl:with-param name="node" select="$node"/>
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="local-variable-name" select="$local-variable-name"/>
                  <xsl:with-param name="FDL-location" select="$node/fdl:fdlLoc"/>
                </xsl:apply-templates>
                <xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
              </tel:parameter>
            </xsl:when>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="fdl:person[3]">
          <xsl:choose>
            <xsl:when test="fdl:person[3]/@name">
              <tel:parameter id="AlternativeID2">
                <xsl:value-of select="fdl:person[3]/@name"/>
              </tel:parameter>
            </xsl:when>
            <xsl:when test="fdl:person[3]/fdl:dataStructureMemberName">
              <tel:parameter id="AlternativeID2">
                <xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
                <xsl:apply-templates select="fdl:person[3]/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
                  <xsl:with-param name="display-name" select="$display-name"/>
                  <xsl:with-param name="node" select="$node"/>
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="local-variable-name" select="$local-variable-name"/>
                  <xsl:with-param name="FDL-location" select="$node/fdl:fdlLoc"/>
                </xsl:apply-templates>
                <xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
              </tel:parameter>
            </xsl:when>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="fdl:person[4]">
          <!-- Create comment: *** CWWBMnnnnW: BPEL mapping for FDL staff query type "People" does not consider more than three persons *** -->
          <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_People', $fdlFileName, $node/fdl:fdlLoc/@line, $node/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
      </xsl:when>
      <!-- CASE: Process administrator -->
      <xsl:when test="$staff-query-type = 'Process administrator'">
        <!-- Create comment: FDL staff query "Process administrator" -->
        <xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Process administrator&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <tel:name>Users by user ID</tel:name>
        <xsl:choose>
          <xsl:when test="fdl:processAdministrator/@name">
            <tel:parameter id="UserID">
              <xsl:value-of select="fdl:processAdministrator/@name"/>
            </tel:parameter>
          </xsl:when>
          <xsl:when test="fdl:processAdministrator/fdl:dataStructureMemberName">
            <tel:parameter id="UserID">
              <xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
              <xsl:apply-templates select="fdl:processAdministrator/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
                <xsl:with-param name="display-name" select="$display-name"/>
                <xsl:with-param name="node" select="$node"/>
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="local-variable-name" select="$local-variable-name"/>
                <xsl:with-param name="FDL-location" select="$node/fdl:fdlLoc"/>
              </xsl:apply-templates>
              <xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
            </tel:parameter>
          </xsl:when>
          <xsl:otherwise>
            <tel:parameter id="UserID">%wf:process.administrators%</tel:parameter>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- CASE: Process starter -->
      <xsl:when test="$staff-query-type = 'Process starter'">
        <!-- Create comment: FDL staff query "Process starter" -->
        <xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Process starter&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <tel:name>Users by user ID</tel:name>
        <tel:parameter id="UserID">%wf:process.starter%</tel:parameter>
      </xsl:when>
      <!-- CASE: Manager of process starter -->
      <xsl:when test="$staff-query-type = 'Manager of process starter'">
        <!-- Create comment: FDL staff query "ManagerOfProcessStarter" -->
        <xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Manager of process starter&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <tel:name>Manager of Employee by user ID</tel:name>
        <tel:parameter id="EmployeeUserID">%wf:process.starter%</tel:parameter>
      </xsl:when>
      <!-- CASE: Starter of activity -->
      <xsl:when test="$staff-query-type = 'Starter of activity'">
        <!-- Create comment: FDL staff query "Starter of activity" -->
        <xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Starter of activity&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <tel:name>Users by user ID</tel:name>
        <xsl:variable name="activity-name" select="fdl:starterOfActivity/fdl:fullyQualifiedActivityName/fdl:nameComponent[last()]/@name"/>
        <tel:parameter id="UserID">%wf:activity(<xsl:value-of select="$activity-name"/>).owner%</tel:parameter>
      </xsl:when>
      <!-- CASE: Manager of starter of activity -->
      <xsl:when test="$staff-query-type = 'Manager of starter of activity'">
        <!-- Create comment: FDL staff query "Manager of starter of activity" -->
        <xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Manager of starter of activity&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <tel:name>Manager of Employee by user ID</tel:name>
        <xsl:variable name="activity-name">
          <xsl:choose>
            <!-- CASE: Explicit activity name is specified -->
            <xsl:when test="fdl:manager/fdl:starterOfActivity/fdl:fullyQualifiedActivityName/fdl:nameComponent">
              <xsl:value-of select="fdl:manager/fdl:starterOfActivity/fdl:fullyQualifiedActivityName/fdl:nameComponent[last()]/@name"/>
            </xsl:when>
            <!-- OTHERWISE: Take name of current activity -->
            <xsl:otherwise>
              <xsl:value-of select="$node/@name"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <tel:parameter id="EmployeeUserID">%wf:activity(<xsl:value-of select="$activity-name"/>).owner%</tel:parameter>
      </xsl:when>
      <!-- CASE: Exclude starter of activity -->
      <xsl:when test="$staff-query-type = 'Exclude starter of activity'">
        <xsl:variable name="remote-activity-name" select="fdl:excludeStarterOfActivity/fdl:fullyQualifiedActivityName/fdl:nameComponent[last()]/@name"/>
        <xsl:variable name="remote-activity" select="key('activity-by-name', $remote-activity-name)"/>
        <xsl:variable name="parent-process" select="$remote-activity/ancestor::fdl:process"/>
        <xsl:variable name="staff-query-type-of-remote-activity">
          <xsl:choose>
            <!-- CASE: Staff settings specified for remote activity -->
            <xsl:when test="$remote-activity/fdl:staff">
              <xsl:apply-templates select="$remote-activity/fdl:staff" mode="find-staff-query-type">
                <xsl:with-param name="node" select="$remote-activity"/>
              </xsl:apply-templates>
            </xsl:when>
            <!-- CASE: No staff settings specified for remote activity (look for staff settings inherited from process )-->
            <xsl:when test="$parent-process/fdl:staff">
              <xsl:apply-templates select="$parent-process/fdl:staff" mode="find-staff-query-type">
                <xsl:with-param name="node" select="$parent-process"/>
              </xsl:apply-templates>
            </xsl:when>
            <!-- OTHERWISE: No default staff settings found (create default staff verb "Everybody") -->
            <xsl:otherwise>
              <xsl:value-of select="'All people'"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="next-named-users-parameter-list">
          <xsl:copy-of select="$current-named-users-parameter-list"/>
          <tel:parameter id="NamedUsers">%wf:activity(<xsl:value-of select="$remote-activity-name"/>).owner%</tel:parameter>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="$staff-query-type-of-remote-activity = 'People'
                        or $staff-query-type-of-remote-activity = 'Members of roles'
                        or $staff-query-type-of-remote-activity = 'Organization'
                        or $staff-query-type-of-remote-activity = 'Exclude starter of activity'">
            <xsl:choose>
              <xsl:when test="$remote-activity/fdl:staff">
                <xsl:variable name="input-variable-name-of-remote-activity" select="concat($remote-activity/@name, $input-variable-suffix)"/>
                <xsl:variable name="primary-input-variable-name-of-remote-activity" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($input-variable-name-of-remote-activity)"/>
                <xsl:apply-templates select="$remote-activity/fdl:staff" mode="create-staff-query-verb">
                  <xsl:with-param name="node" select="$remote-activity"/>
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="local-variable-name" select="$primary-input-variable-name-of-remote-activity"/>
                  <xsl:with-param name="current-named-users-parameter-list" select="xalan:nodeset($next-named-users-parameter-list)"/>
                </xsl:apply-templates>
              </xsl:when>
              <xsl:when test="$parent-process/fdl:staff">
                <xsl:variable name="parent-local-variable-name" select="concat($parent-process/@name, $input-variable-suffix)"/>
                <xsl:variable name="primary-parent-local-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($parent-local-variable-name)"/>
                <xsl:apply-templates select="$parent-process/fdl:staff" mode="create-staff-query-verb">
                  <xsl:with-param name="node" select="$parent-process"/>
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="local-variable-name" select="$primary-parent-local-variable-name"/>
                  <xsl:with-param name="current-named-users-parameter-list" select="xalan:nodeset($next-named-users-parameter-list)"/>
                </xsl:apply-templates>
              </xsl:when>
              <xsl:otherwise>
                <!-- Create comment: *** CWWBMnnnnW: Cannot resolve FDL staff query type "Exclude starter of activity" *** -->
                <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_CannotResolve_ExcludeActivityStarter', $fdlFileName, $node/fdl:fdlLoc/@line, $node/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
                <!-- Create comment: *** CWWBMnnnnW: Default staff verb "Everybody" used *** -->
                <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'DefaultStaffVerbEverybodyUsed'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
                <tel:name>Everybody</tel:name>
              </xsl:otherwise>
            </xsl:choose>
            <xsl:if test="not($staff-query-type-of-remote-activity = 'Exclude starter of activity')">
              <xsl:copy-of select="xalan:nodeset($next-named-users-parameter-list)/tel:parameter[1]"/>
            </xsl:if>
          </xsl:when>
          <xsl:otherwise>
            <!-- Create comment: *** CWWBMnnnnW: Cannot resolve FDL staff query type "Exclude starter of activity" *** -->
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_CannotResolve_ExcludeActivityStarter', $fdlFileName, $node/fdl:fdlLoc/@line, $node/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
            <!-- Create comment: *** CWWBMnnnnW: Default staff verb "Everybody" used *** -->
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'DefaultStaffVerbEverybodyUsed'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
            <tel:name>Everybody</tel:name>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!--
        Dynamic staff queries
      -->
      <!-- CASE: Members of roles -->
      <xsl:when test="$staff-query-type = 'Members of roles'">
        <!-- Create comment: FDL staff query "Members of roles" -->
        <xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Members of roles&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <xsl:choose>
          <xsl:when test="$current-named-users-parameter-list">
            <tel:name>Group Members without Named Users</tel:name>
          </xsl:when>
          <xsl:otherwise>
            <tel:name>Group Members</tel:name>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="fdl:role[1]">
          <xsl:choose>
            <xsl:when test="fdl:role[1]/@name">
              <tel:parameter id="GroupName">
                <xsl:value-of select="fdl:role[1]/@name"/>
              </tel:parameter>
            </xsl:when>
            <xsl:when test="fdl:role[1]/@roleName">
              <tel:parameter id="GroupName">
                <xsl:value-of select="fdl:role[1]/@roleName"/>
              </tel:parameter>
            </xsl:when>
            <xsl:when test="fdl:role[1]/fdl:dataStructureMemberName">
              <tel:parameter id="GroupName">
                <xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
                <xsl:apply-templates select="fdl:role[1]/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
                  <xsl:with-param name="display-name" select="$display-name"/>
                  <xsl:with-param name="node" select="$node"/>
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="local-variable-name" select="$local-variable-name"/>
                  <xsl:with-param name="FDL-location" select="$node/fdl:fdlLoc"/>
                </xsl:apply-templates>
                <xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
              </tel:parameter>
            </xsl:when>
          </xsl:choose>
        </xsl:if>
        <tel:parameter id="IncludeSubgroups">
          <xsl:value-of select="false()"/>
        </tel:parameter>
        <xsl:if test="fdl:role[2]">
          <xsl:choose>
            <xsl:when test="fdl:role[2]/@name">
              <tel:parameter id="AlternativeGroupName1">
                <xsl:value-of select="fdl:role[2]/@name"/>
              </tel:parameter>
            </xsl:when>
            <xsl:when test="fdl:role[2]/fdl:dataStructureMemberName">
              <tel:parameter id="AlternativeGroupName1">
                <xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
                <xsl:apply-templates select="fdl:role[2]/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
                  <xsl:with-param name="display-name" select="$display-name"/>
                  <xsl:with-param name="node" select="$node"/>
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="local-variable-name" select="$local-variable-name"/>
                  <xsl:with-param name="FDL-location" select="$node/fdl:fdlLoc"/>
                </xsl:apply-templates>
                <xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
              </tel:parameter>
            </xsl:when>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="fdl:role[3]">
          <xsl:choose>
            <xsl:when test="fdl:role[3]/@name">
              <tel:parameter id="AlternativeGroupName2">
                <xsl:value-of select="fdl:role[3]/@name"/>
              </tel:parameter>
            </xsl:when>
            <xsl:when test="fdl:role[3]/fdl:dataStructureMemberName">
              <tel:parameter id="AlternativeGroupName2">
                <xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
                <xsl:apply-templates select="fdl:role[3]/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
                  <xsl:with-param name="display-name" select="$display-name"/>
                  <xsl:with-param name="node" select="$node"/>
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="local-variable-name" select="$local-variable-name"/>
                  <xsl:with-param name="FDL-location" select="$node/fdl:fdlLoc"/>
                </xsl:apply-templates>
                <xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
              </tel:parameter>
            </xsl:when>
          </xsl:choose>
        </xsl:if>
        <xsl:if test="fdl:role[4]">
          <!-- Create comment: *** CWWBMnnnnW: BPEL mapping for FDL staff query type "Members of roles" does not consider more than three persons *** -->
          <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_RoleMembers', $fdlFileName, $node/fdl:fdlLoc/@line, $node/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
      </xsl:when>
      <!-- CASE: Organization -->
      <xsl:when test="$staff-query-type = 'Organization'">
        <!-- Create comment: FDL staff query "Organization" -->
        <xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Organization&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        <xsl:choose>
          <xsl:when test="$current-named-users-parameter-list">
            <tel:name>Group Members without Named Users</tel:name>
          </xsl:when>
          <xsl:otherwise>
            <tel:name>Group Members</tel:name>
          </xsl:otherwise>
        </xsl:choose>
        <tel:parameter id="GroupName">
          <xsl:choose>
            <xsl:when test="fdl:organization/@organization">
              <xsl:value-of select="fdl:organization/@organization"/>
            </xsl:when>
            <xsl:when test="fdl:organization/@organizationName">
              <xsl:value-of select="fdl:organization/@organizationName"/>
            </xsl:when>
            <xsl:when test="fdl:organization/fdl:dataStructureMemberName">
              <xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
              <xsl:apply-templates select="fdl:organization/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
                <xsl:with-param name="display-name" select="$display-name"/>
                <xsl:with-param name="node" select="$node"/>
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="local-variable-name" select="$local-variable-name"/>
                <xsl:with-param name="FDL-location" select="$node/fdl:fdlLoc"/>
              </xsl:apply-templates>
              <xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
            </xsl:when>
          </xsl:choose>
        </tel:parameter>
        <tel:parameter id="IncludeSubgroups">
          <xsl:choose>
            <xsl:when test="fdl:organization/@includeChildOrganizations ='yes'">
              <xsl:value-of select="true()"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="false()"/>
            </xsl:otherwise>
          </xsl:choose>
        </tel:parameter>
        <xsl:if test="fdl:organization/@includeReportingManagers='yes'">
          <!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff query type "IncludeReportingManagers" *** -->
          <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_IncludeReportingManagers', $fdlFileName, $node/fdl:fdlLoc/@line, $node/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
      </xsl:when>
      <!-- CASE: Level -->
      <xsl:when test="$staff-query-type = 'Level'">
        <!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff query type "Level" *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_Level', $fdlFileName, $node/fdl:fdlLoc/@line, $node/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
      </xsl:when>
      <!-- OTHERWISE: No BPEL mapping available for FDL staff query type -->
      <xsl:otherwise>
        <!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff query type "nnn" *** -->
        <xsl:choose>
          <xsl:when test="local-name($node) = 'process'">
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_StaffQueryType1', $fdlFileName, $node/fdl:fdlLoc/@line, $staff-query-type, $node/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
            <!-- Create comment: *** CWWBMnnnnW: Default staff verb "Everybody" used *** -->
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'DefaultStaffVerbEverybodyUsed'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
            <tel:name>Everybody</tel:name>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_StaffQueryType2', $fdlFileName, $node/fdl:fdlLoc/@line, $staff-query-type, $node/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
            <!-- Create comment: *** CWWBMnnnnW: Default staff verb "Everybody" used *** -->
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'DefaultStaffVerbEverybodyUsed'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
            <tel:name>Everybody</tel:name>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************
    "find-staff-query-type" template:

    Determines an FDL staff query type.
    *****************************************************************************************
   -->
  <xsl:template match="fdl:staff" mode="find-staff-query-type">
    <xsl:param name="node"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($node)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;find-staff-query-type&quot; match=&quot;fdl:staff&quot;', $eol, 'Parameter &quot;node&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:choose>
      <!--
        Static staff queries (properties page "Staff1"
      -->
      <!-- CASE: Staff from predefined members -->
      <xsl:when test="fdl:staffDefinedInInputContainer | fdl:dataFromInputContainer">
        <xsl:value-of select="'Staff from predefined members'"/>
      </xsl:when>
      <!-- CASE: Coordinator of role -->
      <xsl:when test="fdl:coordinator">
        <xsl:value-of select="'Coordinator of role'"/>
      </xsl:when>
      <!-- CASE: Manager -->
      <xsl:when test="fdl:manager">
        <xsl:choose>
          <!-- CASE: Manager of starter of activity -->
          <xsl:when test="fdl:manager/fdl:starterOfActivity/fdl:fullyQualifiedActivityName/fdl:nameComponent/@name">
            <xsl:value-of select="'Manager of starter of activity'"/>
          </xsl:when>
          <!-- CASE: Manager of process starter -->
          <xsl:when test="fdl:manager/@ofProcessStarter = 'yes'">
            <xsl:value-of select="'Manager of process starter'"/>
          </xsl:when>
          <!-- CASE: Manager of organization -->
          <xsl:when test="fdl:manager/fdl:organization/@name">
            <xsl:value-of select="'Manager of organization'"/>
          </xsl:when>
          <!-- OTHERWISE: Manager of starter of activity -->
          <xsl:otherwise>
            <xsl:value-of select="'Manager of starter of activity'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- CASE: People -->
      <xsl:when test="fdl:person">
        <xsl:value-of select="'People'"/>
      </xsl:when>
      <!-- CASE: Process administrator -->
      <xsl:when test="fdl:processAdministrator">
        <xsl:value-of select="'Process administrator'"/>
      </xsl:when>
      <!-- CASE: Process starter -->
      <xsl:when test="fdl:processStarter">
        <xsl:value-of select="'Process starter'"/>
      </xsl:when>
      <!-- CASE: Starter of activity -->
      <xsl:when test="fdl:starterOfActivity/fdl:fullyQualifiedActivityName/fdl:nameComponent/@name">
        <xsl:value-of select="'Starter of activity'"/>
      </xsl:when>
      <!-- CASE: Exclude starter of activity -->
      <xsl:when test="fdl:excludeStarterOfActivity">
        <xsl:value-of select="'Exclude starter of activity'"/>
      </xsl:when>
      <!--
        Dynamic staff queries (properties page "Staff2"
      -->
      <!-- CASE: Members of roles -->
      <xsl:when test="fdl:role">
        <xsl:choose>
          <xsl:when test="fdl:organization or fdl:level">
            <xsl:variable name="warning" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_CombinedDynamicStaffQueries', $fdlFileName, $node/fdl:fdlLoc/@line)"/>
            <xsl:variable name="information" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'MigrationLimitedToMembersOfRoles', $fdlFileName, $node/fdl:fdlLoc/@line)"/>
            <xsl:value-of select="'Members of roles'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'Members of roles'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- CASE: Organization -->
      <xsl:when test="fdl:organization">
        <xsl:choose>
          <xsl:when test="fdl:level">
            <xsl:variable name="warning" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_CombinedDynamicStaffQueries', $fdlFileName, $node/fdl:fdlLoc/@line)"/>
            <xsl:variable name="information" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'MigrationLimitedToOrganization', $fdlFileName, $node/fdl:fdlLoc/@line)"/>
            <xsl:value-of select="'Organization'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'Organization'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- CASE: Level -->
      <xsl:when test="fdl:level">
        <xsl:value-of select="'Level'"/>
      </xsl:when>
      <!-- OTHERWISE: All people -->
      <xsl:otherwise>
        <xsl:value-of select="'unknown staff query'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************
    Template "create-escalation-chain"

    Called by an "create-standard-activity" template.
    Translates FDL "notifications"  to an "escalation chain" of TEL task definition.
    *****************************************************************************************
   -->
  <xsl:template name="create-escalation-chain">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-escalation-chain&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-escalation-chain&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="firstNotification" select="$activity/fdl:notification[ @type='1st' and fdl:staff ]"/>
    <xsl:variable name="secondNotification" select="$activity/fdl:notification[ @type='2nd']"/>
    <xsl:variable name="local-variable-name" select="concat($activity/@name, $input-variable-suffix)"/>
    <xsl:variable name="primary-local-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($local-variable-name)"/>
    <xsl:if test="$firstNotification">
      <tel:escalationChain activationState="ready">
        <!-- Select the maximum duration (SIMPLE time format assumed) -->
        <xsl:if test="$firstNotification/fdl:dataStructureMemberName">
          <!-- Create comment: ***CWWBMnnnnW: No BPEL mapping available for FDL notification from container *** -->
          <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_NotificationTakenFrom', $fdlFileName, $activity/fdl:fdlLoc/@line, $activity/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
        <tel:escalation atLeastExpectedState="ended" durationUntilEscalation="{$firstNotification/@maximumDuration}" escalationAction="workItem" name="Notification1">
          <tel:escalationReceiver>
            <tel:verb>
              <xsl:apply-templates select="$firstNotification/fdl:staff" mode="create-staff-query-verb">
                <xsl:with-param name="name" select="$activity/@name"/>
                <xsl:with-param name="node" select="$activity"/>
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="local-variable-name" select="$primary-local-variable-name"/>
              </xsl:apply-templates>
            </tel:verb>
          </tel:escalationReceiver>
        </tel:escalation>
        <xsl:if test="$secondNotification">
          <!-- Select the maximum duration (SIMPLE time format assumed) -->
          <xsl:if test="$secondNotification/fdl:dataStructureMemberName">
            <!-- Create comment: ***CWWBMnnnnW: No BPEL mapping available for FDL notification from container *** -->
            <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_NotificationTakenFrom', $fdlFileName, $activity/fdl:fdlLoc/@line, $activity/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
          </xsl:if>
          <tel:escalation atLeastExpectedState="ended" durationUntilEscalation="{$secondNotification/@maximumDuration}" escalationAction="workItem" name="Notification2">
            <tel:escalationReceiver>
              <tel:verb>
                <!-- Provide XFDL staff definition for process administrator who will receive the second notification -->
                <xsl:variable name="process-admin">
                  <fdl:staff>
                    <fdl:processAdministrator/>
                  </fdl:staff>
                </xsl:variable>
                <xsl:apply-templates select="xalan:nodeset($process-admin)/fdl:staff" mode="create-staff-query-verb">
                  <xsl:with-param name="name" select="$activity/@name"/>
                  <xsl:with-param name="node" select="$activity"/>
                  <xsl:with-param name="variables" select="$variables"/>
                  <xsl:with-param name="local-variable-name" select="$primary-local-variable-name"/>
                </xsl:apply-templates>
              </tel:verb>
            </tel:escalationReceiver>
          </tel:escalation>
        </xsl:if>
      </tel:escalationChain>
    </xsl:if>
  </xsl:template>
  <!--
    ********************************************
    "join condition" template:

    Creates a "wpc:joinCondition" element
    ********************************************
   -->
  <xsl:template match="fdl:join" mode="join-condition">
    <!--
      Create "wpc:joinCondition" element, if FDL start condition = "All incoming connectors true".
      Otherwise the default join condition (<wpc:any>) applies.
    -->
    <bpws:joinCondition expressionLanguage="{$BUILTIN}">
      <xsl:choose>
        <xsl:when test="@condition = 'all'">
          <wpc:all/>
        </xsl:when>
        <xsl:otherwise>
          <wpc:any/>
        </xsl:otherwise>
      </xsl:choose>
    </bpws:joinCondition>
  </xsl:template>
  <!--
    ********************************************
    "link sources" template:

    Creates a "source" for each "fdl:control"
    ********************************************
   -->
  <xsl:template match="fdl:control" mode="link-sources">
    <xsl:param name="activity"/>
    <xsl:param name="variables"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-escalation-chain&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;link-sources&quot; match=&quot;fdl:control&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="link-name">
      <xsl:choose>
        <xsl:when test="'true' = $LI1143_Support_for_the_link_name_option_in_ControlFlow_and_DataFlow and string-length(@name) &gt; 0">
          <xsl:value-of select="@name"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="concat(@from, '-to-', @to)"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <bpws:source linkName="{$link-name}">
      <xsl:choose>
        <!-- CASE: Assign a transition condition, if defined. -->
        <xsl:when test="fdl:condition[ * and not( @transitionCondition='true' or @transitionCondition='otherwise' ) ]">
          <!-- Create "xpath" condition -->
          <bpws:transitionCondition expressionLanguage="{$XPATH}">
            <xsl:variable name="condition-expression">
              <xsl:call-template name="create-condition-xpath-expression">
                <xsl:with-param name="display-name" select="$link-name"/>
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="activity" select="$activity"/>
                <xsl:with-param name="condition" select="fdl:condition"/>
                <xsl:with-param name="translate-to-BPEL-while-condition" select="false()"/>
                <xsl:with-param name="FDL-location" select="fdl:fdlLoc[1]"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="condition-expression-could-not-be-resolved">
              <xsl:choose>
                <xsl:when test="contains($condition-expression, 'UNKNOWN_DATA_STRUCTURE_MEMBER')">
                  <xsl:value-of select="'true'"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="'false'"/>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <xsl:if test="'true' = $condition-expression-could-not-be-resolved">
              <xsl:value-of select="concat($eol, '&lt;!-- *** Adjust the following incorrect expression *** ', $eol)" disable-output-escaping="yes"/>
            </xsl:if>
            <xsl:value-of select="$condition-expression"/>
            <xsl:if test="'true' = $condition-expression-could-not-be-resolved">
              <xsl:value-of select="concat($eol, ' --&gt;', $eol)" disable-output-escaping="yes"/>
            </xsl:if>
          </bpws:transitionCondition>
        </xsl:when>
        <!-- CASE: "default connector" -->
        <xsl:when test="@transitionCondition='otherwise'">
          <bpws:transitionCondition expressionLanguage="{$BUILTIN}">
            <wpc:otherwise/>
          </bpws:transitionCondition>
        </xsl:when>
        <xsl:otherwise>
          <bpws:transitionCondition expressionLanguage="{$BUILTIN}">
            <wpc:true/>
          </bpws:transitionCondition>
        </xsl:otherwise>
      </xsl:choose>
    </bpws:source>
  </xsl:template>
  <!--
    ********************************************
    "link targets" template:

    Creates a "target" for each "fdl:control"
    ********************************************
   -->
  <xsl:template match="fdl:control" mode="link-targets">
    <xsl:variable name="link-name">
      <xsl:choose>
        <xsl:when test="'true' = $LI1143_Support_for_the_link_name_option_in_ControlFlow_and_DataFlow and string-length(@name) &gt; 0">
          <xsl:value-of select="@name"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="concat(@from, '-to-', @to)"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <bpws:target linkName="{$link-name}"/>
  </xsl:template>
  <!--
    ********************************************
    "data-defaults" template:

    Creates data defaults for process
    and or activity input/output containers
    ********************************************
   -->
  <xsl:template match="fdl:programActivity | fdl:processActivity | fdl:block" mode="data-defaults">
    <xsl:param name="variables"/>
    <xsl:param name="create-activity" select="true()"/>
    <xsl:param name="activity-type" select="'ASSIGN'"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;data-defaults&quot; match=&quot;fdl:programActivity | fdl:processActivity | fdl:block&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="input-variable-name" select="concat(@name, $input-variable-suffix)"/>
    <xsl:variable name="output-variable-name" select="concat(@name, $output-variable-suffix)"/>
    <xsl:variable name="primary-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($input-variable-name)"/>
    <xsl:variable name="primary-output-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($output-variable-name)"/>
    <!-- Translate the setting of activity input data defaults to "assign" activities. -->
    <xsl:call-template name="set-data-fields">
      <xsl:with-param name="create-activity" select="$create-activity"/>
      <xsl:with-param name="activity-type" select="$activity-type"/>
      <xsl:with-param name="data-fields" select="fdl:input/fdl:dataDefaults"/>
      <xsl:with-param name="variables" select="$variables"/>
      <xsl:with-param name="variable-name" select="$primary-input-variable-name"/>
      <xsl:with-param name="node" select="current()"/>
      <xsl:with-param name="container-type" select="'input'"/>
    </xsl:call-template>
    <!-- Translate the setting of activity output data defaults to "assign" activities. -->
    <xsl:call-template name="set-data-fields">
      <xsl:with-param name="create-activity" select="$create-activity"/>
      <xsl:with-param name="activity-type" select="$activity-type"/>
      <xsl:with-param name="data-fields" select="fdl:output/fdl:dataDefaults"/>
      <xsl:with-param name="variables" select="$variables"/>
      <xsl:with-param name="variable-name" select="$primary-output-variable-name"/>
      <xsl:with-param name="node" select="current()"/>
      <xsl:with-param name="container-type" select="'output'"/>
    </xsl:call-template>
    <!-- Create the data defaults of activities contained in a block -->
    <xsl:if test="local-name() = 'block'">
      <xsl:apply-templates select="fdl:blockImplementation/fdl:programActivity | fdl:blockImplementation/fdl:processActivity | fdl:blockImplementation/fdl:block" mode="data-defaults">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="create-activity" select="$create-activity"/>
        <xsl:with-param name="activity-type" select="$activity-type"/>
      </xsl:apply-templates>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    Template "set-data-fields":

    Creates an "assign" activity which sets the data defaults.
    *****************************************************************************************************************************
   -->
  <xsl:template name="set-data-fields">
    <xsl:param name="create-activity" select="true()"/>
    <xsl:param name="activity-type" select="'ASSIGN'"/>
    <xsl:param name="data-fields"/>
    <xsl:param name="variables"/>
    <xsl:param name="variable-name"/>
    <xsl:param name="node"/>
    <xsl:param name="container-type"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;set-data-fields&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variable-name) or $variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;set-data-fields&quot;', $eol, 'Parameter &quot;variable-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($node)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;set-data-fields&quot;', $eol, 'Parameter &quot;node&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($container-type) or $container-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;set-data-fields&quot;', $eol, 'Parameter &quot;container-type&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:if test="('true' = $createPredefinedDataMembers
            and 'true' = $initializePredefinedDataMembers )
             or $data-fields">
      <!-- Create comment: Set input/output/UPES/global container data defaults of process/activity "nnn" -->
      <xsl:choose>
        <xsl:when test="'SNIPPET' = translate($activity-type, $lower-case-characters, $upper-case-characters)">
          <xsl:value-of select="concat($eol, '// Set ', $container-type, ' data defaults of ', local-name($node), ' &quot;', $node/@displayName, '&quot;', $eol)" disable-output-escaping="yes"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="concat($eol, '&lt;!-- Set ', $container-type, ' data defaults of ', local-name($node), ' &quot;', $node/@displayName, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:variable name="xml-schema-type">
        <xsl:call-template name="xml-schema-type-of-BPEL-variable">
          <xsl:with-param name="variables" select="$variables"/>
          <xsl:with-param name="variable-name" select="$variable-name"/>
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="display-name">
        <xsl:choose>
          <xsl:when test="$container-type = 'UPES'">
            <xsl:value-of select="concat('Set ', $container-type, ' context')"/>
          </xsl:when>
          <xsl:when test="$container-type = 'global container'">
            <xsl:value-of select="concat('Set ', $container-type, ' context')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="local-name($node) = 'process'">
                <xsl:value-of select="concat('Set process ', $container-type, ' defaults')"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="concat('Set ', $container-type, ' defaults')"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <!-- "all data fields" may include default values from predefined data members -->
      <xsl:variable name="all-data-fields">
        <xsl:choose>
          <xsl:when test="not( $container-type = 'UPES' or $container-type = 'global container')
                     and 'true' = $createPredefinedDataMembers
                     and 'true' = $initializePredefinedDataMembers">
            <xsl:variable name="predefined-data-member-values">
              <xsl:choose>
                <!-- CASE: node is a process -->
                <xsl:when test="local-name($node) = 'process'">
                  <fdl:field type="string" value="{$node/@name}">
                    <fdl:dataStructureMemberName>
                      <fdl:nameComponent name="_PROCESS_MODEL"/>
                    </fdl:dataStructureMemberName>
                  </fdl:field>
                  <xsl:if test="'SNIPPET' = translate($activity-type, $lower-case-characters, $upper-case-characters)">
                    <fdl:field type="function" value="processInstance().getName()">
                      <fdl:dataStructureMemberName>
                        <fdl:nameComponent name="_PROCESS"/>
                      </fdl:dataStructureMemberName>
                    </fdl:field>
                  </xsl:if>
                </xsl:when>
                <!-- OTHERWISE: assume that node is an activity -->
                <xsl:otherwise>
                  <xsl:variable name="dotted-activity-name-prefix">
                    <xsl:apply-templates select="$node/ancestor::fdl:process" mode="activity-name-prefix">
                      <xsl:with-param name="activity" select="$node"/>
                    </xsl:apply-templates>
                  </xsl:variable>
                  <fdl:field type="string" value="{concat($dotted-activity-name-prefix, $node/@name)}">
                    <fdl:dataStructureMemberName>
                      <fdl:nameComponent name="_ACTIVITY"/>
                    </fdl:dataStructureMemberName>
                  </fdl:field>
                  <fdl:field type="string" value="{$node/ancestor::fdl:process/@name}">
                    <fdl:dataStructureMemberName>
                      <fdl:nameComponent name="_PROCESS_MODEL"/>
                    </fdl:dataStructureMemberName>
                  </fdl:field>
                  <xsl:if test="'SNIPPET' = translate($activity-type, $lower-case-characters, $upper-case-characters)">
                    <fdl:field type="function" value="processInstance().getName()">
                      <fdl:dataStructureMemberName>
                        <fdl:nameComponent name="_PROCESS"/>
                      </fdl:dataStructureMemberName>
                    </fdl:field>
                  </xsl:if>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <xsl:copy-of select="xalan:nodeset($data-fields)/fdl:field | xalan:nodeset($predefined-data-member-values)/fdl:field"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:copy-of select="$data-fields/fdl:field"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:choose>
        <!-- CASE: activity type "SNIPPET" -->
        <xsl:when test="'SNIPPET' = translate($activity-type, $lower-case-characters, $upper-case-characters)">
          <xsl:choose>
            <xsl:when test="$create-activity = 'true'">
              <!-- Create Java snippet -->
              <bpws:invoke wpc:continueOnError="no" portType="wpc:null" partnerLink="null" operation="null" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="{$display-name}">
                <wpc:script>
                  <wpc:javaCode>
                    <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
                    <!--
                      Create data default copy elements (using Java API "mergeReverse")
                    -->
                    <xsl:call-template name="create-data-field-copy-elements">
                      <xsl:with-param name="activity-type" select="$activity-type"/>
                      <xsl:with-param name="all-data-fields" select="$all-data-fields"/>
                      <xsl:with-param name="display-name" select="$display-name"/>
                      <xsl:with-param name="variable-name" select="$variable-name"/>
                      <xsl:with-param name="xml-schema-type" select="$xml-schema-type"/>
                    </xsl:call-template>
                    <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
                  </wpc:javaCode>
                </wpc:script>
              </bpws:invoke>
            </xsl:when>
            <xsl:otherwise>
              <!--
                Create data default copy elements
              -->
              <xsl:call-template name="create-data-field-copy-elements">
                <xsl:with-param name="activity-type" select="$activity-type"/>
                <xsl:with-param name="all-data-fields" select="$all-data-fields"/>
                <xsl:with-param name="display-name" select="$display-name"/>
                <xsl:with-param name="variable-name" select="$variable-name"/>
                <xsl:with-param name="xml-schema-type" select="$xml-schema-type"/>
              </xsl:call-template>
              <xsl:value-of select="$eol" disable-output-escaping="yes"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <!-- OTHERWISE: activity type "ASSIGN" assumed -->
        <xsl:otherwise>
          <xsl:choose>
            <xsl:when test="$create-activity = 'true'">
              <!-- Create "assign" activity -->
              <bpws:assign wpc:displayName="{$display-name}" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
                <!--
                  Create data default copy elements
                -->
                <xsl:call-template name="create-data-field-copy-elements">
                  <xsl:with-param name="all-data-fields" select="$all-data-fields"/>
                  <xsl:with-param name="display-name" select="$display-name"/>
                  <xsl:with-param name="variable-name" select="$variable-name"/>
                  <xsl:with-param name="xml-schema-type" select="$xml-schema-type"/>
                </xsl:call-template>
              </bpws:assign>
            </xsl:when>
            <xsl:otherwise>
              <!--
                Create data default copy elements
              -->
              <xsl:call-template name="create-data-field-copy-elements">
                <xsl:with-param name="all-data-fields" select="$all-data-fields"/>
                <xsl:with-param name="display-name" select="$display-name"/>
                <xsl:with-param name="variable-name" select="$variable-name"/>
                <xsl:with-param name="xml-schema-type" select="$xml-schema-type"/>
              </xsl:call-template>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
  </xsl:template>
  <!--
    ************************************************************************************************
    "create-data-field-copy-elements" template

    Called by template "set-data-fields"
    ************************************************************************************************
  -->
  <xsl:template name="create-data-field-copy-elements">
    <xsl:param name="activity-type" select="'ASSIGN'"/>
    <xsl:param name="all-data-fields"/>
    <xsl:param name="display-name"/>
    <xsl:param name="variable-name"/>
    <xsl:param name="xml-schema-type"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($all-data-fields)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-field-copy-elements&quot;', $eol, 'Parameter &quot;all-data-fields&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name=''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-field-copy-elements&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variable-name)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-field-copy-elements&quot;', $eol, 'Parameter &quot;variable-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($xml-schema-type) or $xml-schema-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-field-copy-elements&quot;', $eol, 'Parameter &quot;xml-schema-type&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:for-each select="xalan:nodeset($all-data-fields)/fdl:field">
      <xsl:call-template name="set-data-field-copy-element">
        <xsl:with-param name="activity-type" select="$activity-type"/>
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="variable-name" select="$variable-name"/>
        <xsl:with-param name="dataStructureMemberName" select="current()/fdl:dataStructureMemberName"/>
        <xsl:with-param name="value" select="current()/@value"/>
        <xsl:with-param name="XMLSchemaType" select="$xml-schema-type"/>
      </xsl:call-template>
    </xsl:for-each>
  </xsl:template>
  <!--
    ************************************************************************************************
    "set-data-field-copy-element" template

    Called by template "create-process-data-defaults" or "create-activity-data-defaults"
    ************************************************************************************************
  -->
  <xsl:template name="set-data-field-copy-element">
    <xsl:param name="activity-type"/>
    <xsl:param name="display-name"/>
    <xsl:param name="variable-name"/>
    <xsl:param name="dataStructureMemberName"/>
    <xsl:param name="value"/>
    <xsl:param name="XMLSchemaType"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity-type) or $activity-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;set-data-field-copy-element&quot;', $eol, 'Parameter &quot;activity-type&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name=''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;set-data-field-copy-element&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variable-name) or $variable-name=''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;set-data-field-copy-element&quot;', $eol, 'Parameter &quot;variable-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($dataStructureMemberName)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;set-data-field-copy-element&quot;', $eol, 'Parameter &quot;dataStructureMemberName&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($XMLSchemaType) or $XMLSchemaType = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;set-data-field-copy-element&quot;', $eol, 'Parameter &quot;XMLSchemaType&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- Determine the start index of the first "fdl:nameComponent" in the "target" expression ("dotted name" translated to XFDL) -->
    <xsl:variable name="first">
      <xsl:call-template name="find-start-index-for-parsing-a-dotted-name">
        <xsl:with-param name="dataStructureMemberName" select="$dataStructureMemberName"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="value-type">
      <xsl:call-template name="find-data-field-type">
        <xsl:with-param name="XMLSchemaType" select="$XMLSchemaType"/>
        <xsl:with-param name="nameComponent" select="$dataStructureMemberName/fdl:nameComponent[ position() = $first ]"/>
        <xsl:with-param name="FDL-location" select="$dataStructureMemberName/fdl:fdlLoc"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="to-query-expression">
      <xsl:call-template name="translate-dataStructureMemberName-to-XPath">
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="XMLSchemaType" select="$XMLSchemaType"/>
        <xsl:with-param name="nameComponent" select="$dataStructureMemberName/fdl:nameComponent[ position() = $first ]"/>
        <xsl:with-param name="FDL-location" select="$dataStructureMemberName/fdl:fdlLoc"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="to-query-expression-could-not-be-resolved">
      <xsl:choose>
        <xsl:when test="contains($to-query-expression, 'UNKNOWN_DATA_STRUCTURE_MEMBER')">
          <xsl:value-of select="'true'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'false'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!--
      Create data copy element
    -->
    <xsl:choose>
      <!-- CASE: activity type is "SNIPPET" -->
      <xsl:when test="'SNIPPET' = translate($activity-type, $lower-case-characters, $upper-case-characters)">
        <xsl:if test="'true' = $to-query-expression-could-not-be-resolved">
          <xsl:value-of select="concat($eol, '// TODO *** Adjust the following incorrect data mapping *** ', $eol, '/*')" disable-output-escaping="yes"/>
        </xsl:if>
        <xsl:value-of select="concat($eol,
                          $variable-name,
                          ' = com.ibm.bpe.interop.WMQWFHelper.mergeReverse(&quot;',
                          $value,
                          '&quot;, ',
                          $variable-name,
                          ', &quot;',
                          xalan:nodeset($to-query-expression)/*,
                          '&quot;, getVariableType(&quot;',
                          $variable-name,
                          '&quot;));'
                          )" disable-output-escaping="yes"/>
        <xsl:if test="'true' = $to-query-expression-could-not-be-resolved">
          <xsl:value-of select="concat($eol, '*/', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
      </xsl:when>
      <!-- OTHERWISE: activity type "ASSIGN" assumed -->
      <xsl:otherwise>
        <bpws:copy>
          <bpws:from>
            <xsl:choose>
              <!-- CASE: Value is an empty string -->
              <xsl:when test="$value = ''">
                <bpws:expression>''</bpws:expression>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="concat('&lt;![CDATA[', $value, ']]&gt;')" disable-output-escaping="yes"/>
              </xsl:otherwise>
            </xsl:choose>
          </bpws:from>
          <bpws:to variable="{$variable-name}">
            <!-- Add "part" attribute if the BPEL variable has type "interface" -->
            <xsl:if test="'INTERFACE' = $variable-type-mode">
              <xsl:attribute name="part"><xsl:value-of select="$message-part-name"/></xsl:attribute>
            </xsl:if>
            <bpws:query>
              <xsl:choose>
                <xsl:when test="'true' = $to-query-expression-could-not-be-resolved">
                  <xsl:value-of select="concat($eol, '&lt;!-- *** Adjust the following incorrect expression *** ', $eol)" disable-output-escaping="yes"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
                </xsl:otherwise>
              </xsl:choose>
              <xsl:value-of select="xalan:nodeset($to-query-expression)/*" disable-output-escaping="yes"/>
              <xsl:choose>
                <xsl:when test="'true' = $to-query-expression-could-not-be-resolved">
                  <xsl:value-of select="concat($eol, ' --&gt;', $eol)" disable-output-escaping="yes"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
                </xsl:otherwise>
              </xsl:choose>
            </bpws:query>
          </bpws:to>
        </bpws:copy>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ***************************************************************************************************************************************************
    "find-data-field-type" template

    Called by "set-data-field-copy-element"
    ***************************************************************************************************************************************************
  -->
  <xsl:template name="find-data-field-type">
    <xsl:param name="XMLSchemaType"/>
    <xsl:param name="nameComponent"/>
    <xsl:param name="FDL-location"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($XMLSchemaType) or $XMLSchemaType = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;find-data-field-type&quot;', $eol, 'Parameter &quot;XMLSchemaType&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($nameComponent) ">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;find-data-field-type&quot;', $eol, 'Parameter &quot;nameComponent&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="XMLSchemaTypeDef" select="document($xsdfile)//xsd:complexType[concat('mqwf:', @name) = $XMLSchemaType]"/>
    <xsl:variable name="element-name" select="$nameComponent/@name"/>
    <xsl:variable name="XMLSchemaTypeDef-Element" select="$XMLSchemaTypeDef/xsd:sequence/xsd:element[@name = $element-name]"/>
    <xsl:choose>
      <xsl:when test="substring($XMLSchemaTypeDef-Element/@type, 1,4) = 'mqwf'">
        <xsl:variable name="element-type" select="substring-after($XMLSchemaTypeDef-Element/@type, 'mqwf:')"/>
        <xsl:variable name="following-nameComponent" select="$nameComponent/following-sibling::fdl:nameComponent[1]"/>
        <xsl:choose>
          <xsl:when test="$following-nameComponent">
            <xsl:call-template name="find-data-field-type">
              <xsl:with-param name="XMLSchemaType" select="concat('mqwf:', $element-type)"/>
              <xsl:with-param name="nameComponent" select="$following-nameComponent"/>
              <xsl:with-param name="FDL-location" select="$FDL-location"/>
            </xsl:call-template>
          </xsl:when>
          <!-- data default type error -->
          <xsl:otherwise>
            <xsl:value-of select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'IllegalDataType', $fdlFileName, $FDL-location/@line, $FDL-location/@column, $element-type), ' ***')"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <!-- Return value type -->
        <xsl:value-of select="$XMLSchemaTypeDef-Element/@type"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************
    Template "create-data-mapping-standard-to-UPES":

    Called by template "create-UPES-activity".
    Creates an "assign" activity or "Java snippet" that maps the data input message into another one
    which conforms to the UPES interoperability convention.
    *****************************************************************************************************
  -->
  <xsl:template name="create-data-mapping-standard-to-UPES">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-mapping-standard-to-UPES&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-mapping-standard-to-UPES&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="standard-variable-name" select="concat($activity/@name, $input-variable-suffix)"/>
    <xsl:variable name="primary-standard-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($standard-variable-name)"/>
    <xsl:variable name="UPES-variable-name" select="concat($activity/@name, $UPES-input-variable-suffix)"/>
    <xsl:variable name="source-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$primary-standard-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="target-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$UPES-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="standard-to-UPES-mappings">
      <xsl:call-template name="standard-to-UPES-mappings"/>
    </xsl:variable>
    <!-- Create comment: Data format conversion ("standard" to UPES) from variable "nnn" to variable "nnn"-->
    <xsl:value-of select="concat($eol, '&lt;!--  Data format conversion (&quot;standard&quot; to UPES) from variable  &quot;', $primary-standard-variable-name, '&quot; to variable &quot;', $UPES-variable-name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsl:choose>
      <!-- CASE: create "Java snippet" activity -->
      <xsl:when test="'true' = $create_Java_Snippets">
        <bpws:invoke wpc:continueOnError="no" portType="wpc:null" partnerLink="null" operation="null" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Encode UPES input">
          <wpc:script>
            <wpc:javaCode>
              <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
              <!-- Create comment: Encode UPES input -->
              <xsl:value-of select="concat($eol, '// Encode UPES input', $eol)" disable-output-escaping="yes"/>
              <xsl:apply-templates select="xalan:nodeset($standard-to-UPES-mappings)/fdl:map" mode="data">
                <xsl:with-param name="display-name" select="'Encode UPES input'"/>
                <xsl:with-param name="from-variable-name" select="$primary-standard-variable-name"/>
                <xsl:with-param name="to-variable-name" select="$UPES-variable-name"/>
                <xsl:with-param name="source-xml-schema-type" select="$source-xml-schema-type"/>
                <xsl:with-param name="target-xml-schema-type" select="$target-xml-schema-type"/>
              </xsl:apply-templates>
              <!-- Initialize business object -->
              <xsl:value-of select="concat($eol,
                                          'if (',
                          $UPES-variable-name,
                                          ' == null) {',
                                          $eol,
                                          '    com.ibm.websphere.bo.BOFactory boFactory = (com.ibm.websphere.bo.BOFactory)com.ibm.websphere.sca.ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
                                          $eol,
                                          '    ',
                          $UPES-variable-name,
                                          ' = boFactory.createByType(getVariableType(&quot;',
                          $UPES-variable-name,
                          '&quot;));',
                                          $eol,
                                          '}')" disable-output-escaping="yes"/>
              <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
            </wpc:javaCode>
          </wpc:script>
        </bpws:invoke>
      </xsl:when>
      <!-- OTHERWISE: create "assign" activity -->
      <xsl:otherwise>
        <bpws:assign name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Encode UPES input">
          <!-- Create data mappings -->
          <xsl:apply-templates select="xalan:nodeset($standard-to-UPES-mappings)/fdl:map" mode="data">
            <xsl:with-param name="display-name" select="'Encode UPES input'"/>
            <xsl:with-param name="from-variable-name" select="$primary-standard-variable-name"/>
            <xsl:with-param name="to-variable-name" select="$UPES-variable-name"/>
            <xsl:with-param name="source-xml-schema-type" select="$source-xml-schema-type"/>
            <xsl:with-param name="target-xml-schema-type" select="$target-xml-schema-type"/>
          </xsl:apply-templates>
        </bpws:assign>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************
    Template "create-UPES-default-container-mapping":

    Called by template "create-UPES-activity".
    Creates an "assign" activity or "Java snippet" that maps the data output message into the
    "MessageDefaultContainer" element of another message which conforms to the UPES
    interoperability convention.
    *****************************************************************************************************
  -->
  <xsl:template name="create-UPES-default-container-mapping">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-UPES-default-container-mapping&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-UPES-default-container-mapping&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="standard-variable-name" select="concat($activity/@name, $output-variable-suffix)"/>
    <xsl:variable name="primary-standard-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($standard-variable-name)"/>
    <xsl:variable name="UPES-variable-name" select="concat($activity/@name, $UPES-input-variable-suffix)"/>
    <xsl:variable name="source-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$primary-standard-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="target-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$UPES-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="UPES-default-container-mapping">
      <xsl:call-template name="UPES-default-container-mapping"/>
    </xsl:variable>
    <!-- Create comment: Complete the data format conversion ("standard" to UPES) by mapping the output data defaults from variable "nnn" to variable "nnn"-->
    <xsl:value-of select="concat($eol, '&lt;!--  Complete the data format conversion (&quot;standard&quot; to UPES) by mapping the output data defaults from variable  &quot;', $primary-standard-variable-name, '&quot; to variable &quot;', $UPES-variable-name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsl:choose>
      <!-- CASE: create "Java snippet" activity -->
      <xsl:when test="'true' = $create_Java_Snippets">
        <bpws:invoke wpc:continueOnError="no" portType="wpc:null" partnerLink="null" operation="null" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Encode UPES output defaults">
          <wpc:script>
            <wpc:javaCode>
              <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
              <!-- Create comment: Encode UPES output defaults -->
              <xsl:value-of select="concat($eol, '// Encode UPES output defaults', $eol)" disable-output-escaping="yes"/>
              <xsl:apply-templates select="xalan:nodeset($UPES-default-container-mapping)/fdl:map" mode="data">
                <xsl:with-param name="display-name" select="'Encode UPES output defaults'"/>
                <xsl:with-param name="from-variable-name" select="$primary-standard-variable-name"/>
                <xsl:with-param name="to-variable-name" select="$UPES-variable-name"/>
                <xsl:with-param name="source-xml-schema-type" select="$source-xml-schema-type"/>
                <xsl:with-param name="target-xml-schema-type" select="$target-xml-schema-type"/>
              </xsl:apply-templates>
              <!-- Initialize business object -->
              <xsl:value-of select="concat($eol,
                                          'if (',
                          $UPES-variable-name,
                                          ' == null) {',
                                          $eol,
                                          '    com.ibm.websphere.bo.BOFactory boFactory = (com.ibm.websphere.bo.BOFactory)com.ibm.websphere.sca.ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
                                          $eol,
                                          '    ',
                          $UPES-variable-name,
                                          ' = boFactory.createByType(getVariableType(&quot;',
                          $UPES-variable-name,
                          '&quot;));',
                                          $eol,
                                          '}',
                          $eol)" disable-output-escaping="yes"/>
              <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
            </wpc:javaCode>
          </wpc:script>
        </bpws:invoke>
      </xsl:when>
      <!-- OTHERWISE: create "assign" activity -->
      <xsl:otherwise>
        <bpws:assign name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Encode UPES output defaults">
          <!-- Create data mappings -->
          <xsl:apply-templates select="xalan:nodeset($UPES-default-container-mapping)/fdl:map" mode="data">
            <xsl:with-param name="display-name" select="'Encode UPES output defaults'"/>
            <xsl:with-param name="from-variable-name" select="$primary-standard-variable-name"/>
            <xsl:with-param name="to-variable-name" select="$UPES-variable-name"/>
            <xsl:with-param name="source-xml-schema-type" select="$source-xml-schema-type"/>
            <xsl:with-param name="target-xml-schema-type" select="$target-xml-schema-type"/>
          </xsl:apply-templates>
        </bpws:assign>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************
    Template "create-data-mapping-UPES-to-standard":

    Called by template "create-UPES-activity".
    Creates an "assign" activity or "Java snippet" that maps the UPES data output message back to the
    "standard" data message format.
    *****************************************************************************************************
  -->
  <xsl:template name="create-data-mapping-UPES-to-standard">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-mapping-UPES-to-standard&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-mapping-UPES-to-standard&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="UPES-variable-name" select="concat($activity/@name, $UPES-output-variable-suffix)"/>
    <xsl:variable name="standard-variable-name" select="concat($activity/@name, $output-variable-suffix)"/>
    <xsl:variable name="primary-standard-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($standard-variable-name)"/>
    <xsl:variable name="source-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$UPES-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="target-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$primary-standard-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <!-- Create comment: Data format conversion (UPES to "standard") from variable "nnn" to variable "nnn"-->
    <xsl:value-of select="concat($eol, '&lt;!--  Data format conversion (UPES to &quot;standard&quot;) from variable  &quot;', $UPES-variable-name, '&quot; to variable &quot;', $primary-standard-variable-name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsl:variable name="UPES-to-standard-mappings">
      <xsl:call-template name="UPES-to-standard-mappings"/>
    </xsl:variable>
    <xsl:choose>
      <!-- CASE: create "Java snippet" activity -->
      <xsl:when test="'true' = $create_Java_Snippets">
        <bpws:invoke wpc:continueOnError="no" portType="wpc:null" partnerLink="null" operation="null" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Decode UPES output">
          <wpc:script>
            <wpc:javaCode>
              <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
              <!-- Create comment: Decode UPES output -->
              <xsl:value-of select="concat($eol, '// Decode UPES output', $eol)" disable-output-escaping="yes"/>
              <xsl:value-of select="concat($eol,
                              'com.ibm.websphere.bo.BOCopy copyService = (com.ibm.websphere.bo.BOCopy)com.ibm.websphere.sca.ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOCopy&quot;);')" disable-output-escaping="yes"/>
              <xsl:choose>
                <!-- CASE: parameter "createPredefinedDataMembers" is set to "true" -->
                <xsl:when test="'true' = $createPredefinedDataMembers">
                  <!-- Initialize business object -->
                  <xsl:value-of select="concat($eol,
                              'if (',
                              $primary-standard-variable-name,
                              ' == null) {',
                              $eol,
                              '    com.ibm.websphere.bo.BOFactory boFactory = (com.ibm.websphere.bo.BOFactory)com.ibm.websphere.sca.ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
                              $eol,
                              '    ',
                              $primary-standard-variable-name,
                              ' = boFactory.createByType(getVariableType(&quot;',
                              $primary-standard-variable-name,
                              '&quot;));',
                              $eol,
                              '}')" disable-output-escaping="yes"/>
                  <!-- Execute decoding data mappings -->
                  <xsl:value-of select="concat($eol,
                              $primary-standard-variable-name,
                              '.set(&quot;_PROCESS&quot;, ',
                              $UPES-variable-name,
                              '.get(&quot;MessageContext/_PROCESS&quot;));')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              $primary-standard-variable-name,
                              '.set(&quot;_PROCESS_MODEL&quot;, ',
                              $UPES-variable-name,
                              '.get(&quot;MessageContext/_PROCESS_MODEL&quot;));')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              $primary-standard-variable-name,
                              '.set(&quot;_ACTIVITY&quot;, ',
                              $UPES-variable-name,
                              '.get(&quot;MessageContext/_ACTIVITY&quot;));')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              'commonj.sdo.DataObject sourceDataObject = ',
                              $UPES-variable-name,
                              '.getDataObject(&quot;MessageContext/_PROCESS_INFO&quot;);')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              'commonj.sdo.DataObject targetDataObject = null;')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              'if (null != sourceDataObject) { targetDataObject = copyService.copy(sourceDataObject); }')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              $primary-standard-variable-name,
                              '.set(&quot;_PROCESS_INFO&quot;, targetDataObject);')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              'sourceDataObject = ',
                              $UPES-variable-name,
                              '.getDataObject(&quot;MessageContext/_ACTIVITY_INFO&quot;);')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              'targetDataObject = null;')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              'if (null != sourceDataObject) { targetDataObject = copyService.copy(sourceDataObject); }')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              $primary-standard-variable-name,
                              '.set(&quot;_ACTIVITY&quot;, targetDataObject);')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              'sourceDataObject = ',
                              $UPES-variable-name,
                              '.getDataObject(&quot;MessageContainer&quot;);')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              'targetDataObject = null;')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              'if (null != sourceDataObject) { targetDataObject = copyService.copy(sourceDataObject); }')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              $primary-standard-variable-name,
                              '.set(&quot;_STRUCT&quot;, targetDataObject);')" disable-output-escaping="yes"/>
                </xsl:when>
                <!-- OHERWISE: It is assumed, that parameter "createPredefinedDataMembers" is set to "false" -->
                <xsl:otherwise>
                  <xsl:value-of select="concat($eol,
                              'commonj.sdo.DataObject sourceDataObject = ',
                              $UPES-variable-name,
                              '.getDataObject(&quot;MessageContainer&quot;);')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              'commonj.sdo.DataObject targetDataObject = null;')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              'if (null != sourceDataObject) { targetDataObject = copyService.copy(sourceDataObject); }')" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat($eol,
                              $primary-standard-variable-name,
                              ' = targetDataObject;')" disable-output-escaping="yes"/>
                </xsl:otherwise>
              </xsl:choose>
              <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
            </wpc:javaCode>
          </wpc:script>
        </bpws:invoke>
      </xsl:when>
      <!-- OTHERWISE: create "assign" activity -->
      <xsl:otherwise>
        <bpws:assign name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Decode UPES output">
          <!-- Create data mappings -->
          <xsl:apply-templates select="xalan:nodeset($UPES-to-standard-mappings)/fdl:map" mode="data">
            <xsl:with-param name="display-name" select="'Decode UPES output'"/>
            <xsl:with-param name="from-variable-name" select="$UPES-variable-name"/>
            <xsl:with-param name="to-variable-name" select="$primary-standard-variable-name"/>
            <xsl:with-param name="source-xml-schema-type" select="$source-xml-schema-type"/>
            <xsl:with-param name="target-xml-schema-type" select="$target-xml-schema-type"/>
          </xsl:apply-templates>
        </bpws:assign>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************
    Template "standard-to-UPES-mappings":

    Returns the "fdl:map" elements that are needed to create
    "standard-to-UPES-mapping" expressions
    *****************************************************************************************************
  -->
  <xsl:template name="standard-to-UPES-mappings">
    <xsl:if test="'true' = $createPredefinedDataMembers">
      <fdl:map>
        <fdl:sourceMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="_RC"/>
          </fdl:dataStructureMemberName>
        </fdl:sourceMember>
        <fdl:targetMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="MessageContext"/>
            <fdl:nameComponent name="_RC"/>
          </fdl:dataStructureMemberName>
        </fdl:targetMember>
      </fdl:map>
      <fdl:map>
        <fdl:sourceMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="_PROCESS"/>
          </fdl:dataStructureMemberName>
        </fdl:sourceMember>
        <fdl:targetMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="MessageContext"/>
            <fdl:nameComponent name="_PROCESS"/>
          </fdl:dataStructureMemberName>
        </fdl:targetMember>
      </fdl:map>
      <fdl:map>
        <fdl:sourceMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="_PROCESS_MODEL"/>
          </fdl:dataStructureMemberName>
        </fdl:sourceMember>
        <fdl:targetMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="MessageContext"/>
            <fdl:nameComponent name="_PROCESS_MODEL"/>
          </fdl:dataStructureMemberName>
        </fdl:targetMember>
      </fdl:map>
      <fdl:map>
        <fdl:sourceMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="_ACTIVITY"/>
          </fdl:dataStructureMemberName>
        </fdl:sourceMember>
        <fdl:targetMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="MessageContext"/>
            <fdl:nameComponent name="_ACTIVITY"/>
          </fdl:dataStructureMemberName>
        </fdl:targetMember>
      </fdl:map>
      <fdl:map>
        <fdl:sourceMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="_PROCESS_INFO"/>
          </fdl:dataStructureMemberName>
        </fdl:sourceMember>
        <fdl:targetMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="MessageContext"/>
            <fdl:nameComponent name="_PROCESS_INFO"/>
          </fdl:dataStructureMemberName>
        </fdl:targetMember>
      </fdl:map>
      <fdl:map>
        <fdl:sourceMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="_ACTIVITY_INFO"/>
          </fdl:dataStructureMemberName>
        </fdl:sourceMember>
        <fdl:targetMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="MessageContext"/>
            <fdl:nameComponent name="_ACTIVITY_INFO"/>
          </fdl:dataStructureMemberName>
        </fdl:targetMember>
      </fdl:map>
    </xsl:if>
    <fdl:map>
      <fdl:sourceMember>
        <fdl:dataStructureMemberName>
          <fdl:nameComponent name="_STRUCT"/>
        </fdl:dataStructureMemberName>
      </fdl:sourceMember>
      <fdl:targetMember>
        <fdl:dataStructureMemberName>
          <fdl:nameComponent name="MessageContainer"/>
        </fdl:dataStructureMemberName>
      </fdl:targetMember>
    </fdl:map>
  </xsl:template>
  <!--
    *****************************************************************************************************
    Template "UPES-default-container-mapping":

    Returns the "fdl:map" element that is needed to create the
    "UPES-default-container-mapping" expression
    *****************************************************************************************************
  -->
  <xsl:template name="UPES-default-container-mapping">
    <fdl:map>
      <fdl:sourceMember>
        <fdl:dataStructureMemberName>
          <fdl:nameComponent name="_STRUCT"/>
        </fdl:dataStructureMemberName>
      </fdl:sourceMember>
      <fdl:targetMember>
        <fdl:dataStructureMemberName>
          <fdl:nameComponent name="MessageDefaultContainer"/>
        </fdl:dataStructureMemberName>
      </fdl:targetMember>
    </fdl:map>
  </xsl:template>
  <!--
    *****************************************************************************************************
    Template "UPES-to-standard-mappings":

    Returns the "fdl:map" elements that are needed to create
    "UPES-to-standard-mapping" expressions
    *****************************************************************************************************
  -->
  <xsl:template name="UPES-to-standard-mappings">
    <xsl:if test="'true' = $createPredefinedDataMembers">
      <fdl:map>
        <fdl:sourceMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="MessageContext"/>
            <fdl:nameComponent name="_RC"/>
          </fdl:dataStructureMemberName>
        </fdl:sourceMember>
        <fdl:targetMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="_RC"/>
          </fdl:dataStructureMemberName>
        </fdl:targetMember>
      </fdl:map>
      <fdl:map>
        <fdl:sourceMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="MessageContext"/>
            <fdl:nameComponent name="_PROCESS"/>
          </fdl:dataStructureMemberName>
        </fdl:sourceMember>
        <fdl:targetMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="_PROCESS"/>
          </fdl:dataStructureMemberName>
        </fdl:targetMember>
      </fdl:map>
      <fdl:map>
        <fdl:sourceMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="MessageContext"/>
            <fdl:nameComponent name="_PROCESS_MODEL"/>
          </fdl:dataStructureMemberName>
        </fdl:sourceMember>
        <fdl:targetMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="_PROCESS_MODEL"/>
          </fdl:dataStructureMemberName>
        </fdl:targetMember>
      </fdl:map>
      <fdl:map>
        <fdl:sourceMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="MessageContext"/>
            <fdl:nameComponent name="_ACTIVITY"/>
          </fdl:dataStructureMemberName>
        </fdl:sourceMember>
        <fdl:targetMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="_ACTIVITY"/>
          </fdl:dataStructureMemberName>
        </fdl:targetMember>
      </fdl:map>
      <fdl:map>
        <fdl:sourceMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="MessageContext"/>
            <fdl:nameComponent name="_PROCESS_INFO"/>
          </fdl:dataStructureMemberName>
        </fdl:sourceMember>
        <fdl:targetMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="_PROCESS_INFO"/>
          </fdl:dataStructureMemberName>
        </fdl:targetMember>
      </fdl:map>
      <fdl:map>
        <fdl:sourceMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="MessageContext"/>
            <fdl:nameComponent name="_ACTIVITY_INFO"/>
          </fdl:dataStructureMemberName>
        </fdl:sourceMember>
        <fdl:targetMember>
          <fdl:dataStructureMemberName>
            <fdl:nameComponent name="_ACTIVITY_INFO"/>
          </fdl:dataStructureMemberName>
        </fdl:targetMember>
      </fdl:map>
    </xsl:if>
    <fdl:map>
      <fdl:sourceMember>
        <fdl:dataStructureMemberName>
          <fdl:nameComponent name="MessageContainer"/>
        </fdl:dataStructureMemberName>
      </fdl:sourceMember>
      <fdl:targetMember>
        <fdl:dataStructureMemberName>
          <fdl:nameComponent name="_STRUCT"/>
        </fdl:dataStructureMemberName>
      </fdl:targetMember>
    </fdl:map>
  </xsl:template>
  <!--
    *****************************************************************************************************
    Template "initialize-human-task-input":

    Called by template "create-standard-activity".
    Creates a "Java snippet" that initializes the input variable of a human task
        in case that it is not set with data from an inbound data flow.
    *****************************************************************************************************
  -->
  <xsl:template name="initialize-human-task-input">
    <xsl:param name="variable-name"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variable-name) or $variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;initialize-human-task-input&quot;', $eol, 'Parameter &quot;variable-name&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <bpws:invoke wpc:continueOnError="no" portType="wpc:null" partnerLink="null" operation="null" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Initialize human task input">
      <wpc:script>
        <wpc:javaCode>
          <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
          <!-- Create comment: Initialize human task input -->
          <xsl:value-of select="concat($eol, '// Initialize human task input', $eol)" disable-output-escaping="yes"/>
          <!-- Initialize business object -->
          <xsl:value-of select="concat($eol,
                                          'if (',
                          $variable-name,
                                          ' == null) {',
                                          $eol,
                                          '    com.ibm.websphere.bo.BOFactory boFactory = (com.ibm.websphere.bo.BOFactory)com.ibm.websphere.sca.ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
                                          $eol,
                                          '    ',
                          $variable-name,
                                          ' = boFactory.createByType(getVariableType(&quot;',
                          $variable-name,
                          '&quot;));',
                                          $eol,
                                          '}',
                          $eol)" disable-output-escaping="yes"/>
          <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
        </wpc:javaCode>
      </wpc:script>
    </bpws:invoke>
  </xsl:template>
  <!--
    *****************************************************************************************************
    Template "create-data-mapping-human-task-to-standard":

    Called by template "create-standard-activity".
    Creates an "assign" activity or "Java snippet" that merges the human task
        data output message to the "standard" data output of a "staff activity".
    *****************************************************************************************************
  -->
  <xsl:template name="create-data-mapping-human-task-to-standard">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-mapping-human-task-to-standard&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-mapping-human-task-to-standard&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="human-task-variable-name" select="concat($activity/@name, $human-task-output-variable-suffix)"/>
    <xsl:variable name="standard-variable-name" select="concat($activity/@name, $output-variable-suffix)"/>
    <xsl:variable name="primary-standard-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($standard-variable-name)"/>
    <xsl:variable name="source-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$human-task-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="target-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$primary-standard-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <!-- Create comment: Copy the human task output from variable "nnn" to variable "nnn" by merging any default values -->
    <xsl:value-of select="concat($eol, '&lt;!--  Copy the human task output  from variable &quot;', $human-task-variable-name, '&quot; to variable &quot;', $primary-standard-variable-name, '&quot; by merging any default values --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsl:variable name="human-task-to-standard-mappings">
      <xsl:call-template name="human-task-to-standard-mappings"/>
    </xsl:variable>
    <xsl:choose>
      <!-- CASE: create "Java snippet" activity -->
      <xsl:when test="'true' = $create_Java_Snippets">
        <bpws:invoke wpc:continueOnError="no" portType="wpc:null" partnerLink="null" operation="null" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Merge human task output">
          <wpc:script>
            <wpc:javaCode>
              <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
              <!-- Create comment: Merge human task output -->
              <xsl:value-of select="concat($eol, '// Merge human task output', $eol)" disable-output-escaping="yes"/>
              <xsl:apply-templates select="xalan:nodeset($human-task-to-standard-mappings)/fdl:map" mode="data">
                <xsl:with-param name="display-name" select="'Merge human task output'"/>
                <xsl:with-param name="from-variable-name" select="$human-task-variable-name"/>
                <xsl:with-param name="to-variable-name" select="$primary-standard-variable-name"/>
                <xsl:with-param name="source-xml-schema-type" select="$source-xml-schema-type"/>
                <xsl:with-param name="target-xml-schema-type" select="$target-xml-schema-type"/>
              </xsl:apply-templates>
              <!-- Initialize business object -->
              <xsl:value-of select="concat($eol,
                                          'if (',
                          $primary-standard-variable-name,
                                          ' == null) {',
                                          $eol,
                                          '    com.ibm.websphere.bo.BOFactory boFactory = (com.ibm.websphere.bo.BOFactory)com.ibm.websphere.sca.ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
                                          $eol,
                                          '    ',
                          $primary-standard-variable-name,
                                          ' = boFactory.createByType(getVariableType(&quot;',
                          $primary-standard-variable-name,
                          '&quot;));',
                                          $eol,
                                          '}',
                          $eol)" disable-output-escaping="yes"/>
              <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
            </wpc:javaCode>
          </wpc:script>
        </bpws:invoke>
      </xsl:when>
      <!-- OTHERWISE: create "assign" activity -->
      <xsl:otherwise>
        <bpws:assign name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Merge human task output">
          <!-- Create data mappings -->
          <xsl:apply-templates select="xalan:nodeset($human-task-to-standard-mappings)/fdl:map" mode="data">
            <xsl:with-param name="display-name" select="'Merge human task output'"/>
            <xsl:with-param name="from-variable-name" select="$human-task-variable-name"/>
            <xsl:with-param name="to-variable-name" select="$primary-standard-variable-name"/>
            <xsl:with-param name="source-xml-schema-type" select="$source-xml-schema-type"/>
            <xsl:with-param name="target-xml-schema-type" select="$target-xml-schema-type"/>
          </xsl:apply-templates>
        </bpws:assign>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************
    Template "human-task-to-standard-mappings":

    Returns the "fdl:map" elements that are needed to create
    "human-task-to-standard-mapping" expressions
    *****************************************************************************************************
  -->
  <xsl:template name="human-task-to-standard-mappings">
    <fdl:map>
      <fdl:sourceMember>
        <fdl:dataStructureMemberName>
          <fdl:nameComponent name="_STRUCT"/>
        </fdl:dataStructureMemberName>
      </fdl:sourceMember>
      <fdl:targetMember>
        <fdl:dataStructureMemberName>
          <fdl:nameComponent name="_STRUCT"/>
        </fdl:dataStructureMemberName>
      </fdl:targetMember>
    </fdl:map>
  </xsl:template>
  <!--
    *****************************************************************************************************
    Template "create-data-mapping-subprocess-to-standard":

    Called by template "create-activity".
    Creates an "assign" activity or "Java snippet" that merges the subprocess
        data output message to the "standard" data output of a "process activity".
    *****************************************************************************************************
  -->
  <xsl:template name="create-data-mapping-subprocess-to-standard">
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-mapping-subprocess-to-standard&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-mapping-subprocess-to-standard&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="subprocess-variable-name" select="concat($activity/@name, $subprocess-output-variable-suffix)"/>
    <xsl:variable name="standard-variable-name" select="concat($activity/@name, $output-variable-suffix)"/>
    <xsl:variable name="primary-standard-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($standard-variable-name)"/>
    <xsl:variable name="source-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$subprocess-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="target-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$primary-standard-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <!-- Create comment: Copy the subprocess output from variable "nnn" to variable "nnn" by merging any default values -->
    <xsl:value-of select="concat($eol, '&lt;!--  Copy the subprocess output  from variable &quot;', $subprocess-variable-name, '&quot; to variable &quot;', $primary-standard-variable-name, '&quot; by merging any default values --&gt;', $eol)" disable-output-escaping="yes"/>
    <xsl:variable name="subprocess-to-standard-mappings">
      <xsl:call-template name="subprocess-to-standard-mappings"/>
    </xsl:variable>
    <xsl:choose>
      <!-- CASE: create "Java snippet" activity -->
      <xsl:when test="'true' = $create_Java_Snippets">
        <bpws:invoke wpc:continueOnError="no" portType="wpc:null" partnerLink="null" operation="null" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Merge subprocess output">
          <wpc:script>
            <wpc:javaCode>
              <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
              <!-- Create comment: Merge subprocess output -->
              <xsl:value-of select="concat($eol, '// Merge subprocess output', $eol)" disable-output-escaping="yes"/>
              <xsl:apply-templates select="xalan:nodeset($subprocess-to-standard-mappings)/fdl:map" mode="data">
                <xsl:with-param name="display-name" select="'Merge subprocess output'"/>
                <xsl:with-param name="from-variable-name" select="$subprocess-variable-name"/>
                <xsl:with-param name="to-variable-name" select="$primary-standard-variable-name"/>
                <xsl:with-param name="source-xml-schema-type" select="$source-xml-schema-type"/>
                <xsl:with-param name="target-xml-schema-type" select="$target-xml-schema-type"/>
              </xsl:apply-templates>
              <!-- Initialize business object -->
              <xsl:value-of select="concat($eol,
                                          'if (',
                          $primary-standard-variable-name,
                                          ' == null) {',
                                          $eol,
                                          '    com.ibm.websphere.bo.BOFactory boFactory = (com.ibm.websphere.bo.BOFactory)com.ibm.websphere.sca.ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
                                          $eol,
                                          '    ',
                          $primary-standard-variable-name,
                                          ' = boFactory.createByType(getVariableType(&quot;',
                          $primary-standard-variable-name,
                          '&quot;));',
                                          $eol,
                                          '}',
                          $eol)" disable-output-escaping="yes"/>
              <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
            </wpc:javaCode>
          </wpc:script>
        </bpws:invoke>
      </xsl:when>
      <!-- OTHERWISE: create "assign" activity -->
      <xsl:otherwise>
        <bpws:assign name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="Merge human task output">
          <!-- Create data mappings -->
          <xsl:apply-templates select="xalan:nodeset($subprocess-to-standard-mappings)/fdl:map" mode="data">
            <xsl:with-param name="display-name" select="'Merge human task output'"/>
            <xsl:with-param name="from-variable-name" select="$subprocess-variable-name"/>
            <xsl:with-param name="to-variable-name" select="$primary-standard-variable-name"/>
            <xsl:with-param name="source-xml-schema-type" select="$source-xml-schema-type"/>
            <xsl:with-param name="target-xml-schema-type" select="$target-xml-schema-type"/>
          </xsl:apply-templates>
        </bpws:assign>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************
    Template "subprocess-to-standard-mappings":

    Returns the "fdl:map" elements that are needed to create
    "subprocess-to-standard-mapping" expressions
    *****************************************************************************************************
  -->
  <xsl:template name="subprocess-to-standard-mappings">
    <fdl:map>
      <fdl:sourceMember>
        <fdl:dataStructureMemberName>
          <fdl:nameComponent name="_STRUCT"/>
        </fdl:dataStructureMemberName>
      </fdl:sourceMember>
      <fdl:targetMember>
        <fdl:dataStructureMemberName>
          <fdl:nameComponent name="_STRUCT"/>
        </fdl:dataStructureMemberName>
      </fdl:targetMember>
    </fdl:map>
  </xsl:template>
  <!--
    *****************************************************************************************************
    "data" template matching "fdl:data":

    Creates an "assign" activity or "Java snippet" for each "fdl:data" element (data connector).
        Translates each "fdl:map"-element (data mapping) to a respective "copy" element or
        Java statement.
    *****************************************************************************************************
  -->
  <xsl:template match="fdl:data" mode="data">
    <xsl:param name="variables"/>
    <xsl:param name="node"/>
    <xsl:param name="merged_data_distribution" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;data&quot; match=&quot;fdl:data&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($node)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;data&quot; match=&quot;fdl:data&quot;', $eol, 'Parameter &quot;node&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="parent-name">
      <xsl:choose>
        <!-- CASE: Parent is the current process -->
        <xsl:when test="local-name(..) = 'process'">
          <xsl:value-of select="../@name"/>
        </xsl:when>
        <!-- OTHERWISE: Parent is a block activity -->
        <xsl:otherwise>
          <xsl:value-of select="../../@name"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="from-variable-name">
      <xsl:choose>
        <!--   CASE: If the data connector is a default connector,  choose the name of the input variable of the activity specified in attribute "default" -->
        <xsl:when test="@default">
          <xsl:value-of select="concat(@default, $input-variable-suffix)"/>
        </xsl:when>
        <!-- CASE:   If the data connector is a loop connector,  choose the name of the output variable of the activity specified in attribute "loop" -->
        <xsl:when test="@loop">
          <xsl:value-of select="concat(@loop, $output-variable-suffix)"/>
        </xsl:when>
        <!--   CASE: If the data connector source is "SOURCE", choose the name of the input variable of the current process or block   -->
        <xsl:when test="../fdl:input/@name = @from">
          <xsl:value-of select="concat($parent-name, $input-variable-suffix)"/>
        </xsl:when>
        <!-- OTHERWISE: The data connector source should be the output variable of a local activity -->
        <xsl:otherwise>
          <xsl:value-of select="concat(@from, $output-variable-suffix)"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="to-variable-name">
      <xsl:choose>
        <!-- CASE: If the data connector is a default connector,  choose the name of the output variable of the activity specified in attribute "default" -->
        <xsl:when test="@default">
          <xsl:value-of select="concat(@default, $output-variable-suffix)"/>
        </xsl:when>
        <!--   CASE: If the data connector is a loop connector,  choose the name of the input variable of the activity specified in attribute "loop" -->
        <xsl:when test="@loop">
          <xsl:value-of select="concat(@loop, $input-variable-suffix)"/>
        </xsl:when>
        <!--   CASE: If the data connector target is "SINK", choose the name of the output variable of the current process or block -->
        <xsl:when test="../fdl:output/@name = @to">
          <xsl:value-of select="concat($parent-name, $output-variable-suffix)"/>
        </xsl:when>
        <!--   CASE: If the data connector target is "GLOBAL_CONTAINER", choose the "GLOBAL_CONTAINER" variable -->
        <xsl:when test="@to = 'GLOBAL_CONTAINER'">
          <xsl:value-of select="'GLOBAL_CONTAINER'"/>
        </xsl:when>
        <!-- OTHERWISE: The data connector target should be the input variable of a local activity -->
        <xsl:otherwise>
          <xsl:value-of select="concat(@to, $input-variable-suffix)"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="trace" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.traceXsl(concat('Data Connector, from: ', $from-variable-name, ', to: ', $to-variable-name ))"/>
    <xsl:variable name="primary-from-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($from-variable-name)"/>
    <xsl:variable name="primary-to-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($to-variable-name)"/>
    <!-- Translate the data connector provided that neither the "from variable" is shared by the "to variable" nor the "to variable" is shared by the "from variable" -->
    <xsl:if test="not( $primary-from-variable-name = $primary-to-variable-name )">
      <xsl:choose>
        <xsl:when test="@default">
          <!-- Create comment: Default data flow from the input variable to the output variable of activity "nnn" -->
          <xsl:value-of select="concat($eol, '&lt;!-- Default data flow from the input variable to the output variable of activity &quot;', @default, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:when>
        <xsl:when test="@loop">
          <!-- Create comment: Data flow loop from the output variable to the input variable of activity "nnn" -->
          <xsl:value-of select="concat($eol, '&lt;!-- Data flow loop from the output variable to the input variable of activity &quot;', @loop, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:when>
        <xsl:otherwise>
          <!-- Create comment: Data flow from "nnn" to "nnn"-->
          <xsl:choose>
            <xsl:when test="'true' = $merged_data_distribution and 'true' = $create_Java_Snippets">
              <xsl:value-of select="concat($eol, '// Data flow from &quot;', @from, '&quot; to &quot;', @to, '&quot;', $eol)" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="concat($eol, '&lt;!-- Data flow from &quot;', @from, '&quot; to &quot;', @to, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:choose>
        <xsl:when test="fdl:map">
          <!-- Create a data mapping activity ("assign" or "Java snippet") -->
          <xsl:call-template name="create-data-mapping-activity">
            <xsl:with-param name="data" select="current()"/>
            <xsl:with-param name="variables" select="$variables"/>
            <xsl:with-param name="from-variable-name" select="$primary-from-variable-name"/>
            <xsl:with-param name="to-variable-name" select="$primary-to-variable-name"/>
            <xsl:with-param name="node" select="$node"/>
            <xsl:with-param name="merged_data_distribution" select="$merged_data_distribution"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <!-- Create comment: *** CWWBMnnnnW: No data mappings found for the data flow from ''nnn'' to ''nnn'' *** -->
          <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MissingDataMaps', $fdlFileName, fdl:fdlLoc/@line, fdl:fdlLoc/@column, $from-variable-name, $to-variable-name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************
    "map" template matching "fdl:map":

    Creates a data mapping expression ("copy" element or "Java statement")
    *****************************************************************************************************
  -->
  <xsl:template match="fdl:map" mode="data">
    <xsl:param name="display-name"/>
    <xsl:param name="from-variable-name"/>
    <xsl:param name="to-variable-name"/>
    <xsl:param name="source-xml-schema-type"/>
    <xsl:param name="target-xml-schema-type"/>
    <xsl:param name="set_process_input_default_values" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($from-variable-name) or $from-variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;data&quot; match=&quot;fdl:map&quot;', $eol, 'Parameter &quot;from-variable-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($to-variable-name) or $to-variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;data&quot; match=&quot;fdl:map&quot;', $eol, 'Parameter &quot;to-variable-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($source-xml-schema-type) or $source-xml-schema-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;data&quot; match=&quot;fdl:map&quot;', $eol, 'Parameter &quot;source-xml-schema-type&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($target-xml-schema-type) or $target-xml-schema-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;data&quot; match=&quot;fdl:map&quot;', $eol, 'Parameter &quot;target-xml-schema-type&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="source-dataStructureMemberName" select="fdl:sourceMember/fdl:dataStructureMemberName"/>
    <xsl:variable name="target-dataStructureMemberName" select="fdl:targetMember/fdl:dataStructureMemberName"/>
    <!--
      Create data mappings as part of an "assign" activity or "Java snippet"
    -->
    <!-- Determine the position start index of the first "fdl:nameComponent" in the FDL "FROM " expression ("dotted name" translated to XFDL) -->
    <xsl:variable name="source-first">
      <xsl:call-template name="find-start-index-for-parsing-a-dotted-name">
        <xsl:with-param name="dataStructureMemberName" select="$source-dataStructureMemberName"/>
      </xsl:call-template>
    </xsl:variable>
    <!-- Determine the position start index of the first "fdl:nameComponent" in the FDL "TO" expression ("dotted name" translated to XFDL) -->
    <xsl:variable name="target-first">
      <xsl:call-template name="find-start-index-for-parsing-a-dotted-name">
        <xsl:with-param name="dataStructureMemberName" select="$target-dataStructureMemberName"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="from-query-expression">
      <xsl:call-template name="translate-dataStructureMemberName-to-XPath">
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="XMLSchemaType" select="$source-xml-schema-type"/>
        <xsl:with-param name="nameComponent" select="$source-dataStructureMemberName/fdl:nameComponent[ position() = $source-first ]"/>
        <xsl:with-param name="FDL-location" select="$source-dataStructureMemberName/fdl:fdlLoc"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="from-query-expression-could-not-be-resolved">
      <xsl:choose>
        <xsl:when test="contains($from-query-expression, 'UNKNOWN_DATA_STRUCTURE_MEMBER')">
          <xsl:value-of select="'true'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'false'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="to-query-expression">
      <xsl:call-template name="translate-dataStructureMemberName-to-XPath">
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="XMLSchemaType" select="$target-xml-schema-type"/>
        <xsl:with-param name="nameComponent" select="$target-dataStructureMemberName/fdl:nameComponent[ position() = $target-first ]"/>
        <xsl:with-param name="FDL-location" select="$target-dataStructureMemberName/fdl:fdlLoc"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="to-query-expression-could-not-be-resolved">
      <xsl:choose>
        <xsl:when test="contains($to-query-expression, 'UNKNOWN_DATA_STRUCTURE_MEMBER')">
          <xsl:value-of select="'true'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'false'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <!-- CASE: Create "Java statement" -->
      <xsl:when test="'true' = $create_Java_Snippets">
        <xsl:if test="'true' = $from-query-expression-could-not-be-resolved or 'true' = $to-query-expression-could-not-be-resolved">
          <xsl:value-of select="concat($eol, '// TODO *** Adjust the following incorrect data mapping *** ', $eol, '/*')" disable-output-escaping="yes"/>
        </xsl:if>
        <xsl:choose>
          <xsl:when test="'true' = $set_process_input_default_values">
            <xsl:value-of select="concat($eol,
                          $from-variable-name,
                          ' = com.ibm.bpe.interop.WMQWFHelper.merge(',
                          $from-variable-name,
                          ', &quot;',
                          xalan:nodeset($from-query-expression)/*,
                          '&quot;, ',
                          $to-variable-name,
                          ', &quot;',
                          xalan:nodeset($to-query-expression)/*,
                          '&quot;, getVariableType(&quot;',
                          $to-variable-name,
                          '&quot;));'
                          )" disable-output-escaping="yes"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="concat($eol,
                          $to-variable-name,
                          ' = com.ibm.bpe.interop.WMQWFHelper.merge(',
                          $from-variable-name,
                          ', &quot;',
                          xalan:nodeset($from-query-expression)/*,
                          '&quot;, ',
                          $to-variable-name,
                          ', &quot;',
                          xalan:nodeset($to-query-expression)/*,
                          '&quot;, getVariableType(&quot;',
                          $to-variable-name,
                          '&quot;));'
                          )" disable-output-escaping="yes"/>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="'true' = $from-query-expression-could-not-be-resolved or 'true' = $to-query-expression-could-not-be-resolved">
          <xsl:value-of select="concat($eol, '*/', $eol)" disable-output-escaping="yes"/>
        </xsl:if>
      </xsl:when>
      <!-- OTHERWISE: Create "copy" element of an "assign" activity -->
      <xsl:otherwise>
        <bpws:copy>
          <bpws:from variable="{$from-variable-name}">
            <!-- Add "part" attribute if the BPEL variable has type "interface" -->
            <xsl:if test="'INTERFACE' = $variable-type-mode">
              <xsl:attribute name="part"><xsl:value-of select="$message-part-name"/></xsl:attribute>
            </xsl:if>
            <bpws:query>
              <xsl:choose>
                <xsl:when test="'true' = $from-query-expression-could-not-be-resolved">
                  <xsl:value-of select="concat($eol, '&lt;!-- *** Adjust the following incorrect expression *** ', $eol)" disable-output-escaping="yes"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
                </xsl:otherwise>
              </xsl:choose>
              <xsl:value-of select="xalan:nodeset($from-query-expression)/*" disable-output-escaping="yes"/>
              <xsl:choose>
                <xsl:when test="'true' = $from-query-expression-could-not-be-resolved">
                  <xsl:value-of select="concat($eol, ' --&gt;', $eol)" disable-output-escaping="yes"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
                </xsl:otherwise>
              </xsl:choose>
            </bpws:query>
          </bpws:from>
          <bpws:to variable="{$to-variable-name}">
            <!-- Add "part" attribute if the BPEL variable has type "interface" -->
            <xsl:if test="'INTERFACE' = $variable-type-mode">
              <xsl:attribute name="part"><xsl:value-of select="$message-part-name"/></xsl:attribute>
            </xsl:if>
            <bpws:query>
              <xsl:choose>
                <xsl:when test="'true' = $to-query-expression-could-not-be-resolved">
                  <xsl:value-of select="concat($eol, '&lt;!-- *** Adjust the following incorrect expression *** ', $eol)" disable-output-escaping="yes"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
                </xsl:otherwise>
              </xsl:choose>
              <xsl:value-of select="xalan:nodeset($to-query-expression)/*" disable-output-escaping="yes"/>
              <xsl:choose>
                <xsl:when test="'true' = $to-query-expression-could-not-be-resolved">
                  <xsl:value-of select="concat($eol, ' --&gt;', $eol)" disable-output-escaping="yes"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
                </xsl:otherwise>
              </xsl:choose>
            </bpws:query>
          </bpws:to>
        </bpws:copy>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *******************************************************************
    Template "create-assign-activity-to-set-BPEL-variable"
    ********************************************************************
  -->
  <xsl:template name="create-assign-activity-to-set-BPEL-variable">
    <xsl:param name="BPEL-variable"/>
    <xsl:param name="BPEL-variable-value" select="'NOT SET'"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($BPEL-variable) or $BPEL-variable = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-assign-activity-to-set-BPEL-variable&quot;', $eol, 'Parameter &quot;BPEL-variable&quot; is not set')"/>
      <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:variable name="display-name">
      <xsl:choose>
        <xsl:when test="$BPEL-variable-value = 'NOT SET'">
          <xsl:call-template name="tailor-display-name">
            <xsl:with-param name="untailored-display-name" select="concat('Reset ', $BPEL-variable)"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="tailor-display-name">
            <xsl:with-param name="untailored-display-name" select="concat('Set ', $BPEL-variable, ' to ', $BPEL-variable-value)"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <bpws:assign wpc:displayName="{$display-name}" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
      <bpws:copy>
        <bpws:from>
          <!-- DEPRECATED:  <wpc:literal type="xsd:string"> -->
          <xsl:value-of select="concat('&lt;![CDATA[', $BPEL-variable-value, ']]&gt;')" disable-output-escaping="yes"/>
          <!-- DEPRECATED:  </wpc:literal> -->
        </bpws:from>
        <xsl:choose>
          <!-- CASE: interface-typed BPEL variables -->
          <xsl:when test="'INTERFACE' = $variable-type-mode">
            <bpws:to part="{$message-part-name}" variable="{$BPEL-variable}"/>
          </xsl:when>
          <!-- OTHERWISE: data-typed BPEL variables assumed -->
          <xsl:otherwise>
            <bpws:to variable="{$BPEL-variable}"/>
          </xsl:otherwise>
        </xsl:choose>
      </bpws:copy>
    </bpws:assign>
  </xsl:template>
  <!--
    ************************************************************************************************
    Template "create-data-mapping-activity"
    ************************************************************************************************
  -->
  <xsl:template name="create-data-mapping-activity">
    <xsl:param name="data"/>
    <xsl:param name="variables"/>
    <xsl:param name="from-variable-name"/>
    <xsl:param name="to-variable-name"/>
    <xsl:param name="node"/>
    <xsl:param name="merged_data_distribution" select="false()"/>
    <xsl:param name="set_process_input_default_values" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($data)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-mapping-activity&quot;', $eol, 'Parameter &quot;data&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-mapping-activity&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($from-variable-name) or $from-variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-mapping-activity&quot;', $eol, 'Parameter &quot;from-variable-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($to-variable-name) or $to-variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-mapping-activity&quot;', $eol, 'Parameter &quot;to-variable-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($node)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-data-mapping-activity&quot;', $eol, 'Parameter &quot;node&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="primary-from-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($from-variable-name)"/>
    <xsl:variable name="source-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$from-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="target-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$to-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="display-name">
      <xsl:variable name="data-connector-name">
        <xsl:choose>
          <xsl:when test="'true' = $LI1143_Support_for_the_link_name_option_in_ControlFlow_and_DataFlow and string-length(@name) &gt; 0">
            <xsl:value-of select="$data/@name"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="concat($from-variable-name, ' - ', $to-variable-name)"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:call-template name="tailor-display-name">
        <xsl:with-param name="untailored-display-name" select="$data-connector-name"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:choose>
      <!-- CASE: "merged data distribution" is true and it's no default or loop data connector -->
      <xsl:when test="'true' = $merged_data_distribution and not($data/@default or $data/@loop)">
        <xsl:choose>
          <!-- CASE: create "Java snippet" activity -->
          <xsl:when test="'true' = $create_Java_Snippets">
            <!--
                Create data mappings.
            -->
            <xsl:apply-templates select="$data/fdl:map" mode="data">
              <xsl:with-param name="display-name" select="$display-name"/>
              <xsl:with-param name="from-variable-name" select="$from-variable-name"/>
              <xsl:with-param name="to-variable-name" select="$to-variable-name"/>
              <xsl:with-param name="source-xml-schema-type" select="$source-xml-schema-type"/>
              <xsl:with-param name="target-xml-schema-type" select="$target-xml-schema-type"/>
              <xsl:with-param name="set_process_input_default_values" select="$set_process_input_default_values"/>
            </xsl:apply-templates>
            <xsl:if test="not('true' = $set_process_input_default_values)">
              <!-- Initialize target business object -->
              <xsl:value-of select="concat($eol,
                              'if (',
                              $to-variable-name,
                              ' == null) {',
                              $eol,
                              '    com.ibm.websphere.bo.BOFactory boFactory = (com.ibm.websphere.bo.BOFactory) com.ibm.websphere.sca.ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
                              $eol,
                              '    ',
                              $to-variable-name,
                              ' = boFactory.createByType(getVariableType(&quot;',
                              $to-variable-name,
                              '&quot;));',
                              $eol,
                              '}',
                              $eol)" disable-output-escaping="yes"/>
            </xsl:if>
          </xsl:when>
          <!-- OTHERWISE: create "assign" activity -->
          <xsl:otherwise>
            <!--
                Create data mappings.
            -->
            <xsl:apply-templates select="$data/fdl:map" mode="data">
              <xsl:with-param name="display-name" select="$display-name"/>
              <xsl:with-param name="from-variable-name" select="$from-variable-name"/>
              <xsl:with-param name="to-variable-name" select="$to-variable-name"/>
              <xsl:with-param name="source-xml-schema-type" select="$source-xml-schema-type"/>
              <xsl:with-param name="target-xml-schema-type" select="$target-xml-schema-type"/>
            </xsl:apply-templates>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- OTHERWISE: "merged data distribution" is false or default/loop data connector -->
      <xsl:otherwise>
        <xsl:choose>
          <!-- CASE: create "Java snippet" activity -->
          <xsl:when test="'true' = $create_Java_Snippets">
            <bpws:invoke wpc:continueOnError="no" portType="wpc:null" partnerLink="null" operation="null" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}" wpc:displayName="{$display-name}">
              <!-- Data connector description -->
              <xsl:call-template name="translate-description-and-documentation-fields">
                <xsl:with-param name="node" select="$data"/>
                <xsl:with-param name="display-name" select="$display-name"/>
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="primary-input-variable-name" select="$primary-from-variable-name"/>
              </xsl:call-template>
              <!--
                  Create data mappings.
              -->
              <wpc:script>
                <wpc:javaCode>
                  <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
                  <!-- Create comment: Data flow from "from-variable-name" to "to-variable-name" -->
                  <xsl:value-of select="concat($eol, '// Data flow from &quot;', $from-variable-name, '&quot; to &quot;', $to-variable-name, '&quot;', $eol)" disable-output-escaping="yes"/>
                  <xsl:apply-templates select="$data/fdl:map" mode="data">
                    <xsl:with-param name="display-name" select="$display-name"/>
                    <xsl:with-param name="from-variable-name" select="$from-variable-name"/>
                    <xsl:with-param name="to-variable-name" select="$to-variable-name"/>
                    <xsl:with-param name="source-xml-schema-type" select="$source-xml-schema-type"/>
                    <xsl:with-param name="target-xml-schema-type" select="$target-xml-schema-type"/>
                  </xsl:apply-templates>
                  <!-- Initialize target business object -->
                  <xsl:value-of select="concat($eol,
                              'if (',
                              $to-variable-name,
                              ' == null) {',
                              $eol,
                              '    com.ibm.websphere.bo.BOFactory boFactory = (com.ibm.websphere.bo.BOFactory) com.ibm.websphere.sca.ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
                              $eol,
                              '    ',
                              $to-variable-name,
                              ' = boFactory.createByType(getVariableType(&quot;',
                              $to-variable-name,
                              '&quot;));',
                              $eol,
                              '}',
                              $eol)" disable-output-escaping="yes"/>
                  <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
                </wpc:javaCode>
              </wpc:script>
            </bpws:invoke>
          </xsl:when>
          <!-- OTHERWISE: create "assign" activity -->
          <xsl:otherwise>
            <bpws:assign wpc:displayName="{$display-name}" name="{java:com.ibm.bpe.fdl2bpel.converter.NameTable.generateName()}">
              <!-- Data connector description -->
              <xsl:call-template name="translate-description-and-documentation-fields">
                <xsl:with-param name="node" select="$data"/>
                <xsl:with-param name="display-name" select="$display-name"/>
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="primary-input-variable-name" select="$primary-from-variable-name"/>
              </xsl:call-template>
              <!--
                  Create data mappings.
              -->
              <xsl:apply-templates select="$data/fdl:map" mode="data">
                <xsl:with-param name="display-name" select="$display-name"/>
                <xsl:with-param name="from-variable-name" select="$from-variable-name"/>
                <xsl:with-param name="to-variable-name" select="$to-variable-name"/>
                <xsl:with-param name="source-xml-schema-type" select="$source-xml-schema-type"/>
                <xsl:with-param name="target-xml-schema-type" select="$target-xml-schema-type"/>
              </xsl:apply-templates>
            </bpws:assign>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ************************************************************************************************
    Template "create-condition-xpath-expression"
    ************************************************************************************************
  -->
  <xsl:template name="create-condition-xpath-expression">
    <xsl:param name="display-name"/>
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="condition"/>
    <xsl:param name="translate-to-BPEL-while-condition" select="false()"/>
    <xsl:param name="FDL-location"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-condition-xpath-expression&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-condition-xpath-expression&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-condition-xpath-expression&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($condition)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;create-condition-xpath-expression&quot;', $eol, 'Parameter &quot;condition&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="local-variable-name" select="concat($activity/@name, $output-variable-suffix)"/>
    <xsl:variable name="primary-local-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($local-variable-name)"/>
    <xsl:variable name="local-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$primary-local-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <!--
      Translate boolean expression
    -->
    <xsl:variable name="xpath-condition">
      <xsl:apply-templates select="$condition/fdl:operator | $condition/fdl:unaryOperator" mode="condition">
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="activity" select="$activity"/>
        <xsl:with-param name="local-xml-schema-type" select="$local-xml-schema-type"/>
        <xsl:with-param name="FDL-location" select="$FDL-location"/>
      </xsl:apply-templates>
    </xsl:variable>
    <xsl:variable name="activity-status-variable-name" select="concat($activity/@name, $status-variable-suffix)"/>
    <xsl:choose>
      <!-- CASE: exit condition that is translated as a BPEL "while" condition -->
      <xsl:when test="$translate-to-BPEL-while-condition = 'true'">
        <xsl:choose>
          <!-- CASE: interface-typed BPEL variables -->
          <xsl:when test="'INTERFACE' = $variable-type-mode">
            <xsl:value-of select="concat('not( ', $xpath-condition, ' ) or not( ', '$',  $activity-status-variable-name, '.', $message-part-name, ' = &quot;', $activity-started-indicator, '&quot; )' )"/>
          </xsl:when>
          <!-- OTHERWISE: data-typed BPEL variables assumed -->
          <xsl:otherwise>
            <xsl:value-of select="concat('not( ', $xpath-condition, ' ) or not( ', '$',  $activity-status-variable-name, ' = &quot;', $activity-started-indicator, '&quot; )' )"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- OTHERWISE: either the exit condition of an activity that is translated as a BPEL "repeatUntil" condition or the transition condition of a control connector -->
      <xsl:otherwise>
        <xsl:value-of select="$xpath-condition"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ************************************************************************************************
    Template "condition":

    "fdl:operator" found
    ************************************************************************************************
  -->
  <xsl:template match="fdl:operator" mode="condition">
    <xsl:param name="display-name"/>
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="local-xml-schema-type"/>
    <xsl:param name="FDL-location"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:operator&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:operator&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:operator&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($local-xml-schema-type) or $local-xml-schema-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:operator&quot;', $eol, 'Parameter &quot;local-xml-schema-type&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!--
        Translate operator
    -->
    <xsl:variable name="xpath-operator">
      <xsl:choose>
        <xsl:when test="@type = 'and'">
          <xsl:value-of select="'and'"/>
        </xsl:when>
        <xsl:when test="@type = 'or'">
          <xsl:value-of select="'or'"/>
        </xsl:when>
        <xsl:when test="@type = 'equal'">
          <xsl:value-of select="'='"/>
        </xsl:when>
        <xsl:when test="@type = 'notEqual'">
          <xsl:value-of select="'!='"/>
        </xsl:when>
        <xsl:when test="@type = 'greater'">
          <xsl:value-of select="'&gt;'"/>
        </xsl:when>
        <xsl:when test="@type = 'greaterEqual'">
          <xsl:value-of select="'&gt;='"/>
        </xsl:when>
        <xsl:when test="@type = 'smaller'">
          <xsl:value-of select="'&lt;'"/>
        </xsl:when>
        <xsl:when test="@type = 'smallerEqual'">
          <xsl:value-of select="'&lt;='"/>
        </xsl:when>
        <xsl:when test="@type = 'plus'">
          <xsl:value-of select="'+'"/>
        </xsl:when>
        <xsl:when test="@type = 'minus'">
          <xsl:value-of select="'-'"/>
        </xsl:when>
        <xsl:when test="@type = 'mult'">
          <xsl:value-of select="'*'"/>
        </xsl:when>
        <xsl:when test="@type = 'div'">
          <xsl:value-of select="'div'"/>
        </xsl:when>
        <xsl:when test="@type = 'mod'">
          <xsl:value-of select="'mod'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'&quot;unknown operator&quot;'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!--
        Translate left operand
    -->
    <xsl:variable name="left-xpath-operand">
      <xsl:apply-templates select="*[1]" mode="condition">
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="activity" select="$activity"/>
        <xsl:with-param name="local-xml-schema-type" select="$local-xml-schema-type"/>
        <xsl:with-param name="FDL-location" select="$FDL-location"/>
      </xsl:apply-templates>
    </xsl:variable>
    <!--
        Translate right operand
    -->
    <xsl:variable name="right-xpath-operand">
      <xsl:apply-templates select="*[2]" mode="condition">
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="activity" select="$activity"/>
        <xsl:with-param name="local-xml-schema-type" select="$local-xml-schema-type"/>
        <xsl:with-param name="FDL-location" select="$FDL-location"/>
      </xsl:apply-templates>
    </xsl:variable>
    <!--
        Convert result tree fragments to node-sets
    -->
    <xsl:variable name="left-xpath-operand1" select="xalan:nodeset($left-xpath-operand)/*"/>
    <xsl:variable name="right-xpath-operand1" select="xalan:nodeset($right-xpath-operand)/*"/>
    <!--
        Assemble XPath expression
    -->
    <xsl:variable name="xpath-expression">
      <xsl:choose>
        <xsl:when test="$right-xpath-operand1/@isNull = 'true'">
          <xsl:choose>
            <xsl:when test="@type = 'equal'">
              <xsl:value-of select="concat('not( ', $left-xpath-operand1, ' )')"/>
            </xsl:when>
            <xsl:when test="@type = 'notEqual'">
              <xsl:value-of select="$left-xpath-operand1"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:variable name="error-message" select="concat('ASSERTION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:operator&quot;', $eol, 'FDL syntax error found')"/>
              <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
              <xsl:value-of select="concat('( ', $left-xpath-operand1, ' ', $xpath-operator, ' ', $right-xpath-operand1, ' )')"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="concat('( ', $left-xpath-operand1, ' ', $xpath-operator, ' ', $right-xpath-operand1, ' )')"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!--
        Return XPath expression to caller
    -->
    <xsl:choose>
      <xsl:when test="@type = 'plus' or @type = 'minus' or @type = 'mult' or @type = 'div' or @type = 'mod'">
        <operator type="numerical">
          <xsl:value-of select="$xpath-expression"/>
        </operator>
      </xsl:when>
      <xsl:otherwise>
        <operator type="boolean">
          <xsl:value-of select="$xpath-expression"/>
        </operator>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ************************************************************************************************
    Template "condition":

    "fdl:unaryOperator" found
    ************************************************************************************************
  -->
  <xsl:template match="fdl:unaryOperator" mode="condition">
    <xsl:param name="display-name"/>
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="local-xml-schema-type"/>
    <xsl:param name="FDL-location"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:unaryOperator&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:unaryOperator&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:unaryOperator&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($local-xml-schema-type) or $local-xml-schema-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:unaryOperator&quot;', $eol, 'Parameter &quot;local-xml-schema-type&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!--
        Translate operand
    -->
    <xsl:variable name="xpath-operand">
      <xsl:apply-templates select="*[1]" mode="condition">
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="activity" select="$activity"/>
        <xsl:with-param name="local-xml-schema-type" select="$local-xml-schema-type"/>
        <xsl:with-param name="FDL-location" select="$FDL-location"/>
      </xsl:apply-templates>
    </xsl:variable>
    <!--
        Convert result tree fragments to node-sets
    -->
    <xsl:variable name="xpath-operand1" select="xalan:nodeset($xpath-operand)/*"/>
    <!--
        Return XPath expession to caller
    -->
    <xsl:choose>
      <xsl:when test="@type = 'minus'">
        <unaryOperator type="numerical">
          <xsl:value-of select="concat('-', $xpath-operand1)"/>
        </unaryOperator>
      </xsl:when>
      <xsl:when test="@type = 'not'">
        <unaryOperator type="boolean">
          <xsl:value-of select="concat('not( ', $xpath-operand1, ' )')"/>
        </unaryOperator>
      </xsl:when>
      <xsl:otherwise>
        <!-- EXCEPTION FOUND -->
        <xsl:variable name="error-message" select="concat('EXCEPTION in template: mode=&quot;condition&quot; match=&quot;fdl:unaryOperator&quot;', $eol, 'FDL syntax error found')"/>
        <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
        <unaryOperator type="unknown">
          <xsl:value-of select="concat('&quot;unknown operator&quot;', $xpath-operand1)"/>
        </unaryOperator>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ************************************************************************************************
    Template "condition":

    "fdl:function" found
    ************************************************************************************************
  -->
  <xsl:template match="fdl:function" mode="condition">
    <xsl:param name="display-name"/>
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="local-xml-schema-type"/>
    <xsl:param name="FDL-location"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:function&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:function&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:function&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($local-xml-schema-type) or $local-xml-schema-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:function&quot;', $eol, 'Parameter &quot;local-xml-schema-type&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- Create "xpath" code -->
    <!--
        Translate function arguments
    -->
    <xsl:variable name="first-argument">
      <xsl:apply-templates select="*[1]" mode="condition">
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="activity" select="$activity"/>
        <xsl:with-param name="local-xml-schema-type" select="$local-xml-schema-type"/>
        <xsl:with-param name="FDL-location" select="$FDL-location"/>
      </xsl:apply-templates>
    </xsl:variable>
    <xsl:variable name="first-argument1" select="xalan:nodeset($first-argument)/*"/>
    <xsl:variable name="second-argument">
      <xsl:if test="*[2]">
        <xsl:apply-templates select="*[2]" mode="condition">
          <xsl:with-param name="display-name" select="$display-name"/>
          <xsl:with-param name="variables" select="$variables"/>
          <xsl:with-param name="activity" select="$activity"/>
          <xsl:with-param name="local-xml-schema-type" select="$local-xml-schema-type"/>
          <xsl:with-param name="FDL-location" select="$FDL-location"/>
        </xsl:apply-templates>
      </xsl:if>
    </xsl:variable>
    <xsl:variable name="second-argument1" select="xalan:nodeset($second-argument)/*"/>
    <xsl:variable name="third-argument">
      <xsl:if test="*[3]">
        <xsl:apply-templates select="*[3]" mode="condition">
          <xsl:with-param name="display-name" select="$display-name"/>
          <xsl:with-param name="variables" select="$variables"/>
          <xsl:with-param name="activity" select="$activity"/>
          <xsl:with-param name="local-xml-schema-type" select="$local-xml-schema-type"/>
          <xsl:with-param name="FDL-location" select="$FDL-location"/>
        </xsl:apply-templates>
      </xsl:if>
    </xsl:variable>
    <xsl:variable name="third-argument1" select="xalan:nodeset($third-argument)/*"/>
    <!--
        Assemble and return XPath expession to caller
    -->
    <xsl:choose>
      <xsl:when test="@type = 'lower'">
        <function type="string">
          <xsl:value-of select="concat('translate(', $first-argument1, ', &quot;',  $upper-case-characters,  '&quot;, &quot;',  $lower-case-characters,  '&quot;)')"/>
        </function>
      </xsl:when>
      <xsl:when test="@type = 'upper'">
        <function type="string">
          <xsl:value-of select="concat('translate(', $first-argument1, ', &quot;',  $lower-case-characters,  '&quot;, &quot;',  $upper-case-characters,  '&quot;)')"/>
        </function>
      </xsl:when>
      <xsl:when test="@type = 'substr'">
        <function type="string">
          <xsl:choose>
            <xsl:when test="$third-argument1">
              <xsl:value-of select="concat('substring(', $first-argument1, ', ',  $second-argument1,  ', ',  $third-argument1, ')')"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="concat('substring(', $first-argument1, ', ',  $second-argument1, ')')"/>
            </xsl:otherwise>
          </xsl:choose>
        </function>
      </xsl:when>
      <xsl:when test="@type = 'value'">
        <function type="numeric">
          <xsl:value-of select="concat('number(', $first-argument1, ')')"/>
        </function>
      </xsl:when>
      <xsl:when test="@type = '_State'">
        <xsl:variable name="activity-status-variable-name">
          <xsl:variable name="activity-name">
            <xsl:choose>
              <xsl:when test="fdl:literal/@value">
                <xsl:value-of select="fdl:literal/@value"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="$activity/@name"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:variable>
          <xsl:value-of select="concat($activity-name, $status-variable-suffix)"/>
        </xsl:variable>
        <function type="string">
          <xsl:choose>
            <!-- CASE: interface-typed BPEL variables -->
            <xsl:when test="'INTERFACE' = $variable-type-mode">
              <xsl:value-of select="concat('$',  $activity-status-variable-name, '.', $message-part-name)"/>
            </xsl:when>
            <!-- OTHERWISE: data-typed BPEL variables assumed -->
            <xsl:otherwise>
              <xsl:value-of select="concat('$',  $activity-status-variable-name)"/>
            </xsl:otherwise>
          </xsl:choose>
        </function>
      </xsl:when>
      <xsl:otherwise>
        <!-- EXCEPTION FOUND -->
        <xsl:variable name="error-message" select="concat('EXCEPTION in template: mode=&quot;condition&quot; match=&quot;fdl:function&quot;', $eol, 'XFDL syntax error found')"/>
        <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
        <function type="string">
          <xsl:value-of select="concat('&quot;***unknown function***&quot;', '(', $first-argument1, ')')"/>
        </function>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ************************************************************************************************
    Template "condition":

    "fdl:dataStructureMemberName" found
    ************************************************************************************************
  -->
  <xsl:template match="fdl:dataStructureMemberName" mode="condition">
    <xsl:param name="display-name"/>
    <xsl:param name="variables"/>
    <xsl:param name="activity"/>
    <xsl:param name="local-xml-schema-type"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:dataStructureMemberName&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:dataStructureMemberName&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:dataStructureMemberName&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($local-xml-schema-type) or $local-xml-schema-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;condition&quot; match=&quot;fdl:dataStructureMemberName&quot;', $eol, 'Parameter &quot;local-xml-schema-type&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-FDL-dataStructureMemberName">
        <xsl:with-param name="data-structure-member-name" select="current()"/>
        <xsl:with-param name="node" select="$activity"/>
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="local-xml-schema-type" select="$local-xml-schema-type"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="variable-name">
      <xsl:call-template name="find-variable-referenced-by-dataStructureMemberName">
        <xsl:with-param name="data-structure-member-name" select="current()"/>
        <xsl:with-param name="node" select="$activity"/>
        <xsl:with-param name="local-variable-name" select="concat($activity/@name, $output-variable-suffix)"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="primary-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($variable-name)"/>
    <!-- Get the first name component element of the "dotted" data structure name -->
    <xsl:variable name="first">
      <xsl:call-template name="find-start-index-for-parsing-a-dotted-name">
        <xsl:with-param name="dataStructureMemberName" select="current()"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="nameComponent" select="fdl:nameComponent[ position() = $first ]"/>
    <xsl:choose>
      <xsl:when test="$nameComponent">
        <xsl:variable name="translated-dataStructureMemberName">
          <!-- Create "xpath" code -->
          <xsl:call-template name="translate-dataStructureMemberName-to-XPath">
            <xsl:with-param name="display-name" select="$display-name"/>
            <xsl:with-param name="XMLSchemaType" select="$xml-schema-type"/>
            <xsl:with-param name="nameComponent" select="$nameComponent"/>
            <xsl:with-param name="FDL-location" select="fdl:fdlLoc"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="dataStructureMemberType" select="xalan:nodeset($translated-dataStructureMemberName)/bpws:dataStructureMemberName/@type"/>
        <dataStructureMemberName type="{$dataStructureMemberType}">
          <xsl:choose>
            <!-- CASE: interface-typed BPEL variables -->
            <xsl:when test="'INTERFACE' = $variable-type-mode">
              <xsl:copy-of select="concat('$', $variable-name, '.', $message-part-name, '/', $translated-dataStructureMemberName)"/>
            </xsl:when>
            <!-- OTHERWISE: data-typed BPEL variables assumed -->
            <xsl:otherwise>
              <xsl:copy-of select="concat('$', $primary-variable-name, '/', $translated-dataStructureMemberName)"/>
            </xsl:otherwise>
          </xsl:choose>
        </dataStructureMemberName>
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name="error" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'UnknownDataStructureMemberName', $fdlFileName, fdl:loc/@line,  fdl:loc/@column)"/>
        <dataStructureMemberName type="unknown">
          <xsl:value-of select="'&quot;***unknown data structure member name ***&quot;'"/>
        </dataStructureMemberName>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ************************************************************************************************
    Template "condition":

    "fdl:literal" found
    ************************************************************************************************
  -->
  <xsl:template match="fdl:literal" mode="condition">
    <xsl:choose>
      <xsl:when test="@isNull = 'true'">
        <literal isNull="{@isNull}"/>
      </xsl:when>
      <xsl:otherwise>
        <literal type="{@type}">
          <xsl:choose>
            <!-- CASE: STRING -->
            <xsl:when test="@type = 'string'">
              <xsl:value-of select="concat('&quot;', @value, '&quot;')" disable-output-escaping="yes"/>
            </xsl:when>
            <!-- CASE: BINARY -->
            <xsl:when test="@type = 'binary'">
              <xsl:value-of select="@value" disable-output-escaping="yes"/>
            </xsl:when>
            <!-- OTHERWISE -->
            <xsl:otherwise>
              <xsl:value-of select="@value" disable-output-escaping="yes"/>
            </xsl:otherwise>
          </xsl:choose>
        </literal>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ************************************************************************************************
    Template "condition":

    "fdl:state" found
    ************************************************************************************************
  -->
  <xsl:template match="fdl:state" mode="condition">
    <xsl:param name="FDL-location"/>
    <state>
      <xsl:choose>
        <!-- CASE: create "Java" condition -->
        <xsl:when test="'true' = $create_Java_conditions">
          <xsl:choose>
            <xsl:when test="@name ='_Finished' or @name ='_ForceFinished'">
              <xsl:value-of select="'ActivityInstanceData.STATE_FINISHED'" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:when test="@name ='_Skipped'">
              <xsl:value-of select="'ActivityInstanceData.STATE_SKIPPED'" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:when test="@name ='_Expired'">
              <xsl:value-of select="'ActivityInstanceData.STATE_EXPIRED'" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:variable name="error" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'UnsupportedActivityState', $fdlFileName, $FDL-location/@line, @name)"/>
              <xsl:value-of select="concat('&quot;UNSUPPORTED_ACTIVITY_STATE', @name, '&quot;')"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <!-- OTHERWISE: create "XPath" condition -->
        <xsl:otherwise>
          <xsl:choose>
            <xsl:when test="@name ='_Expired'">
              <xsl:value-of select="'&quot;expired&quot;'" disable-output-escaping="yes"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:variable name="error" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'UnsupportedActivityState', $fdlFileName, $FDL-location/@line, @name)"/>
              <xsl:value-of select="concat('&quot;UNSUPPORTED_ACTIVITY_STATE', @name, '&quot;')"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
    </state>
  </xsl:template>
  <!--
    ***************************************************************************************************************************************************
    Template "translate-dataStructureMemberName-to-XPath":

    Translates "fdl:dataStructureMemberName" to XPath location path.

    Parameter "current-location-path":  XPath location path expression recursively extended during each call of the template
                          (see explanation of example below)
    Parameter "XMLSchemaType":      XMLSchema type of current class member
    Parameter "nameComponent"      The current name component while recursively stepping through the dotted member name.

    Example:
    Assume a "dotted" FDL data structure member name:  'B1.C1[3].D1'
    Then the generated XPath location path will look like the following: '/B1/C1[4]/D1'
    (Note that an xpath array begins with 1, other than FDL arrays!)
    ***************************************************************************************************************************************************
  -->
  <xsl:template name="translate-dataStructureMemberName-to-XPath">
    <xsl:param name="display-name" select="''"/>
    <xsl:param name="current-location-path" select="''"/>
    <xsl:param name="XMLSchemaType"/>
    <xsl:param name="nameComponent"/>
    <xsl:param name="FDL-location"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($XMLSchemaType) or $XMLSchemaType = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-dataStructureMemberName-to-XPath&quot;', $eol, 'Parameter &quot;XMLSchemaType&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="XMLSchemaTypeDef" select="document($xsdfile)//xsd:complexType[concat('mqwf:', @name) = $XMLSchemaType]"/>
    <xsl:variable name="element-name" select="$nameComponent/@name"/>
    <xsl:variable name="XMLSchemaTypeDef-Element" select="$XMLSchemaTypeDef/xsd:sequence/xsd:element[ @name = $element-name ]"/>
    <xsl:choose>
      <!-- CASE: $nameComponent not empty -->
      <xsl:when test="$nameComponent">
        <xsl:variable name="element-index">
          <xsl:choose>
            <xsl:when test="$nameComponent/@index">
              <xsl:value-of select="$nameComponent/@index+1"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="''"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="index-expression">
          <xsl:choose>
            <xsl:when test="not($element-index = '')">
              <xsl:value-of select="concat('[', $element-index, ']')"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="''"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="location-step">
          <xsl:choose>
            <xsl:when test="$XMLSchemaTypeDef-Element">
              <xsl:value-of select="concat($XMLSchemaTypeDef-Element/@name, $index-expression)"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:variable name="error" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'IllegalDataPath', $fdlFileName, $FDL-location/@line, $FDL-location/@column, $display-name, $element-name)"/>
              <xsl:value-of select="concat('UNKNOWN_DATA_STRUCTURE_MEMBER_', $element-name, $index-expression)"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name="next-location-path">
          <xsl:choose>
            <xsl:when test="string-length($current-location-path) = 0">
              <xsl:value-of select="$location-step"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="concat($current-location-path, '/', $location-step)"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="substring($XMLSchemaTypeDef-Element/@type, 1,4) = 'mqwf'">
            <xsl:variable name="element-type" select="substring-after($XMLSchemaTypeDef-Element/@type, 'mqwf:')"/>
            <xsl:variable name="following-nameComponent" select="$nameComponent/following-sibling::fdl:nameComponent[1]"/>
            <xsl:choose>
              <xsl:when test="$following-nameComponent">
                <xsl:variable name="translated-xpath-dataStructureMemberName">
                  <xsl:call-template name="translate-dataStructureMemberName-to-XPath">
                    <xsl:with-param name="display-name" select="$display-name"/>
                    <xsl:with-param name="current-location-path" select="$next-location-path"/>
                    <xsl:with-param name="XMLSchemaType" select="concat('mqwf:', $element-type)"/>
                    <xsl:with-param name="nameComponent" select="$following-nameComponent"/>
                    <xsl:with-param name="FDL-location" select="$FDL-location"/>
                  </xsl:call-template>
                </xsl:variable>
                <!-- Return translated "dataStructureMemberName" to caller -->
                <xsl:copy-of select="xalan:nodeset($translated-xpath-dataStructureMemberName)/*"/>
              </xsl:when>
              <xsl:otherwise>
                <!-- Return translated "dataStructureMemberName" to caller -->
                <dataStructureMemberName type="{$element-type}">
                  <xsl:value-of select="$next-location-path"/>
                </dataStructureMemberName>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <!-- Return translated "dataStructureMemberName" to caller -->
            <xsl:variable name="element-type" select="substring-after($XMLSchemaTypeDef-Element/@type, 'xsd:')"/>
            <dataStructureMemberName type="{$element-type}">
              <xsl:value-of select="$next-location-path"/>
            </dataStructureMemberName>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- OTHERWISE: $nameComponent empty -->
      <xsl:otherwise>
        <!-- Determine element type -->
        <xsl:variable name="element-type">
          <xsl:choose>
            <xsl:when test="substring($XMLSchemaTypeDef-Element/@type, 1,4) = 'mqwf'">
              <xsl:value-of select="substring-after($XMLSchemaTypeDef-Element/@type, 'mqwf:')"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="substring-after($XMLSchemaTypeDef-Element/@type, 'xsd:')"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <!-- Return translated "dataStructureMemberName" to caller -->
        <dataStructureMemberName type="{$element-type}">
          <xsl:value-of select="'/'"/>
        </dataStructureMemberName>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "translate-description-and-documentation-fields":

    Translates the content of a description or documentation field.
        This includes the mapping of %-variables.
    Note that the length of the migrated text may change due to different syntax of the translated %-variables.
    If the text exceeds the maximum length, it will be cutt-off and the user will be informed by a warning.
    ****************************************************************************************************************
   -->
  <xsl:template name="translate-description-and-documentation-fields">
    <xsl:param name="node"/>
    <xsl:param name="display-name"/>
    <xsl:param name="variables"/>
    <xsl:param name="primary-input-variable-name"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($node)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-description-and-documentation-fields&quot;', $eol, 'Parameter &quot;node&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-description-and-documentation-fields&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-description-and-documentation-fields&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($primary-input-variable-name) or $primary-input-variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;translate-description-and-documentation-fields&quot;', $eol, 'Parameter &quot;primary-input-variable-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="is-process-description-or-documentation">
      <xsl:choose>
        <xsl:when test="local-name($node) = 'process'">
          <xsl:value-of select="true()"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="false()"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:if test="$node/fdl:description">
      <xsl:variable name="translated-description">
        <xsl:apply-templates select="$node/fdl:description" mode="copy-text-fields-with-context-variables">
          <xsl:with-param name="display-name" select="$display-name"/>
          <xsl:with-param name="node" select="$node"/>
          <xsl:with-param name="variables" select="$variables"/>
          <xsl:with-param name="local-variable-name" select="$primary-input-variable-name"/>
          <xsl:with-param name="is-process-description-or-documentation" select="$is-process-description-or-documentation"/>
        </xsl:apply-templates>
      </xsl:variable>
      <xsl:variable name="tailored-description">
        <xsl:call-template name="tailor-description-or-documentation-text">
          <xsl:with-param name="untailored-text" select="$translated-description"/>
          <xsl:with-param name="maximum-length" select="$maxDescriptionFieldLength"/>
        </xsl:call-template>
      </xsl:variable>
      <xsl:if test="string-length($translated-description) &gt; $maxDescriptionFieldLength">
        <!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $fdlFileName, $node/fdl:description/@line, $maxDescriptionFieldLength, $translated-description), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
      </xsl:if>
      <xsl:if test="string-length($tailored-description) &gt; 0">
        <wpc:description>
          <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
          <xsl:value-of select="$tailored-description" disable-output-escaping="yes"/>
          <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
        </wpc:description>
      </xsl:if>
    </xsl:if>
    <xsl:if test="$node/fdl:documentation">
      <xsl:variable name="translated-documentation">
        <xsl:apply-templates select="$node/fdl:documentation" mode="copy-text-fields-with-context-variables">
          <xsl:with-param name="display-name" select="$display-name"/>
          <xsl:with-param name="node" select="$node"/>
          <xsl:with-param name="variables" select="$variables"/>
          <xsl:with-param name="local-variable-name" select="$primary-input-variable-name"/>
          <xsl:with-param name="is-process-description-or-documentation" select="$is-process-description-or-documentation"/>
        </xsl:apply-templates>
      </xsl:variable>
      <xsl:variable name="tailored-documentation">
        <xsl:call-template name="tailor-description-or-documentation-text">
          <xsl:with-param name="untailored-text" select="$translated-documentation"/>
          <xsl:with-param name="maximum-length" select="$maxDocumentationFieldLength"/>
        </xsl:call-template>
      </xsl:variable>
      <xsl:if test="string-length($translated-documentation) &gt; $maxDocumentationFieldLength">
        <!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
        <xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $fdlFileName, $node/fdl:documentation/@line, $maxDocumentationFieldLength, $translated-documentation), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
      </xsl:if>
      <xsl:if test="string-length($tailored-documentation) &gt; 0">
        <wpc:documentation>
          <xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
          <xsl:value-of select="$tailored-documentation" disable-output-escaping="yes"/>
          <xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
        </wpc:documentation>
      </xsl:if>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
     Template "tailor-description-or-documentation-text":

    Tailors the text of a description or documentation to a predefined maximum length:
    When the "untailored text" does not exceed the limitation then the unchanged text is returned,
    otherwise the text is cut-off and appended by dot characters "...".
    Moreover, a warning is issued.
    *****************************************************************************************************************************
  -->
  <xsl:template name="tailor-description-or-documentation-text">
    <xsl:param name="untailored-text"/>
    <xsl:param name="maximum-length"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($untailored-text) or $untailored-text = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;tailor-description-or-documentation-text&quot;', $eol, 'Parameter &quot;untailored-text&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($maximum-length) or $maximum-length = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;tailor-description-or-documentation-text&quot;', $eol, 'Parameter &quot;maximum-length&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="string-length($untailored-text) &gt; $maximum-length">
        <xsl:value-of select="java:com.ibm.bpe.fdl2bpel.converter.FDL2XFDLVisitor.truncateTextWithContextVariables($untailored-text, $maximum-length)"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$untailored-text"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ***************************************************************************************************************************************************
    Template "copy-text-fields-with-context-variables":

    Copies the content of the description fields of an FDL activity, data or control connector to the output.
    Translates contained "context variables".
    ***************************************************************************************************************************************************
   -->
  <!--
     Initial template for the text copy operation
   -->
  <xsl:template match="fdl:description | fdl:documentation" mode="copy-text-fields-with-context-variables">
    <xsl:param name="display-name"/>
    <xsl:param name="node"/>
    <xsl:param name="variables"/>
    <xsl:param name="local-variable-name"/>
    <xsl:param name="is-process-description-or-documentation" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;copy-text-fields-with-context-variables&quot; match=&quot;fdl:description | fdl:documentation&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($node)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;copy-text-fields-with-context-variables&quot; match=&quot;fdl:description | fdl:documentation&quot;', $eol, 'Parameter &quot;node&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;copy-text-fields-with-context-variables&quot; match=&quot;fdl:description | fdl:documentation&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($local-variable-name) or $local-variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;copy-text-fields-with-context-variables&quot; match=&quot;fdl:description | fdl:documentation&quot;', $eol, 'Parameter &quot;local-variable-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:apply-templates mode="copy-text-fields-with-context-variables">
      <xsl:with-param name="display-name" select="$display-name"/>
      <xsl:with-param name="node" select="$node"/>
      <xsl:with-param name="variables" select="$variables"/>
      <xsl:with-param name="local-variable-name" select="$local-variable-name"/>
      <xsl:with-param name="is-process-description-or-documentation" select="$is-process-description-or-documentation"/>
    </xsl:apply-templates>
  </xsl:template>
  <!--
    This template copies any node to the output except for those that require "context variable" translation before.
     The template that matches a "context variable" follows below and executes with higher priority.
   -->
  <xsl:template match="node()" mode="copy-text-fields-with-context-variables">
    <xsl:param name="display-name"/>
    <xsl:param name="node"/>
    <xsl:param name="variables"/>
    <xsl:param name="local-variable-name"/>
    <xsl:param name="is-process-description-or-documentation" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;copy-text-fields-with-context-variables&quot; match=&quot;node()&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($node)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;copy-text-fields-with-context-variables&quot; match=&quot;node()&quot;', $eol, 'Parameter &quot;node&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;copy-text-fields-with-context-variables&quot; match=&quot;node()&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($local-variable-name) or $local-variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;copy-text-fields-with-context-variables&quot; match=&quot;node()&quot;', $eol, 'Parameter &quot;local-variable-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:copy>
      <xsl:apply-templates mode="copy-text-fields-with-context-variables">
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="node" select="$node"/>
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="local-variable-name" select="$local-variable-name"/>
        <xsl:with-param name="is-process-description-or-documentation" select="$is-process-description-or-documentation"/>
      </xsl:apply-templates>
    </xsl:copy>
  </xsl:template>
  <!--
     Template that matches a "context variable" (represented by "fdl:dataStructureMemberName")
   -->
  <xsl:template match="fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
    <xsl:param name="display-name"/>
    <xsl:param name="node"/>
    <xsl:param name="variables"/>
    <xsl:param name="local-variable-name"/>
    <xsl:param name="is-process-description-or-documentation" select="false()"/>
    <xsl:param name="FDL-location"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($display-name) or $display-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;copy-text-fields-with-context-variables&quot; match=&quot;fdl:dataStructureMemberName&quot;', $eol, 'Parameter &quot;display-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($node)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;copy-text-fields-with-context-variables&quot; match=&quot;fdl:dataStructureMemberName&quot;', $eol, 'Parameter &quot;node&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;copy-text-fields-with-context-variables&quot; match=&quot;fdl:dataStructureMemberName&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($local-variable-name) or $local-variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;copy-text-fields-with-context-variables&quot; match=&quot;fdl:dataStructureMemberName&quot;', $eol, 'Parameter &quot;local-variable-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="actual-FDL-location">
      <xsl:choose>
        <xsl:when test="fdl:fdlLoc">
          <xsl:copy-of select="fdl:fdlLoc"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:copy-of select="$FDL-location"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="local-xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-BPEL-variable">
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="variable-name" select="$local-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="xml-schema-type">
      <xsl:call-template name="xml-schema-type-of-FDL-dataStructureMemberName">
        <xsl:with-param name="data-structure-member-name" select="current()"/>
        <xsl:with-param name="node" select="$node"/>
        <xsl:with-param name="variables" select="$variables"/>
        <xsl:with-param name="local-xml-schema-type" select="$local-xml-schema-type"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="variable-name">
      <xsl:call-template name="find-variable-referenced-by-dataStructureMemberName">
        <xsl:with-param name="data-structure-member-name" select="current()"/>
        <xsl:with-param name="node" select="$node"/>
        <xsl:with-param name="local-variable-name" select="$local-variable-name"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="primary-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($variable-name)"/>
    <!-- Get the first name component element of the "dotted" data structure name -->
    <xsl:variable name="first">
      <xsl:call-template name="find-start-index-for-parsing-a-dotted-name">
        <xsl:with-param name="dataStructureMemberName" select="current()"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="translated-dataStructureMemberName">
      <xsl:call-template name="translate-dataStructureMemberName-to-XPath">
        <xsl:with-param name="display-name" select="$display-name"/>
        <xsl:with-param name="XMLSchemaType" select="$xml-schema-type"/>
        <xsl:with-param name="nameComponent" select="current()/fdl:nameComponent[ position() = $first ]"/>
        <xsl:with-param name="FDL-location" select="xalan:nodeset($actual-FDL-location)/*"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="translated-dataStructureMemberName-could-not-be-resolved">
      <xsl:choose>
        <xsl:when test="contains($translated-dataStructureMemberName, 'UNKNOWN_DATA_STRUCTURE_MEMBER')">
          <xsl:value-of select="'true'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'false'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- Ensure that the XPath expression has no leading forward slash (not allowed in context variables) -->
    <xsl:variable name="translated-dataStructureMemberName_without_leading_forward_slash">
      <xsl:choose>
        <xsl:when test="substring(xalan:nodeset($translated-dataStructureMemberName)/*, 1, 1) = '/'">
          <xsl:value-of select="substring-after(xalan:nodeset($translated-dataStructureMemberName)/*, '/')"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="xalan:nodeset($translated-dataStructureMemberName)/*"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:if test="'true' = $translated-dataStructureMemberName-could-not-be-resolved">
      <xsl:value-of select="' *** Adjust the following incorrect expression *** '" disable-output-escaping="yes"/>
    </xsl:if>
    <xsl:choose>
      <!-- CASE: interface-typed BPEL variables -->
      <xsl:when test="'INTERFACE' = $variable-type-mode">
        <xsl:value-of select="concat('%', $primary-variable-name, '\', $message-part-name, '\', $translated-dataStructureMemberName_without_leading_forward_slash, '%')"/>
      </xsl:when>
      <!-- OTHERWISE: data-typed BPEL variables assumed -->
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$is-process-description-or-documentation = 'true'">
            <xsl:value-of select="concat('%\\', $element-input-name,'/', $translated-dataStructureMemberName_without_leading_forward_slash, '%')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="concat('%', $primary-variable-name, '\\', $translated-dataStructureMemberName_without_leading_forward_slash, '%')"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
     Template "tailor-display-name":

    Tailors the display-name to a predefined maximum length:
    When the "untailored diplay name" does not exceed the limitation then the unchanged name is returned,
    otherwise the name is cut-off and appended by dot characters "..."
    *****************************************************************************************************************************
  -->
  <xsl:template name="tailor-display-name">
    <xsl:param name="untailored-display-name"/>
    <xsl:choose>
      <xsl:when test="string-length($untailored-display-name) &gt; $maxDisplayNameLength">
        <xsl:value-of select="concat(substring($untailored-display-name, 1, $maxDisplayNameLength - 3), '...')"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$untailored-display-name"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "xml-schema-type-of-FDL-dataStructureMemberName":

    Determines the XMLSchema type that is assigned to an FDL datastructure membername.
    ****************************************************************************************************************
   -->
  <xsl:template name="xml-schema-type-of-FDL-dataStructureMemberName">
    <xsl:param name="data-structure-member-name"/>
    <xsl:param name="node"/>
    <xsl:param name="variables"/>
    <xsl:param name="local-xml-schema-type"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($data-structure-member-name)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;xml-schema-type-of-FDL-dataStructureMemberName&quot;', $eol, 'Parameter &quot;data-structure-member-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:if test="not($node)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;xml-schema-type-of-FDL-dataStructureMemberName&quot;', $eol, 'Parameter &quot;node&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;xml-schema-type-of-FDL-dataStructureMemberName&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($local-xml-schema-type) or $local-xml-schema-type = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;xml-schema-type-of-FDL-dataStructureMemberName&quot;', $eol, 'Parameter &quot;local-xml-schema-type&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="@scope">
        <xsl:choose>
          <xsl:when test="@scope = '_BLOCK'">
            <xsl:variable name="scope-activity-name">
              <xsl:choose>
                <!-- CASE: Parent is a "block" -->
                <xsl:when test="local-name($node/..) = 'blockImplementation'">
                  <xsl:value-of select="$node/../../@name"/>
                </xsl:when>
                <!-- OTHERWISE: Assume that parent is a "process" -->
                <xsl:otherwise>
                  <xsl:value-of select="$node/../@name"/>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <xsl:variable name="from-variable-name" select="concat($scope-activity-name, $input-variable-suffix)"/>
            <xsl:variable name="primary-from-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($from-variable-name)"/>
            <xsl:variable name="from-xml-schema-type">
              <xsl:call-template name="xml-schema-type-of-BPEL-variable">
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="variable-name" select="$primary-from-variable-name"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:value-of select="$from-xml-schema-type"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:variable name="scope-activity-name" select="$node/../*[ ( local-name() = 'programActivity' or local-name() = 'processActivity' or local-name() = 'block' ) and current()/@scope = @name ][1]/@name"/>
            <xsl:variable name="from-variable-name" select="concat($scope-activity-name, $output-variable-suffix)"/>
            <xsl:variable name="primary-from-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($from-variable-name)"/>
            <xsl:variable name="from-xml-schema-type">
              <xsl:call-template name="xml-schema-type-of-BPEL-variable">
                <xsl:with-param name="variables" select="$variables"/>
                <xsl:with-param name="variable-name" select="$primary-from-variable-name"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:value-of select="$from-xml-schema-type"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$local-xml-schema-type"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "xml-schema-type-of-BPEL-variable":

    Determines the XMLSchema type that is assigned to a BPEL variable.

        The template works independantly from the used definition style, which means that a BPEL variable
        may have either a "type" attribute or a "messageType" attribute or an "element" attribute.
    ****************************************************************************************************************
   -->
  <xsl:template name="xml-schema-type-of-BPEL-variable">
    <xsl:param name="variables"/>
    <xsl:param name="variable-name"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variables)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;xml-schema-type&quot;', $eol, 'Parameter &quot;variables&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($variable-name) or $variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;xml-schema-type&quot;', $eol, 'Parameter &quot;variable-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="xml-schema-type" select="$variables//bpws:variable[@name = $variable-name]/@type"/>
    <xsl:variable name="wsdl-message-name">
      <xsl:if test="not($xml-schema-type)">
        <xsl:value-of select="$variables//bpws:variable[@name = $variable-name]/@messageType"/>
      </xsl:if>
    </xsl:variable>
    <xsl:variable name="xml-schema-element-name1">
      <xsl:if test="not($wsdl-message-name)">
        <xsl:value-of select="$variables//bpws:variable[@name = $variable-name]/@element"/>
      </xsl:if>
    </xsl:variable>
    <xsl:choose>
      <!-- CASE: BPEL variable use a "type" attribute -->
      <xsl:when test="$xml-schema-type">
        <xsl:value-of select="$xml-schema-type"/>
      </xsl:when>
      <!-- CASE: BPEL variable use a "messageType" attribute -->
      <xsl:when test="wsdl-message-name">
        <xsl:variable name="wsdl-message-part" select="document($wsdlfile)//wsdl:message[ concat('wsdl1:', @name) = $wsdl-message-name ]/wsdl:part[ @name = $message-part-name ]"/>
        <xsl:choose>
          <!-- CASE: WSDL message part found -->
          <xsl:when test="$wsdl-message-part">
            <xsl:variable name="xml-schema-element-name2" select="$wsdl-message-part/@type"/>
            <xsl:variable name="xml-schema-element" select="document($wsdlfile)//wsdl:types/xsd:schema/xsd:element[ concat('mqwf:', @name) = $xml-schema-element-name2 ]"/>
            <xsl:choose>
              <!-- CASE: WSDL message part found -->
              <xsl:when test="$xml-schema-element">
                <xsl:variable name="doclit-wrapper-type" select="$xml-schema-element/xsd:complexType/xsd:sequence/xsd:element/@type"/>
                <xsl:choose>
                  <!-- CASE: WSDL message part found -->
                  <xsl:when test="doclit-wrapper-type">
                    <xsl:value-of select="$doclit-wrapper-type"/>
                  </xsl:when>
                  <!-- OTHERWISE: XMLSchema element not well formed according to Doc/Lit Wrapper style  -->
                  <xsl:otherwise>
                    <xsl:variable name="error-message-text" select="concat('ASSERTION FAILED in template &quot;xml-schema-type&quot;: XMLSchema element &quot;', $xml-schema-element-name2, '&quot; is not well formed according to the &quot;Doc/Lit Wrapper&quot; style (BPEL variable &quot;', $variable-name, '&quot;)')"/>
                    <xsl:variable name="error-message" select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message-text), ' *** ')"/>
                    <xsl:value-of select="'*** illegal type ***'"/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <!-- OTHERWISE: XMLSchema element not found  -->
              <xsl:otherwise>
                <xsl:variable name="error-message-text" select="concat('ASSERTION FAILED in template &quot;xml-schema-type&quot;: XMLSchema element &quot;', $xml-schema-element-name2, '&quot; not found (BPEL variable &quot;', $variable-name, '&quot;)')"/>
                <xsl:variable name="error-message" select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message-text), ' *** ')"/>
                <xsl:value-of select="'*** illegal type ***'"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <!-- OTHERWISE: WSDL message part not found  -->
          <xsl:otherwise>
            <xsl:variable name="error-message-text" select="concat('ASSERTION FAILED in template &quot;xml-schema-type&quot;: WSDL message &quot;', $wsdl-message-name, '&quot; has no part &quot;', $message-part-name, '&quot; (BPEL variable &quot;', $variable-name, '&quot;)')"/>
            <xsl:variable name="error-message" select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message-text), ' *** ')"/>
            <xsl:value-of select="'*** illegal type ***'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- CASE: BPEL variable use an "element" attribute -->
      <xsl:when test="$xml-schema-element-name1">
        <xsl:value-of select="$xml-schema-element-name1"/>
      </xsl:when>
      <!-- OTHERWISE: no appropriate attribute found -->
      <xsl:otherwise>
        <xsl:variable name="error-message-text" select="concat('ASSERTION FAILED in template &quot;xml-schema-type&quot;: BPEL variable &quot;', $variable-name, '&quot; has no attribute &quot;type&quot; or &quot;messageType&quot; or &quot;element&quot;')"/>
        <xsl:variable name="error-message" select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message-text), ' *** ')"/>
        <xsl:value-of select="'*** illegal type ***'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ************************************************************************************************
    Template "find-variable-referenced-by-dataStructureMemberName":

    Find the name of the variable that is referenced by a datastructure membername.
    ************************************************************************************************
  -->
  <xsl:template name="find-variable-referenced-by-dataStructureMemberName">
    <xsl:param name="data-structure-member-name"/>
    <xsl:param name="node"/>
    <xsl:param name="local-variable-name"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($data-structure-member-name)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;find-variable-referenced-by-dataStructureMemberName&quot;', $eol, 'Parameter &quot;data-structure-member-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:if test="not($node)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;find-variable-referenced-by-dataStructureMemberName&quot;', $eol, 'Parameter &quot;node&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($local-variable-name) or $local-variable-name = ''">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;find-variable-referenced-by-dataStructureMemberName&quot;', $eol, 'Parameter &quot;local-variable-name&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="@scope">
        <xsl:choose>
          <xsl:when test="@scope = '_BLOCK'">
            <xsl:variable name="scope-activity-name">
              <xsl:choose>
                <!-- CASE: Parent is a "block" -->
                <xsl:when test="local-name($node/..) = 'blockImplementation'">
                  <xsl:value-of select="$node/../../@name"/>
                </xsl:when>
                <!-- OTHERWISE: Assume that parent is a "process" -->
                <xsl:otherwise>
                  <xsl:value-of select="$node/../@name"/>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <xsl:value-of select="concat($scope-activity-name, $input-variable-suffix)"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:variable name="scope-activity-name" select="$node/../*[ ( local-name() = 'programActivity' or local-name() = 'processActivity' or local-name() = 'block' ) and current()/@scope = @name ][1]/@name"/>
            <xsl:value-of select="concat($scope-activity-name, $output-variable-suffix)"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$local-variable-name"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ************************************************************************************************
    Template "find-start-index-for-parsing-a-dotted-name"

    Find the start index (first "fdl:nameComponent") when parsing the XFDL representation
    of a dotted name.
    ************************************************************************************************
  -->
  <xsl:template name="find-start-index-for-parsing-a-dotted-name">
    <xsl:param name="dataStructureMemberName"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($dataStructureMemberName)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;find-start-index-for-parsing-a-dotted-name&quot;', $eol, 'Parameter &quot;dataStructureMemberName&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:choose>
      <!-- CASE: Option "-pn" ("Do not create predefined data members in BPEL") is NOT set -->
      <xsl:when test="'true' = $createPredefinedDataMembers">
        <xsl:value-of select="1"/>
      </xsl:when>
      <!-- OTHERWISE: Option "-pn" ("Do not create predefined data members in BPEL") is set -->
      <xsl:otherwise>
        <xsl:choose>
          <!-- CASE: First "fdl:nameComponent" is "_STRUCT": Begin parsing of the "dotted name" after the "_STRUCT" element.-->
          <xsl:when test="$dataStructureMemberName/fdl:nameComponent[1]/@name = '_STRUCT'">
            <xsl:value-of select="2"/>
          </xsl:when>
          <!-- OTHERWISE: First "fdl:nameComponent" is not "_STRUCT": Begin parsing of the "dotted name" from position()=1 -->
          <xsl:otherwise>
            <xsl:value-of select="1"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    Template "activity-name-prefix":

    Determines name prefix of a given FDL program activity.
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:process" mode="activity-name-prefix">
    <xsl:param name="activity"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;activity-name-prefix&quot; match=&quot;fdl:process&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="fdl:programActivity[ generate-id() = generate-id($activity) ]">
        <xsl:value-of select="''"/>
      </xsl:when>
      <xsl:when test="fdl:processActivity[ generate-id() = generate-id($activity) ]">
        <xsl:value-of select="''"/>
      </xsl:when>
      <xsl:when test="fdl:block[ generate-id() = generate-id($activity) ]">
        <xsl:value-of select="''"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates select="fdl:block" mode="activity-name-prefix">
          <xsl:with-param name="activity" select="$activity"/>
        </xsl:apply-templates>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="fdl:block" mode="activity-name-prefix">
    <xsl:param name="activity"/>
    <xsl:param name="name-prefix" select="''"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: mode=&quot;activity-name-prefix&quot; match=&quot;fdl:block&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="next-name-prefix" select="concat($name-prefix,  @name, '.')"/>
    <xsl:choose>
      <xsl:when test="fdl:blockImplementation/fdl:programActivity[ generate-id() = generate-id($activity) ]">
        <xsl:value-of select="$next-name-prefix"/>
      </xsl:when>
      <xsl:when test="fdl:blockImplementation/fdl:processActivity[ generate-id() = generate-id($activity) ]">
        <xsl:value-of select="$next-name-prefix"/>
      </xsl:when>
      <xsl:when test="fdl:blockImplementation/fdl:block[ generate-id() = generate-id($activity) ]">
        <xsl:value-of select="$next-name-prefix"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates select="fdl:blockImplementation/fdl:block" mode="activity-name-prefix">
          <xsl:with-param name="activity" select="$activity"/>
          <xsl:with-param name="name-prefix" select="$next-name-prefix"/>
        </xsl:apply-templates>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    Template "register-alias-names-for-variables":

    Registers alias names for shared BPEL variables inside of an FDL block activity
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:block" mode="register-alias-names-for-variables">
    <xsl:apply-templates select="fdl:blockImplementation" mode="register-alias-names-for-SOURCE-variable"/>
    <xsl:apply-templates select="fdl:blockImplementation" mode="register-alias-names-for-SINK-variable"/>
    <!-- Register alias names for fdl:blockImplementation -->
    <xsl:apply-templates select="fdl:blockImplementation" mode="register-alias-names-for-variables"/>
  </xsl:template>
  <xsl:template match="fdl:blockImplementation" mode="register-alias-names-for-variables">
    <xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="register-alias-names-for-activity-input-variable"/>
    <xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="register-alias-names-for-activity-output-variable"/>
    <!-- Register alias names for fdl:block found within fdl:blockImplementation -->
    <xsl:apply-templates select="fdl:block" mode="register-alias-names-for-variables"/>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    Template "register-alias-names-for-activity-input-variable":

    Register output variable as alias name in case of a default data connector:
      If the output variable has no default data settings then register it as alias name of the input variable.

    Register alias names in case of inbound data connectors:
      If the input variable of the current activity is "shareable" then register the output variable names of all
      source activities as "alias names".
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:programActivity | fdl:processActivity | fdl:block" mode="register-alias-names-for-activity-input-variable">
    <xsl:variable name="input-variable-name" select="concat(@name, $input-variable-suffix)"/>
    <xsl:variable name="primary-input-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($input-variable-name)"/>
    <xsl:variable name="output-variable-name" select="concat(@name, $output-variable-suffix)"/>
    <xsl:variable name="output-variable-is-shared" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.isShared($output-variable-name)"/>
    <!--
        Register output variable as alias name in case of a default data connector
        provided that it is a STRUCT-TO-STRUCT data mapping style
        and that there are no initial data settings on the output container
    -->
    <xsl:variable name="default-data-connector" select="key('default-data-connectors-by-activity-name', @name)"/>
    <xsl:if test="'false' = $output-variable-is-shared
              and not($primary-input-variable-name = $output-variable-name)
              and $default-data-connector
              and ( ( key('data-connector-with-STRUCT-TO-STRUCT-mapping-by-id', generate-id($default-data-connector))
                      and ( 'false' = $createPredefinedDataMembers
                            or 'true' = $option_ip
                          )
                    )
                  or key('data-connector-with-CONTAINER-TO-CONTAINER-mapping-by-id', generate-id($default-data-connector))
                  )
              and ( not(fdl:output/fdl:dataDefaults) or 'true' = $option_id )">
      <xsl:variable name="joinVariableNames" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.joinVariableNames($primary-input-variable-name, $output-variable-name)"/>
    </xsl:if>
    <!--
        Register alias names in case of inbound data connectors
    -->
    <xsl:variable name="receiving-from-activities" select="current()/../fdl:programActivity[ key('outDataConnByName', @name)[ @to = current()/@name ] ]
                                   | current()/../fdl:processActivity[ key('outDataConnByName', @name)[ @to = current()/@name ] ]
                                   | current()/../fdl:block[ key('outDataConnByName', @name)[ @to = current()/@name ] ]"/>
    <xsl:variable name="activity-input-variable-is-shareable">
      <xsl:call-template name="target-variable-is-shareable">
        <xsl:with-param name="receiving-from-activities" select="$receiving-from-activities"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:if test="$activity-input-variable-is-shareable = 'true'">
      <xsl:for-each select="$receiving-from-activities">
        <xsl:variable name="current-output-variable-name" select="concat(current()/@name, $output-variable-suffix)"/>
        <xsl:variable name="current-output-variable-is-shared" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.isShared($current-output-variable-name)"/>
        <xsl:if test="'false' = $current-output-variable-is-shared
                  and not($primary-input-variable-name = $current-output-variable-name)">
          <xsl:variable name="joinVariableNames" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.joinVariableNames($primary-input-variable-name, $current-output-variable-name)"/>
        </xsl:if>
      </xsl:for-each>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    Template "register-alias-names-for-activity-output-variable":


    Register input variable as alias name in case of a loop data connector:
      If the input variable has no default data settings then register it as alias name of the output variable.

    Register alias names in case of outbound data connectors:
      If the output variable of the current activity is "shareable" then register the input variable names of all
      target activities as "alias names".
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:programActivity | fdl:processActivity | fdl:block" mode="register-alias-names-for-activity-output-variable">
    <xsl:variable name="input-variable-name" select="concat(@name, $input-variable-suffix)"/>
    <xsl:variable name="input-variable-is-shared" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.isShared($input-variable-name)"/>
    <xsl:variable name="output-variable-name" select="concat(@name, $output-variable-suffix)"/>
    <xsl:variable name="primary-output-variable-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName($output-variable-name)"/>
    <!--
        Register input variable as alias name in case of a loop data connector
        provided that it is a STRUCT-TO-STRUCT data mapping style
        and that there are no initial data settings on the input container
    -->
    <xsl:variable name="loop-data-connector" select="key('loop-data-connectors-by-activity-name', @name)"/>
    <xsl:if test="'false' = $input-variable-is-shared
              and not($primary-output-variable-name = $input-variable-name)
              and $loop-data-connector
              and ( ( key('data-connector-with-STRUCT-TO-STRUCT-mapping-by-id', generate-id($loop-data-connector))
                      and ( 'false' = $createPredefinedDataMembers
                            or 'true' = $option_ip
                          )
                    )
                  or key('data-connector-with-CONTAINER-TO-CONTAINER-mapping-by-id', generate-id($loop-data-connector))
                  )
              and ( not(fdl:input/fdl:dataDefaults) or 'true' = $option_id )">
      <xsl:variable name="joinVariableNames" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.joinVariableNames($primary-output-variable-name, $input-variable-name)"/>
    </xsl:if>
    <!--
        Register alias names in case of outbound data connectors
    -->
    <xsl:variable name="sending-to-activities" select="current()/../fdl:programActivity[ key('inDataConnByName', @name)[ @from = current()/@name ] ]
                                  | current()/../fdl:processActivity[ key('inDataConnByName', @name)[ @from = current()/@name ] ]
                                  | current()/../fdl:block[ key('inDataConnByName', @name)[ @from = current()/@name ] ]"/>
    <xsl:variable name="activity-output-variable-is-shareable">
      <xsl:call-template name="source-variable-is-shareable">
        <xsl:with-param name="sending-to-activities" select="$sending-to-activities"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:if test="$activity-output-variable-is-shareable = 'true'">
      <xsl:for-each select="$sending-to-activities">
        <xsl:variable name="current-input-variable-name" select="concat(current()/@name, $input-variable-suffix)"/>
        <xsl:variable name="current-input-variable-is-shared" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.isShared($current-input-variable-name)"/>
        <xsl:if test="'false' = $current-input-variable-is-shared
                  and not($primary-output-variable-name = $current-input-variable-name)">
          <xsl:variable name="joinVariableNames" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.joinVariableNames($primary-output-variable-name, $current-input-variable-name)"/>
        </xsl:if>
      </xsl:for-each>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    Template "register-alias-names-for-SOURCE-variable":

    If the SOURCE variable of the current process or block is "shareable" then register the input variable names of all
        target activities as "alias names".
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:process | fdl:blockImplementation" mode="register-alias-names-for-SOURCE-variable">
    <xsl:variable name="sending-to-activities" select="current()/fdl:programActivity[ key('inDataConnByName', @name)[ @from = current()/fdl:input/@name ] ]
                                   | current()/fdl:processActivity[ key('inDataConnByName', @name)[ @from = current()/fdl:input/@name ] ]
                                   | current()/fdl:block[ key('inDataConnByName', @name)[ @from = current()/fdl:input/@name ] ]"/>
    <xsl:variable name="SOURCE-is-shareable">
      <xsl:call-template name="source-variable-is-shareable">
        <xsl:with-param name="sending-to-activities" select="$sending-to-activities"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:if test="$SOURCE-is-shareable = 'true'">
      <xsl:variable name="primary-SOURCE-variable-name">
        <xsl:choose>
          <!-- CASE: current node is a "process" -->
          <xsl:when test="local-name(current()) = 'process'">
            <xsl:value-of select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName(concat(current()/@name, $input-variable-suffix))"/>
          </xsl:when>
          <!-- OTHERWISE: current node is a "blockImplementation" -->
          <xsl:otherwise>
            <xsl:value-of select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName(concat(current()/../@name, $input-variable-suffix))"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:for-each select="$sending-to-activities">
        <xsl:variable name="current-input-variable-name" select="concat(current()/@name, $input-variable-suffix)"/>
        <xsl:variable name="current-input-variable-is-shared" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.isShared($current-input-variable-name)"/>
        <xsl:if test="'false' = $current-input-variable-is-shared
                  and not($primary-SOURCE-variable-name = $current-input-variable-name)">
          <xsl:variable name="joinVariableNames" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.joinVariableNames($primary-SOURCE-variable-name, $current-input-variable-name)"/>
        </xsl:if>
      </xsl:for-each>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    Template "register-alias-names-for-SINK-variable":

    If the SINK variable of the current process or block is "shareable" then register the output variable names of all
        source activities as "alias names".
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:process | fdl:blockImplementation" mode="register-alias-names-for-SINK-variable">
    <xsl:variable name="receiving-from-activities" select="current()/fdl:programActivity[ key('outDataConnByName', @name)[ @to = current()/fdl:output/@name ] ]
                                   | current()/fdl:processActivity[ key('outDataConnByName', @name)[ @to = current()/fdl:output/@name ] ]
                                   | current()/fdl:block[ key('outDataConnByName', @name)[ @to = current()/fdl:output/@name ] ]"/>
    <xsl:variable name="SINK-is-shareable">
      <xsl:call-template name="target-variable-is-shareable">
        <xsl:with-param name="receiving-from-activities" select="$receiving-from-activities"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:if test="$SINK-is-shareable = 'true'">
      <xsl:variable name="primary-SINK-variable-name">
        <xsl:choose>
          <!-- CASE: current node is a "process" -->
          <xsl:when test="local-name(current()) = 'process'">
            <xsl:value-of select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName(concat(current()/@name, $output-variable-suffix))"/>
          </xsl:when>
          <!-- OTHERWISE: current node is a "blockImplementation" -->
          <xsl:otherwise>
            <xsl:value-of select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName(concat(current()/../@name, $output-variable-suffix))"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:for-each select="$receiving-from-activities">
        <xsl:variable name="current-output-variable-name" select="concat(current()/@name, $output-variable-suffix)"/>
        <xsl:variable name="current-output-variable-is-shared" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.isShared($current-output-variable-name)"/>
        <xsl:if test="'false' = $current-output-variable-is-shared
                  and not($primary-SINK-variable-name = $current-output-variable-name)">
          <xsl:variable name="joinVariableNames" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.joinVariableNames($primary-SINK-variable-name, $current-output-variable-name)"/>
        </xsl:if>
      </xsl:for-each>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    Template "register-alias-names-for-GLOBAL_CONTAINER-variable":

    If the GLOBAL_CONTAINER variable of the current process is "shareable" then register the output variable names of all
        activities that write data into the GLOBAL_CONTAINER variable as "alias names".
    *****************************************************************************************************************************
   -->
  <xsl:template match="fdl:process" mode="register-alias-names-for-GLOBAL_CONTAINER-variable">
    <xsl:variable name="receiving-from-activities" select="current()//fdl:programActivity[ key('outDataConnByName', @name)[ @to = 'GLOBAL_CONTAINER' ] ]
                                   | current()//fdl:processActivity[ key('outDataConnByName', @name)[ @to = 'GLOBAL_CONTAINER' ] ]
                                   | current()//fdl:block[ key('outDataConnByName', @name)[ @to = 'GLOBAL_CONTAINER' ] ]"/>
    <xsl:variable name="GLOBAL_CONTAINER-is-shareable">
      <xsl:call-template name="target-variable-is-shareable">
        <xsl:with-param name="receiving-from-activities" select="$receiving-from-activities"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:if test="$GLOBAL_CONTAINER-is-shareable = 'true'">
      <xsl:variable name="primary-global-container-name" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.getPrimaryName('GLOBAL_CONTAINER')"/>
      <xsl:for-each select="$receiving-from-activities">
        <xsl:variable name="current-output-variable-name" select="concat(current()/@name, $output-variable-suffix)"/>
        <xsl:variable name="current-output-variable-is-shared" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.isShared($current-output-variable-name)"/>
        <xsl:if test="'false' = $current-output-variable-is-shared
                  and not($primary-global-container-name = $current-output-variable-name)">
          <xsl:variable name="joinVariableNames" select="java:com.ibm.bpe.fdl2bpel.converter.AliasTable.joinVariableNames($primary-global-container-name, $current-output-variable-name)"/>
        </xsl:if>
      </xsl:for-each>
    </xsl:if>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    "source-variable-is-shareable" template:

    Determines whether the source variable of a data flow is shareable.
    That is check whether all "to" activities satisfy the criteria of receiving their input from a shared BPEL variable
    (cp. template "activity-can-receive-input-from-shared-variable").
    *****************************************************************************************************************************
   -->
  <xsl:template name="source-variable-is-shareable">
    <xsl:param name="sending-to-activities"/>
    <xsl:variable name="all-to-activities-can-receive-input-from-shared-variable">
      <xsl:for-each select="$sending-to-activities">
        <xsl:call-template name="activity-can-receive-input-from-shared-variable">
          <xsl:with-param name="activity" select="current()"/>
          <xsl:with-param name="sending-to-activities" select="$sending-to-activities"/>
        </xsl:call-template>
      </xsl:for-each>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="contains($all-to-activities-can-receive-input-from-shared-variable, 'true')
                         and not(contains($all-to-activities-can-receive-input-from-shared-variable, 'false'))">
        <xsl:value-of select="true()"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="false()"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    Template "target-variable-is-shareable":

    Determines whether the target variable of a data flow is shareable.
    That is check whether all "from" activities satisfy the criteria of sending their output to a shared BPEL variable
        (cp. template "activity-can-send-output-to-shared-variable").
    *****************************************************************************************************************************
   -->
  <xsl:template name="target-variable-is-shareable">
    <xsl:param name="receiving-from-activities"/>
    <xsl:variable name="all-from-activities-can-send-output-to-shared-variable">
      <xsl:for-each select="$receiving-from-activities">
        <xsl:call-template name="activity-can-send-output-to-shared-variable">
          <xsl:with-param name="activity" select="current()"/>
          <xsl:with-param name="receiving-from-activities" select="$receiving-from-activities"/>
        </xsl:call-template>
      </xsl:for-each>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="contains($all-from-activities-can-send-output-to-shared-variable, 'true')
                         and not(contains($all-from-activities-can-send-output-to-shared-variable, 'false'))">
        <xsl:value-of select="true()"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="false()"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    Template "activity-can-receive-input-from-shared-variable":

    Determines whether an activity satifies the following criteria of receiving input from a shared BPEL variable:

    CASE: count($sending-to-activities) = 0

      'false'

    CASE: count($sending-to-activities) = 1

      1) Single inbound data connector
        2) _STRUCT TO _STRUCT data mapping style
      3) No default data values assigned to the activity input

    CASE: count($sending-to-activities) > 1

      1) Single inbound data connector
        2) _STRUCT TO _STRUCT data mapping style
      3) No loop data connector to the activity
      4) No default data connector to the activity
      5) No default data values assigned to the activity input
            6) No data flow path connecting the target activities
    *****************************************************************************************************************************
   -->
  <xsl:template name="activity-can-receive-input-from-shared-variable">
    <xsl:param name="activity"/>
    <xsl:param name="sending-to-activities"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;activity-can-receive-input-from-shared-variable&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="inbound-data-connectors" select="key('inDataConnByName', $activity/@name)"/>
    <xsl:choose>
      <!-- CASE: no target activity -->
      <xsl:when test="count($sending-to-activities) = 0">
        <xsl:value-of select="false()"/>
      </xsl:when>
      <!-- CASE: exactly one target activity -->
      <xsl:when test="count($sending-to-activities) = 1">
        <xsl:choose>
          <xsl:when test="count($inbound-data-connectors) = 1
                and ( ( key('data-connector-with-STRUCT-TO-STRUCT-mapping-by-id', generate-id($inbound-data-connectors[1]))
                        and ( 'false' = $createPredefinedDataMembers
                              or 'true' = $option_ip
                            )
                      )
                    or key('data-connector-with-CONTAINER-TO-CONTAINER-mapping-by-id', generate-id($inbound-data-connectors[1]))
                    )
                and ( not($activity/fdl:input/fdl:dataDefaults) or 'true' = $option_id )">
            <xsl:value-of select="true()"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="false()"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- CASE: more than one target activity -->
      <xsl:when test="count($sending-to-activities) &gt; 1">
        <xsl:choose>
          <xsl:when test="count($inbound-data-connectors) = 1
                and ( ( key('data-connector-with-STRUCT-TO-STRUCT-mapping-by-id', generate-id($inbound-data-connectors[1]))
                        and ( 'false' = $createPredefinedDataMembers
                              or 'true' = $option_ip
                            )
                      )
                    or key('data-connector-with-CONTAINER-TO-CONTAINER-mapping-by-id', generate-id($inbound-data-connectors[1]))
                    )
                and not(key('loop-data-connectors-by-activity-name', $activity/@name))
                and not(key('default-data-connectors-by-activity-name', $activity/@name))
                and ( not($activity/fdl:input/fdl:dataDefaults) or 'true' = $option_id )">
            <xsl:value-of select="true()"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="false()"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
    </xsl:choose>
  </xsl:template>
  <!--
    *****************************************************************************************************************************
    Template "activity-can-send-output-to-shared-variable":

    Determines whether an activity satifies the following criteria of sending output to a shared BPEL variable:

    CASE: count($receiving-from-activities) = 0

      'false'

    CASE: count($receiving-from-activities) = 1

      1) Single outbound data connector
        2) _STRUCT TO _STRUCT data mapping style
      3) No default data values assigned to the activity output

    CASE: count($receiving-from-activities) > 1

      1) Single outbound data connector
        2) _STRUCT TO _STRUCT data mapping style
      3) No loop data connector to the activity
      4) No default data connector to the activity
      5) No default data values assigned to the activity output
            6) No data flow path connecting the source activities
      7) No local condition (exit or transition condition) and no remote condition referencing the activity output
    *****************************************************************************************************************************
   -->
  <xsl:template name="activity-can-send-output-to-shared-variable">
    <xsl:param name="activity"/>
    <xsl:param name="receiving-from-activities"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;activity-can-send-output-to-shared-variable&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="outbound-data-connectors" select="key('outDataConnByName', $activity/@name)"/>
    <xsl:choose>
      <!-- CASE: no source activity -->
      <xsl:when test="count($receiving-from-activities) = 0">
        <xsl:value-of select="false()"/>
      </xsl:when>
      <!-- CASE: exactly one source activity -->
      <xsl:when test="count($receiving-from-activities) = 1">
        <xsl:choose>
          <xsl:when test="count($outbound-data-connectors) = 1
                and ( ( key('data-connector-with-STRUCT-TO-STRUCT-mapping-by-id', generate-id($outbound-data-connectors[1]))
                        and ( 'false' = $createPredefinedDataMembers
                              or 'true' = $option_ip
                            )
                      )
                    or key('data-connector-with-CONTAINER-TO-CONTAINER-mapping-by-id', generate-id($outbound-data-connectors[1]))
                    )
                and ( not($activity/fdl:output/fdl:dataDefaults) or 'true' = $option_id )">
            <xsl:value-of select="true()"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="false()"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- CASE: more than one source activity -->
      <xsl:when test="count($receiving-from-activities) &gt; 1">
        <xsl:choose>
          <xsl:when test="count($outbound-data-connectors) = 1
                and ( ( key('data-connector-with-STRUCT-TO-STRUCT-mapping-by-id', generate-id($outbound-data-connectors[1]))
                        and ( 'false' = $createPredefinedDataMembers
                              or 'true' = $option_ip
                            )
                      )
                    or key('data-connector-with-CONTAINER-TO-CONTAINER-mapping-by-id', generate-id($outbound-data-connectors[1]))
                    )
                and not(key('loop-data-connectors-by-activity-name', $activity/@name))
                and not(key('default-data-connectors-by-activity-name', $activity/@name))
                and ( not($activity/fdl:output/fdl:dataDefaults) or 'true' = $option_id )
                and not(    $activity/fdl:exitCondition/fdl:condition
                            or $activity/../fdl:control[ @from = $activity/@name ]/fdl:condition
                            or $activity/ancestor::fdl:process//fdl:condition//fdl:dataStructureMemberName[ @scope = $activity/@name ] )">
            <xsl:value-of select="true()"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="false()"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
    </xsl:choose>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "UPES-execution-mode":

    Determines the execution mode of an "UPES" program activity.
    Selects from types "synchronous", "asynchronous"
    (NOTE THAT THIS TEMPLATE IS SHARED IN "XFDLBPEL_WSDL.XSL"!)
    ****************************************************************************************************************
   -->
  <xsl:template name="UPES-execution-mode">
    <xsl:param name="activity"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;UPES-execution-mode&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:choose>
      <!--
        CASE: "synchronous invocation"
      -->
      <xsl:when test="$activity/fdl:program/@synchronization = 'nested'">
        <xsl:value-of select="'synchronous'"/>
      </xsl:when>
      <!--
        CASE: "asynchronous invocation"
      -->
      <xsl:when test="$activity/fdl:program/@synchronization = 'chained'">
        <xsl:value-of select="'asynchronous'"/>
      </xsl:when>
      <!--
        OTHERWISE: "*** not defined ***"
      -->
      <xsl:otherwise>
        <xsl:value-of select="'*** not defined ***'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ****************************************************************************************************************
    Template "program-activity-type":

    Determines the type of an FDL program activity.
    Selects from types "empty activity", "service invocation activity" (UPES activity),  "staff activity",
    "assumed staff activity"
    NOTE THAT THIS TEMPLATE IS SHARED IN:
      "XFDLBPEL_ANALYZE.XSL", "XFDLBPEL_XSD.XSL", "XFDLBPEL_WSDL.XSL", "XFDLBPEL_SCDL.XSL"
    ****************************************************************************************************************
   -->
  <xsl:template name="program-activity-type">
    <xsl:param name="activity"/>
    <xsl:param name="server-may-be-missing" select="false()"/>
    <!-- ASSERT PRECONDITION -->
    <xsl:if test="not($activity)">
      <xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template: name=&quot;program-activity-type&quot;', $eol, 'Parameter &quot;activity&quot; is not set')"/>
      <xsl:variable name="print-error-message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message)"/>
    </xsl:if>
    <xsl:variable name="domain" select="//fdl:domain[1]"/>
    <xsl:variable name="system-group" select="//fdl:group[1]"/>
    <xsl:variable name="primary-system" select="//fdl:system[ @primarySystem ='yes' ][1]"/>
    <!-- Note that the following variables will contain appropriate values for "service invocation activities" (UPES) only -->
    <xsl:variable name="program-execution-unit" select="$activity/fdl:program/@programExecutionUnit"/>
    <xsl:variable name="server-name" select="substring-before($program-execution-unit, '.')"/>
    <xsl:variable name="related-system-name" select="substring-before(substring-after($program-execution-unit, concat($server-name, '.')), '.')"/>
    <xsl:variable name="server-and-system-name" select="concat($server-name, $related-system-name)"/>
    <xsl:choose>
      <!--
        CASE: "empty activity"
          A program activity is an "empty activity" if
          1) if the activity implementation is a program with the name FMCINTERNALNOOP
          2) the execution mode is chained
          3) the input and output data structures are the same
      -->
      <xsl:when test="$activity/fdl:program/@name='FMCINTERNALNOOP'
                and $activity/fdl:program/@synchronization='chained'
                and $activity/fdl:input/@type = $activity/fdl:output/@type">
        <xsl:value-of select="'empty activity'"/>
      </xsl:when>
      <!--
        CASE: "service invocation activity"
          A program activity is an "service invocation activity" if a user-defined program execution server
          (UPES) is specified (attribute "fdl:program/@programExecutionUnit").
      -->
      <xsl:when test="$activity/fdl:program/@programExecutionUnit
                  and (key('server-by-server-and-system-name', $server-and-system-name)[1]/fdl:userDefinedProgramExecutionServer or $server-may-be-missing = 'true')">
        <xsl:choose>
          <!-- CASE: User option "-un" (no UPES migration) is selected (cp. LI754 (Do not prepare process for reuse of UPES) -->
          <xsl:when test="'true' = $createUPESInvocations">
            <xsl:value-of select="'service invocation activity'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'empty activity'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!--
        CASE: "staff activity"
          A program activity is a "staff activity" if the following conditions apply:
          1. Start type is "manual"
          2. Attribute "checkoutPossible" indicates that it can be checked out from the runtime database.
      -->
      <xsl:when test="$activity/fdl:join/@startType='manual'
                  and ( $activity/fdl:defaultSetting/@checkoutPossible='yes'
                       or (  not($activity/fdl:defaultSetting/@checkoutPossible='no')
                          and (   $activity/ancestor::fdl:process/fdl:activityDefaultSetting/@checkoutPossible='yes'
                              or (   'true' = $LI1274_Support_inheritance_from_network_settings
                                  and not($activity/ancestor::fdl:process/fdl:activityDefaultSetting/@checkoutPossible='no')
                                  and (  $primary-system/fdl:activityDefaultSetting/@checkoutPossible='yes'
                                      or (  not($primary-system/fdl:activityDefaultSetting/@checkoutPossible='no')
                                          and (   $system-group/fdl:activityDefaultSetting/@checkoutPossible='yes'
                                              or (  not($system-group/fdl:activityDefaultSetting/@checkoutPossible='no')
                                                  and $domain/fdl:activityDefaultSetting/@checkoutPossible='yes' ) ) ) ) ) ) ) )">
        <xsl:value-of select="'staff activity'"/>
      </xsl:when>
      <!--
        OTHERWISE: "unclassified activity"
          A program activity is an "unclassified activity" if none of the above rules apply.
          In this case assume a "staff activity".
      -->
      <xsl:otherwise>
        <xsl:value-of select="'assumed staff activity'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!--
    ************************************************************************************************
    "traceTree" template

    Writes the content of a tree to a trace file.
    The tree can be passed as parameter, if it is not passed, then the current tree is used.
    ************************************************************************************************
  -->
  <xsl:template name="traceTree">
    <xsl:param name="treeToTrace" select="."/>
    <xsl:param name="traceContext"/>
    <xsl:variable name="traceFileName" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.getNewFileName($traceContext)"/>
    <xsl:if test="$traceFileName">
      <redirect:write select="concat($outputdir, $traceFileName)">
        <xsl:copy-of select="$treeToTrace"/>
      </redirect:write>
    </xsl:if>
  </xsl:template>
</xsl:transform>
